<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: imprimer.php 907 2010-08-20 18:32:03Z mike007.devpwsphp $
// ---------------------------------------------------------------
/*
#########################################################################################################################
# Fichier   : imprimer.php
# Crer par  : Filipe (www.mmfusion.net)
#
# Description et utilisation :
# Ce fichier vous permet d'imprimer n'importe quel document ayant un ID. Pour l'utiliser, il suffit de mettre un
# elseif ($doc == 'nom_du_fichier') {	} puis de mettre le contenu entre les {		}.
#
# Exemple :
#
# elseif ($doc == 'article')
# {
# 		$requete=reqmysql('SELECT * FROM `articles` WHERE `id`="'.$id.'" ');
# 		$article = mysql_fetch_object($requete);
# 		echo '
# 		<div class="titre">'.$article->titre</div><br />
# 		<div class="texte">'.$article->texte</div>
# 		<div class="auteur">'.$article->auteur</div>';
# }
#
# Voila, avec cet exemple vous afficherez un article bien precis grace  WHERE `id`="'.$id.'" et pourrez le faire
# imprimer. Pour cela il vous faudra aussi mettre un lien sur la page  imprimer.
#
# Exemple :
# <a href="imprimer.php?doc=nom_doc&amp;id='.$id.'" target="_blank">Imprimer</a>
# Le nom_doc est le nom qui est placer dans le if. Dans notre exmple prcdent c'est 'article'.
#########################################################################################################################
*/

// Messages d'erreur
$mess_erreur = '
<p style="text-align:center; margin-top:100px; font-weight:bold">Il n&rsquo;y a aucun document &agrave; imprimer !!!</p>
<p>[ <a href="javascript:window.close()">Fermer</a> ]</p>';

$mess_erreur2 = '
<p style="text-align:center; margin-top:100px; font-weight:bold">Il n&rsquo;y a aucun document &agrave; imprimer</p>
<p>[ <a href="javascript:history.go(-1)">Retour</a> ]</p>';

$id  = intval($_GET['id']);

if (!empty($id) and !empty($_GET['doc']))
{
	// Chargement des fichiers indispensables
	require_once './includes/fonctions.php';
	require_once './config.php';
	include_once './includes/bbcode.php';
	include_once './includes/date.php';
	$doc = ax($_GET['doc']);

	echo '
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-15" />
		<!--
			Titre de la fentre qui apparatra aussi sur la feuille d\'impression. Ne pas modifier car la modification se fait dans l\'administration du site
		-->
	 	<title>'.ax($K_imprim_fenetre).'</title>

		<!--
			Script permettant de redimmensionner la fentre. Modifier la taille si vous le souhaitez ou supprimer le script si vous voulez qu\'il soit en mode plein cran
		-->
		<script type="text/javascript">
		// <![CDATA[
			window.resizeTo(700,720);
			var Kle = "'.$Kle.'";
		// ]]>
		</script>
		<script type="text/javascript" src="./includes/fonctions.js"></script>

		<!--
			Prparation du style CSS. Ne pas modifier car la modification se fait dans l\'administration du site
		-->
		<style type="text/css">
			<!--
			body{font-family:'.ax($K_imprim_police).'; font-size:'.ax($K_imprim_taille).'; padding:20px}
			a:link,a:active,a:visited {color:'.ax($K_imprim_linkcolor).'; text-decoration:'.ax($K_imprim_linkdeco).';}
			a:hover {color:'.ax($K_imprim_hovercolor).'; text-decoration:'.ax($K_imprim_hoverdeco).'}
			.titre {color:'.ax($K_imprim_color1).'; font-size:'.ax($K_imprim_taille1).'; font-style:'.ax($K_imprim_style1).'; font-weight:'.ax($K_imprim_weight1).'; text-decoration:'.ax($K_imprim_deco1).';}
			.texte, .auteur {color:'.ax($K_imprim_color).';}
			.auteur {border-top:1px solid'.ax($K_imprim_color).'; padding-top:7px;}
			-->
		</style>
	</head>
	<body>';

	#=================================== DEBUT ==================================#

	#================================================
	# Imprimer une documentation
	#================================================
	// Vous devez avoir le module Documentation pour pouvoir l'utiliser
	if ($doc == 'documentation' and is_module('documentation'))
	{
		// Prparation de la requete pour l'affichage de la documentation
		$req_imprim1 = reqmysql('
			SELECT	*
			FROM	`documentation`
			WHERE	`validation`="0"
				AND	`id`="'.$id.'"
		') or die ("Erreur dans la base de donn&eacute;es");

		if (mysql_num_rows($req_imprim1) > 0)
		{
			$imprim_doc  = mysql_fetch_object($req_imprim1);
			$imprim_doc->titre         = ax($imprim_doc->titre);
			$imprim_doc->documentation = ax($imprim_doc->documentation);
			// Affichage de la documentation
			echo '
			<div class="titre">'.$imprim_doc->titre.'</div><br />
			<div class="texte">';
			if($imprim_doc->type==1)
			{
				echo bbcode($imprim_doc->documentation,$imprim_doc->smileys,$imprim_doc->type,1);
			}
			else
			{
				echo $imprim_doc->documentation;
			}
			echo'
			</div><br /><br />
			<div class="auteur">Document &eacute;crit par '.$imprim_doc->auteur.' '.kws_date ('\l\e l jS F Y \&\a\g\r\a\v\e\; H:i', $imprim_doc->date).'</div><br />';

			// Liens pour imprimer et/ou fermer la fenetre
			echo '
			<div style="text-align:center">
			[ <a href="javascript:window.print()">'.$K_imprim_lien.'</a> ]&nbsp;-&nbsp;[ <a href="javascript:window.close()">Fermer la fen&ecirc;tre</a> ]
			</div>';
		}
		else
		{
			echo $mess_erreur2;
		}
		// On ferme toutes les requetes
		mysql_close();
	}

	#================================================
	# Imprimer un article
	#================================================
	elseif ($doc == 'article' and is_module('articles'))
	{
		// Prparation de la requete pour l'affichage de l'article
		$req_imprim2 = reqmysql('
			SELECT		`articles`.`auteur`,
						`articles`.`titre`,
						`articles`.`id`,
						`articles`.`type`,
						`articles`.`texte`,
						`articles`.`date`,
						`articles`.`attribut`
			FROM		`articles`
			WHERE		`articles`.`id`="'.$id.'"
			AND			`validation` = "0"
		') or die ("Erreur dans la base de donn&eacute;es");

		if (mysql_num_rows($req_imprim2) > 0)
		{
			$imprim_art = mysql_fetch_object($req_imprim2);
			$imprim_art->titre = ax($imprim_art->titre);
			// Affichage de l'article
			echo '
			<div class="titre">'.$imprim_art->titre.'</div><br />
			<div class="texte">';
			if($imprim_art->type==1)  //BBCode
			{
				echo bbcode($imprim_art->texte,$imprim_art->attribut,$imprim_art->type,1);
			}
			else if($imprim_art->type==2) //lien externe
			{
				echo 'lien externe, impossible &agrave imprimer';
			}
			else  // HTML
			{
				echo bbcode($imprim_art->texte,$imprim_art->smiley,0,1,1);
			}
			echo'
			</div><br /><br />
			<div class="auteur">Article &eacute;crit par '.ax($imprim_art->auteur).' '.kws_date ('\l\e l jS F Y \&\a\g\r\a\v\e\; H:i', $imprim_art->date).'</div><br />';

			// Liens pour imprimer et/ou fermer la fenetre
			echo '
			<div style="text-align:center">
				[ <a href="javascript:window.print()">'.$K_imprim_lien.'</a> ]&nbsp;-&nbsp;[ <a href="javascript:window.close()">Fermer la fen&ecirc;tre</a> ]
			</div>';
		}
		else
		{
			echo $mess_erreur2;
		}
		// On ferme toutes les requetes
		mysql_close();
	}

	#================================================
	# Imprimer une news
	#================================================
	elseif ($doc == 'news' and is_module('news'))
	{
		// Prparation de la requete pour l'affichage de l'article
		$req_imprim3 = reqmysql('
			SELECT	*
			FROM	`news`
			WHERE	`id`="'.$id.'"
			AND		`validation` < 1
			AND		`date` <= '.time().'
		') or die ("Erreur dans la base de donn&eacute;es");

		if (mysql_num_rows($req_imprim3) > 0)
		{
			$imprim_news = mysql_fetch_object($req_imprim3);
			$imprim_news->titre = ax($imprim_news->titre);
			// Affichage de la documentation
			echo '
			<div class="titre">'.$imprim_news->titre.'</div><br />
			<div class="texte">';
			if($imprim_news->type==1) // BBCode
			{
				echo bbcode($imprim_news->contenu,$imprim_news->smiley,$imprim_news->type,1);
			}
			else  // HTML
			{
				echo bbcode($imprim_news->contenu,$imprim_news->smiley,0,1,1,($imprim_news->js ? 1:0));
			}
			echo'
			</div><br /><br />
			<div class="auteur">News &eacute;crite par '.ax($imprim_news->auteur).' '.kws_date ('\l\e l jS F Y \&\a\g\r\a\v\e\; H:i', $imprim_news->date).'</div><br />';

			// Liens pour imprimer et/ou fermer la fenetre
			echo '
			<div style="text-align:center">
				[ <a href="javascript:window.print()">'.$K_imprim_lien.'</a> ]&nbsp;-&nbsp;[ <a href="javascript:window.close()">Fermer la fen&ecirc;tre</a> ]
			</div>';

		}
		else
		{
			echo $mess_erreur2;
		}
		// On ferme toutes les requetes
		mysql_close();
	}
	#================================================
	# Imprimer une page
	#================================================
	elseif ($doc == 'page' and is_module('page'))
	{
		// Prparation de la requete pour l'affichage de l'article
		$req_imprim4 = reqmysql('
						SELECT		`droit`.`page`,
									`droit`.`grade`,
									`droit`.`condition`,
									`droit`.`groupe`,
									`d2`.`page` AS page_rub,
									`d2`.`grade` AS grade_rub,
									`d2`.`condition` AS condition_rub,
									`d2`.`groupe` AS groupe_rub,
									`page`.`id`,
									`page`.`ref`,
									`page`.`titre`,
									`page`.`contenu`,
									`rubriques`.`titre` AS rub_titre
						FROM `page`
						LEFT JOIN `droit`
							ON		`droit`.`page` = CONCAT("id_page_",`page`.`id`)
						LEFT JOIN `droit` d2
							ON		`d2`.`page` = CONCAT("id_",`page`.`ref`)
						LEFT JOIN `rubriques`
							ON		`rubriques`.`id` = `page`.`ref`
						WHERE		`page`.`id`="'.intval($id).'"
					') or die('Erreur :' .mysql_error());

		if (mysql_num_rows($req_imprim4) > 0)
		{
			$imprim_page = mysql_fetch_object($req_imprim4);
			$imprim_page->titre = ax($imprim_page->titre);
			// Affichage de la documentation
			echo '
			<div class="titre">'.$imprim_page->titre.'</div><br />
			<div class="texte">';
				echo bbcode($imprim_page->contenu,1,1,1);
			echo'
			</div><br /><br />';

			// Liens pour imprimer et/ou fermer la fenetre
			echo '
			<div style="text-align:center">
				[ <a href="javascript:window.print()">'.$K_imprim_lien.'</a> ]&nbsp;-&nbsp;[ <a href="javascript:window.close()">Fermer la fen&ecirc;tre</a> ]
			</div>';
		}
		else
		{
			echo $mess_erreur2;
		}
		// On ferme toutes les requetes
		mysql_close();
	}

	elseif (is_module('forum'))
	{
		#================================================
		# Imprimer un sujet du forum
		#================================================
		if ($doc == 'topic')
		{
			// on charge la liste des forums en cache en session si ce n'est pas encore fait
			if(empty($_SESSION[$CachePseudo.'_CatForum_0']) or empty($_SESSION['ListeGrSpe']))
			{
				include './modules/forum/sessionCache.php';
			}
			$r_forum_cat = reqmysql('
				SELECT		`forum_topic`.`titre`	AS topic_titre,
							`forum_topic`.`auteur`,
							`forum_topic`.`contenu`,
							`forum_topic`.`editeur`,
							`forum_topic`.`date`
				FROM		`forum_topic`
				LEFT JOIN	`forum_cat`
					ON		`forum_topic`.`ref` = `forum_cat`.`id`
				WHERE		`forum_cat`.`id` IN '.$_SESSION[$CachePseudo.'_CatForum_0'].'
				AND			`forum_topic`.`id` = "'.$id.'"
			');

			if (mysql_num_rows($r_forum_cat) > 0)
			{
				$imprim_topic = mysql_fetch_object($r_forum_cat);
				$imprim_topic->titre = ax($imprim_topic->topic_titre);
				// Affichage de la documentation
				echo '
				<div class="titre">'.$imprim_topic->titre.'</div><br />
				<div class="texte">';
				if($imprim_topic->editeur=='bbcode') // BBCode
				{
					echo bbcode($imprim_topic->contenu,$imprim_topic->smiley,1,1);
				}
				else  // HTML
				{
					echo bbcode($imprim_topic->contenu,$imprim_topic->smiley,0,1,1);
				}
				echo'
				</div><br /><br />
				<div class="auteur">Sujet &eacute;crit par '.ax($imprim_topic->auteur).' '.kws_date ('\l\e l jS F Y \&\a\g\r\a\v\e\; H:i', $imprim_topic->date).'</div><br />';

				// Liens pour imprimer et/ou fermer la fenetre
				echo '
				<div style="text-align:center">
					[ <a href="javascript:window.print()">'.$K_imprim_lien.'</a> ]&nbsp;-&nbsp;[ <a href="javascript:window.close()">Fermer la fen&ecirc;tre</a> ]
				</div>';

			}
			else
			{
				echo $mess_erreur2;
			}

			// On ferme toutes les requetes
			mysql_close();
		}

		#================================================
		# Imprimer une rponse du forum
		#================================================
		elseif ($doc == 'post')
		{
			// on charge la liste des forums en cache en session si ce n'est pas encore fait
			if(empty($_SESSION[$CachePseudo.'_CatForum_0']) or empty($_SESSION['ListeGrSpe']))
			{
				include './modules/forum/sessionCache.php';
			}
			$r_forum_cat = reqmysql('
				SELECT		`forum_rep`.`titre`	AS post_titre,
							`forum_rep`.`auteur`,
							`forum_rep`.`contenu`,
							`forum_rep`.`editeur`,
							`forum_rep`.`date`
				FROM		`forum_rep`
				LEFT JOIN	`forum_topic`
					ON		`forum_rep`.`ref` = `forum_topic`.`id`
				LEFT JOIN	`forum_cat`
					ON		`forum_topic`.`ref` = `forum_cat`.`id`
				WHERE		`forum_cat`.`id` IN '.$_SESSION[$CachePseudo.'_CatForum_0'].'
				AND			`forum_rep`.`id` = "'.$id.'"
			');

			if (mysql_num_rows($r_forum_cat) > 0)
			{
				$imprim_post = mysql_fetch_object($r_forum_cat);
				$imprim_post->titre = ax($imprim_post->post_titre);
				// Affichage de la documentation
				echo '
				<div class="titre">'.$imprim_post->titre.'</div><br />
				<div class="texte">';
				if($imprim_post->editeur=='bbcode') // BBCode
				{
					echo bbcode($imprim_post->contenu,$imprim_post->smiley,1,1);
				}
				else  // HTML
				{
					echo bbcode($imprim_post->contenu,$imprim_post->smiley,0,1,1);
				}
				echo'
				</div><br /><br />
				<div class="auteur">Sujet &eacute;crit par '.ax($imprim_post->auteur).' '.kws_date ('\l\e l jS F Y \&\a\g\r\a\v\e\; H:i', $imprim_post->date).'</div><br />';

				// Liens pour imprimer et/ou fermer la fenetre
				echo '
				<div style="text-align:center">
					[ <a href="javascript:window.print()">'.$K_imprim_lien.'</a> ]&nbsp;-&nbsp;[ <a href="javascript:window.close()">Fermer la fen&ecirc;tre</a> ]
				</div>';

			}
			else
			{
				echo $mess_erreur2;
			}
			// On ferme toutes les requetes
			mysql_close();
		}
	}
	#=================================== FIN ==================================#
	else
	{
		echo $mess_erreur;
	}
	echo '
		</body>
	</html>
	';
}
else
{
	echo $mess_erreur2;
}
?>
