<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: bbcode.php 913 2011-02-08 16:27:22Z mike007 $
// ---------------------------------------------------------------
// Fichier  : bbcode.php
// BBcode revu,renov et corrig
// Par zeta le 13/02/2005
// Modifi par Ditch le 29/07/06
// Revu par mike007 le 28/03/08
// ---------------------------------------------------------------

require_once './includes/fonctions.php';
if(empty($_SESSION['check_bbcode_sup']))
{
	$_SESSION['check_bbcode_sup']['autorise'] = false;
	if (is_module('bbcode_sup'))
	{
		$bbcode_sup_search	= array();
		$bbcode_sup_replace	= array();
		$BBcodeSupAutorise = array();
		$req_bbcode_plus	= reqmysql('SELECT * FROM `bbcode_sup` WHERE `active`="oui"');
		while ($rep_bbcode_plus = mysql_fetch_object($req_bbcode_plus))
		{
			array_push($bbcode_sup_search, $rep_bbcode_plus->search);
			array_push($bbcode_sup_replace,$rep_bbcode_plus->replace);
		}
		$_SESSION['check_bbcode_sup']['autorise'] = true;
		$_SESSION['check_bbcode_sup']['search'] = $bbcode_sup_search;
		$_SESSION['check_bbcode_sup']['replace'] = $bbcode_sup_replace;
	}
}
$autorisation_bbcode_sup = $_SESSION['check_bbcode_sup']['autorise'];

################################
##  Ajout de la possibilit de mettre du html
##  Passage d'une vingtaine de masques  5 tableaux
##  Mise en indentation
##  Ajout d'une directive qui devrait rsoudre tout les pbm de slasches du forum

#######################
##  Fonction bbcode  ##
#######################
/**
* Fonction qui met en forme les texte en interprteant les balises bbcode
* @param $texte texte  interprter
* @param $aff_smileys interprte (1) ou non (0) les smiley
* @param $nl2br les \n sont interprt en <br />
* @param $aff_table les tableau sont interprt
* @param $html l'html est autoris et est filtr (EXPERIMENTAL)
* @param $js le javascript est autoris
* @param $brut retourne le texte brut sans balise html ou bbcode
* @return code html correspondant au texte interprt
*/

function bbcode($texte, $aff_smileys=0, $nl2br=0, $aff_table=0, $html=0, $js=0, $brut=0)
{
	if ($brut==1)
	{
		$texte = preg_replace('#<[^>]*>#','',$texte);
		$texte = preg_replace('#\[[^\]]*\]#', '', $texte);
		$texte = preg_replace('#\\r\\n\\r\\n#', ' ', $texte);
		$texte = preg_replace('#\\r\\n#', ' ', $texte);
		return $texte;
	}
	global $K_user, $K_url_site, $K_mod, $K_ac, $K_theme;
	global $autorisation_bbcode_sup, $bbcode_noreplace, $K_BbcodeOptions;
	$K_url_site = preg_replace('#/modules/([a-zA-Z0-9-_]+?)/#','/',$K_url_site);

	##########################################
	##  Ajout de slashes pour le traitement ##
	##########################################
	$texte = addslashes($texte);

	###########################################################
	##  Suppression des balises html et mise des & en &amp;  ##
	##         Transformation de quelques exceptions         ##
	###########################################################
	$texte = str_replace(
		array("&",		"<",	">",	"'",		'"',		"$",		''),
		array("&amp;",	"&lt;",	"&gt;",	"&#039;",	"&quot;",	"&#36;",	'&euro;')
		, $texte);
	$texte	= reduce_entityhtml($texte);

	#############################################
	##  Interprtation des retours  la ligne  ##
	#############################################
	if ($nl2br != 0)
	{
		##  Passages  la ligne  ##
		$texte = str_replace("\r\n", '<br />', $texte);
		$texte = str_replace("\n", '<br />', $texte);
	}

	#############################
	##  Affichage des smileys  ##
	#############################
	if (!is_module('smileys')) $aff_smileys = 0;
	if ($aff_smileys != 0)
	{
		$im = array('g3ag','g3bg','g28g','g29g','g23g','g7cg','g21g','g24g','g25g','g27g','g2ag','g3cg','g3dg','g3eg','g3fg','g40g','g5bg','g5cg','g5dg','g5fg','g7bg','g7dg');
		$re = array(':',';','\(','\)','#','\|','!','$','%','\'','*','<','=','>','?','@','[','\\',']','_','\{','\}');
		$i=0;

		$rep=opendir('./images/smileys/');     //lecture du repertoire de smileys
		while (($file = readdir($rep)) != false)
		{
			if ((strtolower(substr($file,-3))=="gif" || strtolower(substr($file,-3))=="jpg" || strtolower(substr($file,-3))=="png") && substr($file,0,1)=="s")
			{
				$id_img = substr($file,1,-4);
				$id_img2[$i]='/'.$id_img.'/';
				$fichier[$i]='<!--smil '.$file.'--><img src="'.$K_url_site.'images/smileys/'.$file.'" style="border:0px;vertical-align:middle;" alt="smiley '.$file.'" /><!--smil '.$file.'-->';
				$i++;
			}
		}
		$id_img2 = str_replace($im,$re,$id_img2);
		closedir($rep);
		clearstatcache();						//vidange

		// echo '<pre>'.print_r($id_img2,true).'</pre>';  //informations pour debugage

		$texte = preg_replace('`(&[a-zA-Z]{1,8};)\)`','$1 )',$texte);	// Cas particulier d'un smiley prcd d'une entit html
		$texte = preg_replace($id_img2,$fichier,$texte).' ';			//remplacement smileys
		$texte = preg_replace('`(&[a-zA-Z]{1,8};) \)`','$1)',$texte);	// Rtablissement du cas particulier d'un smiley prcd d'une entit html
	}

	$UrlPancarteHaut= $K_url_site.'images/pancarte_haut.png';
	$UrlPancarte	= $K_url_site.'images/pancarte.png';
	$K_OptionsBbcode = unserialize($K_BbcodeOptions);
	if ($K_mod!='ajash00t_bloc')	$Limit = 80;
	else							$Limit = 25;

	################################################################################################
	##  Recherche et remplacement quote et code (doit etre pris en compte avant tous les autres)  ##
	################################################################################################
	$SearchCode = array(
	'quote'		=>	'`(\[quote(=(.*?)\]|\]))(.+?)(\[/quote\])`iUe',									//quote
	'code1'		=>	'`\[code=(.*?)\](.+?)\[/code\]`ie',												//code
	'code2'		=>	'`\[code\](.+?)\[/code\]`ie',													//code
	'code3'		=>	'`([^\]])(\&lt;\?php)(.+?)(\?\&gt;)`iUe'										//code php
	);
	#########################################
	##  Interprtation associe au BBcode  ##
	#########################################
	$ReplaceCode = array(
	'quote'		=>	'bb_cite(\'$1$4$5\')',
	'code1'		=>	"'<br /><div class=\"code_php_titre\" style=\"font-weight:bold;\">Code PHP ($1) : </div><div style=\"width:600px;max-height:450px;overflow:auto;margin:auto\" class=\"code_php\">'.bb_high('$2').'</div>'",
	'code2'		=>	"'<br /><div class=\"code_php_titre\" style=\"font-weight:bold;\">Code PHP : </div><div style=\"width:600px;max-height:450px;overflow:auto;margin:auto\" class=\"code_php\">'.bb_high('$1').'</div>'",
	'code3'		=>	'\'$1<br /><div class="code_php_titre" style="font-weight:bold;">Code PHP : </div><div style="width:600px;max-height:450px;overflow:auto;margin:auto" class="code_php">\'.bb_high(\'$2$3$4\').\'</div>\''
	);
	$texte = preg_replace($SearchCode, $ReplaceCode, ' '.$texte);
	#########################################
	##  BBcodes supplmentaire via module  ##
	#########################################
	if ($_SESSION['check_bbcode_sup']['autorise'])
	{
		$texte=preg_replace($_SESSION['check_bbcode_sup']['search'],$_SESSION['check_bbcode_sup']['replace'],$texte);
	}

	########################
	##  Recherche BBcode  ##
	########################
	$search = array(
	'taille'	=>	'`\[(taille|size)=(([0-3])[0-9])\](.+?)\[/(taille|size)\]`i',					//taille
	'panneau1'	=>	'`\[center\](.*?)\[panneau\](.+?)\[/panneau\](.*?)\[/center\]`ie',				//panneau centr
	'panneau2'	=>	'`\[align=center\](.*?)\[panneau\](.+?)\[/panneau\](.*?)\[/align\]`ie',			//panneau centr
	'panneau3'	=>	'`\[panneau\](.+?)\[/panneau\]`ie',												//panneau
	'puce'		=>	'`\[puce\](.+?)\[/puce\]`i',													//puce
	'puce2'		=>	'`\[list(=(a|1|i){1})?\](<br />)?(\[\*\])?(.+?)\[/list\]`ie',					//liste de puces
	'surlign1'	=>	'`\[surlign\](.+?)\[/surlign\]`i',												//surlignement par dfaut
	'surlign2'	=>	'`\[surlign=(\#[0-9A-F]{6}|[a-z]+)\](.+?)\[/surlign\]`i',						//surlignement dfini
	'align1'	=>	'`\[(center|justify|left|right)\](.+?)\[/(center|justify|left|right)\]`i',		//alignement
	'align2'	=>	'`\[align=(center|justify|left|right)+\](.+?)\[/align\]`i',						//alignement plus gnralis
	'float'		=>	'`\[float=(left|right)\](.+?)\[/float\]`i',										//float
	'u'			=>	'`\[u\](.+?)\[/u\]`i',															//soulign
	'glow1'		=>	'`\[glow\](.+?)\[/glow\]`i',													//glow par dfaut
	'glow2'		=>	'`\[glow=(\#[0-9A-F]{6}|[a-z]+)\](.+?)\[/glow\]`i',								//glow dfini
	'mail1'		=>	'`\[email\]([a-z0-9._-]+@[a-z0-9._-]{2,}\.[a-z]{2,6})\[/email\]`ie',			//emails
	'mail2'		=>	'`\[email=([a-z0-9._-]+@[a-z0-9._-]{2,}\.[a-z]{2,6})\]([^@].+?)\[/email\]`ie',	//emails
	'mail3'		=>	'`([a-z0-9._-]+@[a-z0-9._-]{2,}\.[a-z]{2,6})`ie',								//emails auto
	'font'		=>	'`\[font=([a-zA-Z\s]+)\](.+?)\[/font\]`i',										//police
	'b'			=>	'`\[b\](.+?)\[/b\]`i',															//gras
	'i'			=>	'`\[i\](.+?)\[/i\]`i',															//italique
	'barre'		=>	'`\[barre\](.+?)\[/barre\]`i',													//barre
	'color'		=>	'`\[(color|couleur)=(\#[0-9A-F]{6}|[a-z]+)\](.+?)\[/(color|couleur)\]`i',		//couleur de police
	'url1'		=>	'`([^-\]=/"\';.])(www.)([\w./=&~?,;:\-_\#]+)`ie',								//url auto www.
	'url2'		=>	'`([^-\]=/"\';.])(http://|ftp://)('.substr($K_url_site,7).')?([\w./=&~?,;:\-_\#]+)`ie',	//url auto http:// ftp://
	'url3'		=>	'`\[url\]('.$K_url_site.'|\./|index)(.[^"\'()<>\]\[]*?)\[/url\]`ie',			//url interne [url]http://monsite.com
	'url4'		=>	'`\[url=('.$K_url_site.'|\./|index)(.[^"\'()<>\]\[]*?)\](.*?)\[/url\]`ie',		//url interne [url=http://monsite.com
	'url5'		=>	'`\[url\](http|ftp)(.[^"\'()<>\]\[]+?)\[/url\]`ie',								//url externe [url]http://...
	'url6'		=>	'`\[url\]www(.[^"\'()<>\]\[]+?)\[/url\]`ie',									//url externe [url]www....
	'url7'		=>	'`\[url=(www.)(.[^"\'()<>\]\[]+?)\](.*?)\[/url\]`ie',							//url externe [url=www...]
	'url8'		=>	'`\[url=(.[^"\'()<>\]\[]*?)\](.+?)\[/url\]`ie',									//url externe [url=......]
	'img1'		=>	'`\[img\]www(.[^"\'()<>\]\[]+?)\[/img\]`ie',									//images
	'img11'		=>	'`\[img=(.+?)\]www(.[^"\'()<>\]\[]+?)\[/img\]`ie',								//images
	'img2'		=>	'`\[img\](.[^"\'()<>\]\[]+?)\[/img\]`ie',										//images
	'img22'		=>	'`\[img=(.+?)\](.[^"\'()<>\]\[]+?)\[/img\]`ie',									//images
	'hr'		=>	'`\[hr\]`i',																	//ligne de sparation
	'smil'		=>	'`<!--smil s(.*?).[a-z]{0,4}-->`i'
	);
	#########################################
	##  Interprtation associe au BBcode  ##
	#########################################
	$replace = array(
	'taille'	=>	'<span style="font-size:$2px">$4</span>',
	'panneau1'	=>	'\'[center]$1 [/center]<table cellspacing="0" cellpadding="0" style="border:0px;text-align:center;margin:auto;" summary="pancarte_haut1"><tbody><tr><td><img src="'.$UrlPancarteHaut.'" alt="Panneau haut" /></td></tr><tr><td class="panneau">$2</td></tr><tr><td><img alt="Pancarte" src="'.$UrlPancarte.'" /></td></tr></tbody></table>[center]$3 [/center]\'',
	'panneau2'	=>	'\'[center]$1 [/center]<table cellspacing="0" cellpadding="0" style="border:0px;text-align:center;margin:auto;" summary="pancarte_haut1"><tbody><tr><td><img src="'.$UrlPancarteHaut.'" alt="Panneau haut" /></td></tr><tr><td class="panneau">$2</td></tr><tr><td><img alt="Pancarte" src="'.$UrlPancarte.'" /></td></tr></tbody></table>[center]$3 [/center]\'',
	'panneau3'	=>	'\'<table cellspacing="0" cellpadding="0" style="border:0px;text-align:center" summary="pancarte_haut1"><tbody><tr><td><img src="'.$UrlPancarteHaut.'" alt="Panneau haut" /></td></tr><tr><td class="panneau">$1</td></tr><tr><td><img alt="Pancarte" src="'.$UrlPancarte.'" /></td></tr></tbody></table>\'',
	'puce'		=>	'<ul><li style="margin-left:12px;">$1</li></ul>',
	'puce2'		=>	'bb_liste(\'$2\',\'$5\')',
	'surlign1'	=>	'<span class="surlign">$1</span>',
	'surlign2'	=>	'<span style="background-color:$1">$2</span>',
	'align1'	=>	'<span style="float:left;width:100%;text-align:$1">$2</span><br style="clear:both" />',
	'align2'	=>	'<span style="float:left;width:100%;text-align:$1">$2</span><br style="clear:both" />',
	'float'		=>	'<span style="margin:5px;float:$1">$2</span>',
	'u'			=>	'<span style="text-decoration: underline;">$1</span>',
	'glow1'		=>	'<div style="width:100%;filter:glow(color=#000000,strength=1);">$1</div>',
	'glow2'		=>	'<div style="width:100%;filter:glow(color=$1,strength=1);">$2</div>',
	'mail1'		=>	"'<a style=\"cursor:pointer\" onclick=\"KmTo(\''.BrouilleMail('$1').'\')\"><img style=\"border:none;vertical-align:middle\" src=\"./modules/generateur/topho.php?a='.bb_email('$1').'\" alt=\"email anti-spam\" /></a>'",
	'mail2'		=>	"'<a href=\"javascript:void()\" onclick=\"KmTo(\''.BrouilleMail('$1').'\')\"><img style=\"border:none;\" src=\"./images/ico/mail.png\" alt=\"\" /> $2</a>'",
	'mail3'		=>	'\''.$aff_autres.'\'==\'0\' ? \'$1\':\'<a style="cursor:pointer" onclick="KmTo(\\\'\'.BrouilleMail(\'$1\').\'\\\')"><img style="border:none;vertical-align:middle" src="./modules/generateur/topho.php?a=\'.bb_email(\'$1\').\'" alt="email anti-spam" /></a>\'',
	'font'		=>	'<span style="font-family:$1">$2</span>',
	'b'			=>	'<span style="font-weight:bold">$1</span>',
	'i'			=>	'<span style="font-style:italic">$1</span>',
	'barre'		=>	'<strike>$1</strike>',
	'color'		=>	'<span style="color:$2">$3</span>',
	'url1'		=>	'strlen(\'$2$3\') > $Limit ? \'$1<a class="bbcode_url" href="$2$3" target="_blank">Lien ICI</a>\' : \'$1<a class="bbcode_url" href="http://$2$3" target="_blank">$2$3</a>\'',
	'url2'		=>	'strlen(\'$2$3$4\') > $Limit ? \'$1<a class="bbcode_url" href="\'.url_rw(\'$2$3$4\').\'" \'.($K_url_site=="$2$3"?\'\':\'target="_blank"\').\'>Lien ICI</a>\'	: \'$1<a class="bbcode_url" href="\'.url_rw(\'$2$3$4\').\'" \'.($K_url_site=="$2$3"?\'\':\'target="_blank"\').\'>\'.url_rw(\'$2$3$4\').\'</a>\'',
	'url3'		=>	'strlen(\'$1$2\') > $Limit ? \'<a class="bbcode_url" href="\'.url_rw(\'$1$2\').\'">Lien ICI</a>\' : \'<a class="bbcode_url" href="\'.url_rw(\'$1$2\').\'">$1$2</a>\'',
	'url4'		=>	'(strlen(\'$3\') > $Limit and \'$1$2\'==\'$3\') ?\'<a class="bbcode_url" href="\'.url_rw(\'$1$2\').\'">Lien ICI</a>\':\'<a class="bbcode_url" href="\'.url_rw(\'$1$2\').\'">$3</a>\'',
	'url5'		=>	'strlen(\'$1$2\') > $Limit ? \'<a class="bbcode_url" href="$1$2" target="_blank">Lien ICI</a>\' : \'<a class="bbcode_url" href="$1$2" target="_blank">$1$2</a>\'',
	'url6'		=>	'strlen(\'http://www$2\') > $Limit ? \'<a class="bbcode_url" href="http://www$1" target="_blank">Lien ICI</a>\':\'<a class="bbcode_url" href="http://www$1" target="_blank">http://www$1</a>\'',
	'url7'		=>	'(strlen(\'$1$2\') > $Limit and \'$1$2\'==\'$3\') ? \'<a class="bbcode_url" href="http://$1$2" target="_blank">Lien ICI</a>\':\'<a class="bbcode_url" href="http://$1$2" target="_blank">$3</a>\'',
	'url8'		=>	'(strlen(\'$2\') > $Limit and \'$1\'==\'$2\') ? \'<a class="bbcode_url" href="$2" target="_blank">Lien ICI</a>\':\'<a class="bbcode_url" href="$1" target="_blank">$2</a>\'',
	'img1'		=>	'\'<img style=" max-width:'.$K_OptionsBbcode['MaxSizeImgWidth'].'px;max-height:'.$K_OptionsBbcode['MaxSizeImgHeight'].'px;border:none;overflow:auto;" alt="image" src="http://www$1" />\'',
	'img11'		=>	'\'<img style=" max-width:'.$K_OptionsBbcode['MaxSizeImgWidth'].'px;max-height:'.$K_OptionsBbcode['MaxSizeImgHeight'].'px;border:none;overflow:auto;" alt="$1" title="$1" src="http://www$2" />\'',
	'img2'		=>	'\'<img style=" max-width:'.$K_OptionsBbcode['MaxSizeImgWidth'].'px;max-height:'.$K_OptionsBbcode['MaxSizeImgHeight'].'px;border:none;overflow:auto;" alt="image" src="$1" />\'',
	'img22'		=>	'\'<img style=" max-width:'.$K_OptionsBbcode['MaxSizeImgWidth'].'px;max-height:'.$K_OptionsBbcode['MaxSizeImgHeight'].'px;border:none;overflow:auto;" alt="$1" title="$1" src="$2" />\'',
	'hr'		=>	'<hr style="border:1px dotted" />',
	'smil'		=> 	' '
	);

	if (is_array($bbcode_noreplace))
	{
		foreach ($bbcode_noreplace as $BbcodeToDel)
		{
			unset($search[$BbcodeToDel]);
			unset($SearchCode[$BbcodeToDel]);
			unset($replace[$BbcodeToDel]);
			unset($ReplaceCode[$BbcodeToDel]);
		}
	}
	###################################################################
	##  Remplacement de tous BBcodes sauf ceux de $bbcode_noreplace ##
	##                                                             ################################################
	##  Espace avant $texte pour prendre en compte le cas ou on debute par une url sans balise ou bien par <?php  #
	###############################################################################################################
	$texte = preg_replace($search, $replace, ' '.$texte);


	###############################################
	##  Suppression des slashes aprs traitement ##
	###############################################
	$texte = stripslashes($texte);

	#################################
	##  Interprtation des tables  ##
	#################################
	if ($aff_table == 1)
	{
		##  Balises html <table> <td> et <tr> acceptes  ##
		$texte = preg_replace('`\&lttable(.*?)\&gt(.*?)\&lt/table\&gt`i', '<table border="1" cellspacing="0" cellpading="0" $1>$2</table>', $texte);
		$texte = preg_replace('`\&lttr(.*?)\&gt(.*?)\&lt/tr\&gt`i', '<tr $1>$2</tr>', $texte);
		$texte = preg_replace('`\&lttd(.*?)\&gt(.*?)\&lt/td\&gt`i', '<td $1>$2</td>', $texte);

		########################################
		##  Affiche le tableau correspondant  ##
		########################################
		$texte1 = explode('[table=', $texte);

		for($i=1; $i<count($texte1); $i++)
		{
			$fin = strpos($texte1[$i], '][/table]');
			$id_table = intval(substr($texte1[$i], 0, $fin));
			$text = '[table='.$id_table.'][/table]';

			$req_table=$tableau='';
			if (!empty($id_table))
			{
				$req_table	= reqmysql('SELECT * FROM `tableau` WHERE `id`='.$id_table);
				$tableau	= mysql_fetch_object($req_table);
				$texte		= str_replace("$text", $tableau->contenu, $texte);
			}
		}
	}

	##############################
	##  Si l'html est autoris  ##
	##############################

	if ($html == 1)
	{
		$htmldang = array(
							"`&lt\;`i",			"`&gt\;`i",
							"`&#039\;`i",		"`&quot\;`i",
							"`javascript`i",	"`script`i",
							"`\(`i",			"`\)`i",
							"`\.`i",			"`&amp\;amp\;`i",
							"`&amp\;lt\;`i",	"`&amp\;gt\;`i",
							"`&amp\;#039\;`i",	"`&amp\;quot\;`i",
							"`&amp\;#96\;`i",	"`&amp\;#46\;`i"
						);

		$assure = array(
							"<",			">",
							"'",			'"',
							"&#74;&#115;",	"&#115;&#99;&#114;&#105;&#112;&#116;",
							"&#40;",		"&#41;",
							"&#46;",		"&amp;",
							"&lt;",			"&gt;",
							"&#039;",		"&quot;",
							"`",			"&#46;"
						);

		$texte = preg_replace($htmldang, $assure, $texte); //remplacement pour un minimu de scu
	}

	if ($js != 0)
	{
		$htmldang	= array("/\&#46;/i", "/&#74;&#115;/i", "/\&#40;/i", "/\&#41;/i", "/&#115;&#99;&#114;&#105;&#112;&#116;/i");
		$assure		= array(".", "javascript", "(", ")", "script");
		$texte		= preg_replace($htmldang, $assure, $texte); //remplacement pour un minimu de scu
	}

	return $texte;
}

#########################
##  Fonction bb_liste  ##
#########################
/**
* Fonction qui encode une liste
* @param $style format de la list
* @param $li texte  encoder
* @return texte encod
*/
function bb_liste($style,$li)
{
	if (empty($style))		$style = 'square';
	elseif ($style=='a')	$style = 'lower-alpha';
	elseif ($style=='i')	$style = 'lower-roman';
	elseif ($style=='1')	$style = 'decimal';
	$texte = '<ul style="list-style:'.$style.'">';
	$li_array = explode('[*]',$li);
	for($i=0 ; $i < count($li_array) ; $i++)
	{
		$li_array[$i] = str_replace('<br />','',$li_array[$i]);
		if(trim($li_array[$i])!='') $texte .= '<li>'.$li_array[$i].'<br /></li>';
	}
	$texte .= '</ul>';
	if ($texte == '<ul style="list-style:'.$style.'"></ul>') $texte='[list][*][/list]';
	return $texte;
}

#########################
##  Fonction bb_email  ##
#########################
/**
* Fonction qui encode un email pour passer en parametre du gnrateur d'image
* @param $msg texte  encoder
* @return texte encod
*/
function bb_email($msg)
{
	global $Kle;
	$msg = array($Kle, BrouilleMail($msg));
	return urlencode(serialize($msg));

	$msg = str_replace(array('@','.'),array('[at]','[dot]'),$msg);

	$final = "";

	for ($i=0; $i<=strlen($msg); $i++)
	{
		$final .= substr($msg, strlen($msg)-$i, 1);
	}
	$final = str_rot13($final);

	return $final;
}

###########################################
##  Fonction bb_cite pour les citations  ##
###########################################
/**
* Fonction qui gre les quotes
* @param $texte texte
* @return html correspondant au texte interprt
*/
function bb_cite($texte)
{
	$texte_ori = $texte;
	$texte1='';
	$texte = str_replace(array("\'",'\"'),array("'",'"'),$texte);

	$nb_quote_ouv = substr_count($texte,'[quote');
	$nb_quote_fer = substr_count($texte,'[/quote]');
	$texte1 = explode('[quote',$texte);

	$j=0;
	for($i=1; $i < count($texte1); $i++)
	{
		$j++;
		$text=$texte1[$i];

		if(substr($texte1[$i],0,1) == '=')
		{
			$texte1[$i]=substr_replace($texte1[$i],'',0,1);
			$nb=strpos($texte1[$i],']');
			$CitAuteur=substr($texte1[$i],0,$nb);
			if (substr($CitAuteur,0,1) == '/')	$CitAuteur = substr_replace($CitAuteur,'',0,1);
			else								$CitAuteur = 'Citation de '.$CitAuteur;
			$texte1[$i]=substr_replace($texte1[$i],'',0,$nb+1);
			$texte1[$i]='<br /><strong>'.$CitAuteur.' : </strong><br /><div style="width: 98%;overflow:auto;max-height:450px;margin:auto;" class="quote">'.$texte1[$i].'';
		}
		else
		{
			$texte1[$i]=substr_replace($texte1[$i],'',0,1);
			$texte1[$i]='<br /><strong>Citation : </strong><br /><div style="width: 98%;overflow:auto;max-height:450px;margin:auto;" class="quote">'.$texte1[$i].'';
		}
		$texte=str_replace('[quote'.$text,$texte1[$i],$texte);
	}

	if($nb_quote_ouv > $nb_quote_fer)
	{
		// fait l'effort de fermer l'erreur
		while($nb_quote_ouv > $nb_quote_fer)
		{
			$nb_quote_fer++;
			$texte.='</div><br />';
		}
	}
	elseif($nb_quote_ouv < $nb_quote_fer)
	{
		// non l c'est la merde, il faut faire attention ;)
		$texte_false = str_replace('[quote','[color=green][quote[/color]',$texte_ori);
		$texte_false = str_replace('[/quote]','[color=red][/quote][/color]',$texte_false);
		$texte_false = '<small><strong>[quote] ouvrant ('.$nb_quote_ouv.') inf&eacute;rieur au [/quote] fermant ('.$nb_quote_fer.')</strong><br />=&gt; Pour la bonne mise en page de votre message, veuillez &eacute;diter votre message et corriger. Merci.</small><br /><br /><em>'.$texte_false.'</em>';
		return $texte_false;
/*
		while($nb_quote_ouv < $nb_quote_fer)
		{
			$nb_quote_ouv++;
		}
*/
	}
	$texte=str_replace('[/quote]', '</div><br />', $texte);
	return $texte;
}

########################
##  Fonction bb_high  ##
########################
/**
* Fonction qui gre la coloration syntaxique du code php
* @param $texte texte  colorer
* @return texte colorer
*/


function bb_high($texte)
{
	$im = array('g3ag','g3bg','g28g','g29g','g23g','g7cg','g21g','g24g','g25g','g27g','g2ag','g3cg','g3dg','g3eg','g3fg','g40g','g5bg','g5cg','g5dg','g5fg','g7bg','g7dg');

	$re = array(':',';','(',')','#','|','!','$','%','\'','*','<','=','>','?','@','[','\\',']','_','{','}');

	$texte = preg_replace('#<!--smil s(.*?).[a-z]{0,4}-->(.*?)<!--smil s(.*?).[a-z]{0,4}-->#ise','str_replace($im ,$re ,"$1")',$texte );

	$texte = str_replace (
		array("<br />",	"&",	"&amp;lt;",	"&amp;gt;",	"&amp;#039;",	"&amp;quot;",	"&amp;#36;",	"&amp;euro;",	"&amp;amp;"),
		array("\r\n",	"&amp;","<",		">",		"'",			'"',			"$",			"&euro;",		"&")
		, $texte);
	$texte	= reduce_entityhtml($texte);

	$texte = stripslashes($texte);
	$TexteOri = $texte;
	$texte=str_replace(
					array(
							chr(92),
							chr(92).chr(92).'"',
							chr(92).chr(92)."'",
						),
					array(
							chr(92).chr(92),
							chr(92).chr(92).chr(92).'"',
							chr(92).chr(92).chr(92)."'",
						),
						$texte);
/*
	if (!get_magic_quotes_gpc())
	{
		$texte=str_replace(
						array(
								chr(92)."'",
								chr(92).chr(92).'"',
								chr(92).chr(92)."'",
							),
						array(
								chr(92).chr(92)."'",
								'"',
								"'",
							),
							$texte);
	}
	else
	{
		$texte=str_replace(
						array(
								chr(92),
								chr(92).chr(92).'"',
								chr(92).chr(92)."'",
								chr(92).chr(92).chr(92).'"',
								chr(92).chr(92).chr(92)."'",
							),
						array(
								chr(92).chr(92),
								chr(92).chr(92).chr(92).chr(92).'"',
								chr(92).chr(92).chr(92).chr(92)."'",
								'"',
								"'",
							),
							$texte);
		$texte = stripslashes($texte);
	}
*/
	static $IdCodePHP = 0;
	$IdCodePHP++;
	global $K_BbcodeOptions;

	$K_BbcodeOptions = unserialize($K_BbcodeOptions);
	if (get_grade()>= $K_BbcodeOptions['GrCodePhpBouton'] AND $K_BbcodeOptions['GrCodePhpBouton'] != -2)
	{
		//$TexteOri = str_replace(chr(92).'"','"',$TexteOri);
		$FormClic = '<input type="hidden" id="PrevCode'.$IdCodePHP.'" value="'.base64_encode(trim($TexteOri)).'" />
		ou <input type="button" name="PrevCode'.$IdCodePHP.'" value=" Cliquez ici " onclick="javascript:popupcentre(\'./includes/code.php?id=\'+this.name,\'CodePHP\',\'650\',\'350\',\'no\')" />
		';
	}
	$K_BbcodeOptions = serialize($K_BbcodeOptions);

	$style_codePHP	= 'style="border-bottom:1px solid; padding-bottom:5px; font-weight:bold; font-size:15px; font-style:italic; font-variant:small-caps; font-family: Arial;text-align:center;"';
	$TextCite = '<div '.$style_codePHP.' class="code_php_citer">Pour copier le contenu exact du code,<br />Veuillez citer le message'.$FormClic.'</div>';

	$rand=0;
	if(strpos($texte ,'<?')===FALSE && strpos($texte ,'?>')===FALSE)
	{
		$rand =1;
		$texte ='<?php  '."\n#####!!!#####\n\n".$texte ."\n\n#####!!!#####\n".'?>';
	}

	include_once('PHP_Highlight.php');
	$h=new PHP_Highlight();
	$h->loadString($texte);
	$texte=$h->toList(true);

//	$texte = highlight_string($texte, true);

	if(!$rand)
	{
//		$texte = preg_replace('/.*\/\/!!!!!<\/span><\/code><\/li>(.*?)<li><code><span style="color\: .{0,8}\;">\/\/!!!!!.*/is','<ol>\1</ol>',$texte );
		$texte = preg_replace('`.*#####!!!#####</span></code></li>(.*?)<li><code><span style="color\: .{0,8}\;">#####!!!#####.*`is','<ol>$1</ol>',$texte );
	}

	return $TextCite.$texte;

}

?>
