<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: install.php 926 2011-05-17 11:20:57Z mike007 $
// ---------------------------------------------------------------
// Par Nico_ (nico@koogar.org) le 25/07/05
// Mise a jour : 10/10/07 par mike007
// ---------------------------------------------------------------

// Script d'installation
$Version_Rev = '1.6.925';
$install_titre = '<h2 style="text-align:center;width:100%">Installation de KwsPHP  <span style="color:#009900">V'.$Version_Rev.'</span></h2><br />';

if (dirname(session_save_path())!='' && ini_get('safe_mode')=='-1')
{
	if (strpos(dirname(__FILE__),dirname(session_save_path()))!==FALSE)
	{
		$d=session_save_path();
		if(!file_exists($d))
		{
			mkdir($d);
			chmod($d,0777);
		}
		if(!file_exists($d.'/.htaccess'))
		{
			$fp=fopen($d.'/.htaccess','w');
			fwrite($fp,'Deny from all');
			fclose($fp);
			chmod($d.'/.htaccess',0777);
		}
	}
}
session_start();

error_reporting (E_ALL ^ E_NOTICE);
if (function_exists(date_default_timezone_set)) date_default_timezone_set('Europe/Paris');

// Controle url tapes
if (isset($_POST['step']) and $_POST['step'] >= 0 and $_POST['step'] < 10)
{
	$step = intval($_POST['step']);
}
elseif (isset($_POST['step2']))
{
	$step = intval($_POST['step2']);
}
else
{
	$step = 1;
}

// Chargement de la langue
require_once './langues/config_lang.php';

// Inclusion du fichier class
chdir('../');
require_once './includes/class.install.php';
chdir('install');

// Ouverture de la class des fonctions
$class_install = new install;

// Boucle tape 3 si licence non accepte
if((isset($_SESSION['okilicense']) && $_SESSION['okilicense']===TRUE ) || (isset($_POST['oklicence']) && $_POST['oklicence']=='on'))
{
	$_SESSION['okilicense']=TRUE;
}
else
{
	$_SESSION['okilicense']=FALSE;
}
if($step>3 && !$_SESSION['okilicense'])
{
	$step	= 3;
	$alerte	= '<span style="color:red;font-weight:bold;font-size:14px;padding-right:3em">Vous devez accepter la licence pour continuer !</span>';
}

// Affichage de la barre des tapes  gauche
if ($step != 0)
{
	$step_array		= array(STEP_1, STEP_2, STEP_3, STEP_4, STEP_5, STEP_6, STEP_7);
	$install_menu	= $class_install->aff_step($step, $step_array);
}

$install_no=0;

// ---------------------------------------------------------
// ETAPE 0 : Choix de la langue
// ---------------------------------------------------------
if ($step == 0)
{
	$install_contenu = '
	<p style="text-align:center">
	Langue <select name="langue">';

	$dir = opendir('langues');
	while (($file = readdir($dir)) != false)
	{
		$info = pathinfo($dir.'/'.$file);
		if ($info['extension'] == 'php')
		$install_contenu .= '<option value="'.substr($file, 0, strlen($file)-4).'">'.strtoupper(substr($file, 0, 1)).substr($file, 1, strlen($file)-5).'</option>';
	}

	$install_contenu .= '</select>
	</p><br />
	&copy; KwsPHP - All rights reserved';

	$install_form1 = '<form method="post" action="install.php" name="form1">';

	$install_form2 = '';

	$install_button = '<input type="submit" value=" Continue " />';
}

// ---------------------------------------------------------
// ETAPE 1 : Prsentation
// ---------------------------------------------------------
elseif ($step == 1)
{
	$install_contenu =
	_1_TEXT_1.'
	<p>'._1_TEXT_2.'</p>';

	$install_form1 = '';

	$install_form2 = '
	<form method="post" action="install.php" name="form1">
	<input type="hidden" name="langue" value="'.htmlentities($_POST['langue']).'" />';

	if (file_exists ('../connect.php'))
	{
		$install_contenu .= '
		<div style="color:#cc3300;font-weight:bold;text-align:center;font-variant:small-caps">
		'._1_ERREUR_1.'<br /><br />
		'._1_ERREUR_2.'<br /><br />
		'._1_ERREUR_3.'<br /><br />
		</div>';

		$install_button = '<input type="hidden" name="step" value="1" />
		<input type="submit" value=" '.TEST.' " /></div></form>
		<form  method="post" action="install.php" name="form1b">
		<div style="text-align:right">
		<input type="hidden" name="langue" value="'.htmlentities($_POST['langue']).'" />
		<input type="hidden" name="step" value="2" />
		<input type="submit" value=" '.OVERTEST.' " />';
	}
	else
	{
		$install_contenu .= '
		<p>'._1_TEXT_3.'</p>';

		$install_button = '<input type="submit" value=" '.SUIVANT.' " />';
	}
	session_destroy();
	unset($_SESSION);
}

// ---------------------------------------------------------
// ETAPE 2 : configuration
// ---------------------------------------------------------
elseif ($step == 2)
{
	include './config_server.php';
}

// ---------------------------------------------------------
// ETAPE 3 : licence
// ---------------------------------------------------------
elseif ($step == 3)
{
	if (isset($_SESSION['okilicense'])) unset($_SESSION['okilicense']);

	$install_contenu = '
	<script type="text/javascript">
	// <![CDATA[
		function verif_form()
		{
			if(window.document.form1.oklicence.checked == false)
			{
				alert ("Vous devez accepter la licence pour continuer");
				return false;
			}
			else
			{
				return true; //document.form1.submit();
			}
		}
	// ]]>
	</script>

	'.$alerte.'
	<p style="font-weight:bold">Licence</p>
	<br />
	<div style="text-align:center">
		<iframe src="./opl.html" class="license" frameborder="0" scrolling="auto"></iframe>
		<p><input type="checkbox" name="oklicence"  />'._3_TEXT_1.'</p>
	</div>
	<br />';

	$install_form1 = '
	<form method="post" action="install.php" name="form1" onsubmit="return verif_form()">';

	$install_form2='';

	$install_button = $alerte.'
	<input type="hidden" name="langue" value="'.htmlentities($_POST['langue']).'" />
	<input type="submit" value=" '.SUIVANT.' " name="s1" />';
}

// ---------------------------------------------------------
// ETAPE 4 : connexion
// ---------------------------------------------------------
elseif ($step == 4)
{
	$install_contenu = '
	<script type="text/javascript">
	// <![CDATA[
		function verif_form()
		{
			var u_serv = window.document.form1.serveur.value;
			var u_login = window.document.form1.login.value;
			var u_bdd = window.document.form1.bdd.value;

			if(u_serv == "")
			{
				alert ("Entrer le nom du serveur");
			}
				else if(u_login == "")
			{
				alert ("Entrer un login");
			}
			else if(u_bdd == "")
			{
				alert ("Entrer une base de donne");
			}
			else
			{
				return true; //document.form1.submit();
			}

			return false;
		}
	// ]]>
	</script>
	<noscript><p style="text-align:center;font-style:italic">Javascript d&eacute;sactiv&eacute; ou non support&eacute;.<br />Certaines fonctionnalit&eacute;s sont donc inaccessibles.</p></noscript>

	<p>
	<strong>'._4_TEXT_1.'</strong><br />
	<br />
	</p>
  <p>'._4_TEXT_2.'</p><br />

				<table style="width:50%; margin-left:150px;" class="cadre" summary="cadre">
					<tr>
						<td colspan="2"><b>'._4_TEXT_3.'</b></td>
					</tr>
					<tr>
						<td>'._4_TEXT_4.'</td>
						<td><input type="text" name="serveur" value="localhost" /></td>
					</tr>
					<tr>
						<td>'._4_TEXT_5.'</td>
						<td><input type="text" name="login" value="root" /></td>
					</tr>
					<tr>
						<td>'._4_TEXT_6.'</td>
						<td><input type="password" name="pass" value="" /></td>
					</tr>
					<tr>
						<td>'._4_TEXT_7.'</td>
						<td><input type="text" name="bdd" value="" /></td>
					</tr>
					<tr>
						<td colspan="2"><br /></td>
					</tr>
				</table>
	<br />';

	$install_form1 = '
	<form method="post" action="install.php" name="form1" onsubmit="return verif_form()">';

	$install_form2='';

	$install_button = $alerte.'
	<input type="hidden" name="langue" value="'.htmlentities($_POST['langue']).'" />
	<input type="submit" value=" '.SUIVANT.' " name="s1" />';
}

// ---------------------------------------------------------
// ETAPE 5 : parametres
// ---------------------------------------------------------
elseif ($step == 5)
{
	$step6 = (isset($_POST['step6']) || $_POST['step6']=='ok') ? true : false;

	if (!empty($_POST['serveur']) && !empty($_POST['login']) && !empty($_POST['bdd']) && !$step6)
	{

		// Tentative de connection a la base avec les parametres fournis
		$install_result_connectdb = @mysql_connect($_POST['serveur'], $_POST['login'], $_POST['pass']);
		require_once '../includes/traitement_variable.php';
		$install_result_selectdb  = @mysql_selectdb($_POST['bdd']);

		if (!$install_result_selectdb)
		{
			//Tentative de creation de la base
			$install_result_selectdb = @reqmysql('CREATE DATABASE `'.$_POST['bdd'].'`; ');
			$install_result_selectdb = @mysql_selectdb($_POST['bdd']);
		}

		if ($install_result_connectdb and $install_result_selectdb)
		{
			$_SESSION['install_type'] = 'all';

			// Creation du fichier connect.php
			$cc_result = $class_install->create_connect($_POST['serveur'], $_POST['login'], $_POST['pass'], $_POST['bdd']);

			// Si c'est bon, on installe les tables du moteur
			if (($_SESSION['install_type'] == 'all' or $_SESSION['install_type'] == 'table') and $cc_result)
			{
				$install_sql_result = $class_install->querry_sql_file('install.sql', FALSE);
			}
			else
			{
				$install_sql_result = true;
			}

			if (substr(mysql_get_server_info(), 0, 3) < '4.1')
			{
				$install_contenu = '
				<span style="color:#cc3300">'._5_TEXT_19_2.' '.substr(mysql_get_server_info(), 0, 3).'.<br /><br />'._5_TEXT_19_3.' '.(mysql_get_server_info()=='' ? ''._5_TEXT_19_5.'':''._5_TEXT_19_4.'').'</span>';
			}
			else
			{
				$install_mysql = _5_TEXT_19_6;
			}
		}
	}
	elseif (!$step6)
	{
		$install_contenu = '
		<span style="color:#cc3300">'._5_TEXT_19_1.'</span>';
	}

	if (($install_sql_result && $cc_result && empty($install_contenu)) || $step6)
	{
		// Formulaire des parametres
		$install_contenu = '
		<script type="text/javascript">
		// <![CDATA[
			function verif_form(envoyer)
			{
				var u_pseudo =		window.document.form1.user_pseudo.value;
									window.document.form1.user_pseudo.style.borderColor ="green";
				var u_pass =		window.document.form1.user_pass.value;
									window.document.form1.user_pass.style.borderColor ="green";
				var u_pass_verif =	window.document.form1.user_pass_verif.value;
									window.document.form1.user_pass_verif.style.borderColor ="green";
				var u_email =		window.document.form1.user_email.value;
									window.document.form1.user_email.style.borderColor ="green";
				var u_url =			window.document.form1.site_url.value;
									window.document.form1.site_url.style.borderColor ="green";
				var u_exp =			window.document.form1.mail_exp.value;
									window.document.form1.mail_exp.style.borderColor ="green";
				var u_exp_adr =		window.document.form1.mail_adresse.value;
									window.document.form1.mail_adresse.style.borderColor ="green";
				var message = "";

				if (u_pseudo.length <3)
				{
					if (message =="") message = "Remplissez le champ pseudo de l\'admin d\'au moins 3 caractres";
					window.document.form1.user_pseudo.style.borderColor ="red";
				}
				if (u_pass.length <5)
				{
					if (message =="") message = "Le champ mot de passe doit tre compos de 5 caractres au minimum";
					window.document.form1.user_pass.style.borderColor ="red";
				}
				if (u_pass_verif.length <5)
				{
					if (message =="") message = "Le champ mot de passe de vrification doit tre compos de 5 caractres au minimum";
					window.document.form1.user_pass_verif.style.borderColor ="red";
				}
				if (u_pseudo == u_pass)
				{
					if (message =="") message = "Vous devez avoir un pseudo et un mot de passe diffrent";
					window.document.form1.user_pass.style.borderColor ="red";
				}
				if (u_pass_verif != u_pass)
				{
					if (message =="") message = "Vous n\'avez pas renseign le mme mot de passe";
					window.document.form1.user_pass_verif.style.borderColor ="red";
				}

				var bool_email = false;
				for (var j=1 ; j<(u_email.length) ; j++)
				{
					if (u_email.charAt(j)==\'@\')
					{
						if (j<(u_email.length-4))
						{
							for (var k=j ; k<(u_email.length-2) ; k++)
							{
								if (u_email.charAt(k)==\'.\')
								{
									bool_email = true;
								}
							}
						}
					}
				}
				if (!bool_email)
				{
					if (message =="") message = "Remplissez le champ email de l\'admin";
					window.document.form1.user_email.style.borderColor ="red";
				}
				if(u_url.substr(0,7)!="http://" || u_url.substr(u_url.length-1,1)!="/" || u_url.length<9 )
				{
					if (message =="") message = "Remplissez le champ URL du site";
					window.document.form1.site_url.style.borderColor ="red";
				}

				if (document.forms.form1.mail_type.value == "off")
					document.getElementById("warning_mail").style.display = "block";
				else
					document.getElementById("warning_mail").style.display = "none";

				if (u_exp.length <3)
				{
					if (message =="") message = "Remplissez le champ Expditeur d\'au moins 3 caractres";
					window.document.form1.mail_exp.style.borderColor ="red";
				}
				var bool_email2 = false;
				for (var j=1 ; j<(u_exp_adr.length) ; j++)
				{
					if (u_exp_adr.charAt(j)==\'@\')
					{
						if (j<(u_exp_adr.length-4))
						{
							for (var k=j ; k<(u_exp_adr.length-2) ; k++)
							{
								if (u_exp_adr.charAt(k)==\'.\')
								{
									bool_email2 = true;
								}
							}
						}
					}
				}
				if (!bool_email2)
				{
					if (message =="") message = "Remplissez le champ email de l\'expditeur";
					window.document.form1.mail_adresse.style.borderColor ="red";
				}

				if (envoyer)
				{
					if (message == "")
					{
						return true;
					}
					else
					{
						alert(message);
						return false;
					}
				}
			}
			// Fonction de vrification de frappes mdp
			function verif_frappe()
			{
				var pass = window.document.form1.user_pass.value;
				var pass_verif = window.document.form1.user_pass_verif.value;
				if (pass.length < 5)
				{
					window.document.form1.user_pass.style.borderColor ="red";
				}
				else
				{
					window.document.form1.user_pass.style.borderColor ="green";
				}
				if (pass_verif != pass || pass_verif.length < 5)
				{
					window.document.form1.user_pass_verif.style.borderColor ="red";
				}
				else
				{
				}
			}

			//  script trouv sur http://www.phpfrance.com/forums/voir_reponse-212801.php
			function testPassword(passwd)
			{
				var description = new Array();
				description[0] = "<input style=\'text-align:center; background-color:#FF6F6F; color:#cFcFcF;\' value=\'Insuffisant\' disabled=\'disabled\' \/><br\/>";
				description[1] = "<input style=\'text-align:center; background-color:#FDB14D; color:#adadad;\' value=\'Faible\' disabled=\'disabled\' \/><br\/>";
				description[2] = "<input style=\'text-align:center; background-color:blue; color:#adadad;\' value=\'Moyen\' disabled=\'disabled\' \/><br\/>";
				description[3] = "<input style=\'text-align:center; background-color:cyan; color:#adadad;\' value=\'Bon\' disabled=\'disabled\' \/><br\/>";
				description[4] = "<input style=\'text-align:center; background-color:#A0DA54; color:#adadad;\' value=\'Optimal\' disabled=\'disabled\' \/><br\/>";
				description[5] = "";
				var intScore   = 0
				var strVerdict = 0

				// PASSWORD LENGTH
				if (passwd.length==0 || !passwd.length)		// length 0
				{
					intScore = -1
				}
				else if (passwd.length>0 && passwd.length<5) // length between 1 and 4
				{
					intScore = (intScore+3)
				}
				else if (passwd.length>4 && passwd.length<8) // length between 5 and 7
				{
					intScore = (intScore+8)
				}
				else if (passwd.length>7 && passwd.length<12)// length between 8 and 15
				{
					intScore = (intScore+12)
				}
				else if (passwd.length>11)                    // length 16 or more
				{
					intScore = (intScore+18)
				}

				// LETTERS (Not exactly implemented as dictacted above because of my limited understanding of Regex)
				if (passwd.match(/[a-z]/))                              // [verified] at least one lower case letter
				{
					intScore = (intScore+3)
				}

				if (passwd.match(/[A-Z]/))                              // [verified] at least one upper case letter
				{
					intScore = (intScore+8)
				}

				// NUMBERS
				if (passwd.match(/d+/))                                 // [verified] at least one number
				{
					intScore = (intScore+8)
				}

				if (passwd.match(/(.*[0-9].*[0-9].*[0-9])/))             // [verified] at least three numbers
				{
					intScore = (intScore+5)
				}

				// SPECIAL CHAR
				if (passwd.match(/.[!,@,#,$,%,^,&,*,?,_,~]/))            // [verified] at least one special character
				{
					intScore = (intScore+8)
				}

				// [verified] at least two special characters
				if (passwd.match(/(.*[!,@,#,$,%,^,&,*,?,_,~].*[!,@,#,$,%,^,&,*,?,_,~])/))
				{
					intScore = (intScore+5)
				}

				// COMBOS
				if (passwd.match(/([a-z].*[A-Z])|([A-Z].*[a-z])/))        // [verified] both upper and lower case
				{
					intScore = (intScore+2)
				}

				if (passwd.match(/(d.*D)|(D.*d)/))                    // [FAILED] both letters and numbers, almost works because an additional character is required
				{
					intScore = (intScore+2)
				}

				// [verified] letters, numbers, and special characters
				if (passwd.match(/([a-zA-Z0-9].*[!,@,#,$,%,^,&,*,?,_,~])|([!,@,#,$,%,^,&,*,?,_,~].*[a-zA-Z0-9])/))
				{
					intScore = (intScore+12)
				}


				if(intScore == -1)
				{
					strVerdict = description[5];
				}
				else if(intScore > -1 && intScore < 16)
				{
					strVerdict = description[0];
				}
				else if (intScore > 15 && intScore < 25)
				{
					strVerdict = description[1];
				}
				else if (intScore > 24 && intScore < 35)
				{
					strVerdict = description[2];
				}
				else if (intScore > 34 && intScore < 45)
				{
					strVerdict = description[3];
				}
				else
				{
					strVerdict = description[4];
				}

				document.getElementById("Words").innerHTML= (strVerdict);
			}
		// ]]>
		</script>
		<noscript><p style="text-align:center;font-style:italic">Javascript d&eacute;sactiv&eacute; ou non support&eacute;.<br />Certaines fonctionnalit&eacute;s sont donc inaccessibles.</p></noscript>
		';

		if (!$step6)
		{
			$install_contenu .= '
			<span style="color:#009900">'.$install_mysql.'</span><br />
			<br />
			<span style="color:#009900">'._5_TEXT_1.'</span><br />
			<br />
			<span style="color:#009900">'._5_TEXT_2.'</span><br />
			<br />';
		}
		$install_contenu .= '
		<h3>Param&egrave;tres du portail</h3>
		<br />
		<table style="width:100%; border:none" summary="table">
			<tr>
				<td valign="top">
					<b>'._5_TEXT_3.'</b><br />
					<br />
					'._5_TEXT_4.'
				</td>
				<td width="50%">
					<table class="cadre" summary="cadre">
						<tr>
							<td>'._5_TEXT_5.'</td>
							<td align="right"><input type="text" name="user_pseudo" onkeyup="verif_form(false);" /></td>
						</tr>
						<tr>
							<td>'._5_TEXT_6.'</td>
							<td align="right"><input type="password" name="user_pass" onkeyup="verif_form(false);testPassword(this.value);" /></td>
						</tr>
						<tr>
							<td>Niveau de s&eacute;curit&eacute;</td>
							<td align="right"><span id="Words"><input value="" disabled="disabled" /></span></td>
						</tr>
						<tr>
							<td>'._5_TEXT_25.'</td>
							<td align="right"><input type="password" name="user_pass_verif" onkeyup="verif_form(false);"/></td>
						</tr>
						<tr>
							<td>'._5_TEXT_7.'</td>
							<td align="right"><input type="text" name="user_email" onkeyup="verif_form(false);" /></td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td colspan="2"><br /></td>
			</tr>
			<tr>
				<td valign="top">
					<b>'._5_TEXT_8.'</b><br />
					<br />
					'._5_TEXT_9.'
				</td>
				<td width="50%">
					<table class="cadre" summary="cadre">
						<tr>
							<td>'._5_TEXT_10.'</td>
							<td align="right"><input type="text" name="site_name" /></td>
						</tr>
						<tr>
							<td>'._5_TEXT_11.'</td>
							<td align="right"><input type="text" name="site_desc" /></td>
						</tr>
						<tr>
							<td>'._5_TEXT_12.'</td>
							<td align="right"><input type="text" name="site_url" value="http://'.dirname(dirname($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'])).'/" onkeyup="verif_form(false);" /></td>
						</tr>
						<tr>
							<td>'._5_TEXT_13.'</td>
							<td align="right"><textarea name="site_copyrights" rows="2" cols="20">R&eacute;alis&eacute; avec KwsPHP (vous pouvez mettre vos copyrights &agrave; cet emplacement)</textarea></td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td colspan="2"><br /></td>
			</tr>
			<tr>
				<td valign="top">
					<b>'._5_TEXT_14.'</b><br />
					<br />
					'._5_TEXT_15.'
					<div id="warning" style="display:none">'._5_TEXT_15_1.'</div>
					</td>
				<td width="50%">
					<table class="cadre" summary="cadre">
						<tr>
							<td>'._5_TEXT_16.'</td>
							<td align="right">
								<select name="mail_type" onchange="verif_form(false);">
									<option value="php">Fonction mail php</option>
									<option value="off">Pas d\'envoi</option>
								</select>
							</td>
						</tr>
						<tr>
							<td>'._5_TEXT_17.'</td>
							<td align="right"><input type="text" name="mail_exp" onkeyup="verif_form(false);"/></td>
						</tr>
						<tr>
							<td>'._5_TEXT_18.'</td>
							<td align="right"><input type="text" name="mail_adresse" onkeyup="verif_form(false);"/></td>
						</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td colspan="2"><br /></td>
			</tr>
			<tr>
				<td valign="top"></td>
				<td width="50%"></td>
			</tr>
		</table>
		<br />';

		$install_form1='<form method="post" action="install.php" name="form1" onsubmit="return verif_form(true)">';

		$install_form2='';

		$install_button = '
		<input type="hidden" name="langue" value="'.htmlentities($_POST['langue']).'" />
		<input type="submit" value=" '.SUIVANT.' " />';
	}
	else
	{
		// Si c'est pas bon, on retourne a l'etape 4
		$install_menu=$class_install->aff_step(4, $step_array);
		$step = 3;

		$install_form1='';
		$install_form2='
		<form method="post" action="install.php" name="form1">';
		$install_button = '
		<input type="hidden" name="langue" value="'.htmlentities($_POST['langue']).'" />
		<input type="submit" value=" '.RETOUR.' " />';

		if (empty($install_contenu))
		{
			if (!$install_result_connectdb)
			{
				// Erreur connexion serveur
				$install_contenu = '
				<span style="color:#cc3300">'._5_TEXT_22.' \''.$_POST['serveur'].'\' '._5_TEXT_23.' \''.$_POST['login'].'\'</span><br />';
			}
			elseif (!$install_result_selectdb)
			{
				// Erreur selection base
				$install_contenu = '
				<span style="color:#cc3300">'._5_TEXT_24.' \''.$_POST['bdd'].'\'</span><br />';
			}
			elseif (!$install_sql_result)
			{
			 	// Erreur creation tables
				$install_contenu = '
				<span style="color:#cc3300">
				'._5_TEXT_20.'<br />
					<br />'.mysql_error().'
				</span>
				<br />';
			}
			elseif (!$cc_result)
			{
				// Erreur cration connect.php
				$install_contenu = '
				<span style="color:#cc3300">'._5_TEXT_21.'</span><br />';
			}
		}
		$install_contenu = ERREUR.' :<br />
		<br />
		'.$install_contenu;
	}
}

// ---------------------------------------------------------
// ETAPE 6 : parametres suite
// ---------------------------------------------------------
elseif ($step == 6)
{
	// Controle des parametres fournis
	$atom	= '[-a-z0-9!#$%&\'*+\\/=?^_`{|}~]';		// caractres autoriss avant l'arobase
	$domain = '([a-z0-9]([-a-z0-9]*[a-z0-9]+)?)';	// caractres autoriss aprs l'arobase (nom de domaine)

	$regex = '/^' . $atom . '+' .					// Une ou plusieurs fois les caractres autoriss avant l'arobase
	'(\.' . $atom . '+)*' . 						// Suivis par zro point ou plus
													// spars par des caractres autoriss avant l'arobase
	'@' .											// Suivis d'un arobase
	'(' . $domain . '{1,63}\.)+' .					// Suivis par 1  63 caractres autoriss pour le nom de domaine
													// spars par des points
	$domain . '{2,63}$/i';							// Suivi de 2  63 caractres autoriss pour le nom de domaine

	if (!isset($_POST['user_pseudo']) || strlen($_POST['user_pseudo'])<3 ||
		!isset($_POST['user_pass']) || strlen($_POST['user_pass'])<5 || $_POST['user_pass']!=$_POST['user_pass_verif'] ||
		!isset($_POST['user_email']) || !preg_match($regex, $_POST['user_email']))
	{
		$install_contenu = '
		<span style="color:#cc3300">'._6_TEXT_1.'</span><br />';
	}
	if (!isset($_POST['site_url']))
	{
		$install_contenu .= '<br />
		<span style="color:#cc3300">'._6_TEXT_2.'</span><br />';
	}

	if ((!isset($_POST['mail_exp']) || strlen($_POST['mail_exp'])<3) &&
		(!isset($_POST['mail_adresse']) || !preg_match($regex, $_POST['mail_adresse'])))
	{
		$install_contenu .= '<br />
		<span style="color:#cc3300">'._6_TEXT_2b.'</span><br />';
	}

	if ($install_contenu != '')
	{
		$install_menu = $class_install->aff_step(5, $step_array);
		$install_contenu = ERREUR.' :<br />
		<br />
		'.$install_contenu;

		$step = 4;

		$install_form1='
		<form method="post" action="install.php" name="form1">';

		$install_form2='';

		$install_button = '
		<input type="hidden" name="langue" value="'.htmlentities($_POST['langue']).'" />
		<input type="hidden" name="step6" value="ok" />
		<input type="submit" value=" '.RETOUR.' " name="sbutton" />';
	}
	else
	{
		chdir('../');
		require_once './connect.php';
		include_once './includes/fonctions.php';
		chdir('install/');

		// Installation des parametres
		if ($_SESSION['install_type'] == 'data' or $_SESSION['install_type'] == 'all')
		{
			// Parametres
			reqmysql('INSERT INTO `parametres` SET `nom`="nom_page", `valeur`="'.sp($_POST['site_name']).'" '); 
			reqmysql('INSERT INTO `parametres` SET `nom`="description", `valeur`="'.sp($_POST['site_desc']).'" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="url_site", `valeur`="'.sp($_POST['site_url']).'" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="copyrights", `valeur`="'.sp($_POST['site_copyrights']).'" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="email_type", `valeur`="'.sp($_POST['mail_type']).'" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="expediteur", `valeur`="'.sp($_POST['mail_exp']).'" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="email_expediteur", `valeur`="'.sp($_POST['mail_adresse']).'" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="distribution", `valeur`="KwsPHP '.$Version_Rev.'" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="distribution_pre_copy", `valeur`="Propuls par" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="distribution_versions", `valeur`="-'.$Version_Rev.'" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="distribution_page_gen", `valeur`="1" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="distribution_image", `valeur`="" ');
			reqmysql('INSERT INTO `parametres` SET `nom`="theme", `valeur`="kwsday" ');
			// administrateur
			reqmysql('INSERT INTO `users` SET `id`="1", `pseudo`="'.sp($_POST['user_pseudo']).'", `pass`="'.md5(sp($_POST['user_pass'])).'", `grade`="4", `email`="'.sp($_POST['user_email']).'", `theme`="kwsday", `date`="'.time().'", `avatar`="./images/avatars/upload/quiestce.png", `date_der_connec`="'.time().'" ');
			reqmysql('INSERT INTO `users_cplt` SET `id_pseudo`="1", `nom`="'.sp($_POST['user_pseudo']).'"');
			reqmysql('INSERT INTO `parametres` SET `nom`="K_expediteurMP", `valeur`="1" ');
			reqmysql('INSERT INTO `users` SET `id`="2", `pseudo`="Ancien membre", `date`="'.time().'", `avatar`="./images/avatars/upload/nophoto.png", `date_der_connec`="'.time().'"');
			reqmysql('INSERT INTO `users_cplt` SET `id_pseudo`="2", `nom`="Anonyme"');
			//connection automatique au site
			setcookie ('sql_pseudo', $_POST['user_pseudo'], time()+3600, substr(str_replace('http://','',$_POST['site_url']),strpos(str_replace('http://','',$_POST['site_url']),'/')));
			setcookie ('sql_pass', md5(sp($_POST['user_pass'])), time()+3600, substr(str_replace('http://','',$_POST['site_url']),strpos(str_replace('http://','',$_POST['site_url']),'/')));
			setcookie ('auto', 'off', time()+3600, substr(str_replace('http://','',$_POST['site_url']),strpos(str_replace('http://','',$_POST['site_url']),'/')));
		}

		$install_menu = $class_install->aff_step(5, $step_array);

		$install_contenu = '
		<p><b>'._6_TEXT_3.'<br /></p>
		<br />
		<div style="overflow: auto; width: 530px; height: 300px; border: solid 1px #4177bf;">';

		$mod_buffer='';

		// Parcourt du dossier module pour voir ce qu'il faut installer
		$mod_dir_op = ScannerRepertoire('../modules','dir', false);

		foreach ($mod_dir_op as $mod_rep)
		{
			if (is_dir('../modules/'.$mod_rep))
			{
				if (file_exists('../modules/'.$mod_rep.'/gestionnaire.txt'))
				{
					$mod_file_op=fopen('../modules/'.$mod_rep.'/gestionnaire.txt','r');

					$mod_buffer_2  = '<b>'.fgets($mod_file_op ,999).'</b><br />';	// Nom
					$mod_buffer_2 .= fgets($mod_file_op ,999);						// Description

					$inst_type1 = '';
					$inst_type2 = '';

					/*
					if (file_exists('../modules/'.$mod_rep.'/install.php'))
					$inst_type1 = 'PHP';
					*/
					if (file_exists('../modules/'.$mod_rep.'/install.sql'))
					$inst_type2 = 'MySQL';

					if ($inst_type1 != '' or $inst_type2 != '')
					$mod_buffer_2 .= '&nbsp;-&nbsp;Installation : '.$inst_type1.(($inst_type1 != '' and $inst_type2 != '') ? ' / ' : '').$inst_type2;

					$mod_ft = fgets($mod_file_op ,999);        // Obligatoire ou non

					fclose($mod_file_op);
				}
				else
				{
					$mod_ft = 0;
					$mod_buffer_2 = '<b>'.$mod_rep.'</b><br />Pas de description';
				}
				$mod_buffer .= '<input type="checkbox" name="module_'.$mod_rep.'" checked="checked" '.($mod_ft==1 ? 'disabled="disabled"': '').' />'.($mod_ft==1 ? '<input type="hidden" name="module_'.$mod_rep.'" value="on" />' : '').'&nbsp;'.$mod_buffer_2.'<br /><br />';
			}
		}

		$install_contenu .= $mod_buffer.'
		</div>';

		$install_form1 = '
		<form method="post" action="install.php" name="form1">';

		$install_form2='';

		$install_button = '
		<input type="hidden" name="langue" value="'.ax($_POST['langue']).'" />
		<input type="submit" value=" '.SUIVANT.' " name="sbutton" />';
		mysql_close();
	}
}

// ---------------------------------------------------------
// ETAPE 7 : installation des modules
// ---------------------------------------------------------
elseif ($step == 7)
{
	chdir('../');
	require_once './connect.php';
	include_once './includes/fonctions.php';
	chdir('install/');

	// Parcourt du dossier module pour voir ce qu'il faut installer
	$mod_dir_op = ScannerRepertoire('../modules','dir', false);
	$mod_log_i = '';
	$mod_log_u = '';

	foreach ($mod_dir_op as $mod_rep)
	{
		if (isset($_POST['module_'.$mod_rep]) && $_POST['module_'.$mod_rep] == 'on' and is_dir('../modules/'.$mod_rep))
		{
			// On install le module
			$mod_log_i .= $class_install->install_mod($mod_rep);
		}
		elseif (is_dir('../modules/'.$mod_rep))
		{
			// On install pas le module
			$class_install->uninstall_mod($mod_rep);
			$mod_log_u .= '
			<span style="color:#009900">Le module '.$mod_rep.' n\'a pas &eacute;t&eacute; install&eacute;. <strong>Vous pouvez supprimer</strong> le dossier "modules/'.$mod_rep.'" sans risques (c\'est m&ecirc;me vivement conseill&eacute;).</span><br />';
		}
	}
	$install_contenu .= $mod_log_u;
	$pos_0 = -1;
	$pos_1 = -1;
	$pos_menu = -1;
	if(isset($_POST['module_menu']) && $_POST['module_menu']=='on')
	{
		reqmysql('INSERT INTO `modules` SET `type`="bloc", `emplacement`="0", `position`="'.(++$pos_0).'", `module`="menu", `parametre1`="Menu gnral :", `parametre2`="non", `parametre3`="-1", `afficher`="1" ');
		reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="1", `position`="'.(++$pos_menu).'", `module`="lien", `parametre1`="Accueil", `parametre2`="./", `afficher`="-1" ');
		reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="1", `position`="'.(++$pos_menu).'", `module`="lien", `parametre1`="Les membres", `parametre2`="./index.php?mod=espace_membre&ac=memberlist", `afficher`="0" ');
		if($_POST['module_archives']=='on')	{reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="1", `position`="'.(++$pos_menu).'", `module`="lien", `parametre1`="Downloads", `parametre2`="./index.php?mod=download", `afficher`="0" ');}
		if($_POST['module_articles']=='on')	{reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="1", `position`="'.(++$pos_menu).'", `module`="lien", `parametre1`="Articles", `parametre2`="./index.php?mod=articles", `afficher`="0" ');}
		if($_POST['module_multi-faq']=='on'){reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="1", `position`="'.(++$pos_menu).'", `module`="lien", `parametre1`="FAQ", `parametre2`="./index.php?mod=multi-faq", `afficher`="0" ');}
		if($_POST['module_groupes']=='on')	{reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="1", `position`="'.(++$pos_menu).'", `module`="lien", `parametre1`="Groupes", `parametre2`="./index.php?mod=groupes", `afficher`="0" ');}
		reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="1", `position`="'.(++$pos_menu).'", `module`="lien", `parametre1`="Forum", `parametre2`="./index.php?mod=forum", `afficher`="-1" ');
		if($_POST['module_livredor']=='on')	{reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="1", `position`="'.(++$pos_menu).'", `module`="lien", `parametre1`="Livre d\'or", `parametre2`="./index.php?mod=livredor", `afficher`="-1" ');}
		reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="1", `position`="'.(++$pos_menu).'", `module`="separateur", `afficher`="4" ');
		reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="1", `position`="'.(++$pos_menu).'", `module`="lien", `parametre1`="Modifier le menu", `parametre2`="./index.php?mod=menu&id=1", `afficher`="4" ');
	}
	reqmysql('INSERT INTO `modules` SET `type`="bloc", `emplacement`="0", `position`="'.(++$pos_0).'", `module`="menu", `parametre1`="Gestion :", `parametre2`="non", `parametre3`="4", `afficher`="1" ');
	$Emplacement = mysql_insert_id();
	reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="'.$Emplacement.'", `position`="0", `module`="lien", `parametre1`="Administration", `parametre2`="./index.php?mod=espace_membre&ac=login&doss=admin", `afficher`="4" ');
	reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="'.$Emplacement.'", `position`="1", `module`="lien", `parametre1`="Gestion des Modules", `parametre2`="./index.php?mod=espace_membre&ac=login&doss=mod", `afficher`="4" ');
	reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="'.$Emplacement.'", `position`="2", `module`="lien", `parametre1`="Outils", `parametre2`="./index.php?mod=espace_membre&ac=login&doss=outils", `afficher`="4" ');
	reqmysql('INSERT INTO `modules` SET `type`="menu", `emplacement`="'.$Emplacement.'", `position`="3", `module`="lien", `parametre1`="Mon compte", `parametre2`="./index.php?mod=espace_membre&ac=login", `afficher`="4" ');

	if($_POST['module_forum']=='on')		{reqmysql('INSERT INTO `modules` SET `type`="bloc", `emplacement`="0", `position`="'.(++$pos_0).'", `module`="forum", `parametre1`="Forum :", `parametre2`="10", `parametre3`="Forum :", `parametre4`="1 bloc", `afficher`="1" ');}
	if($_POST['module_stats']=='on')		{reqmysql('INSERT INTO `modules` SET `type`="bloc", `emplacement`="0", `position`="'.(++$pos_0).'", `module`="stats", `parametre2`="1 bloc", `parametre3`="Non", `parametre4`="Oui", `afficher`="1" ');}
	if($_POST['module_espace_membre']=='on'){reqmysql('INSERT INTO `modules` SET `type`="bloc", `emplacement`="1", `position`="'.(++$pos_1).'", `module`="espace_membre", `parametre1`="Espace Membre :", `afficher`="1" ');}

	$install_menu=$class_install->aff_step(5, $step_array);

	$install_contenu .= '
	<script type="text/javascript">
	// <![CDATA[
		function open_p()
		{
			window.open(\'install_log.php\',\'\',\'width=600,height=600\');
		}
	// ]]>
	</script>
	<noscript><p style="text-align:center;font-style:italic">Javascript d&eacute;sactiv&eacute; ou non support&eacute;.<br />Certaines fonctionnalit&eacute;s sont donc inaccessibles.</p></noscript>

	<span style="color:#009900">'._7_TEXT_1.'</span><br />
	<br />
	'._7_TEXT_2.'
	<a href="javascript:open_p()"><b>'._7_TEXT_3.'</b></a>,  '._7_TEXT_4.'<br />
	<br />
	<br />
	<center><h3>'._7_TEXT_5.'</h3></center>
	<br />
	<br />
	<br />
	'._7_TEXT_6.'<br />';

	$_SESSION['install_log']='<h3>'._7_TEXT_7.'</h3>
	<br />
	'.$mod_log_i.'<br />
	<br />
	<h3>'._7_TEXT_8.'</h3>
	<br />
	'.$mod_log_u.'<br />
	<br />
	<p style="text-align:center;color:red;">Attention, l\'installation peut se r&eacute;v&eacute;ler longue.</p>';

	// Si possible, on ecrit un fichier txt avec le log
	if (is_writable('../'))
	{
		$connect_op = @fopen('../install_log.txt','w+');
		$connect_put = @fputs($connect_op, $_SESSION['install_log']);
		@ fclose($connect_op);
	}

	$install_form1='';

	$install_form2 = '
	<form method="post" action="install.php" name="form1">';

	$install_button = '
	<input type="hidden" name="langue" value="'.htmlentities($_POST['langue']).'" />
	<input type="submit" value=" '.SUIVANT.' " name="sbutton" />';
	mysql_close();
}

// ---------------------------------------------------------
// ETAPE 8 : Credits
// ---------------------------------------------------------
elseif ($step == 8)
{
	$install_menu=$class_install->aff_step (6, $step_array);

	$install_contenu='<center>
		'._8_TEXT_1.'<br />
		<br />
		<img src="./images/kwsphp.jpg" width="332" height="164" alt="logo" />
	</center>
	<br />
	'._8_TEXT_2.' :<br /><br />
			<table align="center" width="50%">
					<tr>
						<td><a href="mailto:ditch@kwsphp.org">Ditch</a>, </td>
						<td><a href="mailto:nico@kwsphp.org">Nico_</a>, </td>
						<td><a href="mailto:ripou@kwsphp.org">Philippe</a></td>
					</tr>
			</table>
	<br />
	'._8_TEXT_3.' :<br />
	<br />
			<table align="center" width="100%">
					<tr>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=1438" target="_blank">FouPouDave</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=12" target="_blank">Jack</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=5" target="_blank">Jacknikolson</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=51" target="_blank">Mala</a>,</td>
					</tr>
					<tr>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=87" target="_blank">Maxou</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=366" target="_blank">Mike007</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=1153" target="_blank">Otocinclus</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=3103" target="_blank">Ricky</a>,</td>
					</tr>
					<tr>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=150" target="_blank">Sexw@x</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=7132" target="_blank">Garveur</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=7277" target="_blank">Fifi69</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=6689" target="_blank">Julkien</a>,</td>
					</tr>
					<tr>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=3456" target="_blank">Karim10</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=18" target="_blank">Stefff</a>,</td>
						<td><a href="http://www.kwsphp.org/index.php?mod=espace_membre&amp;ac=profil&amp;id=20" target="_blank">Zeta</a></td>
					</tr>
			</table>
	<br />
	KwsPHP est bas sur PwsPHP version 1.2.3<br />
	<br />
	'._8_TEXT_13.'<br />
	<br />';

	$install_form1 = '
	<form method="post" action="install.php" name="form1">';

	$install_form2='';

	$install_button = '
	<input type="hidden" name="langue" value="'.htmlentities($_POST['langue']).'" />
	<input type="submit" value=" '.SUIVANT.' " name="sbutton" />';
}

// ---------------------------------------------------------
// ETAPE 9 : Fin
// ---------------------------------------------------------
elseif ($step == 9)
{
	require_once '../connect.php';
	$req = reqmysql('
		SELECT `valeur`
		FROM `parametres`
		WHERE `nom`="is_infoZ"
	');
	$rep = mysql_fetch_object($req);
	$action_finale = $rep->valeur==1 ? '?mod=infoZ&amp;ac=comparaison' : '';

	$install_menu=$class_install->aff_step(7, $step_array);

	$install_contenu='
	'._9_TEXT_1.'<br />
	<br />
	'._9_TEXT_2.' <a href="http://www.kwsphp.org/index.php?mod=liens_web">'._9_TEXT_3.'</a>.<br />
	<br />
	'._9_TEXT_4.' <a href="http://www.kwsphp.org/">KwsPHP.org</a>.<br />
	<br />
	<br />
	'._9_TEXT_5.'<br />
	<br />
	<br />
	'._9_TEXT_6;

	$install_form1='';

	$install_form2 = '
	<form method="post" action="../index.php'.$action_finale.'" name="form1">';

	$install_button = '
	<input type="submit" value=" '.TERMINER.' " name="sbutton" />';
	mysql_close();
}
ob_end_flush();
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	<title>Installation de KwsPHP version <?php echo $Version_Rev;?></title>
	<link rel="stylesheet" type="text/css" href="install.css" />
</head>

<body>
	<table class="tab_exterieur" summary="tab_exterieur">
		<tr>
			<td>
				<table class="tab_middle" summary="tab_middle">
					<tr>
						<td>
							<table class="tab_interne" summary="tab_interne">
								<tr>
									<td colspan="3">
										<img src="images/kwsphp2.jpg" width="266" height="75" align="middle" alt="Logo install" />
										<br /><br />
										Un portail en PHP cl&eacute; en main !
										<br /><br />
									</td>
								</tr>
								<tr>
									<td valign="top"><?php echo $install_menu; ?></td>
									<td width="2"> </td>
									<td width="85%" valign="top">
										<?php echo $install_form1; ?>
										<table bgcolor="#ffffff" style="width:100%; border: 1px solid #BCBCBC;" summary="install">
											<tr>
												<td valign="top"><?php echo $install_titre.$install_contenu; ?></td>
											</tr>
										</table>
										<?php echo $install_form2; ?>
										<input type="hidden" name="step" value="<?php echo $step+1; ?>" />
										<div align="right"><?php echo $install_button; ?></div>
										</form>
									</td>
								</tr>
							</table>
						</td>
					</tr>
				</table>
				<br />
				<div id="ckws"><a href="http://www.kwsphp.org/"> &copy; KwsPHP version <?php echo $Version_Rev;?></a></div>
			</td>
		</tr>
	</table>
</body>
</html>
