<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: update1.3.456_to_1.6.745.php 925 2011-05-14 11:27:11Z mike007 $
// ---------------------------------------------------------------
// Fait par mike007, FouPouDave
// ---------------------------------------------------------------

session_start();

$Version_Ant = '1.3.456';
$Version_Rev = '1.6.745';
$update_titre = '<h2 style="text-align:center;width:100%">Mise &agrave; jour de KwsPHP <span style="color:#cc3300">V'.$Version_Ant.'</span> vers <span style="color:#009900">V'.$Version_Rev.'</span></h2><br />';

if (file_exists ('../connect.php'))
{
	chdir('../');
	include 'connect.php';
	chdir('install');
}
else
{
	header ('Location: install.php');
}

// Controle url etapes
if (isset ($_POST['step2']))
{
	$step = $_POST['step2'];
}
elseif (isset ($_POST['step']) and $_POST['step'] >= 0 and $_POST['step'] <= 4 )
{
	$step = $_POST['step'];
}
else
{
	$step = 1;
}

// Chargement de la langue
require_once './langues/config_lang.php';

// Inclusion du fichier class
chdir('../');
require_once('includes/class.install.php');
require_once 'includes/traitement_variable.php';
chdir('install');
$class_install = new install ();

// Affichage de la barre des etapes a gauche
$step_array = array ('Configuration', 'Identification', 'Mise &agrave; jour', 'Terminer');
$update_menu = $class_install->aff_step ($step, $step_array);


if ($step == 1)
{
	include './config_server.php';
}
// Identification de l'admin
elseif ($step == 2)
{
	$req_lignes_distrib = reqmysql('
			SELECT	*
			FROM	`parametres`
			WHERE	`nom` = "distribution"
			OR		`nom` = "distribution_versions"
			OR		`nom` = "_IN_SVN"
			/*OR      `nom` = "url_site"*/
		');
	while ($ligne = mysql_fetch_object($req_lignes_distrib))
	{
		$recupligne[$ligne->nom] = $ligne->valeur;
	}

	if (file_exists('.svn') or file_exists('_svn'))
	{
		$recupligne['distribution'] = 'KwsPHP '.$Version_Ant;
	}

	if ($recupligne['distribution'] == 'KwsPHP '.$Version_Rev)
	{
		$update_form1 = '<form method="post" action="../" name="form1">';
		$update_contenu = 'Cette version est d&eacute;j&agrave; celle install&eacute;e.';
		$update_form2 = '';
		$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
	}
	elseif ($recupligne['distribution'] == 'KwsPHP '.$Version_Ant)
	{
		$update_form1 = '<form method="post" action="update'.$Version_Ant.'_to_'.$Version_Rev.'.php" name="form1">';

		$update_contenu = 'La version du portail disponible sur votre ftp est KwsPHP version '.$Version_Ant.'. Votre base de donn&eacute;es doit maintenant &ecirc;tre mise &agrave; jour.<br />
		<br /><br />'._1_TEXT_CGU.'
		<span style="color:#cc3300">Il est recommand&eacute; d\'effectuer une sauvegarde de la base MySQL</span><br />
		<br />
		<table class="cadre" summary="cadre">
			<tr>
				<td>Administrateur</td>
				<td><input type="text" name="pseudo1" value="'.$_POST['pseudo'].'" /></td>
			</tr>
			<tr>
				<td>Mot de passe</td>
				<td><input type="password" name="password" /></td>
			</tr>
		</table>';

		$liste_a_effacer = array(
			array('modules/agenda/antidroit.txt',true),
			array('modules/articles/antidroit.txt',true),
			array('modules/forum/erreur_flood_forum.php',true),
			array('modules/forum/erreur_forum.php',true),
			array('modules/forum/erreur_gr_forum.php',true),
			array('modules/forum/erreur_notopic_forum.php',true),
			array('modules/lien_web',true),
			array('modules/livredor/alerte.php',true),
			array('modules/ip',true),
			array('.htaccess',false),
			array('bbcode.js',true),
			array('erreur403.php',true),
			array('erreur404.php',true),
			array('Date_version.txt',true),
			array('erreur500.html',true),
			array('enregistrer.php',false),
			array('function.php',true),
			array('install.sql',false),
			array('login.php',false),
			array('logout.php',false),
			array('memberlist.php',false),
			array('parutions.php',false),
			array('perdu.php',false),
			array('profil.php',false),
			array('theme.php',false)
		);
		if(count($liste_a_effacer)>0)
		{
			foreach($liste_a_effacer as $id => $fichier)
			{
				if ($fichier[1])
				{
					@unlink('../'.$fichier[0]);
				}
				if (!file_exists('../'.$fichier[0]))
				{
					unset($liste_a_effacer[$id]);
				}
			}
		}

		$liste_a_verifier = array(
			'connect.php',
			'modules/infoZ/kwsphp.sql'
		);
		if(count($liste_a_verifier)>0)
		{
			foreach($liste_a_verifier as $id => $fichier)
			{
				if (file_exists('../'.$fichier))
				{
					unset($liste_a_verifier[$id]);
				}
			}
		}

		if (count($liste_a_effacer)>0)
		{
			$update_contenu .= '<div>';
			foreach ($liste_a_effacer as $id => $fichier)
			{
				$update_contenu .= '<div style="color:#990000">- Le fichier <strong>'.$fichier[0].'</strong> doit tre effac. Veuillez le supprimer manuellement du ftp.</div>';
				if ($fichier[0] == '.htaccess')
				{
					$update_contenu .= '<div style="color:green;margin-left:25px">Si vous avez des donn&eacute;es dans votre htaccess que vous avez rajout&eacute;s<br />
					-&gt; Supprimez-le pour l\'update en ayant pris soin de le sauvegarder.<br />
					-&gt; Faites l\'update et remettez-le en enlevez dans son contenu les lignes suivantes.
					<ul>
						<li>ErrorDocument 500 /erreur500.html</li>
						<li>ErrorDocument 403 /erreur403.php</li>
						<li>ErrorDocument 404 /erreur404.php</li>
					</ul></div>';
				}
			}
			$update_contenu .= '</div>';
			$update_button = '<input type="hidden" name="step2" value="1" />
			<input type="submit" value=" Retester " />';
		}
		elseif (count($liste_a_verifier)>0)
		{
			$update_contenu .= '<div>';
			foreach ($liste_a_verifier as $id => $fichier)
			{
				$update_contenu .= '<div style="color:#990000">- Le fichier <strong>'.$fichier.'</strong> est manquant. Veuillez le remettre manuellement sur le ftp.</div>';
			}
			$update_contenu .= '</div>';
			$update_button = '<input type="hidden" name="step2" value="1" />
			<input type="submit" value=" Retester " />';
		}
		else
		{
			$update_button = '<input type="hidden" name="sql_distribution_versions" value="'.$recupligne['distribution_versions'].'" />
			<input type="hidden" name="sql_url_site" value="'.$recupligne['url_site'].'" />
			<input type="hidden" name="int_IN_SVN" value="'.$recupligne['_IN_SVN'].'" />
			<input type="submit" value=" Continuer " />';
		}

		$update_form2 = '';
	}
	else
	{
		$update_form1 = '<form method="post" action="../" name="form1">';
		$update_contenu = 'Cette version n\'est pas support&eacute;e par le programme de mise &agrave; jour.';
		
		$update_form2 = '';
		$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
	}
}
elseif ($step == 3)
{
	$user_req = reqmysql('
		SELECT	`pass`, `grade`
		FROM	`users`
		WHERE	`pseudo` = "'.sp($_POST['pseudo1']).'"
	');
	$user_line = mysql_fetch_object ($user_req);

	$update_erreur = '';
	if (mysql_num_rows ($user_req) != 0)
	{
		if ($user_line->grade < 4)
		{
			$update_erreur = 'Vous n\'avez pas le grade requis pour lancer l\'update.';
		}
		elseif ($user_line->pass != md5(sp($_POST['password'])))
		{
			$update_erreur = 'Le mot de passe est incorrect.<input type="hidden" name="pseudo" value="'.$_POST['pseudo1'].'" />';
		}
	}
	else
	{
		$update_erreur = 'Pseudo administrateur incorrect.';
	}
	if (substr(mysql_get_server_info(), 0, 3) < '4.1')
	{
		$update_erreur = '
		<span style="color:#cc3300">'._5_TEXT_19_2.' '.substr(mysql_get_server_info(), 0, 3).'.<br /><br />'._5_TEXT_19_3.'</span>';
	}
	else
	{
		$update_mysql = _5_TEXT_19_4;
	}

	if ($update_erreur=='')
	{
		/*
		// cookie de connection
		$url_site = $_POST['sql_url_site'];

		setcookie ('sql_pseudo', $user_line->pseudo, time()+3600, substr(str_replace('http://','',$url_site),strpos(str_replace('http://','',$url_site),'/')));
		setcookie ('sql_pass', $user_line->pass, time()+3600, substr(str_replace('http://','',$url_site),strpos(str_replace('http://','',$url_site),'/')));
		setcookie ('auto', 'off', time()+3600, substr(str_replace('http://','',$url_site),strpos(str_replace('http://','',$url_site),'/')));
		*/

		$update_result = '';
		function update_query ($query, $erreur=true)
		{
			global $update_result;
			$update_test = reqmysql ($query, $erreur);
			if (! $update_test)
			{
				$update_result .= '<span style="color:red">Erreur de mise &agrave; jour lors de l\'execution de la requ&ecirc;te :</span><br />
				<span style="color:orange;">'.$query.'</span><br />
				<br />';
			}
			return $update_test;
		}

		$tables = reqmysql("SHOW TABLES;");
		while($tables_array = mysql_fetch_row($tables))
		{
			$liste_table[$tables_array[0]] = 'Oto je sais que tu ne vas pas aimer !';
		}

		// ------------------------------------------------
		// Mise a jour depuis la version antrieure
		// ------------------------------------------------
		// Lignes  conserver sans modification d'ici
		update_query ('UPDATE `parametres` SET `valeur` = "KwsPHP '.$Version_Rev.'" WHERE `nom` = "distribution";');
		if (!preg_match('#'.$Version_Rev.'#i',$_POST['sql_distribution_versions']))
		{
			update_query ('UPDATE `parametres` SET `valeur` = "'.$_POST['sql_distribution_versions'].'-'.$Version_Rev.'" WHERE `nom` = "distribution_versions";');
		}

		if (is_dir('../modules/infoZ'))
		{
			update_query("DROP TABLE IF EXISTS `infoz`;");
			$class_install->querry_sql_file('../modules/infoZ/kwsphp.sql', false);
		}
		// Lignes  conserver sans modification  ici (n'est ce pas mike !)

		function nettoyage($string)
		{
			while (eregi('^.+\\\.+$',$string))
			{
				$string = stripslashes($string);
			}
			return $string;
		}

		function table($table)
		{
			if ($table=='articles')
			{
				$champ = 'texte';
			}
			else
			{
				$champ = 'contenu';
			}

			$sql = reqmysql("
				SELECT		`id`, `titre`, `".$champ."`
				FROM		`".$table."`
				ORDER BY	`id` ASC
			");
			if(mysql_num_rows($sql) >0)
			{
				while($ligne = mysql_fetch_object($sql))
				{
					$titre = nettoyage($ligne->titre);
					$contenu = nettoyage($ligne->$champ);
					$contenu = str_replace('Edit&eacute;','Edit',$contenu);

					reqmysql('UPDATE `'.$table.'` SET `titre`="'.sp($titre).'", `'.$champ.'`="'.sp($contenu).'" WHERE `id`="'.$ligne->id.'";');
				}
			}
		}

		table('commentaires');
		
		// Priorit au module droit  cause des insertions, faut transformer la table avant
		// Module droit
		update_query("ALTER TABLE `droit` ADD `condition` ENUM( 'or', 'and' ) NOT NULL DEFAULT 'or' AFTER `groupe` ;");
		update_query("ALTER TABLE `droit_exclu` ADD `accessible` ENUM( '0', '1' ) NOT NULL DEFAULT '1' AFTER `page`;");

		// Admin
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="revalidation_regles"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='revalidation_regles', `valeur`='0';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="gestion_comptes_mail"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='gestion_comptes_mail', `valeur`='oui';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="gestion_comptes_avatar"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='gestion_comptes_avatar', `valeur`='oui';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="delai_supprime_auto"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='delai_supprime_auto', `valeur`='0';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="head_plus"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='head_plus', `valeur`='on';");
		}
		update_query ("DELETE FROM `parametres` WHERE `nom`='installed';");
		update_query ("DELETE FROM `parametres` WHERE `nom`='grd_forum';");
		update_query ("DELETE FROM `parametres` WHERE `nom`='upload';");
		update_query ('UPDATE `parametres` SET `valeur` = "off" WHERE `nom` = "avatars_ext";');
		update_query ('UPDATE `parametres` SET `valeur` = "0" WHERE `nom` = "up_avatars";');
		// rsolution du soucis avec debug
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="debug"'))== 0)
		{
			update_query("INSERT INTO `parametres` SET `nom`='debug', `valeur`='off';");
		}
		else
		{
			update_query("UPDATE `parametres` SET `valeur`='off' WHERE `nom`='debug';");
		}



		// Module afaire
		if (is_dir('../modules/afaire') and isset($liste_table['afaire']) and (!isset($liste_table['afaire_etat'])))
		{
			update_query("RENAME TABLE `afaire` TO `afaire_temp`;");

			update_query("DROP TABLE IF EXISTS `afaire`;");
			update_query("
				CREATE TABLE `afaire` (
				  `id` int(11) NOT NULL auto_increment,
				  `id_pseudo` int(11) NOT NULL default '0',
				  `titre` varchar(255) NOT NULL default '',
				  PRIMARY KEY  (`id`)
				) TYPE=MyISAM COMMENT='Module afaire : Liste des choses a faire' AUTO_INCREMENT=1;
			");

			update_query("DROP TABLE IF EXISTS `afaire_etat`;");
			update_query("
				CREATE TABLE `afaire_etat` (
				  `id_etat` int(11) NOT NULL auto_increment,
				  `id_tache` int(11) NOT NULL default '0',
				  `etat` int(3) default '0',
				  `date` int(11) default '0',
				  `commentaire` text default NULL,
				  PRIMARY KEY  (`id_etat`)
				) TYPE=MyISAM COMMENT='Module afaire : etat' AUTO_INCREMENT=1;
			");

			$requete = update_query("
				SELECT		`users`.`id`				AS id,
							`afaire_temp`.`titre`		AS titre,
							`afaire_temp`.`etat`		AS etat,
							`afaire_temp`.`date`		AS date,
							`afaire_temp`.`commentaire`	AS commentaire
				FROM		`afaire_temp`
				LEFT JOIN	`users`
					ON		`users`.`pseudo`=`afaire_temp`.`pseudo`
			");
			while ($ligne = mysql_fetch_object($requete))
			{
				update_query("
					INSERT INTO	`afaire`
					SET			`id_pseudo`='".sp($ligne->id)."',
								`titre`='".sp($ligne->titre)."'

				");
				update_query("
					INSERT INTO	`afaire_etat`
					SET			`id_tache`='".mysql_insert_id()."',
								`etat`='".sp($ligne->etat)."',
								`date`='".sp($ligne->date)."',
								`commentaire`='".sp($ligne->commentaire)."'
				");
			}
			update_query("DROP TABLE IF EXISTS `afaire_temp`;");

			update_query("INSERT INTO `parametres` SET `nom`='is_afaire', `valeur`='1';");
		}
		
		// Module agenda
		if (isset($liste_table['agenda_opt']))
		{
			$req_opt = reqmysql('SELECT * FROM `agenda_opt`');
			$agenda = array();
			while ($obj_opt = mysql_fetch_object($req_opt))
			{
				if ($obj_opt->nom == 'agenda_grade_mod')
				{
					update_query('INSERT INTO `droit` SET `module`="agenda", `page`="gerer", `grade`="'.$obj_opt->valeur.'", `groupe`="0", `condition`="or"');
				}
				elseif ($obj_opt->nom == 'agenda_grade_post')
				{
					update_query('INSERT INTO `droit` SET `module`="agenda", `page`="poster", `grade`="'.$obj_opt->valeur.'", `groupe`="0", `condition`="or"');
				}
				elseif ($obj_opt->nom == 'agenda_grade_voir')
				{
					update_query('INSERT INTO `droit` SET `module`="agenda", `page`="voir", `grade`="'.$obj_opt->valeur.'", `groupe`="0", `condition`="or"');
				}
				else
				{
					update_query('INSERT INTO `parametres` SET `nom`="'.$obj_opt->nom.'", `valeur`="'.sp($obj_opt->valeur).'"');
				}
			}
			update_query('INSERT INTO `droit` SET `module`="agenda", `page`="administrer", `grade`="4", `groupe`="0", `condition`="or"');
			update_query('DROP TABLE `agenda_opt`');		
		}
		if (isset($liste_table['agenda_anniv']) && isset($liste_table['agenda_events']) && isset($liste_table['agenda_fetes']))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_agenda"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_agenda', `valeur`='1';");
			}
		}
		
		// Module articles
		if (isset($liste_table['article']))
		{
			update_query ("DROP TABLE IF EXISTS `articles`;");
			update_query("RENAME TABLE `article` TO `articles`;");
			table('articles');
		}
		update_query("ALTER TABLE `articles`
						ADD `mots_cles` VARCHAR(250) NOT NULL DEFAULT '' AFTER `texte`;
					");
		update_query("ALTER TABLE `articles`
						ADD `accroche` VARCHAR (250) NOT NULL DEFAULT '' AFTER `auteur`,
						ADD `img` VARCHAR (100) NOT NULL DEFAULT '' AFTER `auteur`,
						ADD `vote_nbr` INT (11) DEFAULT '0' ,
						ADD `vote_somme` TINYINT (11) DEFAULT '0';
					");
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_articles"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='is_articles', `valeur`='1';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="articles_lecture_session"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='articles_lecture_session', `valeur`='oui';");
		}
		if (is_dir('../modules/articles') and isset($liste_table['article_options']))
		{
			$requete = update_query ("SELECT * FROM `article_options`");
			$ligne = mysql_fetch_object($requete);
			update_query ("INSERT INTO `parametres`	SET `nom`='articles_gr_admin', `valeur`='".$ligne->grade_admin."';");
			update_query ("INSERT INTO `parametres`	SET `nom`='articles_gr_poster', `valeur`='".$ligne->grade_poster."';");
			update_query ("INSERT INTO `parametres`	SET `nom`='articles_valider', `valeur`='".$ligne->valider."';");
			update_query ("DROP TABLE IF EXISTS `article_options`;");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="articles_gr_commentaires"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='articles_gr_commentaires', `valeur`='0';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="articles_keywords"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='articles_keywords', `valeur`='oui';");
		}

		// Module ajash00t
		if (is_dir('../modules/ajash00t') and isset($liste_table['ajash00t']))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_ajash00t"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_ajash00t', `valeur`='1';");
			}
		}

		// Module citations
		if (is_dir('../modules/citations') and isset($liste_table['citations']))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_citations"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_citations', `valeur`='1';");
			}
		}

		// Module contact
		if (is_dir('../modules/contact'))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_contact"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_contact', `valeur`='1';");
			}
		}

		// Module debug
		if (is_dir('../modules/debug'))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_debug"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_debug', `valeur`='1';");
			}
		}

		// Module download
		if (is_dir('../modules/download') and isset($liste_table['dl']) and isset($liste_table['dl_parametres']))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `dl_parametres` WHERE `parametre` ="nb_dl_pagetab"'))== 0)
			{
				update_query ("INSERT INTO `dl_parametres` SET id='', `parametre`='nb_dl_pagetab', `valeur`='5'");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `dl_parametres` WHERE `parametre` ="nouveaute"'))== 0)
			{
				update_query ("INSERT INTO `dl_parametres` SET id='', `parametre`='nouveaute', `valeur`='30'");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `dl_parametres` WHERE `parametre` ="width_maxi"'))== 0)
			{
				update_query ("INSERT INTO `dl_parametres` SET id='', `parametre`='width_maxi', `valeur`='100';");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `dl_parametres` WHERE `parametre` ="height_maxi"'))== 0)
			{
				update_query ("INSERT INTO `dl_parametres` SET id='', `parametre`='height_maxi', `valeur`='100';");
			}
			update_query ("DELETE FROM `dl_parametres` WHERE `parametre`='aff_drt';");

			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_download"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_download', `valeur`='1';");
			}
			update_query ("INSERT INTO `parametres` SET `nom`='is_download', `valeur`='1';");

			$requete = reqmysql("SELECT * FROM `dl_parametres`;");
			while ($ligne = mysql_fetch_object($requete ))
			{
				update_query ("INSERT INTO `parametres` SET `nom`='dl_".$ligne->parametre."', `valeur`='".$ligne->valeur."';");
			}
			update_query ("DROP TABLE IF EXISTS `dl_parametres`;");
		}

		// Module droit
		update_query ("DELETE FROM `droit_exclu` WHERE `module`='maintenance' AND `page`='index';");
		update_query ("DELETE FROM `droit_exclu` WHERE `module`='recherche' AND `page`='includes';");
		update_query ("UPDATE `droit_exclu` SET `accessible`='0' WHERE `module`='admin' AND `page`='class_modules';");
		update_query ("UPDATE `droit_exclu` SET `accessible`='0' WHERE `module`='ajash00t' AND `page`='xml';");
		update_query ("UPDATE `droit_exclu` SET `accessible`='0' WHERE `module`='espace_membre' AND (`page`='header' OR `page`='popup');");
		update_query ("UPDATE `droit_exclu` SET `accessible`='0' WHERE `module`='liens_web' AND `page`='visite';");
		update_query ("UPDATE `droit_exclu` SET `accessible`='0' WHERE `module`='menu' AND `page`='class_menu';");
		update_query ("UPDATE `droit_exclu` SET `accessible`='0' WHERE `module`='stats' AND (`page`='config' OR `page`='stats_inf_light' OR `page`='stats_inf' OR `page`='visites');");

		// Droits Articles
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="articles" AND `page`="affadmin"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'articles', 'affadmin', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="articles" AND `page`="ajouter"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'articles', 'ajouter', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="articles" AND `page`="commentaires"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'articles', 'commentaires', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="articles" AND `page`="gestion"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'articles', 'gestion', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="articles" AND `page`="options"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'articles', 'options', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="articles" AND `page`="poster"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'articles', 'poster', '0');");
		}
		// Droits Forum
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="affgrd"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'affgrd', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="aide"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'aide', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="annonce"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'annonce', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="de_prev"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'de_prev', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="editer"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'editer', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="entete"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'entete', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="fonctions"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'fonctions', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="gestion_options"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'gestion_options', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="lock"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'lock', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="move"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'move', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="moveposts"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'moveposts', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="moveposts_ids"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'moveposts_ids', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="nonlu"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'nonlu', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="no_reponse"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'no_reponse', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="post"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'post', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="regles"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'regles', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="reindexation"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'reindexation', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="resume"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'resume', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="smil"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'smil', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="supprimer"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'supprimer', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="theme_prev"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'theme_prev', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="toutlu"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'toutlu', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="voir_prev"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'forum', 'voir_prev', '0');");
		}
		// Droits Liens_web
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="liens_web" AND `page`="script_java"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'liens_web', 'script_java', '0');");
		}
		else
		{
			update_query ("UPDATE `droit_exclu` SET `accessible`='0' WHERE `module`='liens_web' AND `page`='script_java';");
		}
		// Droits News
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="news" AND `page`="affadmin"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'news', 'affadmin', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="news" AND `page`="commentaires"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'news', 'commentaires', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="news" AND `page`="gestion"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'news', 'gestion', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="news" AND `page`="options"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'news', 'options', '0');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="news" AND `page`="poster"'))== 0)
		{
			update_query ("INSERT INTO `droit_exclu` (`id`, `module`, `page`, `accessible`) VALUES ('', 'news', 'poster', '0');");
		}

		// Module eskuel
		if (is_dir('../modules/eskuel'))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_eskuel"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_eskuel', `valeur`='1';");
			}
		}

		//Dlacement des fichiers vers l'espace_membre
		update_query ("UPDATE `modules` SET `parametre2`='./index.php?mod=espace_membre&ac=memberlist' WHERE `parametre2`='memberlist.php'");
		update_query ("UPDATE `parametres` SET `valeur`='Bonjour\r\n\r\nVeuillez confirmer votre inscription en cliquant sur le lien suivant :\r\n\r\n%url_site%index.php?mod=espace_membre&ac=val&cle=%cle%\r\n\r\nMerci' WHERE `nom`='mailvalidation'");
		update_query ("UPDATE `parametres` SET `valeur`='Veuillez confirmer le changement d email en suivant le lien suivant :\r\n\r\n%url_site%index.php?mod=espace_membre&ac=val&cle=%cle%\r\n\r\nMerci' WHERE `nom`='mailchg'");
		update_query ("ALTER TABLE `users` CHANGE `date_der_connec` `date_der_connec` VARCHAR( 10 ) NOT NULL DEFAULT '9999999999';");
		update_query ("ALTER TABLE `users` ADD `editeur` ENUM( 'bbcode', 'html' ) NOT NULL DEFAULT 'bbcode' COMMENT 'Editeur de texte du membre' AFTER `flood`;");
		update_query ("ALTER TABLE `users` CHANGE `email` `email` VARCHAR( 64 );");

		// Module espion
		if (is_dir('../modules/espion'))
		{
			update_query ("
				CREATE TABLE IF NOT EXISTS `espion` (
				  `id` int(11) NOT NULL auto_increment,
				  `pseudo` varchar(200) NOT NULL default '',
				  `ip` varchar(15) NOT NULL default '',
				  `date` int(12) NOT NULL default '0',
				  `url` varchar(200) NOT NULL default '',
				  PRIMARY KEY  (`id`)
				) TYPE=MyISAM AUTO_INCREMENT=1 ;
			");
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_espion"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_espion', `valeur`='0';");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="espion_sauvegarde"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='espion_sauvegarde', `valeur`='0';");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="espion_firewall_robot"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='espion_firewall_robot', `valeur`='0';");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit` WHERE `module`="espion" AND `page`="clic_oeil"'))== 0)
			{
				update_query ("INSERT INTO `droit` SET `module`='espion', `page`='clic_oeil', `grade`='4', `groupe`='0';");
			}
		}

		// Module forum
 		update_query ("ALTER TABLE `forum_prev` ADD `etat` VARCHAR(10) NOT NULL DEFAULT 'suivi';");
 		update_query ("TRUNCATE TABLE `forum_lecture`");
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_forum"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='is_forum', `valeur`='1';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_lecture_session"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='forum_lecture_session', `valeur`='oui';");
		}
		if (is_dir('../modules/forum') and !isset($liste_table['forum_cniv']))
		{
			table('forum_rep');
			table('forum_topic');

			update_query("
				CREATE TABLE IF NOT EXISTS `forum_cniv` (
				  `id` int(11) NOT NULL auto_increment,
				  `id_cat` int(11) NOT NULL default '0',
				  `ref_cat` int(11) NOT NULL default '0',
				  `position` int(11) NOT NULL default '1',
				  `sous_position` int(11) NOT NULL default '1',
				  PRIMARY KEY  (`id`)
				) TYPE=MyISAM COMMENT='Positions multi-niveaux' AUTO_INCREMENT=1 ;
			");

			if ($_POST['int_IN_SVN'])
			{
				update_query('
					UPDATE	`forum_cat`
					SET		`attribut` = 0, `ref` = 0
					WHERE	`attribut` = 2
				');
				update_query('
					UPDATE	`forum_cat`
					SET		`attribut` = 2, `ref` = 1
					WHERE	`attribut` = 3
				');
			}

			$requete = update_query("
				SELECT		`id`,
							`ref`,
							`position`
				FROM		`forum_cat`
				ORDER BY	`position` ASC
			");
			while ($ligne = mysql_fetch_object($requete))
			{
				update_query('
					UPDATE	`forum_cat`
					SET		`position` = `ref`+1
				');
				if ($ligneref_old!=$ligne->ref)
				{
					$i=1;
				}
				update_query('
					INSERT INTO	`forum_cniv`
					SET			`id_cat`="'.$ligne->id.'",
								`ref_cat`="'.$ligne->ref.'",
								`position` = '.$ligne->ref.'+1,
								`sous_position`="'.($ligne->ref==0 ? $ligne->position : $i).'"
				');
				$i++;
				$ligneref_old = $ligne->ref;
			}
		}

		// Module groupes
		update_query("ALTER TABLE `groupes_grp` DROP `date`, DROP `fondateur`;");
		if (mysql_num_rows(reqmysql('SELECT * FROM `droit` WHERE `module`="groupes" AND `page`="administration"'))== 0)
		{
			update_query ("INSERT INTO `droit` SET `module`='groupes', `page`='administration', `grade`='4', `groupe`='0';");
		}
		update_query ("DELETE FROM `parametres` WHERE `nom`='grade_creation_grp';");

		// Module liens_web
		if (is_dir('../modules/liens_web') and isset($liste_table['liens_web']) and isset($liste_table['liens_web_opt']))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `liens_web_opt` WHERE `nom`="nb_liens_page"'))== 0)
			{
				update_query ("INSERT INTO `liens_web_opt` SET `nom`='nb_liens_page', `valeur`='10', `commentaire`='Nombre de liens par page';");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `liens_web_opt` WHERE `nom` ="aff_miniature"'))== 0)
			{
				update_query ("INSERT INTO `liens_web_opt` SET `id`='', `nom`='aff_miniature', `valeur`='0', `commentaire`='Affichage des miniatures (0 ou 1)'");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `liens_web_opt` WHERE `nom` ="opacity"'))== 0)
			{
				update_query ("INSERT INTO `liens_web_opt` SET `id`='', `nom`='opacity', `valeur`='Oui', `commentaire`='Activation transparence miniature'");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `liens_web_opt` WHERE `nom` ="opacity_out"'))== 0)
			{
				update_query ("INSERT INTO `liens_web_opt` SET `id`='', `nom`='opacity_out', `valeur`='30', `commentaire`='Opacit de l\'image par dfaut'");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `liens_web_opt` WHERE `nom` ="opacity_over"'))== 0)
			{
				update_query ("INSERT INTO `liens_web_opt` SET `id`='', `nom`='opacity_over', `valeur`='90', `commentaire`='Opacit de l\'image au passage de la souris'");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_liens_web"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_liens_web', `valeur`='1';");
			}
			update_query ("UPDATE `modules` SET `parametre2`='./index.php?mod=liens_web' WHERE parametre2='index.php?mod=lien_web'");
		}

		// Module livredor
		if (is_dir('../modules/livredor') and isset($liste_table['livredor']))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_livredor"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_livredor', `valeur`='1';");
			}
		}

		// Module infoZ
		if (is_dir('../modules/infoZ'))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_infoZ"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_infoZ', `valeur`='1';");
			}
		}

		// Module multi-faq
		if (is_dir('../modules/multi-faq') and isset($liste_table['faq_cat']) and isset($liste_table['faq_rep']))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_multi-faq"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_multi-faq', `valeur`='1';");
			}
		}

		// Module news
		update_query("ALTER TABLE `news` ADD `mots_cles` VARCHAR(250) NOT NULL DEFAULT '' AFTER `contenu`;");
		update_query("ALTER TABLE `news` ADD `validation` tinyint(2) NOT NULL default '0' AFTER `hit`;");
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_news"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='is_news', `valeur`='1';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="news_gr_admin"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='news_gr_admin', `valeur`='3';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="news_gr_poster"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='news_gr_poster', `valeur`='3';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="news_valider"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='news_valider', `valeur`='1';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="news_gr_commentaires"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='news_gr_commentaires', `valeur`='0';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="news_keywords"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='news_keywords', `valeur`='oui';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="news_lecture_session"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='news_lecture_session', `valeur`='oui';");
		}

		// Module newsletter
		if (is_dir('../modules/newsletter') and isset($liste_table['newsletter']))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_newsletter"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_newsletter', `valeur`='1';");
			}
			update_query ("DELETE FROM `newsletter` WHERE email NOT LIKE '%@%';");
		}

		// Module page
		update_query("ALTER TABLE `page` ADD `mots_cles` VARCHAR(250) NOT NULL DEFAULT '' AFTER `contenu`;");
		if (is_dir('../modules/page') and isset($liste_table['page']) and isset($liste_table['tableau']))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_page"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_page', `valeur`='1';");
			}
		}

		// Module plan
		if (is_dir('../modules/plan'))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_plan"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_plan', `valeur`='1';");
			}
		}

		// Module questionnaire
		update_query ("CREATE TABLE IF NOT EXISTS `questionnaire_question` (
		  `id` int(11) NOT NULL auto_increment,
		  `module` varchar(50) NOT NULL default '',
		  `question` varchar(255) NOT NULL default '',
		  PRIMARY KEY  (`id`)
		) TYPE=MyISAM COMMENT='Questionnaire';");
		update_query ("CREATE TABLE IF NOT EXISTS `questionnaire_reponse` (
		  `id` int(11) NOT NULL auto_increment,
		  `id_question` int(11) NOT NULL default '0',
		  `reponse` varchar(255) NOT NULL default '',
		  `juste` varchar(3) NOT NULL default '',
		  PRIMARY KEY  (`id`)
		) TYPE=MyISAM COMMENT='Questionnaire';");

		// Module recherche
		if (is_dir('../modules/recherche'))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_recherche"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_recherche', `valeur`='1';");
			}
		}

		// Module resume
		if (is_dir('../modules/resume'))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_resume"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_resume', `valeur`='1';");
			}
			update_query ("UPDATE `modules` SET `parametre3`='2' WHERE `type`='resume' AND `module`='news';");
			update_query ("UPDATE `modules` SET `parametre3`='2' WHERE `type`='resume' AND `module`='articles';");
		}

		// rubriques
		if (is_dir('../modules/rubriques') and (!isset($liste_table['rubriques'])))
		{
			update_query ("RENAME TABLE `article_cat` TO `rubriques`;");
			update_query ("ALTER TABLE `rubriques` ADD `module` VARCHAR( 100 ) NOT NULL AFTER `id`;");
			update_query ("ALTER TABLE `rubriques` CHANGE `grade` `groupe` TINYINT( 1 ) NOT NULL DEFAULT '0';");
			update_query ("ALTER TABLE `rubriques` ADD `sref` INT (11) DEFAULT '0' AFTER `id`;");
		}

		// Module stats
		update_query ("UPDATE `parametres` SET `nom` = 'date_simultanemous_membre' WHERE `nom` = 'date_simultanemous_membre '");
		update_query ("UPDATE `modules` SET `parametre2`='2eme bloc', `parametre3`='3eme bloc', `parametre4`='Oui-Oui-Oui' WHERE `type`='bloc' AND `module`='stats';");
		update_query ("DELETE FROM `stats` WHERE type='page' AND (`valeur` LIKE '%erreur404.php' OR `valeur` LIKE '%erreur403.php');");

		// Module theme_pour_tous
		if (is_dir('../modules/theme_pour_tous'))
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="is_theme_pour_tous"'))== 0)
			{
				update_query ("INSERT INTO `parametres` SET `nom`='is_theme_pour_tous', `valeur`='1';");
			}
		}

		//paramtres manquants
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="avatars_ext"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='avatars_ext', `valeur`='off';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="msgbienvenue_Envoi"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='msgbienvenue_Envoi', `valeur`='on';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="expediteurMP"'))== 0)
		{
			update_query ("DELETE FROM `parametres` WHERE `nom`='expediteurMP';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="K_expediteurMP"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='K_expediteurMP', `valeur`='1';");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="K_edito_aff"'))== 0)
		{
			update_query ("INSERT INTO `parametres` SET `nom`='K_edito_aff', `valeur`='oui';");
		}

		//nouveaux paramtres
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="grade_1_option"'))== 0)
		{
			update_query ("INSERT INTO `parametres` VALUES ('','grade_1_option','color:#990099<=>+<=>Membre privilgi');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="grade_2_option"'))== 0)
		{
			update_query ("INSERT INTO `parametres` VALUES ('','grade_2_option','color:#009900<=>&Omega;<=>Modrateur de forum');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="grade_3_option"'))== 0)
		{
			update_query ("INSERT INTO `parametres` VALUES ('','grade_3_option','color:#cc3300<=>&Omega;<=>Modrateur');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="grade_4_option"'))== 0)
		{
			update_query ("INSERT INTO `parametres` VALUES ('','grade_4_option','color:#003366<=>&Psi;<=>Administrateur');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="grade_5_option"'))== 0)
		{
			update_query ("INSERT INTO `parametres` VALUES ('','grade_5_option','color:#ff00ff<=>&copy;<=>Ttard');");
		}

		// Gabarit
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="commentaires_gabarit"'))== 0)
		{
			update_query ("INSERT INTO `parametres` VALUES ('','commentaires_gabarit','0');");
		}

		// Copyright
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="distribution_versions"'))== 0)
		{
			update_query ("INSERT INTO `parametres` VALUES ('','distribution_versions','-".$Version_Ant."-".$Version_Rev."');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="distribution_page_gen"'))== 0)
		{
			update_query ("INSERT INTO `parametres` VALUES ('','distribution_page_gen','1');");
		}
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="distribution_pre_copy"'))== 0)
		{
			update_query ("INSERT INTO `parametres` VALUES ('','distribution_pre_copy','Propuls par');");
		}

		$update_form1 = '<form method="post" action="update'.$Version_Ant.'_to_'.$Version_Rev.'.php" name="form1">';

		$update_contenu = '<strong>Mise &agrave; jour des tables</strong><br /><br />';
		
		if (!empty($update_result))
		{
			$update_contenu.= '<span style="color:#009900">'.$update_mysql.'</span>
			<br /><br />
			<b>Erreur</b><br />
			'.$update_result.'
			<br />
			<span style="color:red;">La mise &agrave; jour a donc &eacute;t&eacute; incompl&egrave;te, vous &ecirc;tes donc contraint de nous signaler l\'erreur.</span><br />
			<br />
			Reportez cette erreur sur notre <a href="http://www.kwsphp.org/" target="_blank">forum de support</a>.';
		}
		else
		{
			$update_contenu.= '<span style="color:#009900">'.$update_mysql.'</span>
			<br /><br />
			<span style="color:#009900">Les tables ont &eacute;t&eacute; correctement mises &agrave; jour !</span>';
		}

		$update_form2 = '';

		$update_button = '<input type="submit" value=" Suivant " />';
	}
	else
	{
		$update_menu = $class_install->aff_step (1, $step_array);
		$step = 0;

		$update_form1 = '<form method="post" action="update'.$Version_Ant.'_to_'.$Version_Rev.'.php" name="form1">';

		$update_contenu = '
		<div style="color:#cc3300;font-weight:bold;text-align:center;font-variant:small-caps">
			Erreur<br /><br />'.$update_erreur.'<br /><br />
		</div>';

		$update_form2 = '';

		$update_button = '<input type="submit" value=" Retour " />';
	}
}
elseif ($step == 4)
{
	$update_form1 = '';

	$update_contenu = '
	<p>KwsPHP est maintenant mise &agrave; jour sur votre serveur.</p>
	<p style="text-align:center; color:#cc3300; font-size:18pt;">
		Vous devez IMPERATIVEMENT supprimer<br />
		le r&eacute;pertoire "install" de votre serveur<br />
		avant de poursuivre !
	</p>
	<p>Si vous souhaitez que votre site soit r&eacute;f&eacute;renc&eacute; sur l\'annuaire de Kws, envoyer un email &agrave; <a href="mailto:annuaire@kwsphp.org">cette adresse</a>.</p>
	<p>Le support du portail est assur&eacute; sur le forum de notre communaut&eacute; <a href="http://www.kwsphp.org/">KwsPHP.org</a>.</p>
	<p>La KwsPHP Team vous souhaite une bonne utilisation et esp&egrave;re que vous serez satisfait.</p>
	<p>Cliquer sur "Terminer" pour quitter le programme d\'installation et vous rendre sur votre nouveau portail.</p>';

	$update_form2 = '<form method="post" action="../index.php" name="form1">';

	$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
}
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" >
	<title>Mise &agrave; jour de KwsPHP en version <?php echo $Version_Rev;?></title>
	<link rel="stylesheet" type="text/css" href="install.css" >
</head>

<body>
	<table class="tab_exterieur" summary="tab_exterieur">
		<tr>
			<td>
				<table class="tab_middle" summary="tab_middle">
					<tr>
						<td>
							<table class="tab_interne" summary="tab_interne">
								<tr>
									<td colspan="3">
										<img src="images/kwsphp2.jpg" width="266" height="75" align="middle" alt="Logo install" />
										<br /><br />
										Un portail en PHP cl&eacute; en main !
										<br /><br />
									</td>
								</tr>
								<tr>
  								<td style="vertical-align:top"><?php echo $update_menu; ?></td>
  								<td style="width:2px"></td>
  								<td style="vertical-align:top;width:85%">
  									<?php echo $update_form1; ?>
  									<table style="border: 1px solid #BCBCBC;width:100%;background-color:#ffffff" summary="update3">
  										<tr>
  											<td style="vertical-align:top"><?php echo $update_titre.$update_contenu; ?></td>
  										</tr>
  									</table>
  									<?php echo $update_form2; ?>
  									<input type="hidden" name="step" value="<?php echo $step+1; ?>" /><br />
  									<div style="text-align:right"><?php echo $update_button; ?></div>
  									</form>
  								</td>
  							</tr>
  						</table>
  					</td>
  				</tr>
  			</table>
  			<br />
				<div id="ckws"><a href="http://www.kwsphp.org/"> &copy; KwsPHP version <?php echo $Version_Rev;?></a></div>
  		</td>
  	</tr>
  </table>
</body>
