<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: gestion_module.php 926 2011-05-17 11:20:57Z mike007 $
// ---------------------------------------------------------------
// Cration : 28/01/08 par FouPouDave
// Mise  jour : octobre 2008 par julkien. Ajout vrif update module
// ---------------------------------------------------------------

if (!(defined('__KWS__'))) {die('Erreur d\'appel de fichier.');}

if (get_grade() >= GRD_ADMIN)
{
	if (isset($_GET['dlup']) and $_GET['dlup']=='update')
	{
		$_SESSION['dlup_ForceCheck'] = 1;
		header('Location: index.php?mod=admin&ac=gestion_module');
		exit();
	}
	
	if (is_dir('./modules/'.$_GET['module']) and !empty($_GET['module']))
	{
		// Installation d'un module
		// -----------------------------------------------------------------------------------------
		if ($_GET['action']=='install')
		{
			bloc_head('Installation du module "'.ax($_GET['module']).'"');
			if (etat_module($module) != 'nonistalle')
			{
				echo df_message('erreur','Ce module ne peut pas &ecirc;tre install&eacute;.');
			}
			elseif ($_POST['validation'] == 'Installer la base de donnes' )
			{
				require_once './includes/class.install.php';
				$class_install = new install;
				$class_install->install_mod($_GET['module']);

				echo df_message('information','L&rsquo;installation a &eacute;t&eacute; faite.');
			}
			elseif ($_POST['validation'] == 'Le dclarer' )
			{
				reqmysql("
					INSERT INTO	`parametres`
					SET			`nom` = 'is_".sp($_GET['module'])."',
								`valeur` = '1'
				");

				echo df_message('information','La d&eacute;claration &agrave; &eacute;t&eacute; faite.');
			}
			else
			{
				if (!is_module_officiel($_GET['module']))
				{	
					echo df_message('information','Le module &laquo;<em>'.ax($_GET['module']).'</em>&raquo; est-il d&eacute;j&agrave; install&eacute; ?<br />Si oui il faut simplement
					<form action="index.php?mod=admin&amp;ac=gestion_module&amp;module='.ax($_GET['module']).'&amp;action=install" method="post">
						<p style="text-align:center;">
							<input type="submit" id="submit" name="validation" value="Le d&eacute;clarer" />
						</p>
					</form>
					car il n&rsquo;est pas d&eacute;clar&eacute; en tant que tel.<br />
					Sinon il faut proc&eacute;der &agrave; l&rsquo;installation compl&egrave;te :').'
					<hr />';
				}
				
				echo df_message('attention','Une installation g&eacute;n&egrave;re un effacement des tables existantes du module !
				<form action="index.php?mod=admin&amp;ac=gestion_module&amp;module='.ax($_GET['module']).'&amp;action=install" method="post">
					<p style="text-align:center;">
						<input type="submit" name="validation" value="Installer la base de donn&eacute;es" />
					</p>
				</form>');
			}
			echo '<p style="text-align:center;"><a href="index.php?mod=admin&amp;ac=gestion_module">Retour</a></p>';
			close_table();
		}
		
		// Dsinstallation d'un module
		// -----------------------------------------------------------------------------------------
		elseif ($_GET['action']=='desinstall')
		{
			bloc_head('D&eacute;sinstallation du module "'.ax($_GET['module']).'"');
			if (etat_module($module) != 'active' and etat_module($module) != 'desactive')
			{
				echo df_message('erreur','Ce module ne peut pas tre d&eacute;sinstall&eacute;.');
			}
			elseif (isset($_POST['validation']))
			{
				require_once './includes/class.install.php';
				$class_install = new install;
				$class_install->uninstall_mod($_GET['module']);

				echo df_message('information','La d&eacute;sinstallation a &eacute;t&eacute; faite.');
			}
			else
			{
				echo '<form action="index.php?mod=admin&amp;ac=gestion_module&amp;module='.ax($_GET['module']).'&amp;action=desinstall" method="post">
					<p style="text-align:center;">
						<input type="submit" id="submit" name="validation" value="D&eacute;sinstaller la base de donn&eacute;es" />
					</p>
				</form>';
			}
			echo '<p style="text-align:center;"><a href="index.php?mod=admin&amp;ac=gestion_module">Retour</a></p>';
			close_table();
		}
		
		// Activation d'un module
		// ------------------------------------------------------------------------------------------
		elseif ($_GET['action']=='active')
		{
			bloc_head('Activation du module "'.ax($_GET['module']).'"');
			if (etat_module($module) != 'desactive')
			{
				echo df_message('erreur','Ce module ne peut pas tre activ&eacute;.');
			}
			else
			{
				reqmysql('UPDATE `parametres` SET `valeur`="1" WHERE `nom`="is_'.sp($_GET['module']).'"');
				echo df_message('information','L&rsquo;activation a &eacute;t&eacute; faite.');
			}
			echo '<p style="text-align:center;"><a href="index.php?mod=admin&amp;ac=gestion_module">Retour</a></p>';
			close_table();
		}
		
		// Dsactivation d'un module
		// ------------------------------------------------------------------------------------------
		elseif ($_GET['action']=='desactive')
		{
			bloc_head('D&eacute;sactivation du module "'.ax($_GET['module']).'"');
			if (etat_module($module) != 'active')
			{
				echo df_message('erreur','Ce module ne peut pas tre d&eacute;sactiv&eacute;.');
			}
			else
			{
				reqmysql('UPDATE `parametres` SET `valeur`="0" WHERE `nom`="is_'.sp($_GET['module']).'"');
				echo df_message('information','La d&eacute;sactivation a &eacute;t&eacute; faite.');
			}
			echo '<p style="text-align:center;"><a href="index.php?mod=admin&amp;ac=gestion_module">Retour</a></p>';
			close_table();
		}
	}
	else
	{
		if ((!empty($_POST['submit_update']) OR $_SESSION['modules_maj']=='OK') && !empty($_SESSION['update_modules']))
		{
			$_SESSION['modules_maj']='OK';
			$module_up_todo = key(array_slice($_SESSION['update_modules'],0,1));
			unset ($_SESSION['update_modules'][$module_up_todo]);
			if (empty($_SESSION['update_modules']))
			{
				unset($_SESSION['modules_maj']);
			}
			header ('Location: ./index.php?mod='.$module_up_todo.'&ac=update');
			exit();
		}
		unset ($_SESSION['update_modules']);
		$distribution_on  = array_pop(explode('-',$distribution_versions));
		$portail_version  = array_pop(explode('.',$distribution_on));

		bloc_head('Ajout, suppression et mise &agrave; jour des modules');

		if (!empty($_GET['deldoss']))
		{
			$liste = ScannerRepertoire('./modules/'.$_GET['deldoss'], 'files',true);
			for ($i=0 ; $i<count($liste) ; $i++)
			{
				@chmod($liste[$i],0755);
				$erreur_fichier = !@unlink($liste[$i]);
			}
			$liste = ScannerRepertoire('./modules/'.$_GET['deldoss'], 'dir',true);
			for ($i=0 ; $i<count($liste) ; $i++)
			{
				@chmod($liste[$i].'index.html',0755);
				@unlink($liste[$i].'index.html');
				@chmod($liste[$i].'index.htm',0755);
				@unlink($liste[$i].'index.htm');
				@chmod($liste[$i].'Thumbs.db',0755);
				@unlink($liste[$i].'Thumbs.db');
				$erreur_dossier = !@rmdir($liste[$i]);
			}
			@chmod('./modules/'.$_GET['deldoss'].'/',0755);
			$erreur_dossier_mod = !@rmdir('./modules/'.$_GET['deldoss'].'/');
			
			if ($erreur_fichier or $erreur_dossier or $erreur_dossier_mod)
				$_SESSION['message_erreur_del_doss'] = df_message ('erreur',$_GET['deldoss'],'Erreur lors de la suppression. Veuillez l\'effectuer manuellement sur votre ftp.');
			else
				$_SESSION['message_erreur_del_doss'] = df_message ('',$_GET['deldoss'],'Dossier supprim&eacute;');
			header ('Location: ./index.php?mod='.$K_mod.'&ac='.$K_ac.'');
			exit();
		}
		//if ($_IN_SVN)
		{
			if (!empty ($_SESSION['message_erreur_del_doss']))
			{
				echo $_SESSION['message_erreur_del_doss'];
				unset($_SESSION['message_erreur_del_doss']);
			}
			echo df_message(
				'information',
				'<p style="text-align:center">
				Si vous &ecirc;tes concepteur et que vous voulez avertir d\'une mise &agrave; jours de l\'un de vos modules,<br />
				il vous suffit de cliquer sur le bouton ci-dessous.</p>',
				'<form action="index.php?mod=admin&amp;ac=dlup_avertir" method="post" style="margin:0px;">
				<p style="text-align:center;">
					<input type="submit" name="avertirNew" value="Avertir d\'une mise &agrave; jours de vos modules" />
					<input type="submit" name="avertirList" value="Voir vos alertes existantes" />
				</p>
				</form>'.$_SESSION['dlup_msg']
			).'
			<br />';
			unset($_SESSION['dlup_msg']);
		}

		echo '
		<p style="text-align:center;">Maintenez la souris sur les images pour avoir un compl&eacute;ment d&rsquo;informations.<br />
		Pour supprimer directement un module non install depuis cette interface,<br />
		Veuillez attribuer les chmod nec&eacute;ssaires aux dossier &laquo;modules&raquo; et &agrave; ses sous-r&eacute;pertoires.</p>
		<table style="margin:auto;" summary="gestion des modules">
			<tr>
				<th style="width:50px">Etat</th>
				<th style="width:100px">Module</th>
				<th style="width:50px">Version</th>
				<th style="width:100px">Activation</th>
				<th style="width:100px">Installation</th>
				<th style="width:100px" ondblclick="'.base64_decode('YWxlcnQoJ1RyaWNoZXVyICEhIScpOw==').'location.href=\'index.php?mod=admin&amp;ac=gestion_module&amp;dlup=update\';">Update</th>
			</tr>
			<tr>
				<th colspan="6"><hr /></th>
			</tr>';

		$dlup_modules = unserialize($K_dlup_modules);
		$modules = ScannerRepertoire('./modules','dir', false);
		foreach ($modules as $module)
		{
			if (!isset(${$module.'_version'}))
			{
				${$module.'_version'} = '1.6';
			}

			if (file_exists('./modules/'.$module.'/gestionnaire.txt'))
			{
				$module_file = @file('./modules/'.$module.'/gestionnaire.txt');
				$module_version = trim($module_file[3]); 	// version
				$module_url 	= trim($module_file[4]);	// Url
				$module_txt		= $module_version;
			}
			else
			{
				$module_version = ${$module.'_version'};
			}

			if (!file_exists('./modules/'.$module.'/update.php'))
			{
				$module_version = ${$module.'_version'};
			}

			// verification de l'existence d'une maj  tlcharger
			$update_possible_file = array_key_exists($module, $dlup_modules);
				
			if (!empty($module_url) and get_grade()>=GRD_ADMIN and ( ($K_dlup_lastTime!=0 AND ($K_dlup_lastTime+$K_dlup_frequence)<time()) or $_SESSION['dlup_ForceCheck'] ))
			{
				// adresse pour faire le lien vers le fichier de controle distant
				$update_adresse = $module_url.'modules/admin/update/'.$module.'/update.xml';
				$dlup_exists = @remote_file_exists($update_adresse);
				if ($dlup_exists===true)
				{
					// ouverture du fichier de controle distant
					$file = @fopen($update_adresse, 'r');
					if ($file)
					{
						// lecture du fichier distant pour le comparer
						$xml = lit_xml($update_adresse, 'update', array('update_version', 'update_id', 'update_url_site'));

						foreach($xml as $row)
						{
							list($update_version, $update_id, $update_url_site) = array_values($row);
						}
						if ($update_version > $module_version)
						{
							// une nouvelle version existe
							$update_possible_file = true;
							$dlup_modules[$module]['version']	= $update_version;
							$dlup_modules[$module]['id']		= $update_id;
							$dlup_modules[$module]['url']		= $update_url_site;
							unset($update_version);
						}
					}
					@fclose($file);
				}
			}
			// verification des updates a lancer
			if ($module_version > ${$module.'_version'} AND (etat_module($module) == 'obligatoire' OR etat_module($module) == 'active'))
			{
				$_SESSION['update_modules'][$module]='update todo';
				unset($dlup_modules[$module]);
				$K_dlup_modules = serialize($dlup_modules);
				reqmysql('UPDATE `parametres` SET `valeur`="'.sp($K_dlup_modules).'" WHERE `nom`="dlup_modules";');
				// supression de l'alerte
				reqmysql('DELETE FROM `alerte` WHERE `module`="'.sp($module).'" AND `auteur`="KwsPHP (UPDATE)";');
				$update_possible_file = false;
			}

			if (etat_module($module) == 'introuvable')
			{
				echo '
				<tr onmouseover="this.className = \'onmouse_over\';" onmouseout="this.className = \'onmouse_out\';">
					<td style="text-align:center;"><img src="./modules/admin/images/effacer.png" title="R&eacute;pertoire du module &agrave; effacer" alt="Image" border="0" /></td>
					<td nowrap="nowrap"><strong style="color:green;">'.$module.'</strong></td>
					<td style="text-align:center;"><font style="color:green;">'.${$module.'_version'}.'</font></td>
					<td style="text-align:center;"><img src="./modules/admin/images/inconnu.png" alt="Image" title="Module non g&eacute;r&eacute; par le gestionnaire" border="0" /></td>
					<td style="text-align:center;"><img src="./modules/admin/images/inconnu.png" alt="Image" title="Module non g&eacute;r&eacute; par le gestionnaire" border="0" /></td>
					<td style="text-align:center;"><img src="./modules/admin/images/inconnu.png" alt="Image" title="Module non g&eacute;r&eacute; par le gestionnaire" border="0" /></td>
				</tr>';
			}
			elseif (etat_module($module) == 'ancien module')
			{
				echo '
				<tr onmouseover="this.className = \'onmouse_over\';" onmouseout="this.className = \'onmouse_out\';">
					<td style="text-align:center;"><img src="./modules/admin/images/active.png" alt="Image" title="Module actif" border="0" /></td>
					<td nowrap="nowrap"><strong style="color:red;">'.$module.'</strong></td>
					<td style="text-align:center;"><font style="color:red;">-</font></td>
					<td style="text-align:center;"><img src="./modules/admin/images/inconnu.png" alt="Image" title="Module non g&eacute;r&eacute; par le gestionnaire" border="0" /></td>
					<td style="text-align:center;"><img src="./modules/admin/images/inconnu.png" alt="Image" title="Module non g&eacute;r&eacute; par le gestionnaire" border="0" /></td>
					<td style="text-align:center;"><img src="./modules/admin/images/inconnu.png" alt="Image" title="Module non g&eacute;r&eacute; par le gestionnaire" border="0" /></td>
				</tr>';
			}
			elseif (etat_module($module) == 'inconnu')
			{
				echo '
				<tr onmouseover="this.className = \'onmouse_over\';" onmouseout="this.className = \'onmouse_out\';">
					<td style="text-align:center;"><img src="./modules/admin/images/active.png" alt="Image" title="Module actif" border="0" /></td>
					<td nowrap="nowrap"><strong style="color:red;">'.$module.'</strong></td>
					<td style="text-align:center;"><font style="color:red;">-</font></td>
					<td style="text-align:center;"><img src="./modules/admin/images/inconnu.png" alt="Image" title="Module non g&eacute;r&eacute; par le gestionnaire" border="0" /></td>
					<td style="text-align:center;"><img src="./modules/admin/images/inconnu.png" alt="Image" title="Module non g&eacute;r&eacute; par le gestionnaire" border="0" /></td>
					<td style="text-align:center;"><img src="./modules/admin/images/inconnu.png" alt="Image" title="Module non g&eacute;r&eacute; par le gestionnaire" border="0" /></td>
				</tr>';
			}
			elseif (etat_module($module) == 'obligatoire')
			{
				// On ne fait apparaitre un obligatoire que si update
				if ($_IN_SVN || $module_version > ${$module.'_version'} || $update_possible_file)
				{
					echo '
					<tr onmouseover="this.className = \'onmouse_over\';" onmouseout="this.className = \'onmouse_out\';">
						<td style="text-align:center;"><img src="./modules/admin/images/active.png" alt="Image" title="Module actif" border="0" /></td>
						<td nowrap="nowrap"><strong>'.$module.'</strong></td>
						<td style="text-align:center;"><font>'.${$module.'_version'}.'</font></td>
						<td style="text-align:center;"><img src="./modules/admin/images/kwsphp.png" alt="Image" title="Moteur" border="0" /></td>
						<td style="text-align:center;"><img src="./modules/admin/images/kwsphp.png" alt="Image" title="Moteur" border="0" /></td>
						<td style="text-align:center;">';
							if ($update_possible_file)
							{
								echo'<a href="index.php?mod=admin&amp;ac=dlup_updateur&amp;upmodule='.$module.'">
									<img src="./modules/admin/images/dlupdate.png" alt="Image" title="Nouvelle version disponible (v'.$dlup_modules[$module]['version'].') - Cliquez pour t&eacute;l&eacute;charger." border="0" />
								</a>';
							}
							elseif ($module_version > ${$module.'_version'})
							{
								if ($K_maintenance == 2 or $_IN_SVN)
								{
									echo '<a href="index.php?mod='.$module.'&amp;ac=update">
										<img src="./modules/admin/images/update.png" alt="Image" title="Cliquez pour mettre &agrave; jour vers la version '.$module_version.'" border="0" />
									</a>';
								}
								else
								{
									echo '<a href="index.php?mod=maintenance&amp;ac=gestion&amp;int_update=1">
										<img src="./modules/admin/images/update_maintenance.png" alt="Image" title="Mettre en maintenance bloque pour faire la mise &agrave; jour" border="0" />
									</a>';
								}
							}
							else
							{
								echo '<img src="./modules/admin/images/desactive.png" alt="No_update" title="pas d\'update" border="0" />';
							}
						echo '</td>
					</tr>';
				}
			}
			elseif (etat_module($module) == 'active')
			{
				echo '
				<tr onmouseover="this.className = \'onmouse_over\';" onmouseout="this.className = \'onmouse_out\';">
					<td style="text-align:center;"><img src="./modules/admin/images/active.png" alt="Image" title="Module actif" border="0" /></td>
					<td nowrap="nowrap"><strong style="color:green;">'.$module.'</strong></td>
					<td style="text-align:center;"><font style="color:green;">'.${$module.'_version'}.'</font></td>
					<td style="text-align:center;"><a href="index.php?mod=admin&amp;ac=gestion_module&amp;module='.$module.'&amp;action=desactive"><img src="./modules/admin/images/active.png" alt="Image" title="Cliquez pour d&eacute;sactiver" border="0" /></a></td>
					<td style="text-align:center;"><a href="index.php?mod=admin&amp;ac=gestion_module&amp;module='.$module.'&amp;action=desinstall"><img src="./modules/admin/images/active.png" alt="Image" title="Cliquez pour d&eacute;sinstaller" border="0" /></a></td>
					<td style="text-align:center;">';
						if ($update_possible_file)
						{
							echo'<a href="index.php?mod=admin&amp;ac=dlup_updateur&amp;upmodule='.$module.'">
								<img src="./modules/admin/images/dlupdate.png" alt="Image" title="Nouvelle version disponible (v'.$dlup_modules[$module]['version'].') - Cliquez pour t&eacute;l&eacute;charger." border="0" />
							</a>';
						}
						elseif ($module_version > ${$module.'_version'})
						{
							if ($K_maintenance == 2 or $_IN_SVN)
							{
								echo '<a href="index.php?mod='.$module.'&amp;ac=update">
									<img src="./modules/admin/images/update.png" alt="Image" title="Cliquez pour mettre &agrave; jour vers la version '.$module_version.'" border="0" />
								</a>';
							}
							else
							{
								echo '<a href="index.php?mod=maintenance&amp;ac=gestion&amp;int_update=1">
									<img src="./modules/admin/images/update_maintenance.png" alt="Image" title="Mettre en maintenance bloque pour faire la mise &agrave; jour" border="0" />
								</a>';
							}
						}
						else
						{
							echo '<img src="./modules/admin/images/desactive.png" alt="No_update" title="pas d\'update" border="0" />';
						}
					echo '</td>
				</tr>';
			}
			elseif (etat_module($module) == 'desactive')
			{
				echo '
				<tr onmouseover="this.className = \'onmouse_over\';" onmouseout="this.className = \'onmouse_out\';">
					<td style="text-align:center;"><img src="./modules/admin/images/desactive.png" alt="Image" title="Module inactif" border="0" /></td>
					<td nowrap="nowrap"><strong style="color:orange;">'.$module.'</strong></td>
					<td style="text-align:center;"><font style="color:orange;">'.${$module.'_version'}.'</font></td>
					<td style="text-align:center;"><a href="index.php?mod=admin&amp;ac=gestion_module&amp;module='.$module.'&amp;action=active"><img src="./modules/admin/images/desactive2.png" alt="Image" title="Cliquez pour activer" border="0" /></a></td>
					<td style="text-align:center;"><a href="index.php?mod=admin&amp;ac=gestion_module&amp;module='.$module.'&amp;action=desinstall"><img src="./modules/admin/images/active.png" alt="Image" title="Cliquez pour d&eacute;sinstaller" border="0" /></a></td>
					<td style="text-align:center;">';
						if ($update_possible_file)
						{
							echo'<a href="index.php?mod=admin&amp;ac=dlup_updateur&amp;upmodule='.$module.'">
								<img src="./modules/admin/images/dlupdate.png" alt="Image" title="Nouvelle version disponible (v'.$dlup_modules[$module]['version'].') - Cliquez pour t&eacute;l&eacute;charger." border="0" />
							</a>';
						}
						elseif ($module_version > ${$module.'_version'})
						{
							echo '<img src="./modules/admin/images/update_maintenance.png" alt="Image" title="Vous devez activez le module pour effectuer l&rsquo;update" border="0" />';
						}
						else
						{
							echo '<img src="./modules/admin/images/desactive.png" alt="No_update" title="pas d\'update" border="0" />';
						}
					echo '</td>
				</tr>';
			}
			elseif (etat_module($module) == 'nonistalle')
			{
				// on indique le numro de version du module prsent sur le FTP (gestionnaire.txt)
				// car c'est celle qui sera installe si on installe le module !
				echo '
				<tr onmouseover="this.className = \'onmouse_over\';" onmouseout="this.className = \'onmouse_out\';">
					<td style="text-align:center;">
						<a href="./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;deldoss='.$module.'"><img src="./modules/admin/images/effacer.png" alt="Image" title="Effacer du Ftp" border="0" /></a>
					</td>
					<td nowrap="nowrap"><strong style="color:orange;">'.$module.'</strong></td>
					<td style="text-align:center;"><font style="color:orange;">'.$module_txt.'</font></td>
					<td style="text-align:center;">&nbsp;</td>
					<td style="text-align:center;"><a href="index.php?mod=admin&amp;ac=gestion_module&amp;module='.$module.'&amp;action=install"><img src="./modules/admin/images/install.png" alt="Image" title="Cliquez pour installer" border="0" /></a></td>
					<td style="text-align:center;">'.($update_possible_file ? '<a href="index.php?mod=admin&amp;ac=dlup_updateur&amp;upmodule='.$module.'"><img src="./modules/admin/images/dlupdate.png" alt="Image" title="Nouvelle version disponible (v'.$dlup_modules[$module]['version'].') - Cliquez pour t&eacute;l&eacute;charger." border="0" /></a>' : '<img src="./modules/admin/images/desactive.png" alt="No_update" title="pas de mise &agrave jour" border="0" />').'</td>
				</tr>';
			}
			else
			{
				echo '
				<tr onmouseover="this.className = \'onmouse_over\';" onmouseout="this.className = \'onmouse_out\';">
					<td style="text-align:center;" colspan="6">Il y a un probl&egrave;me sur '.$module.' pr&eacute;venir KwsPHP</td>
				</tr>';
			}
		}
		if ($_SESSION['dlup_ForceCheck'])
		{
			$K_dlup_modules = serialize($dlup_modules);
			reqmysql('UPDATE `parametres` SET `valeur`="'.sp($K_dlup_modules).'" WHERE `nom`="dlup_modules";');
			unset($_SESSION['dlup_ForceCheck']);
		}
		echo '
			</table>';
		if (!empty($_SESSION['update_modules']))
		{
			echo'<hr /><form style="text-align:center" action="./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'" method="post">
					<input type="submit" name="submit_update" '.(($K_maintenance == 2 or $_IN_SVN)? 'value=" Lancer toutes les mises &agrave; jour "':'disabled="disabled" value="Mettre en maintenance bloqu&eacute;e pour faire les mises &agrave; jour"').' />
				</form>';
		}
		close_table();
	}
}
else
{
	ZoneReserve();
}
?>
