<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: robots.php 889 2010-01-24 17:39:31Z mike007.devpwsphp $
// ---------------------------------------------------------------
// Mise a jour : 29/07/06 par Ditch
// Mise a jour : 16/06/07 par jack
// ---------------------------------------------------------------

if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

//if (get_grade() >= GRD_ADMIN and $_IN_SVN)
if (get_grade() >= GRD_ADMIN)
{
	$modif = false;
	if (!is_array($K_robots)) $K_robots = unserialize($K_robots);

	// Suppression d'un robot avec toutes ses IP
	if (empty($_POST['traitement_ip']) and !empty($_POST['sql_robot']))
	{
		unset ($K_robots[$_POST['sql_robot']]);
		$modif = true;
	}
	elseif (!empty($_POST['sql_robot']) and !empty($_POST['sql_ip']) and preg_match('#^([0-9]{1,3}\.)([0-9]{1,3}\.?){1,3}$#',$_POST['sql_ip']))
	{
		if (substr_count($_POST['sql_ip'], '.') < 3 and substr($_POST['sql_ip'],-1) != '.' )
			$_POST['sql_ip'] .= '.';
		if (substr_count($_POST['sql_ip'], '.') > 3 and substr($_POST['sql_ip'],-1) == '.' )
			$_POST['sql_ip'] = substr($_POST['sql_ip'],0,-1);

		// Ajout d'un Robot et de sa premire ip
		if ($_POST['traitement_ip'] == ' Ajouter un Robot ')
		{
			if (!array_key_exists(ucfirst($_POST['sql_robot']),$K_robots))
				$K_robots[ucfirst($_POST['sql_robot'])][0] = $_POST['sql_ip'];
			else
				$Buffer_message = df_message ('erreur','Robot <strong>&ldquo;'.ax(ucfirst($_POST['sql_robot'])).'&rdquo;</strong> d&eacute;j&agrave; existant');
		}
		// Ajout d'une IP
		elseif ($_POST['traitement_ip'] == ' Ajouter une IP ')
		{
			if (!in_array($_POST['sql_ip'],$K_robots[$_POST['sql_robot']]))
				array_push($K_robots[$_POST['sql_robot']],$_POST['sql_ip']);
			else
				$Buffer_message = df_message ('erreur','IP <strong>&ldquo;'.ax($_POST['sql_ip']).'&rdquo;</strong> d&eacute;j&agrave; existante pour le robot <strong>&ldquo;'.ax(ucfirst($_POST['sql_robot'])).'&rdquo;</strong>');
		}
		// Suppression d'une IP
		elseif ($_POST['traitement_ip'] == ' Supprimer une IP ')
		{
			if (in_array($_POST['sql_ip'],$K_robots[$_POST['sql_robot']]))
			{
				$robot_to_del = array_keys($K_robots[$_POST['sql_robot']],$_POST['sql_ip']);
				unset ($K_robots[$_POST['sql_robot']][$robot_to_del[0]]);

				if (count($K_robots[$_POST['sql_robot']]) == 0)
					unset ($K_robots[$_POST['sql_robot']]);
			}
			else
				$Buffer_message = df_message ('erreur','IP <strong>&ldquo;'.ax($_POST['sql_ip']).'&rdquo;</strong> inexistante pour le robot <strong>&ldquo;'.ax(ucfirst($_POST['sql_robot'])).'&rdquo;</strong>');
		}
		if (empty($Buffer_message))
		{
			sort($K_robots[ucfirst($_POST['sql_robot'])]);
			$modif = true;
		}
	}
	else
	{
		if (!empty($_POST['traitement_ip']) and (empty($_POST['sql_robot']) or empty($_POST['sql_ip'])))
			$Buffer_message = df_message ('erreur','Erreurs','Donn&eacute;e(s) manquante(s)');
		elseif (!empty($_POST['sql_ip']))
			$Buffer_message = df_message ('erreur','Erreur','IP <strong>&ldquo;'.ax($_POST['sql_ip']).'&rdquo;</strong> incorrect');
	}
	if ($modif)
	{
		uksort($K_robots,'strnatcasecmp');
		reqmysql ('UPDATE `parametres` SET `valeur`="'.sp(serialize($K_robots)).'" WHERE `nom`="K_robots" ');
		$Buffer_message = df_message ('','Op&eacute;ration effectu&eacute;e');
	}

	bloc_head ('Gestion des robots par IP');

		if (!empty($Buffer_message)) echo $Buffer_message;
		unset($Buffer_message);
	
		echo '
		<form method="post" action="./index.php?mod='.$K_mod.'&ac='.$K_ac.'">
			<fieldset class="fieldset_post"><legend> <input type="submit" name="traitement_ip" value=" Ajouter un Robot " /> </legend>
			<dl>
				<dt><label>Nom du robot:</label><dt>
				<dd><input type="text" name="sql_robot" /></dd>
			</dl>
			<dl>
				<dt><label>IP du robot:</label></dt>
				<dd><input type="text" name="sql_ip" /></dd>
			</dl>
			</fieldset>
		</form>
		<hr />
		';
		foreach ($K_robots as $robot => $listeip)
		{
			echo '
			<form method="post" action="./index.php?mod='.$K_mod.'&ac='.$K_ac.'">
				<input type="hidden" name="sql_robot" value="'.ax($robot).'" />
				<fieldset class="fieldset_post"><legend>'.ax($robot).(ax($robot)=='Twiceler'?' (alias Cuil)':'').'<span style="margin-left:25px;">&nbsp;</span><input type="submit" value=" Supprimer '.ax($robot).' " /></legend>';
					foreach ($listeip as $ip)
					{
						echo '<span style="cursor:pointer" onclick="document.getElementById(\'sql_ip_'.ax($robot).'\').value=\''.ax($ip).'\'">'.ax($ip).'</span><br />';
					}
					echo '
					<div class="fieldset_post">
						<input type="text" name="sql_ip" id="sql_ip_'.ax($robot).'" />
						<span style="margin-left:25px;">&nbsp;</span>
						<input type="submit" name="traitement_ip" value=" Ajouter une IP " />
						<span style="margin-left:25px;">&nbsp;</span>
						<input type="submit" name="traitement_ip" value=" Supprimer une IP " />
					</div>
				</fieldset>
			</form>
			';
		}
	close_table ();

	$Open_Crawler_List		= @fopen('./includes/crawlerlist.txt','r');
	$MAJ_crawlerlist = fgets($Open_Crawler_List ,200000);
	for ($i=0;$i<6;$i++)
		$MAJ_crawlerlist = fgets($Open_Crawler_List ,100);

	bloc_head ('Visualisation des robots par User Agent');
		if(empty($_SESSION[$CachePseudo.'_crawler_robots']))
		{
			VisitorBot();
		}
		echo df_message('','Merci &agrave; http://www.crawltrack.net',trim($MAJ_crawlerlist));
		foreach ($_SESSION[$CachePseudo.'_crawler_robots'] as $robot => $liste_user_agent)
		{
			echo '
			<fieldset class="fieldset_post"><legend style="font-weight:bold">'.ax($robot).(ax($robot)=='Twiceler'?' (alias Cuil)':'').'</legend>';
				foreach ($liste_user_agent as $user_agent)
				{
					if (strlen(ax($user_agent)) > 95)
						echo '<span title="'.ax($user_agent).'" style="cursor:help;font-weight:bold"> - '.substr(ax($user_agent),0,95).'...</span><br />';
					else
						echo ' - '.ax($user_agent).'<br />';
				}
				echo '
			</fieldset>
			';
		}
	close_table ();
}
else
{
	ZoneReserve();
}
?>
