<?php
// -----------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: index.php 841 2009-02-10 10:04:57Z foupoudave.devpwsphp $
// -----------------------------------------------------------------
//
// Module Agenda
//
// -----------------------------------------------------------------

/**
 * @file index.php
 *
 * Fichier index du module Agenda prenant en charge l'affichage des donnes sous forme de calendriers.
 *
 * @author Otocinclus
 * @version 1.0
 * @date Novembre 2007
 */

// Ligne de scu
if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

// ---------- Initialisation ----------
//-------------------------------------

include_once 'modules/agenda/includes/lib_agenda.php';
include_once 'modules/agenda/includes/lib_calend.php';

// Il faut avoir le grade mini requis
if((get_grade('voir')< GRD_MEMBR))
{
	// grade insuffisant
	zoneReserve();
}
else
{
	dateInfo($_REQUEST['int_a'], $_REQUEST['int_m'], $_REQUEST['int_j'], $_REQUEST['int_w']);
	if (!in_array($_REQUEST['type'], array('an', 'mois', 'sem', 'jour'))) $_REQUEST['type'] = $agenda_def_cal;
	switch(strtolower($_REQUEST['type']))
	{
		case 'an' : // calendrier annuel
			bloc_head ('&nbsp;&nbsp;Calendrier annuel');
			calendAnnuel(@in_array('an', $agenda_aff_fetes), $agenda_aff_anniv, $agenda_aff_event);
			break;

		case 'sem':
		if (empty($_REQUEST['int_w'])) dateInfo($_REQUEST['int_a'], $_REQUEST['int_m'], $_REQUEST['int_j'], date('W'));
			bloc_head ('&nbsp;&nbsp;Calendrier hebdomadaire');
			echo navCalendType('hebdo').
			calendSemaine(@in_array('sem', $agenda_aff_fetes), $agenda_aff_anniv, $agenda_aff_event);
			break;

		case 'jour':
			bloc_head ('&nbsp;&nbsp;Calendrier journalier');
			echo navCalendType('journalier').
			calendJour(@in_array('jour', $agenda_aff_fetes), $agenda_aff_anniv, $agenda_aff_event);
			break;

		case 'mois' :
			$tabfete = array();
			$cond = 'LEFT(`jour`, 2) = "'.date('m', mktime(0, 0, 0, $cal['mois'], '1', $cal['annee'])).'"';
			$tabfete = findFetes($cond);
			$tabfete['aff'] = @in_array('mois', $agenda_aff_fetes) ? 1 : 0;

			bloc_head ('&nbsp;&nbsp;Calendrier mensuel');
			echo navCalendType('mensuel').
			calendMois($tabfete, $agenda_aff_anniv, $agenda_aff_event);
	}

	// JavaScript pour la barre de nav
	echo '
	<script type="text/javascript">
	//<![CDATA[
	function modifier(formulaire)
	{
		window.location.href = 	"index.php?mod='.$K_mod.'&type=" + formulaire.elements["type"].value +
								"&int_j=" + formulaire.elements["day"].options[formulaire.elements["day"].selectedIndex].value +
								"&int_m=" + formulaire.elements["month"].options[formulaire.elements["month"].selectedIndex].value +
								"&int_a=" + formulaire.elements["year"].options[formulaire.elements["year"].selectedIndex].value
	}
	function ceJour(formulaire)
	{
		window.location.href = 	"index.php?mod='.$K_mod.'&type=" + formulaire.elements["type"].value +
								"&int_j='.$today['mday'].'&int_m='.$today['mon'].'&int_a='.$today['year'].'";
	}
	//]]>
	</script>';

	// Barre de Nav
	echo '
	<div style="padding-top:10px;text-align:center;">
	<form action="void();" name="lienNav" id="lienNav">
	<input type="hidden" name="type" value="'.$type.'" />
	<input type="hidden" name="sem" value="'.$cal['semaine'].'" />
	'.select('day" onchange="modifier(this.form);', $cal['jour'], 1, $cal['nbJour_mois']).'&nbsp;&nbsp;&nbsp;
	'.select('month" onchange="modifier(this.form);', $cal['mois'], 1, 12).'&nbsp;&nbsp;&nbsp;
	'.select('year" onchange="modifier(this.form);', $cal['annee'], $cal['annee']-5, $cal['annee']+5).'&nbsp;&nbsp;&nbsp;&nbsp;
	<input type="button" id="button" value=" Aujourd\'hui " onclick="ceJour(this.form);" />
	</form>';
	if (get_grade('poster') >= GRD_MEMBR && strtolower($_REQUEST['type'])!='jour')
	{
		echo '
		<p><img src="'.affImage('crayon.png').'" style="border:none;height:16px;width:13px" alt="proposer" /> <a href="index.php?mod='.$K_mod.'&amp;ac=evenements&amp;date='.date('d-m-Y').'">Proposer un evenement</a></p>';
	}
	echo '
	</div>';

	close_table();
}

?>
