<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: gestion_administration.php 846 2009-02-12 10:39:14Z foupoudave.devpwsphp $
// ---------------------------------------------------------------
// Cration : 17/01/08 par FouPouDave
// ---------------------------------------------------------------

/**
*	Scurit
*/
if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

/** 
*	Transformation des paramtres du module en variables
*/
require './modules/download/parametres.php';

// ---------------------------------------------------------------

function dl_select_grade ($dl_parametre)
{
	global ${'dl_'.$dl_parametre};
	$form = '<form action="index.php?mod=download&amp;ac=gestion_administration" method="post">
		<input type="hidden" name="nom" value="'.$dl_parametre.'" /> 
		<select name="valeur" onchange="submit()">';
			for($i=GRD_EXCLU;($n=get_grd_name($i))!=null;$i++)
			{
				$form .= '<option value="'.$i.'"'.(${'dl_'.$dl_parametre}==$i?' selected="selected"':'').'>'.$n.'</option>';
			}
		$form .= '</select>
	</form>';
	return $form;
}

function dl_select_groupe ($dl_parametre)
{
	global $K_liste_groupe, ${'dl_'.$dl_parametre};
	$select = '<form action="index.php?mod=download&amp;ac=gestion_administration" method="post">
		<input type="hidden" name="nom" value="'.$dl_parametre.'" /> 
		<select name="valeur" onchange="submit()">
			<option value="0"'.(${'dl_'.$dl_parametre}=='0' ? ' selected="selected"':'').'>Aucun groupe n&eacute;cessaire</option>';
			foreach ($K_liste_groupe as $id => $nom)
			{
				$select.= '<option value="'.$id.'"'.(${'dl_'.$dl_parametre}==$id ? ' selected="selected"':'').'>'.$nom.'</option>';
			}
		$select.= '</select>
	</form>';
	return $select;
}

function dl_checkbox($dl_parametre)
{
	global ${'dl_'.$dl_parametre};
	return '<form action="index.php?mod=download&amp;ac=gestion_administration" method="post">
		<input type="hidden" name="nom" value="'.$dl_parametre.'" />
		<input type="checkbox" name="valeur" '.(${'dl_'.$dl_parametre}=='on' ? ' checked':'').' onchange="submit()"/>
	</form>';
}

function dl_input($dl_parametre,$enabled=true)
{
	global ${'dl_'.$dl_parametre};
	$taille = strlen(${'dl_'.$dl_parametre})+3;
	if ($taille<20)
	{
		$taille=20;
	}
	return '<form action="index.php?mod=download&amp;ac=gestion_administration" method="post">
			<input type="hidden" name="nom" value="'.$dl_parametre.'" />
			<input type="text" name="valeur" value="'.${'dl_'.$dl_parametre}.'" size="'.$taille.'"'.($enabled ? '':' disabled="disabled"').' onchange="submit()" />
			<input type="submit" id="submit" name="ok" value=" OK " />
		</form>';
}

// ---------------------------------------------------------------

if (isset($_POST['nom']))
{
	if ($_POST['nom']=='upload' or $_POST['nom']=='upload_image')
	{
		$_POST['valeur'] = './'.str_replace('./','',$_POST['valeur']);
		if (substr($_POST['valeur'], -1, 1)!='/')
		{
			$_POST['valeur'].= '/';
		}
	}

	$erreur = false;
	reqmysql('
		UPDATE	`parametres`
		SET		`valeur`="'.$_POST['valeur'].'"
		WHERE	`nom`="dl_'.$_POST['nom'].'"
	') or $erreur = true;

	//Message
	if ($erreur)
	{
		echo df_message('erreur','Il y a un probl&egrave;me dans la modification !');
	}
	else
	{
		open_table();
		echo df_message('information','La modification a &eacute;t&eacute; effectu&eacute;e avec succ&egrave;s !');
		close_table();
	}

	header('Location: index.php?mod=download&ac=gestion_administration');
}

if ($dl_administration)
{
	bloc_head('Administration des options du module');
	
	echo '<b><u>Configuration</u></b><br />';
	
	echo '<fieldset>
		<legend>Affichage par d&eacute;faut de l\'index</legend>
		<form action="index.php?mod=download&amp;ac=gestion_administration" method="post">
			<input type="hidden" name="nom" value="aff_index" />
			<select name="valeur" onchange="submit()">';
				if ($dh = @opendir('./modules/download/'))
				{
					while (($dl_fichier = readdir($dh)) !== false)
					{
						if (substr($dl_fichier,0,9) == 'afficher_')
						{
							$dl_texte = substr($dl_fichier,9,-4);
							echo '<option value="'.$dl_texte.'"'.($dl_aff_index==$dl_texte ? ' selected="selected"' : '').'>'.$dl_texte.'</option>';
						}
					}
					closedir($dh);
				}
			echo '</select>
		</form>
	</fieldset>';

	echo '<fieldset>
		<legend>Indication de la dur&eacute;e des nouveaut&eacute;s</legend>
		<form action="index.php?mod=download&amp;ac=gestion_administration" method="post">
			<input type="hidden" name="nom" value="nouveaute" />
			<select name="valeur" onchange="submit()">';
				for ($i=1; $i<=7; $i++)
				{
					echo '<option value="'.$i.'"'.($dl_nouveaute==$i ? ' selected="selected"' : '').'>'.$i.' jour'.($i>=2 ? 's' : '').'</option>';
				}
			echo '<option value="15"'.($dl_nouveaute==15 ? ' selected="selected"' : '').'>15 jours</option>
			<option value="30"'.($dl_nouveaute==30 ? ' selected="selected"' : '').'>30 jours</option>
			<option value="60"'.($dl_nouveaute==60 ? ' selected="selected"' : '').'>60 jours</option>
			<option value="90"'.($dl_nouveaute==90 ? ' selected="selected"' : '').'>90 jours</option>
		</select>
		</form>
	</fieldset>';

	echo '<fieldset>
		<legend>Affichage de tous les fichiers non autoris&eacute;s</legend>
		<form action="index.php?mod=download&amp;ac=gestion_administration" method="post">
			<input type="hidden" name="nom" value="visible" />
			<select name="valeur" onchange="submit()">
				<option value="0"'.($dl_visible==0 ? ' selected="selected"' : '').'>non (utiliser les propri&eacute;t&eacute;s propres de chaque fichier)</option>
				<option value="1"'.($dl_visible==1 ? ' selected="selected"' : '').'>oui (ne tient pas compte des propri&eacute;t&eacute;s de chaque fichier)</option>
			</select>
		</form>
	</fieldset>';

	echo '<fieldset>
		<legend>Indication de la largeur et de la hauteur maximun des miniatures</legend>
		<form action="index.php?mod=download&amp;ac=gestion_administration" method="post">
			Largeur : <input type="hidden" name="nom" value="width_maxi" />
			<select name="valeur" onchange="submit()">';
				for ($i=25; $i<=400; $i=$i+25)
				{
					echo '<option value="'.$i.'"'.($dl_width_maxi==$i ? ' selected="selected"' : '').'>'.$i.' px</option>';
				}
			echo '</select><br />
		</form>
		<form action="index.php?mod=download&amp;ac=gestion_administration" method="post">
			Hauteur : <input type="hidden" name="nom" value="height_maxi" />
			<select name="valeur" onchange="submit()">';
				for ($i=25; $i<=400; $i=$i+25)
				{
					echo '<option value="'.$i.'"'.($dl_height_maxi==$i ? ' selected="selected"' : '').'>'.$i.' px</option>';
				}
			echo '</select><br />
		</form>
	</fieldset>';

	echo '<fieldset>
		<legend>Concernant l\'affichage du tableau</legend>
		<form action="index.php?mod=download&amp;ac=gestion_administration" method="post">
			Nombre de fichiers visualisable par page : <input type="hidden" name="nom" value="nb_dl_pagetab" />
			<select name="valeur" onchange="submit()">';
				for ($i=5; $i<=50; $i=$i+5)
				{
					echo '<option value="'.$i.'"'.($dl_nb_dl_pagetab==$i ? ' selected="selected"' : '').'>'.$i.'</option>';
				}
			echo '</select><br />
		</form>
	</fieldset>';
	echo '<br />';

	echo '<b><u>Permissions</u></b><br />';

	echo '<fieldset>
		<legend>Administration</legend>
		<table summary="Administration">
			<tr>
				<td><u>Action</u></td>
				<td><u>Grade</u></td>
				<td>&nbsp;</td>
				<td><u>Groupe</u></td>
			</tr>
			<tr>
				<td>Editer</td>
				<td>'.dl_select_grade('grd_administration').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_administration').'</td>
			</tr>
		</table>
	</fieldset>';

	echo '<fieldset>
		<legend>Cat&eacute;gorie</legend>
		<table summary="Cat&eacute;gorie">
			<tr>
				<td><u>Action</u></td>
				<td><u>Grade</u></td>
				<td>&nbsp;</td>
				<td><u>Groupe</u></td>
				<td>&nbsp;</td>
				<td><u>Grade par d&eacute;faut</u></td>
				<td>&nbsp;</td>
				<td><u>Groupe par d&eacute;faut</u></td>
			</tr>
			<tr>
				<td>Ajouter</td>
				<td>'.dl_select_grade('grd_repertoire_ajouter').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_repertoire_ajouter').'</td>
				<td>&nbsp;</td>
				<td>'.dl_select_grade('grd_repertoire_defaut').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_repertoire_defaut').'</td>
			</tr>
			<tr>
				<td>Editer</td>
				<td>'.dl_select_grade('grd_repertoire_editer').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_repertoire_editer').'</td>
			</tr>
			<tr>
				<td>Supprimer</td>
				<td>'.dl_select_grade('grd_repertoire_supprimer').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_repertoire_supprimer').'</td>
			</tr>
		</table>
	</fieldset>';

	echo '<fieldset>
		<legend>Fichier</legend>
		<table summary="Fichier">
			<tr>
				<td><u>Action</u></td>
				<td><u>Grade</u></td>
				<td>&nbsp;</td>
				<td><u>Groupe</u></td>
				<td>&nbsp;</td>
				<td><u>Grade par d&eacute;faut</u></td>
				<td>&nbsp;</td>
				<td><u>Groupe par d&eacute;faut</u></td>
			</tr>
			<tr>
				<td>Ajouter</td>
				<td>'.dl_select_grade('grd_fichier_ajouter').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_fichier_ajouter').'</td>
				<td>&nbsp;</td>
				<td>'.dl_select_grade('grd_fichier_defaut').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_fichier_defaut').'</td>
			</tr>
			<tr>
				<td>Editer</td>
				<td>'.dl_select_grade('grd_fichier_editer').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_fichier_editer').'</td>
			</tr>
			<tr>
				<td>Remplacer</td>
				<td>'.dl_select_grade('grd_fichier_remplacer').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_fichier_remplacer').'</td>
			</tr>
			<tr>
				<td>Deplacer</td>
				<td>'.dl_select_grade('grd_fichier_deplacer').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_fichier_deplacer').'</td>
			</tr>
			<tr>
				<td>Supprimer</td>
				<td>'.dl_select_grade('grd_fichier_supprimer').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_fichier_supprimer').'</td>
			</tr>
		</table>
	</fieldset>';

	echo '<fieldset>
		<legend>Image</legend>
		<table summary="Image">
			<tr>
				<td><u>Action</u></td>
				<td><u>Grade</u></td>
				<td>&nbsp;</td>
				<td><u>Groupe</u></td>
			</tr>
			<tr>
				<td>Ajouter</td>
				<td>'.dl_select_grade('grd_image_ajouter').'</td>
				<td> ou </td>
				<td>'.dl_select_groupe('grp_image_ajouter').'</td>
			</tr>
		</table>
	</fieldset>';

	echo '<br />';

	echo '<b><u>Upload</u></b><br />';
	$dl_requete = reqmysql ('
		SELECT	*
		FROM	`dl`
	');
	if (mysql_num_rows($dl_requete)==0)
	{
		echo '<table summary="stockage1">
				<tr>
					<td>Dossier de stockage des fichiers upload&eacute;s : </td>
					<td>'.dl_input('upload').'</td>
				</tr>
			</table>';
	}
	else
	{
		echo '<table summary="stockage2">
				<tr>
					<td>Dossier de stockage des fichiers upload&eacute;s : </td>
					<td>'.$dl_upload.'</td>
				</tr>
			</table>';
	}
	if (file_exists($dl_upload))
	{
		@chmod ($dl_upload,0777);
		if (chmod_fichier($dl_upload)<777)
		{
			echo df_message('erreur','Le chmod de ce r&eacute;pertoire est insuffisant pour faire des uploads en ligne (mettre &agrave; 777).');
		}
	}
	else
	{
		echo df_message('erreur','Attention, le r&eacute;pertoire n\'existe pas !');
	}

	if (mysql_num_rows($dl_requete)==0)
	{
		echo '<table summary="stockage3">
				<tr>
					<td>Dossier de stockage des images des fichiers upload&eacute;s : </td>
					<td>'.dl_input('upload_image').'</td>
				</tr>
			</table>';
	}
	else
	{
		echo '<table summary="stockage4">
				<tr>
					<td>Dossier de stockage des images des fichiers upload&eacute;s : </td>
					<td>'.$dl_upload_image.'</td>
				</tr>
			</table>';
	}
	if (file_exists($dl_upload_image))
	{
		@chmod($dl_upload_image,0777);
		if (chmod_fichier($dl_upload_image)<777)
		{
			echo df_message('erreur','Le chmod de ce r&eacute;pertoire est insuffisant pour faire des uploads en ligne (mettre &agrave; 777).');
		}
	}
	else
	{
		echo df_message('erreur','Attention, le r&eacute;pertoire n\'existe pas !');
	}
	close_table();
}
else
{
	ZoneReserve();
}
?>
