<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: remplacer_fichier.php 889 2010-01-24 17:39:31Z mike007.devpwsphp $
// ---------------------------------------------------------------
// Cration : 12/10/08 par FouPouDave
// ---------------------------------------------------------------

/**
*	Scurit
*/
if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

/** 
*	Transformation des paramtres du module en variables
*/
require './modules/download/parametres.php';

// ---------------------------------------------------------------

require './modules/download/trier.php';
// Chargement de la classe
require_once './includes/upload.class.php';

if ($dl_fichier_remplacer)
{
	bloc_head('Remplacer un fichier');
	// Instanciation d'un nouvel objet "upload"
	$Upload = new Upload();

	if (isset($dl_liste[$_POST['fichier']]))
	{
		// Pour changer le mode d'criture (entre 0 et 3)
		$Upload->WriteMode = 0;
		// Pour filtrer les fichiers par extension
		$Upload->Extension = $dl_liste[$_POST['fichier']]->filtre;
		// Pour filtrer les fichiers par entte
		//$Upload->MimeType  = 'image/gif;image/pjpeg;image/bmp;image/x-png'; 
		// Pour vrifier la page appelante
		//$Upload->CheckReferer = 'http://mondomaine/mon_chemin/mon_fichier.php';
		// Pour gnrer une erreur si les champs sont obligatoires
		$Upload->Required     = true;
		// Pour interdire automatiquement tous les fichiers considrs comme "dangereux"
		$Upload->SecurityMax  = true;
		// Dfinition du rpertoire de destination
		$Upload->DirUpload    = $dl_liste[$_POST['fichier']]->fichier;
		// On lance la procdure d'upload
		$Upload->Execute();
		// Gestion erreur / succs
		if ($UploadError)
		{
			foreach ($Upload->GetError() as $dl_id => $dl_champ)
			{
				if (is_array($dl_champ))
				{
					foreach ($dl_champ as $dl_id2 => $dl_champ2)
					{
						echo df_message('erreur',$dl_champ2);
					}
				}
				else
				{
					echo df_message('erreur',$dl_champ);
				}
			}
		}
		else
		{
			$_POST['synchroniser'] = '';
			include 'modules/download/synchroniser.php';

			//header(html_entity_decode('Location: index.php?mod=download&amp;ac=editer&amp;int_id='.mysql_insert_id()));
			header(html_entity_decode('Location: index.php?mod=download&amp;ac=gestion'));
		}
		echo '<hr/>';
	}

	// Pour limiter la taille d'un fichier (exprime en ko)
	//$Upload->MaxFilesize		= '1024';
	// Pour ajouter des attributs aux champs de type file
	$Upload->FieldOptions		= 'size="80"';
	// Pour indiquer le nombre de champs dsir
	$Upload->Fields				= 1;
	// Initialisation du formulaire
	$Upload->InitForm();
	//Formulaire
	if (preg_replace('#M#', '', ini_get('upload_max_filesize'))*1024 <= $Upload->MaxFilesize/1024)
	{
		echo 'La taille des fichiers est limit&eacute;e par l\'h&eacute;bergeur  '.(preg_replace('#M#', '', ini_get('upload_max_filesize'))*1024).' ko.<br />';
	}
	else
	{
		echo 'La taille des fichiers est limit&eacute;e par le webmaster  '.($Upload->MaxFilesize/1024).' ko.<br />';
	}
	echo '<br />
	<form method="post" enctype="multipart/form-data" action="index.php?mod=download&amp;ac=remplacer_fichier">
	<div style="text-align:center;">'.$Upload->Field[0].$Upload->Field[1].'</div>
	<br />';
	foreach ($dl_liste_repertoire as $dl_nom => $dl_fichier)
	{
		echo '<table width="100%" cellpadding="0" cellspacing="1" summary="icone repertoire" onmouseover="this.className = \'onmouse_over\';" onmouseout="this.className = \'onmouse_out\';">
			<tr >
				<td width="24"><input type="radio" name="fichier" value="'.$dl_fichier->fichier.'"/></td>';
				//Dcalage "Explorateur"
				for ($i=1;$i<=$dl_fichier->niveau_repertoire;$i++)
				{
					echo '<td width="24">&nbsp;</td>';
				}
				// Icone "Rpertoire" et "Fichier"
				echo '<td width="24">';
				if (!file_exists($dl_fichier->fichier))
				{
					echo '<img src="modules/download/images/'.$dl_fichier->type.'_non.png" alt="'.$dl_fichier->type.'" border="0" name="pas_de_correction_c'.$dl_fichier->id.'" />';
				}
				elseif (!($dl_repertoire_ajouter or $dl_repertoire_supprimer or $dl_fichier_ajouter or $dl_fichier_deplacer or $dl_fichier_supprimer))
				{
					echo '<img src="modules/download/images/'.$dl_fichier->type.'.png" alt="'.$dl_fichier->type.'" border="0" name="pas_de_correction_c'.$dl_fichier->id.'" />';
				}
				elseif (!$dl_fichier->valid)
				{
					echo '<img src="modules/download/images/'.$dl_fichier->type.'_novalid.png" alt="'.$dl_fichier->type.'" border="0" name="pas_de_correction_c'.$dl_fichier->id.'" />';
				}
				elseif ($dl_fichier->type=='repertoire' and $dl_fichier->chmod<'0777')
				{
					echo '<img src="modules/download/images/'.$dl_fichier->type.'_chmod.png" alt="'.$dl_fichier->type.'" border="0" name="pas_de_correction_c'.$dl_fichier->id.'" />';
				}
				elseif ($dl_fichier->type=='fichier' and $dl_fichier->chmod<'0666')
				{
					echo '<img src="modules/download/images/'.$dl_fichier->type.'_chmod.png" alt="'.$dl_fichier->type.'" border="0" name="pas_de_correction_c'.$dl_fichier->id.'" />';
				}
				else
				{
					echo '<img src="modules/download/images/'.$dl_fichier->type.'_oui.png" alt="'.$dl_fichier->type.'" border="0" name="pas_de_correction_c'.$dl_fichier->id.'" />';
				}
				echo '</td>';

				// Nom
				echo '<td colspan="10"><b>'.basename($dl_fichier->fichier).'</b>'.(!empty($dl_fichier->titre) ? ' ('.$dl_fichier->titre.')' : '').'</td>
				<td align="right">'.$dl_fichier->filtre.'</td>
			</tr>
		</table>';
	}
	echo '<br />
	<div style="text-align:center;">
		<input type="submit" id="submit" name="remplacer_fichier" value="Remplacer" />
	</div>
	</form>
	<br />';
	close_table();
}
else
{
	ZoneReserve();
}
?>
