<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: update.php 900 2010-04-12 21:03:22Z mike007.devpwsphp $
// ---------------------------------------------------------------
// Cration : 18/06/08 par FouPouDave
// ---------------------------------------------------------------
 
if (!(defined('__KWS__'))) {die('Erreur d\'appel de fichier.');}

if (get_grade() < GRD_ADMIN)
{
	zoneReserve();
}
elseif (!file_exists('./modules/'.$K_mod.'/gestionnaire.txt'))
{
	bloc_head('Mise &agrave; jour du module '.$K_mod);
	echo df_message('erreur', '<h2>Votre module '.$K_mod.' est incomplet !</h2>', '<h3>Veuillez re-uploader les fichiers sur votre serveur<br />et recommencer la proc&eacute;dure de mise &agrave; jour !</h3>');
	close_table();
}
else
{
	if (isset($_POST['updateCNL']))
	{
		unset($_SESSION['modules_maj']);
		header('Location: index.php?mod=admin&ac=gestion_module');
		exit();
	}

	if (!isset(${$K_mod.'_version'}))
	{
		${$K_mod.'_version'} = 0;
	}

	if (file_exists('./modules/'.$K_mod.'/gestionnaire.txt'))
	{
		$module_file = fopen('./modules/'.$K_mod.'/gestionnaire.txt','r');

		$mod_rev = fgets($module_file ,999);	// Nom
		$mod_rev = fgets($module_file ,999);	// Description
		$mod_rev = fgets($module_file ,999);	// Obligatoire
		$mod_rev = fgets($module_file ,999);	// Version

		fclose($module_file);
	}
	else
	{
		$mod_rev = ${$K_mod.'_version'};
	}

	$kws_rev = '1.6';

	// Controle url etapes
	if (isset($_POST['step2']))
	{
		$step = $_POST['step2'];
	}
	elseif (isset($_POST['step']) and $_POST['step'] > 0 and $_POST['step'] < 4)
	{
		$step = $_POST['step'];
	}
	else
	{
		$step = 1;
	}
	if ($step == 2 and !isset($_POST['updateOK']))
	{
		$step = 1;
	}

	// Inclusion du fichier class
	require_once './includes/class.install.php';
	$class_install = new install();

	// Affichage de la barre des etapes a gauche
	$step_array = array ('Compatibilit&eacute;', 'Mise &agrave; jour', 'Terminer');
	$update_menu = $class_install->aff_step($step, $step_array);

	// Verif compatibilite
	if ($step == 1)
	{
		$distribution_tmp = explode('-',$K_distribution_versions);
		foreach ($distribution_tmp as $distribution_num)
		{
			$distribution_on = $distribution_num;
		}
		if (substr($distribution_on, 0, 3) < $kws_rev)
		{
			$update_menu = $class_install->aff_step(3, $step_array);
			$update_form1 = '';
			$update_contenu = df_message('attention', '<span style="color:red;font-weight:bold">AVERTISSEMENT</span>', '<p>Cette version du module n&eacute;cessite la version '.$kws_rev.' de kwsPHP.<br />Vous devez proceder &agrave; la mise &agrave; jour de votre portail avant de poursuivre.</p>');
			$update_form2 = '<form name="rtb" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';
			$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
		}
		elseif ($mod_rev <= ${$K_mod.'_version'})
		{
			$update_menu = $class_install->aff_step(3, $step_array);
			$update_form1 = '';
			$update_contenu = df_message('information', '<strong>Mise &agrave; jour inutile.</strong>', '<p>Cette version du module est d&eacute;j&agrave; celle install&eacute;e sur votre portail.</p>');
			$update_form2 = '<form name="rtb" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';
			$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
		}
		else
		{
			$liste_a_effacer = array(
				array('./modules/'.$K_mod.'/pied_de_module.php',true),
				array('./modules/'.$K_mod.'/images/download2.png',true),
				array('./modules/'.$K_mod.'/images/aucune_image.png',true)
			);
			if(count($liste_a_effacer)>0)
			{
				foreach($liste_a_effacer as $id => $fichier)
				{
					if ($fichier[1])
					{
						@unlink($fichier[0]);
					}
					if (!file_exists($fichier[0]))
					{
						unset($liste_a_effacer[$id]);
					}
				}
			}

			$liste_a_verifier = array(
				//'./modules/'.$K_mod.'/update.php'
			);
			if(count($liste_a_verifier)>0)
			{
				foreach($liste_a_verifier as $id => $fichier)
				{
					if (file_exists($fichier))
					{
						unset($liste_a_verifier[$id]);
					}
				}
			}

			$update_fichier = '';
			if (count($liste_a_effacer)>0)
			{
				$update_fichier .= '<div>';
				foreach ($liste_a_effacer as $id => $fichier)
				{
					$update_fichier .= '<div style="color:#990000">- Le fichier <strong>'.$fichier[0].'</strong> doit tre effac. Veuillez le supprimer manuellement du ftp.</div>';
				}
				$update_fichier .= '</div>';
				$update_button = '<input type="hidden" name="step2" value="1" />
				<input type="submit" value=" Retester " />
				<input type="submit" name="updateCNL" value=" Abandonner la mise &agrave; jour " style="margin-left:4em" />';
			}
			elseif (count($liste_a_verifier)>0)
			{
				$update_fichier .= '<div>';
				foreach ($liste_a_verifier as $id => $fichier)
				{
					$update_fichier .= '<div style="color:#990000">- Le fichier <strong>'.$fichier.'</strong> est manquant. Veuillez le remettre manuellement sur le ftp.</div>';
				}
				$update_fichier .= '</div>';
				$update_button = '<input type="hidden" name="step2" value="1" />
				<input type="submit" value=" Retester " />
				<input type="submit" name="updateCNL" value=" Abandonner la mise &agrave; jour " style="margin-left:4em" />';
			}
			else
			{
				$update_button = '<input type="submit" name="updateOK"  value=" Poursuivre la mise &agrave; jour " />
				<input type="submit" name="updateCNL" value=" Abandonner la mise &agrave; jour " style="margin-left:4em" />';
			}

			$update_form1 = '';
			$update_contenu = df_message('attention', '<span style="color:red;font-weight:bold">AVERTISSEMENT</span>', $update_fichier.'<p>Il est fortement recommand&eacute; d\'effectuer une sauvegarde de la base MySQL <strong>AVANT</strong> de proc&eacute;der &agrave; la mise &agrave; jour.</p><p>Ne soyez pas impatient !<br />La mise &agrave; jour peut se montrer longue.</p>');
			$update_form2 = '<form name="'.$K_mod.'_update" action="index.php?mod='.$K_mod.'&amp;ac=update" method="post">';
		} 
	}

	// Mise  jour
	elseif ($step == 2)
	{
		$update_result = '';
		function update_query($query, $erreur=true)
		{
			global $update_result;
			$update_test = reqmysql($query, $erreur);
			if (!$update_test)
			{
				$update_result .= 'Erreur de mise &agrave; jour lors de l\'execution de la requ&ecirc;te : '.$query.'<br />
				<br />';
			}
			return $update_test;
		}

		if (${$K_mod.'_version'} < 757)
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="dl_visible"'))== 0)
			{
				update_query("INSERT INTO `parametres` (`id`, `nom`, `valeur`) VALUES ('', 'dl_visible', '0');");
			}
		}
		if (${$K_mod.'_version'} < 808)
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="dl_grd_fichier_remplacer"'))== 0)
			{
				update_query("INSERT INTO `parametres` (`id`, `nom`, `valeur`) VALUES ('', 'dl_grd_fichier_remplacer', '4');");
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="dl_grp_fichier_remplacer"'))== 0)
			{
				update_query("INSERT INTO `parametres` (`id`, `nom`, `valeur`) VALUES ('', 'dl_grp_fichier_remplacer', '0');");
			}
		}
		if (${$K_mod.'_version'} < 845)
		{
			if (mysql_num_rows(reqmysql('DESCRIBE `dl` "taille"'))==0)
			{
				update_query("ALTER TABLE `dl` ADD `taille` INT( 11 ) NOT NULL DEFAULT '0' AFTER `fichier`;");
				update_query("ALTER TABLE `dl` ADD `taille_str` VARCHAR( 15 ) NOT NULL AFTER `taille`;");
				update_query("ALTER TABLE `dl` ADD `type` VARCHAR( 15 ) NOT NULL AFTER `taille_str`;");
				update_query("ALTER TABLE `dl` ADD `chmod` INT( 11 ) NOT NULL DEFAULT '0' AFTER `type`;");
				update_query("ALTER TABLE `dl` ADD `md5_file` VARCHAR( 255 ) NOT NULL AFTER `chmod`;");
				update_query("ALTER TABLE `dl` ADD `niveau_repertoire` INT( 11 ) NOT NULL DEFAULT '0' AFTER `md5_file`;");
				update_query("ALTER TABLE `dl` ADD `visible` INT( 1 ) NOT NULL DEFAULT '0' AFTER `niveau_repertoire`;");
				update_query("ALTER TABLE `dl` ADD `licence` VARCHAR( 255 ) NOT NULL AFTER `visible`;");
				update_query("ALTER TABLE `dl` ADD `image_miniature` VARCHAR( 255 ) NOT NULL AFTER `image`;");
				update_query("ALTER TABLE `dl` ADD `vote` INT( 11 ) NOT NULL DEFAULT '0' AFTER `vote_somme`;");

				$dl_requete = reqmysql('
					SELECT	*
					FROM	`dl`
				');
				while ($dl_fichier = mysql_fetch_object($dl_requete))
				{
					$dl_fichier->taille				= filesize($dl_fichier->fichier);
					$dl_fichier->taille_str			= taille_fichier($dl_fichier->taille);
					$dl_fichier->type				= substr($dl_fichier->fichier, -1, 1)=='/' ? 'repertoire' : 'fichier';
					$dl_fichier->chmod				= chmod_fichier($dl_fichier->fichier);
					$dl_fichier->md5_file			= @md5_file($dl_fichier->fichier);
					$dl_fichier->niveau_repertoire	= niveau_repertoire($dl_fichier->fichier,$dl_upload);
					$dl_fichier->visible			= 0;
					$dl_fichier->licence			= dirname($dl_fichier->fichier).'/licence.html';
					if (!file_exists($dl_fichier->licence))
					{
						$dl_fichier->licence		= '';
					}
					if ($dl_fichier->type == 'fichier')
					{
						$image = $dl_upload_image.substr(basename($dl_fichier->fichier),0,-4);
					}
					else
					{
						$image = $dl_upload_image.basename($dl_fichier->fichier);
					}
					$dl_fichier->image = '';
					if (empty($dl_fichier->image) and file_exists($image.'.png'))
					{
						$dl_fichier->image = $image.'.png';
					}
					elseif (empty($dl_fichier->image) and file_exists($image.'.jpg'))
					{
						$dl_fichier->image = $image.'.jpg';
					}
					elseif (empty($dl_fichier->image) and file_exists($image.'.gif'))
					{
						$dl_fichier->image = $image.'.gif';
					}
					if (file_exists($image.'_mini.png'))
					{
						$dl_fichier->image_miniature = $image.'_mini.png';
					}
					elseif (file_exists($image.'_mini.jpg'))
					{
						$dl_fichier->image_miniature = $image.'_mini.jpg';
					}
					elseif (file_exists($image.'_mini.gif'))
					{
						$dl_fichier->image_miniature = $image.'_mini.gif';
					}
					elseif (!empty($dl_fichier->image))
					{
						$dl_fichier->image_miniature = $dl_fichier->image;
					}
					elseif ($dl_fichier->type == 'fichier')
					{
						$dl_fichier->image_miniature = 'modules/download/upload_image/fichier.png';
					}
					else
					{
						$dl_fichier->image_miniature = 'modules/download/upload_image/repertoire_ferme.png';
					}
					if ($dl_fichier->vote_nbr!=0)
					{
						$dl_fichier->vote				= round($dl_fichier->vote_somme/$dl_fichier->vote_nbr);
					}
					else
					{
						$dl_fichier->vote				= 0;
					}

					update_query("
						UPDATE	`dl`
						SET		`taille`='".$dl_fichier->taille."',
								`taille_str`='".$dl_fichier->taille_str."',
								`type`='".$dl_fichier->type."',
								`chmod`='".$dl_fichier->chmod."',
								`md5_file`='".$dl_fichier->md5_file."',
								`niveau_repertoire`='".$dl_fichier->niveau_repertoire."',
								`visible`='".$dl_fichier->visible."',
								`licence`='".$dl_fichier->licence."',
								`image`='".sp($dl_fichier->image)."',
								`image_miniature`='".sp($dl_fichier->image_miniature)."',
								`vote`='".$dl_fichier->vote."'
						WHERE	`id`='".$dl_fichier->id."'
					");
				}
			}
		}

		if (${$K_mod.'_version'} < 846)
		{
			if (mysql_num_rows(reqmysql('DESCRIBE `dl` "vote_autorisation"'))==0)
			{
				update_query("ALTER TABLE `dl` ADD `vote_autorisation` INT( 1 ) NOT NULL DEFAULT '1' AFTER `hit`;");
			}
		}

		if (${$K_mod.'_version'} < 889)
		{
			update_query("DELETE FROM `dl` WHERE `fichier` LIKE '%index.htm%';");
			update_query("DELETE FROM `dl` WHERE `fichier` LIKE '%licence.htm%';");
			update_query("DELETE FROM `dl` WHERE `fichier` LIKE '%.htaccess%';");
			update_query('DELETE FROM `parametres` WHERE `nom`="`'.$K_mod.'_version`" '); // erreur d'insertion sur la 835 ds le install.sql = variable en double
			update_query('UPDATE `dl` SET `image`="" WHERE `image` LIKE "%aucune_image%" ');
			update_query('UPDATE `dl` SET `image_miniature`="" WHERE `image_miniature` LIKE "%aucune_image%" ');
		}

		// table parametres
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="'.$K_mod.'_version"'))== 0)
		{
			update_query('INSERT INTO `parametres` SET `nom`="'.$K_mod.'_version", `valeur`="'.$mod_rev.'"');
		}
		else
		{
			update_query('UPDATE `parametres` SET `valeur`="'.$mod_rev.'" WHERE `nom`="'.$K_mod.'_version"');
		}

		// suppression de l'alerte de MAJ
		update_query('DELETE FROM `alerte` WHERE `module` = "'.$K_mod.'" AND `auteur` = "KwsPHP (MAJ)"');

		$update_form1 = '<form name="form1" action="index.php?mod='.$K_mod.'&amp;ac=update" method="post">';

		$update_contenu = '<p><strong>Mise &agrave; jour des tables</strong><br />
		<br />';
		if (!empty($update_result))
		{
			$update_contenu.= '<strong>Erreur</strong><br />
			'.$update_result.'
			<br />
			<span style="color:red;">La mise &agrave; jour a donc &eacute;t&eacute; incompl&egrave;te, vous &ecirc;tes donc contraint de nous signaler l\'erreur.</span><br />
			<br />
			Reportez cette erreur sur notre <a href="http://www.kwsphp.org/" target="_blank">forum de support</a>.</p>';
		}
		else
		{
			$update_contenu.= '<span style="color:#009900">Les tables ont &eacute;t&eacute; correctement mises &agrave; jour !</span></p>';
		}

		$update_form2 = '';

		$update_button = '<input type="submit" value=" Suivant " />';
	}

	elseif ($step == 3)
	{
		$update_form1 = '';

		$update_contenu = '<p>Votre module est maintenant &agrave; jour sur votre serveur.</p>
		'.(empty($_SESSION['update_msg'])? '' : $_SESSION['update_msg']).'
		<p>Le support du portail est assur&eacute; sur le forum de notre communaut&eacute; <a href="http://www.kwsphp.org/">KwsPHP.org</a>.</p>
		<p>Cliquer sur "Terminer" pour quitter le programme de mise &agrave; jour et retourner au gestionnaire de votre site.</p>';

		unset($_SESSION['update_msg']);

		$update_form2 = '<form name="form1" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';

		$update_button = '<input type="submit" name="sbutton" value=" Terminer " />';
	}

	bloc_head('Update du module '.$K_mod);
	echo '
	<script type="text/javascript" language="javascript">
		var head = document.getElementsByTagName("head")[0];
		var head_inc = document.createElement("link");
		head_inc.rel = "stylesheet";
		head_inc.type = "text/css";
		head_inc.href = "./includes/updatephp.css";
		head.appendChild(head_inc);
	</script>

	<p style="float:left;text-align:center;padding-left:5em;padding-top:20px;font-size:14px;font-weight:bold">
		Mise &agrave; jour du module '.$K_mod.' (vers la version '.$mod_rev.') pour KwsPHP '.$kws_rev.'
	</p>
	<div style="clear:both;float:left;width:20%;height:150px;text-align:center;padding-top:30px">'.$update_menu.'</div>
	<div style="float:right;width:75%;text-align:center;padding-top:15px">'.$update_form1.'
		<div style="width:95%;margin:auto;border: 1px solid #BCBCBC;">'.$update_contenu.'</div>
		'.$update_form2.'
		<input type="hidden" name="step" value="'.($step+1).'" /><br />
		<div style="text-align:right;padding-right:3em">'.$update_button.'</div>
		</form>
	</div>
	<br style="clear:both" />';
	close_table();
}
?>
