/* $Id: redim_boite.js 900 2010-04-12 21:03:22Z mike007.devpwsphp $ */

/*
	Ralis par oli.
	http://blog.oli-web.com/?2006/04/23/53-redimensionnement-et-drag-n-drop-javascript
	Corrig par Pouss
	http://blog.oli-web.com/?2006/04/23/53-redimensionnement-et-drag-n-drop-javascript#c336
	Adapt par mike007 pour KwsPHP
*/
var isDragging = false;
var objectToDrag;
var obj;
var ecartX;
var ecartY;
var curX;
var curY;
var newPosX;
var newPosY;
var initialHeight;
var initialWidth;
var initialCurX;
var initialCurY;
var theAction;
var minWidth = 40;
var minHeight = 65;
var thePadding = 2;
var _MOVE_ 		= 0;
var _RESIZE_N_ 	= 1;
var _RESIZE_S_ 	= 2;
var _RESIZE_W_ 	= 3;
var _RESIZE_E_ 	= 4;
var _RESIZE_NW_ = 5;
var _RESIZE_NE_ = 6;
var _RESIZE_SW_ = 7;
var _RESIZE_SE_ = 8;

function getPositionCurseur(e)
{
	//ie
	if(document.all)
	{
		curX = event.clientX;
		curY = event.clientY;
	}
	//netscape 4
	if(document.layers)
	{
		curX = e.pageX;
		curY = e.pageY;
	}
	//mozilla
	if(document.getElementById)
	{
		curX = e.clientX;
		curY = e.clientY;
	}
}

function beginDrag(p_obj,e)
{
	isDragging = true;
	objectToDrag = p_obj;
	getPositionCurseur(e);
	ecartX = curX - parseInt(objectToDrag.style.left);
	ecartY = curY - parseInt(objectToDrag.style.top);

	initialWidth = objectToDrag.offsetWidth;
	initialHeight = objectToDrag.offsetHeight;
	initialCurX = curX;
	initialCurY = curY;
	// Si c'est IE (correction de la selection)
	if(document.all)
	{
		selection();
	}
	theAction = modifCurseur(p_obj, e);
}

function drag(e)
{
	if(isDragging == true)
	{
		getPositionCurseur(e);

		switch (theAction)
		{
			case _MOVE_ :
			newPosX = curX - ecartX;
			newPosY = curY - ecartY;
			objectToDrag.style.left = newPosX + 'px';
			objectToDrag.style.top = newPosY + 'px';
			break;
			case _RESIZE_S_ :
				resizeByBottom(curY);
				break;
/*			case _RESIZE_N_ :
				resizeByTop(curY);
				break;
			case _RESIZE_W_ :
				resizeByLeft(curX);
				break;
			case _RESIZE_E_ :
				resizeByRight(curX);
				break;
			case _RESIZE_NW_ :
				resizeByTop(curY);
				resizeByLeft(curX);
				break;
			case _RESIZE_NE_ :
				resizeByTop(curY);
				resizeByRight(curX);
				break;
			case _RESIZE_SW_ :
				resizeByBottom(curY);
				resizeByLeft(curX);
				break;
			case _RESIZE_SE_ :
				resizeByBottom(curY);
				resizeByRight(curX);
				break;
*/
		}
	}
}

function modifCurseur(p_obj, e)
{
	getPositionCurseur(e);
/*
	// haut gauche
	if(((curY - parseInt(p_obj.style.top)) < thePadding) &&
		((curX - parseInt(p_obj.style.left)) < thePadding )){
			p_obj.style.cursor = 'nw-resize';
			return _RESIZE_NW_;
		}

	// haut droit
	if(((curY - parseInt(p_obj.style.top)) < thePadding) &&
		(((parseInt(p_obj.style.left) +  p_obj.offsetWidth) - curX) < thePadding)){
			p_obj.style.cursor = 'ne-resize';
			return _RESIZE_NE_;
		}

	// bas gauche
	if((((parseInt(p_obj.style.top) +  p_obj.offsetHeight) - curY) < thePadding) &&
		((curX - parseInt(p_obj.style.left)) < thePadding )){
			p_obj.style.cursor = 'sw-resize';
			return _RESIZE_SW_;
		}

	// bas droit
	if((((parseInt(p_obj.style.top) +  p_obj.offsetHeight) - curY) < thePadding) &&
		(((parseInt(p_obj.style.left) +  p_obj.offsetWidth) - curX) < thePadding)){
			p_obj.style.cursor = 'se-resize';
			return _RESIZE_SE_;
		}

	// cote gauche
	if((curX - parseInt(p_obj.style.left)) < thePadding ){
			p_obj.style.cursor = 'w-resize';
			return _RESIZE_W_;
		}

	// cote droit
	if(((parseInt(p_obj.style.left) +  p_obj.offsetWidth) - curX) < thePadding){
			p_obj.style.cursor = 'e-resize';
			return _RESIZE_E_;
		}

	// haut
	if((curY - parseInt(p_obj.style.top)) < thePadding){
			p_obj.style.cursor = 'n-resize';
			return _RESIZE_N_;
		}
*/
	// bas
	if(((parseInt(p_obj.style.top) +  p_obj.offsetHeight) - curY) < thePadding)
	{
		p_obj.style.cursor = 's-resize';
		return _RESIZE_S_;
	}

	p_obj.style.cursor = 'move';
	return _MOVE_;
}

function endDrag()
{
	isDragging = false;
	objectToDrag.style.cursor = 'pointer';

	// Si c'est IE (correction de la selection)
	if(document.all)
	{
		selection();
	}
	EcrireCookie("K_HeightMess", objectToDrag.style.height);
}

// Empeche la selection
function selection()
{
	function voleur(e)	{ return false; }

	function bien()	{ return true; }

	document.onselectstart=new Function ("return false");

	if (window.sidebar)
	{
		document.onmousedown=voleur;
		document.onclick=bien;
	}
}

function resizeByTop(p_curY){
	var newPosY;
	var newHeight;
	newHeight = (initialHeight + (initialCurY - p_curY));
	if(newHeight > minHeight){
		newPosY = p_curY - ecartY;
		objectToDrag.style.top = newPosY + 'px';
		objectToDrag.style.height = newHeight + 'px';
	}
}

function resizeByBottom(p_curY){
	var newHeight;
	newHeight = (initialHeight - (initialCurY - p_curY));
	if(newHeight > minHeight && newHeight < 600)
		objectToDrag.style.height = newHeight + 'px';
}

function resizeByLeft(p_curX){
	var newPosX;
	var newWidth;
	newWidth = (initialWidth + (initialCurX - p_curX));
	if(newWidth > minWidth){
		newPosX = p_curX - ecartX;
		objectToDrag.style.left = newPosX + 'px';
		objectToDrag.style.width = newWidth + 'px';
	}
}

function resizeByRight(p_curX){
	var newWidth;
	newWidth = (initialWidth - (initialCurX - p_curX));
	if(newWidth > minWidth)
		objectToDrag.style.width = newWidth + 'px';
}