<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: update.php 903 2010-04-25 07:54:35Z mike007.devpwsphp $
// ---------------------------------------------------------------
// Cration : 18/06/08 par FouPouDave
// ---------------------------------------------------------------
 
if (!(defined('__KWS__'))) {die('Erreur d\'appel de fichier.');}

if (get_grade() < GRD_ADMIN)
{
	zoneReserve();
}
elseif (!file_exists('./modules/'.$K_mod.'/gestionnaire.txt'))
{
	bloc_head('Mise &agrave; jour du module '.$K_mod);
	echo df_message('erreur', '<h2>Votre module '.$K_mod.' est incomplet !</h2>', '<h3>Veuillez re-uploader les fichiers sur votre serveur<br />et recommencer la proc&eacute;dure de mise &agrave; jour !</h3>');
	close_table();
}
else
{
	if (isset($_POST['updateCNL']))
	{
		unset($_SESSION['modules_maj']);
		header('Location: index.php?mod=admin&ac=gestion_module');
		exit();
	}

	if (!isset(${$K_mod.'_version'}))
	{
		${$K_mod.'_version'} = 0;
	}

	$module_file = fopen('./modules/'.$K_mod.'/gestionnaire.txt','r');
	$mod_rev = trim(fgets($module_file ,999));	// Nom
	$mod_rev = trim(fgets($module_file ,999));	// Description
	$mod_rev = trim(fgets($module_file ,999));	// Obligatoire
	$mod_rev = trim(fgets($module_file ,999));	// Version
	fclose($module_file);

	$kws_rev = '1.6';

	// Controle url etapes
	if (isset($_POST['step2']))
	{
		$step = $_POST['step2'];
	}
	elseif (isset($_POST['step']) and $_POST['step'] > 0 and $_POST['step'] < 4)
	{
		$step = $_POST['step'];
	}
	else
	{
		$step = 1;
	}
	if ($step == 2 and !isset($_POST['updateOK']))
	{
		$step = 1;
	}

	// Inclusion du fichier class
	require_once 'includes/class.install.php';
	$class_install = new install();

	// Affichage de la barre des etapes a gauche
	$step_array = array ('Compatibilit&eacute;', 'Mise &agrave; jour', 'Terminer');
	$update_menu = $class_install->aff_step($step, $step_array);

	// Verif compatibilite
	if ($step == 1)
	{
		// rcup version portail
		$distribution_tmp = explode('-',$K_distribution_versions);
		foreach ($distribution_tmp as $distribution_num)
		{
			$distribution_on = $distribution_num;
		}
		// version portail insuffisante => pas de mise a jour possible
		if (substr($distribution_on, 0, 3) < $kws_rev)
		{
			$update_menu = $class_install->aff_step(3, $step_array);
			$update_form1 = '';
			$update_contenu = df_message('attention', '<span style="color:red;font-weight:bold">AVERTISSEMENT</span>', '<p>Cette version du module n&eacute;cessite la version '.$kws_rev.' de kwsPHP.<br />Vous devez proceder &agrave; la mise &agrave; jour de votre portail avant de poursuivre.</p>');
			$update_form2 = '<form name="rtb" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';
			$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
		}
		// Version module ok => mise  jour inutile
		elseif ($mod_rev <= ${$K_mod.'_version'})
		{
			$update_menu = $class_install->aff_step(3, $step_array);
			$update_form1 = '';
			$update_contenu = df_message('information', '<strong>Mise &agrave; jour inutile.</strong>', '<p>Cette version du module est d&eacute;j&agrave; celle install&eacute;e sur votre portail.</p>');
			$update_form2 = '<form name="rtb" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';
			$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
		}
		// ok pour la mise  jour
		else
		{
			$update_form1 = '';
			$update_contenu = df_message('attention', '<span style="color:red;font-weight:bold">AVERTISSEMENT</span>', '<p>Il est fortement recommand&eacute; d\'effectuer une sauvegarde de la base MySQL <strong>AVANT</strong> de proc&eacute;der &agrave; la mise &agrave; jour.</p><p>Ne soyez pas impatient !<br />La mise &agrave; jour peut se montrer longue.</p>');
			$update_form2 = '<form name="'.$mod.'_update" action="index.php?mod='.$mod.'&amp;ac=update" method="post">';
			$update_button = '<input type="submit" name="updateOK"  value=" Poursuivre la mise &agrave; jour " />
			<input type="submit" name="updateCNL" value=" Abandonner la mise &agrave; jour " style="margin-left:4em" />';
		} 
	}

	// Mise  jour
	elseif ($step == 2)
	{
		$update_result = '';
		function update_query($query, $erreur=true)
		{
			global $update_result;
			$update_test = reqmysql($query, $erreur);
			if (!$update_test)
			{
				$update_result .= 'Erreur de mise &agrave; jour lors de l\'execution de la requ&ecirc;te : '.$query.'<br />
				<br />';
			}
			return $update_test;
		}

		// Mise  jour de la table infoz pour la comparaison
		if (is_dir('./modules/infoZ') and file_exists('./modules/infoZ/MajBdd.php'))
		{
			include './modules/infoZ/MajBdd.php';
		}

		if (${$K_mod.'_version'} < 765)
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit` WHERE `module`="espace_membre" AND `page`="consul_profil";'))== 0)
			{
				update_query('INSERT INTO `droit` SET `module`="espace_membre", `page`="consul_profil", `grade`="-1", `groupe`="0", `condition`="or"');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit` WHERE `module`="espace_membre" AND `page`="modif_profil";'))== 0)
			{
				update_query('INSERT INTO `droit` SET `module`="espace_membre", `page`="modif_profil", `grade`="-1", `groupe`="0", `condition`="or"');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="espace_membre" AND `page`="profil";'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` VALUES ("","espace_membre","profil","0");');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="espace_membre" AND `page`="stu_attdel";'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` VALUES ("","espace_membre","stu_attdel","0");');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="espace_membre" AND `page`="stu_attval";'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` VALUES ("","espace_membre","stu_attval","0");');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="espace_membre" AND `page`="stu_banni";'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` VALUES ("","espace_membre","stu_banni","0");');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="espace_membre" AND `page`="stu_rglmnt";'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` VALUES ("","espace_membre","stu_rglmnt","0");');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="espace_membre" AND `page`="stu_suspen";'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` VALUES ("","espace_membre","stu_suspen","0");');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="espace_membre" AND `page`="val";'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` VALUES ("","espace_membre","val","0");');
			}
			update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="profil";');
			update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="stu_attdel";');
			update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="stu_attval";');
			update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="stu_banni";');
			update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="stu_rglmnt";');
			update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="stu_suspen";');
			update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="val";');
		}
		
		if (${$K_mod.'_version'} < 800)
		{
			update_query('UPDATE `users` SET `icq` = "" WHERE `icq` = "0"');
		}

		if (${$K_mod.'_version'} < 878)
		{
			// double controle: depuis la 745 `editeur` n'etait pas ds install.sql
			if (mysql_num_rows(reqmysql('DESCRIBE `users` "editeur"'))==0)
			{
				update_query('ALTER TABLE `users` ADD `editeur` ENUM( "defaut", "bbcode", "html" ) NOT NULL DEFAULT "defaut" COMMENT "Editeur de texte du membre" AFTER `flood`');
			}
			elseif (mysql_result(reqmysql('DESCRIBE `users` "editeur"'),0,'Type')!='enum(\'defaut\',\'bbcode\',\'html\')')
			{
				update_query('ALTER TABLE `users` CHANGE `editeur` `editeur` ENUM( "defaut", "bbcode", "html" ) NOT NULL DEFAULT "defaut" COMMENT "Editeur de texte du membre"');
				update_query('UPDATE `users` SET `editeur`="defaut"');
			}
		}

		if (${$K_mod.'_version'} < 887)
		{
			unset($_SESSION['champs_cplt']);
			unset($_SESSION['users_cplt']);
			if (mysql_num_rows(reqmysql('SHOW TABLES LIKE "users_champs";'))==0)
			{
				update_query('
				CREATE TABLE IF NOT EXISTS `users_champs` (
				  `id` int(11) NOT NULL auto_increment,
				  `nom` varchar(30) NOT NULL DEFAULT "",
				  `taille` smallint(3) NOT NULL DEFAULT "30",
				  `titre` varchar(30) NOT NULL DEFAULT "",
				  `type` enum("facultatif","obligatoire") NOT NULL DEFAULT "facultatif",
				  `format` enum("texte","select","radio") NOT NULL DEFAULT "texte",
				  `options` text NOT NULL DEFAULT "",
				  `actif` enum("0","1") NOT NULL DEFAULT "1",
				  PRIMARY KEY (`id`)
				) TYPE=MyISAM COMMENT="Dfinition des champs supplmentaires pour les membres" AUTO_INCREMENT=1 ;
				');
				update_query('INSERT INTO `users_champs` SET `nom`="nom", `taille`="32", `titre`="Nom complet", `type`="obligatoire", `format`="texte", `actif`="1"');
				update_query('INSERT INTO `users_champs` SET `nom`="icq", `taille`="9", `titre`="Numro ICQ", `type`="facultatif", `format`="texte", `actif`="1"');
				update_query('INSERT INTO `users_champs` SET `nom`="msn", `taille`="40", `titre`="MSN Messenger", `type`="facultatif", `format`="texte", `actif`="1"');
				update_query('INSERT INTO `users_champs` SET `nom`="yahoom", `taille`="40", `titre`="Yahoo Messenger", `type`="facultatif", `format`="texte", `actif`="1"');
				update_query('INSERT INTO `users_champs` SET `nom`="aim", `taille`="40", `titre`="Adresse AIM", `type`="facultatif", `format`="texte", `actif`="1"');
				update_query('INSERT INTO `users_champs` SET `nom`="site", `taille`="100", `titre`="Site personnel", `type`="facultatif", `format`="texte", `actif`="1"');
				update_query('INSERT INTO `users_champs` SET `nom`="localisation", `taille`="40", `titre`="Localisation", `type`="facultatif", `format`="texte", `actif`="1"');
			}
			if (mysql_num_rows(reqmysql('SHOW TABLES LIKE "users_cplt";'))==0)
			{
				update_query('CREATE TABLE `users_cplt` AS SELECT `id`, `nom`, `icq`, `msn`, `yahoom`, `aim`, `site`, `localisation` FROM `users` ;');
				update_query('ALTER TABLE `users_cplt` CHANGE `id` `id_pseudo` INT( 11 ) NOT NULL  ;');
				update_query('ALTER TABLE `users_cplt` ADD PRIMARY KEY(`id_pseudo`) ;');
				update_query('ALTER TABLE `users_cplt`  COMMENT = "Champs supplmentaires pour les membres" ;');
				update_query('ALTER TABLE `users` DROP `nom` ;');
				update_query('ALTER TABLE `users` DROP `icq` ;');
				update_query('ALTER TABLE `users` DROP `msn` ;');
				update_query('ALTER TABLE `users` DROP `yahoom` ;');
				update_query('ALTER TABLE `users` DROP `aim` ;');
				update_query('ALTER TABLE `users` DROP `site` ;');
				update_query('ALTER TABLE `users` DROP `localisation` ;');
			}
		}

		if (${$K_mod.'_version'} < 889)
		{
			if (mysql_num_rows(reqmysql('DESCRIBE `users_champs` "message"'))==0)
			{
				update_query('ALTER TABLE `users_champs` ADD `message` varchar(70) NOT NULL DEFAULT "" AFTER `titre`');
			}
		}

		if (${$K_mod.'_version'} < 891)
		{
			if (mysql_num_rows(reqmysql('DESCRIBE `users_champs` "position"'))==0)
			{
				update_query('ALTER TABLE `users_champs` ADD `position` INT(11) NOT NULL DEFAULT "1" AFTER `actif`');
				$req_chp_sup = update_query('SELECT `id` FROM `users_champs` ORDER BY `type` DESC, `position` ASC');
				$i=1;
				while ($rep_chp_sup = mysql_fetch_object($req_chp_sup))
				{
					update_query('UPDATE `users_champs` SET `position` = "'.$i.'"  WHERE `id` = "'.$rep_chp_sup->id.'"');
					$i++;
				}
			}
		}

		if (${$K_mod.'_version'} < 894)
		{
			if (mysql_num_rows(reqmysql('DESCRIBE `users` "infos_ban"'))==0)
			{
				update_query('ALTER TABLE `users` ADD `infos_ban` TEXT NOT NULL DEFAULT "" AFTER `statut`');
			}
		}

		if (${$K_mod.'_version'} < 900)
		{
			$req_UsersEnTrop = reqmysql('SELECT `id`,`id_pseudo` FROM `users_cplt` LEFT JOIN `users` ON `users_cplt`.`id_pseudo` = `users`.`id` WHERE `users`.`id` IS NULL');
			while ($rep_UsersEnTrop = mysql_fetch_object($req_UsersEnTrop))
			{
				update_query('DELETE FROM `users_cplt` WHERE `id_pseudo`="'.$rep_UsersEnTrop->id_pseudo.'";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="espace_membre" AND `page`="login"'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` SET `module`="espace_membre", `page`="login", `accessible`="1";');
				update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="login";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="espace_membre" AND `page`="logout"'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` SET `module`="espace_membre", `page`="logout", `accessible`="0";');
				update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="logout";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="espace_membre" AND `page`="enregistrer_js"'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` SET `module`="espace_membre", `page`="enregistrer_js", `accessible`="0";');
				update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="enregistrer_js";');
			}
			update_query ('DELETE FROM `droit` WHERE `module`="espace_membre" AND `page`="meta";');
		}

		if (${$K_mod.'_version'} < 903)
		{
			update_query('ALTER TABLE `users_champs` CHANGE `taille` `taille` SMALLINT(3) NOT NULL DEFAULT "40"');
			update_query('ALTER TABLE `users_champs` CHANGE `format` `format` ENUM("texte","select","radio","textarea") NOT NULL DEFAULT "texte"');
			$_SESSION['update_msg'] .= df_message(
				'information',
				'Modifications :',
				'Ajout de l&rsquo;option "textarea" dans la gestion des champs suppl&eacute;mentaires'
			);
		}

		// table parametres
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="'.$mod.'_version"'))== 0)
		{
			update_query('INSERT INTO `parametres` SET `nom`="'.$K_mod.'_version", `valeur`="'.$mod_rev.'"');
		}
		else
		{
			update_query('UPDATE `parametres` SET `valeur`="'.$mod_rev.'" WHERE `nom`="'.$K_mod.'_version"');
		}

		// suppression de l'alerte de MAJ
		update_query('DELETE FROM `alerte` WHERE `module` = "'.$K_mod.'" AND `auteur` = "KwsPHP (MAJ)"');

		$update_form1 = '<form name="form1" action="index.php?mod='.$K_mod.'&amp;ac=update" method="post">';

		$update_contenu = '<p><strong>Mise &agrave; jour des tables</strong><br />
		<br />';
		if (!empty($update_result))
		{
			$update_contenu.= '<strong>Erreur</strong><br />
			'.$update_result.'
			<br />
			<span style="color:red;">La mise &agrave; jour a donc &eacute;t&eacute; incompl&egrave;te, vous &ecirc;tes donc contraint de nous signaler l\'erreur.</span><br />
			<br />
			Reportez cette erreur sur notre <a href="http://www.kwsphp.org/" target="_blank">forum de support</a>.</p>';
		}
		else
		{
			$update_contenu.= '<span style="color:#009900">Les tables ont &eacute;t&eacute; correctement mises &agrave; jour !</span></p>';
		}

		$update_form2 = '';

		$update_button = '<input type="submit" value=" Suivant " />';
	}

	elseif ($step == 3)
	{
		$update_form1 = '';

		$update_contenu = '<p>Votre module est maintenant &agrave; jour sur votre serveur.</p>
		'.(empty($_SESSION['update_msg'])? '' : $_SESSION['update_msg']).'
		<p>Le support du portail est assur&eacute; sur le forum de notre communaut&eacute; <a href="http://www.kwsphp.org/">KwsPHP.org</a>.</p>
		<p>Cliquer sur "Terminer" pour quitter le programme de mise &agrave; jour et retourner au gestionnaire de votre site.</p>';

		unset($_SESSION['update_msg']);

		$update_form2 = '<form name="form1" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';

		$update_button = '<input type="submit" name="sbutton" value=" Terminer " />';
	}

	bloc_head('Update du module '.$K_mod);
	echo '
	<script type="text/javascript" language="javascript">
		var head = document.getElementsByTagName("head")[0];
		var head_inc = document.createElement("link");
		head_inc.rel = "stylesheet";
		head_inc.type = "text/css";
		head_inc.href = "./includes/updatephp.css";
		head.appendChild(head_inc);
	</script>

	<p style="float:left;text-align:center;padding-left:5em;padding-top:20px;font-size:14px;font-weight:bold">
		Mise &agrave; jour du module '.$K_mod.' (vers la version '.$mod_rev.') pour KwsPHP '.$kws_rev.'
	</p>
	<div style="clear:both;float:left;width:20%;height:150px;text-align:center;padding-top:30px">'.$update_menu.'</div>
	<div style="float:right;width:75%;text-align:center;padding-top:15px">'.$update_form1.'
		<div style="width:95%;margin:auto;border: 1px solid #BCBCBC;">'.$update_contenu.'</div>
		'.$update_form2.'
		<input type="hidden" name="step" value="'.($step+1).'" /><br />
		<div style="text-align:right;padding-right:3em">'.$update_button.'</div>
		</form>
	</div>
	<br style="clear:both" />';
	close_table();
}
?>
