<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: update.php 915 2011-04-20 19:41:37Z mike007 $
// ---------------------------------------------------------------
// Cration : 18/06/08 par FouPouDave
// ---------------------------------------------------------------
 
if (!(defined('__KWS__'))) {die('Erreur d\'appel de fichier.');}

if (get_grade() < GRD_ADMIN)
{
	zoneReserve();
}
elseif (!file_exists('./modules/'.$K_mod.'/gestionnaire.txt'))
{
	bloc_head('Mise &agrave; jour du module '.$K_mod);
	echo df_message('erreur', '<h2>Votre module '.$K_mod.' est incomplet !</h2>', '<h3>Veuillez re-uploader les fichiers sur votre serveur<br />et recommencer la proc&eacute;dure de mise &agrave; jour !</h3>');
	close_table();
}
else
{
	if (isset($_POST['updateCNL']))
	{
		unset($_SESSION['modules_maj']);
		header('Location: index.php?mod=admin&ac=gestion_module');
		exit();
	}

	if (!isset(${$K_mod.'_version'}))
	{
		${$K_mod.'_version'} = 0;
	}

	$module_file = fopen('./modules/'.$K_mod.'/gestionnaire.txt','r');
	$mod_rev = trim(fgets($module_file ,999));	// Nom
	$mod_rev = trim(fgets($module_file ,999));	// Description
	$mod_rev = trim(fgets($module_file ,999));	// Obligatoire
	$mod_rev = trim(fgets($module_file ,999));	// Version
	fclose($module_file);

	$kws_rev = '1.6';

	// Controle url etapes
	if (isset($_POST['step2']))
	{
		$step = $_POST['step2'];
	}
	elseif (isset($_POST['step']) and $_POST['step'] > 0 and $_POST['step'] < 4)
	{
		$step = $_POST['step'];
	}
	else
	{
		$step = 1;
	}
	if ($step == 2 and !isset($_POST['updateOK']))
	{
		$step = 1;
	}

	// Inclusion du fichier class
	require_once 'includes/class.install.php';
	$class_install = new install();

	// Affichage de la barre des etapes a gauche
	$step_array = array ('Compatibilit&eacute;', 'Mise &agrave; jour', 'Terminer');
	$update_menu = $class_install->aff_step($step, $step_array);

	// Verif compatibilite
	if ($step == 1)
	{
		// rcup version portail
		$distribution_tmp = explode('-',$K_distribution_versions);
		foreach ($distribution_tmp as $distribution_num)
		{
			$distribution_on = $distribution_num;
		}
		// version portail insuffisante => pas de mise a jour possible
		if (substr($distribution_on, 0, 3) < $kws_rev)
		{
			$update_menu = $class_install->aff_step(3, $step_array);
			$update_form1 = '';
			$update_contenu = df_message('attention', '<span style="color:red;font-weight:bold">AVERTISSEMENT</span>', '<p>Cette version du module n&eacute;cessite la version '.$kws_rev.' de kwsPHP.<br />Vous devez proceder &agrave; la mise &agrave; jour de votre portail avant de poursuivre.</p>');
			$update_form2 = '<form name="rtb" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';
			$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
		}
		// Version module ok => mise  jour inutile
		elseif ($mod_rev <= ${$K_mod.'_version'})
		{
			$update_menu = $class_install->aff_step(3, $step_array);
			$update_form1 = '';
			$update_contenu = df_message('information', '<strong>Mise &agrave; jour inutile.</strong>', '<p>Cette version du module est d&eacute;j&agrave; celle install&eacute;e sur votre portail.</p>');
			$update_form2 = '<form name="rtb" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';
			$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
		}
		// ok pour la mise  jour
		else
		{
			$liste_a_effacer = array(
				//array('./modules/'.$K_mod.'/pied_de_module.php',true)
				array('./modules/'.$K_mod.'/de_prev.php',true),
				array('./modules/'.$K_mod.'/no_reponse.php',true)
			);
			if(count($liste_a_effacer)>0)
			{
				foreach($liste_a_effacer as $id => $fichier)
				{
					if ($fichier[1])
					{
						@unlink($fichier[0]);
					}
					if (!file_exists($fichier[0]))
					{
						unset($liste_a_effacer[$id]);
					}
				}
			}

			$liste_a_verifier = array(
				//'./modules/'.$K_mod.'/update.php'
			);
			if(count($liste_a_verifier)>0)
			{
				foreach($liste_a_verifier as $id => $fichier)
				{
					if (file_exists($fichier))
					{
						unset($liste_a_verifier[$id]);
					}
				}
			}

			$update_fichier = '';
			if (count($liste_a_effacer)>0)
			{
				$update_fichier .= '<div>';
				foreach ($liste_a_effacer as $id => $fichier)
				{
					$update_fichier .= '<div style="color:#990000">- Le fichier <strong>'.$fichier[0].'</strong> doit tre effac. Veuillez le supprimer manuellement du ftp.</div>';
				}
				$update_fichier .= '</div>';
				$update_button = '<input type="hidden" name="step2" value="1" />
				<input type="submit" value=" Retester " />
				<input type="submit" name="updateCNL" value=" Abandonner la mise &agrave; jour " style="margin-left:4em" />';
			}
			elseif (count($liste_a_verifier)>0)
			{
				$update_fichier .= '<div>';
				foreach ($liste_a_verifier as $id => $fichier)
				{
					$update_fichier .= '<div style="color:#990000">- Le fichier <strong>'.$fichier.'</strong> est manquant. Veuillez le remettre manuellement sur le ftp.</div>';
				}
				$update_fichier .= '</div>';
				$update_button = '<input type="hidden" name="step2" value="1" />
				<input type="submit" value=" Retester " />
				<input type="submit" name="updateCNL" value=" Abandonner la mise &agrave; jour " style="margin-left:4em" />';
			}
			else
			{
				$update_button = '<input type="submit" name="updateOK"  value=" Poursuivre la mise &agrave; jour " />
				<input type="submit" name="updateCNL" value=" Abandonner la mise &agrave; jour " style="margin-left:4em" />';
			}

			$update_form1 = '';
			$update_contenu = df_message('attention', '<span style="color:red;font-weight:bold">AVERTISSEMENT</span>', $update_fichier.'<p>Il est fortement recommand&eacute; d\'effectuer une sauvegarde de la base MySQL <strong>AVANT</strong> de proc&eacute;der &agrave; la mise &agrave; jour.</p><p>Ne soyez pas impatient !<br />La mise &agrave; jour peut se montrer longue.</p>');
			$update_form2 = '<form name="'.$K_mod.'_update" action="index.php?mod='.$K_mod.'&amp;ac=update" method="post">';
		} 
	}

	// Mise  jour
	elseif ($step == 2)
	{
		$update_result = '';
		function update_query($query, $erreur=true)
		{
			global $update_result;
			$update_test = reqmysql($query, $erreur);
			if (!$update_test)
			{
				$update_result .= 'Erreur de mise &agrave; jour lors de l\'execution de la requ&ecirc;te : '.$query.'<br />
				<br />';
			}
			return $update_test;
		}

		// Mise  jour de la table infoz pour la comparaison
		if (is_dir('./modules/infoZ') and file_exists('./modules/infoZ/MajBdd.php'))
		{
			include './modules/infoZ/MajBdd.php';
		}

		if (${$K_mod.'_version'} < 849)
		{
			if (mysql_result(reqmysql('DESCRIBE `forum_topic` "edit"'),0,'Type')!='text')
			{
				update_query('ALTER TABLE `forum_topic` CHANGE `edit` `edit` TEXT NOT NULL');
				update_query('UPDATE `forum_topic` SET `edit`=""');
			}
			if (mysql_result(reqmysql('DESCRIBE `forum_rep` "edit"'),0,'Type')!='text')
			{
				update_query('ALTER TABLE `forum_rep` CHANGE `edit` `edit` TEXT NOT NULL');
				update_query('UPDATE `forum_rep` SET `edit`=""');
			}
			// Requete Team ayant dej mis a jour le portail mais on pourra l'effacer par la suite
			update_query('UPDATE `forum_rep` SET `edit`="" WHERE `edit`="'.sp(serialize(array())).'"');
			
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_rep` "accept"'))==0)
			{
				update_query('ALTER TABLE `forum_rep` ADD `accept` TEXT NOT NULL');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_gr_invisible";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_gr_invisible", `valeur`="4";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_gr_repactiv_oui";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_gr_repactiv_oui", `valeur`="0";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_gr_repactiv_non";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_gr_repactiv_non", `valeur`="4";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_repactiv";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_repactiv", `valeur`="non";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_repactiv_color";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_repactiv_color", `valeur`="ccff99";');
			}
			// oubli dans install
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_lecture_session";'))== 0)
			{
				update_query ('INSERT INTO `parametres` SET `nom`="forum_lecture_session", `valeur`="oui";');
			}
		}

		if (${$K_mod.'_version'} < 860)
		{
			// ajout du sondage

			// Cration table des votes
			update_query('
				CREATE TABLE IF NOT EXISTS `forum_sondage_vote` (
					`topic_id` int(11) NOT NULL default "0",
					`membre`   int(11) NOT NULL default "0",
					PRIMARY KEY (`topic_id`,`membre`)
				) TYPE=MyISAM COMMENT="Mouchard des membres ayant dj vot";
			');

			// update table des topics
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_topic` "sondage"'))==0)
			{
				update_query('ALTER TABLE `forum_topic` ADD `sondage` TEXT NOT NULL AFTER `resolu`;');
			}

			if (mysql_num_rows(reqmysql('SELECT `id` FROM `parametres` WHERE `nom`="forum_sondage_grd_creer";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_sondage_grd_creer", `valeur`=2');
			}
			if (mysql_num_rows(reqmysql('SELECT `id` FROM `parametres` WHERE `nom`="forum_sondage_grd_voter";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_sondage_grd_voter", `valeur`=0');
			}
		}

		if (${$K_mod.'_version'} < 868)
		{
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_cat` "mots_cles"'))==0)
			{
				update_query('ALTER TABLE `forum_cat` ADD `mots_cles` VARCHAR(250) NOT NULL DEFAULT "" AFTER `description`;');
			}
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_topic` "mots_cles"'))==0)
			{
				update_query('ALTER TABLE `forum_topic` ADD `mots_cles` VARCHAR(250) NOT NULL DEFAULT "" AFTER `contenu`;');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_rep_joint";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_rep_joint", `valeur`="on";');
			}
		}

		if (${$K_mod.'_version'} < 875)
		{
			update_query ('UPDATE `droit_exclu` SET `page`="dePrev" WHERE `module`="forum" AND `page`="de_prev"');
			update_query ('UPDATE `droit_exclu` SET `page`="noReponse" WHERE `module`="forum" AND `page`="no_reponse"');
		}

		if (${$K_mod.'_version'} < 876)
		{
			update_query('UPDATE `forum_topic` SET `edit`="" WHERE `edit`="'.sp(serialize(array())).'"');
			update_query('UPDATE `forum_rep` SET `edit`="" WHERE `edit`="'.sp(serialize(array())).'"');
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_nbrep_rep";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_nbrep_rep", `valeur`="10";');
			}
		}

		if (${$K_mod.'_version'} < 878)
		{
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_topic` "move"'))==0)
			{
				update_query('ALTER TABLE `forum_topic` ADD `move` TEXT NOT NULL DEFAULT "" AFTER `edit`;');
			}
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_rep` "move"'))==0)
			{
				update_query('ALTER TABLE `forum_rep` ADD `move` TEXT NOT NULL DEFAULT "" AFTER `edit`;');
			}
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_topic` "editeur"'))==0)
			{
				update_query('ALTER TABLE `forum_topic` ADD `editeur` ENUM("bbcode","html") NOT NULL DEFAULT "bbcode" AFTER `contenu`;');
			}
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_rep` "editeur"'))==0)
			{
				update_query('ALTER TABLE `forum_rep` ADD `editeur` ENUM("bbcode","html") NOT NULL DEFAULT "bbcode" AFTER `contenu`;');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_ico_gr2_evol";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_ico_gr2_evol", `valeur`="off";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_ico_gr3_evol";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_ico_gr3_evol", `valeur`="off";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_ico_gr4_evol";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_ico_gr4_evol", `valeur`="off";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_topic_edit";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_topic_edit", `valeur`="on";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_topic_2rep";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_topic_2rep", `valeur`="off";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_topic_move";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_topic_move", `valeur`="on";');
			}
		}

		if (${$K_mod.'_version'} < 887)
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_gr_motscles";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_gr_motscles", `valeur`="3";');
			}
			$Req_Forum_Lecture = reqmysql('SELECT `forum_lecture`.`ref`, `users`.`id` FROM `forum_lecture` LEFT JOIN `users` ON `forum_lecture`.`ref` = `users`.`id`;');
			while ($Rep_Forum_Lecture = mysql_fetch_object($Req_Forum_Lecture))
			{
				if($Rep_Forum_Lecture->id == NULL)
				{
					update_query('DELETE FROM `forum_lecture` WHERE `ref`="'.$Rep_Forum_Lecture->ref.'";');
				}
			}
		}

		if (${$K_mod.'_version'} < 889)
		{
			//Hack sponsor / Rponse automatique
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_sponsor";'))== 0)
			{
				update_query('DELETE FROM `parametres` WHERE `nom`="forum_sponsor_user";');
				update_query('DELETE FROM `parametres` WHERE `nom`="forum_sponsor_user_id";');
				update_query('DELETE FROM `parametres` WHERE `nom`="forum_sponsor_post";');
				update_query('DELETE FROM `parametres` WHERE `nom`="forum_sponsor_texte";');
				$K_forum_sponsor['actif'] = 0;
				$K_forum_sponsor['nom'] = 'Sponsor-Bot';
				$K_forum_sponsor = serialize($K_forum_sponsor);
				update_query('INSERT INTO `parametres` SET `nom`="forum_sponsor", `valeur`="'.sp($K_forum_sponsor).'";');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_sponsor_texte";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_sponsor_texte", `valeur`="Contenu de la rponse automatique (Texte) ici";');
			}
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_cat` "deroule"'))==0)
			{
				update_query('ALTER TABLE `forum_cat` ADD `deroule` VARCHAR(3) NOT NULL DEFAULT "" AFTER `id_groupe`;');
			}
			unset($_SESSION);
		}

		if (${$K_mod.'_version'} < 897)
		{
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_sponsor_pub";'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom`="forum_sponsor_pub", `valeur`="<p style=\"text-align:center\">\r\nContenu de de la rponse automatique (Pub) ici\r\n</p>";');
			}
			$ForumSponsor = unserialize($K_forum_sponsor);
			$ForumSponsor['actif'] = $K_forum_sponsor['actif'];
			$ForumSponsor['gr_pub'] = -1;
			$ForumSponsor['gr_txt'] = -1;
			$ForumSponsor['nom'] = $K_forum_sponsor['nom'];
			$ForumSponsor = serialize($ForumSponsor);
			update_query ('UPDATE `parametres` SET `valeur`="'.sp($ForumSponsor).'" WHERE `nom`="forum_sponsor"');
		}

		if (${$K_mod.'_version'} < 899)
		{
			update_query ('DELETE FROM `droit` WHERE `module`="forum" AND `page`="meta";');
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="forum" AND `page`="sessionCache"'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` SET `module`="forum", `page`="sessionCache", `accessible`="0";');
				update_query ('DELETE FROM `droit` WHERE `module`="forum" AND `page`="sessionCache";');
			}
		}

		if (${$K_mod.'_version'} < 900)
		{
			update_query ('UPDATE `parametres` SET `nom`="forum_sponsor" WHERE `nom`="K_forum_sponsor"');
			update_query ('UPDATE `parametres` SET `nom`="forum_sponsor_texte" WHERE `nom`="K_forum_sponsor_texte"');
			update_query ('UPDATE `parametres` SET `nom`="forum_sponsor_pub" WHERE `nom`="K_forum_sponsor_pub"');

			if (mysql_num_rows(reqmysql('DESCRIBE `forum_cat` "grade"'))==0)
			{
				update_query('ALTER TABLE `forum_cat` ADD `grade` int(1) NOT NULL DEFAULT "-1" AFTER `dern_date`;');
			}
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_cat` "gr_cretop"'))==0)
			{
				update_query('ALTER TABLE `forum_cat` ADD `gr_cretop` int(1) NOT NULL DEFAULT "0" AFTER `id_groupe`;');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_regles"'))== 0)
			{
				update_query ('INSERT INTO `parametres` SET `nom`="forum_regles", `valeur`=""');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="forum_reglesAff"'))== 0)
			{
				update_query ('INSERT INTO `parametres` SET `nom`="forum_reglesAff", `valeur`="off"');
			}
			$_SESSION['update_msg'] .= '<br />'.df_message(
				'information',
				'Mise en place de grades pour les cat&eacute;gories :<br />
				- 1 pour l&rsquo;acc&egrave;s aux cat&eacute;gories<br />
				- 1 pour &eacute;crire un nouveau topic'
			);
			$_SESSION['update_msg'] .= '<br />'.df_message(
				'information',
				'Modification de la gestion des <strong style="color:red">r&egrave;gles du forum</strong>',
				'D&eacute;sormais, les r&egrave;gles du forum sont ind&eacute;pendantes de celles du site'
			);
		}

		if (${$K_mod.'_version'} < 906)
		{
			update_query('UPDATE `forum_topic` SET `edit`="" WHERE `edit`="'.sp(serialize(unserialize(''))).'"');
			update_query('UPDATE `forum_rep` SET `edit`="" WHERE `edit`="'.sp(serialize(unserialize(''))).'"');
		}

		if (${$K_mod.'_version'} < 908)
		{
			if (mysql_num_rows(reqmysql('DESCRIBE `forum_prev` "mail"'))==0)
			{
				update_query('ALTER TABLE `forum_prev` ADD `mail` ENUM("0","1") NOT NULL DEFAULT "0";');
				update_query('UPDATE `parametres` SET `valeur`=concat(`valeur`,"<br /><br />PS: Vous ne recevrez plus de mail lors de l\'ajout d\'une rponse jusqu\' la lecture du sujet s\'y rapportant.") WHERE `nom`="mailreponsetopic";');
			}
		}

		// N de version
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="'.$K_mod.'_version"'))== 0)
		{
			update_query('INSERT INTO `parametres` SET `nom`="'.$K_mod.'_version", `valeur`="'.$mod_rev.'"');
		}
		else
		{
			update_query('UPDATE `parametres` SET `valeur`="'.$mod_rev.'" WHERE `nom`="'.$K_mod.'_version"');
		}

		// suppression de l'alerte de MAJ
		update_query('DELETE FROM `alerte` WHERE `module` = "'.$K_mod.'" AND `auteur` = "KwsPHP (MAJ)"');

		$update_form1 = '<form name="form1" action="index.php?mod='.$K_mod.'&amp;ac=update" method="post">';

		$update_contenu = '<p><strong>Mise &agrave; jour des tables</strong><br />
		<br />';
		if (!empty($update_result))
		{
			$update_contenu.= '<strong>Erreur</strong><br />
			'.$update_result.'
			<br />
			<span style="color:red;">La mise &agrave; jour a donc &eacute;t&eacute; incompl&egrave;te, vous &ecirc;tes donc contraint de nous signaler l\'erreur.</span><br />
			<br />
			Reportez cette erreur sur notre <a href="http://www.kwsphp.org/" target="_blank">forum de support</a>.</p>';
		}
		else
		{
			$update_contenu.= '<span style="color:#009900">Les tables ont &eacute;t&eacute; correctement mises &agrave; jour !</span></p>';
		}

		$update_form2 = '';

		$update_button = '<input type="submit" value=" Suivant " />';
	}

	elseif ($step == 3)
	{
		$update_form1 = '';

		$update_contenu = '<p>Votre module est maintenant &agrave; jour sur votre serveur.</p>
		'.(empty($_SESSION['update_msg'])? '' : $_SESSION['update_msg']).'
		<p>Le support du portail est assur&eacute; sur le forum de notre communaut&eacute; <a href="http://www.kwsphp.org/">KwsPHP.org</a>.</p>
		<p>Cliquer sur "Terminer" pour quitter le programme de mise &agrave; jour et retourner au gestionnaire de votre site.</p>';

		unset($_SESSION['update_msg']);

		$update_form2 = '<form name="form1" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';

		$update_button = '<input type="submit" name="sbutton" value=" Terminer " />';
	}

	bloc_head('Update du module '.$K_mod);
	echo '
	<script type="text/javascript" language="javascript">
		var head = document.getElementsByTagName("head")[0];
		var head_inc = document.createElement("link");
		head_inc.rel = "stylesheet";
		head_inc.type = "text/css";
		head_inc.href = "./includes/updatephp.css";
		head.appendChild(head_inc);
	</script>

	<p style="float:left;text-align:center;padding-left:5em;padding-top:20px;font-size:14px;font-weight:bold">
		Mise &agrave; jour du module '.$K_mod.' (vers la version '.$mod_rev.') pour KwsPHP '.$kws_rev.'
	</p>
	<div style="clear:both;float:left;width:20%;height:150px;text-align:center;padding-top:30px">'.$update_menu.'</div>
	<div style="float:right;width:75%;text-align:center;padding-top:15px">'.$update_form1.'
		<div style="width:95%;margin:auto;border: 1px solid #BCBCBC;">'.$update_contenu.'</div>
		'.$update_form2.'
		<input type="hidden" name="step" value="'.($step+1).'" /><br />
		<div style="text-align:right;padding-right:3em">'.$update_button.'</div>
		</form>
	</div>
	<br style="clear:both" />';
	close_table();
}
?>
