<?php

// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// ---------------------------------------------------------------
// Mise a jour : 18/07/06 par Ditch
// ---------------------------------------------------------------


// merci php.net

// Cration de l'image
function draw($donn,$taille,$angle=0.5){
	krsort($donn);
	$image = imagecreate($taille, $taille);
	$trans    = imagecolorallocatealpha($image, 255, 255, 255, 127);
	/* Allocation de quelques couleurs
	$white    = imagecolorallocate($image, 0xFF, 0xFF, 0xFF);
	$gray     = imagecolorallocate($image, 0xC0, 0xC0, 0xC0);
	$darkgray = imagecolorallocate($image, 0x90, 0x90, 0x90);
	$navy     = imagecolorallocate($image, 0x00, 0x00, 0x80);
	$darknavy = imagecolorallocate($image, 0x00, 0x00, 0x50);
	$red      = imagecolorallocate($image, 0xFF, 0x00, 0x00);
	$darkred  = imagecolorallocate($image, 0x90, 0x00, 0x00);
	*/
	# $black     = imagecolorallocate($image, 0x00, 0x00, 0x00);
	#    imagefilledarc($image, $taille/2, $taille*7/10+2, $taille, $taille/2,0, 360, $black, IMG_ARC_PIE);
	
	$anc=360;
	$ecart=32;
	if($angle!=1){
		foreach($donn as $lin)
		{
			$new=$anc-(360*$lin[0]/100);
			
			$col=array(substr($lin[1],1,2),substr($lin[1],3,2),substr($lin[1],5,2));
			//  print_r($col);
			$m=max($col);
			$darkcolor=imagecolorallocate($image, (base_convert($col[0],16,10)-($col[0]==$m?$ecart:0))%255, (base_convert($col[1],16,10)-($col[1]==$m?$ecart:0))%255, (base_convert($col[2],16,10)-($col[2]==$m?$ecart:0))%255);
			
			
			
			// Cration de l'effet 3D
			for ($i = 7/10*$taille; $i > $taille/2; $i--) {
				imagefilledarc($image, $taille/2, $i, $taille, $taille*$angle,$new, $anc, $darkcolor, IMG_ARC_PIE);
			}
			$anc=$new;
			
	}}
	#    imagefilledarc($image, $taille/2, $taille/2+2, $taille, $taille/2+2,0, 360, $black, IMG_ARC_PIE);
	
	
	$anc=0;
	reset($donn);
	ksort($donn);
	foreach($donn as $lin)
	{
		
		$new=$anc+(360*$lin[0]/100);
		#  echo $anc."\n";
		#  echo $new."\n";
		
		$col=array(substr($lin[1],1,2),substr($lin[1],3,2),substr($lin[1],5,2));
		$color=imagecolorallocate($image, base_convert($col[0],16,10), base_convert($col[1],16,10), base_convert($col[2],16,10));
		imagefilledarc($image, $taille/2,$taille/2, $taille, $taille*$angle, $anc, $new, $color, IMG_ARC_PIE);
		
		$anc=$new;
		
	}
	// Affichage de l'image
	//echo $anc;
	# if(function_exists('imagefilter')){
	# imagefilter($image,IMG_FILTER_SMOOTH,-120);                                  }
	
	
	header('Content-type: image/png');
	imagepng($image);
	imagedestroy($image);
}

/*$donnes=array();
$donnes[]=array(14,'#000080');
$donnes[]=array(23,'#00FF00');
$donnes[]=array(7,'#C0C0C0');
$donnes[]=array(56,(isset($_GET['col']) && $_GET['col']!=''?$_GET['col']:'#FF0000'));*/
//print_r($_GET);

//draw(unserialize(stripslashes($_GET['donn'])),$_GET['taille'],(isset($_GET['angle'])?$_GET['angle']:0.5));



/*
- Date de cration : 18/09/2005
- nom : camembert.php
- auteur : opossum_farceur.
- Object : les camemberts 3D.
- Source : http://fr3.php.net/manual/fr/function.imagefilledarc.php
- http://www.phpcs.com/codes/CAMEMBERTS-3D_34131.aspx
*/

function camembert($arr)
{
	$size=2; /* taille de la police, largeur du caractre */
	$ifw=imagefontwidth($size);

	$w=700; /* largeur de l'image */
	$h=350; /* hauteur de l'image */
	$a=175; /* grand axe du camembert */
	$b=$a/2; /* 60 : petit axe du camembert */
	$d=$a/2; /* 60 : "paisseur" du camembert */
	$cx=$w/2-1; /* abscisse du "centre" du camembert */
	$cy=($h-$d)/2; /* 95 : ordonne du "centre" du camembert */

	$A=190; /* grand axe de l'ellipse "englobante" */
	$B=160; /* petit axe de l'ellipse "englobante" */
	$oy=-$d/2; /* -30 : du "centre" du camembert  celui de l'ellipse "englobante"*/

	$img=imagecreate($w,$h);
	$bgcolor=imagecolorallocate($img,0xCD,0xCD,0xCD);
	imagecolortransparent($img,$bgcolor);
	$black=imagecolorallocate($img,0,0,0);
	/* calcule la somme des donnes */
	for ($i=$sum=0,$n=count($arr);$i<$n;$i++) $sum+=$arr[$i][0];

	/* fin des prliminaires : on peut vraiment commencer! */
	for ($i=$v[0]=0,$x[0]=$cx+$a,$y[0]=$cy,$doit=true;$i<$n;$i++)
	{
		for ($j=0,$k=16;$j<3;$j++,$k-=8) $t[$j]=($arr[$i][1]>>$k) & 0xFF;
		/* dtermine les "vraies" couleurs */
		$color[$i]=imagecolorallocate($img,$t[0],$t[1],$t[2]);
		/* calcule l'angle des diffrents "secteurs" */
		$v[$i+1]=$v[$i]+round($arr[$i][0]*360/$sum);

		if ($doit)
		{ /* dtermine les couleurs "ombres" */
			$shade[$i]=imagecolorallocate($img,max(0,$t[0]-50),max(0,$t[1]-50),max(0,$t[2]-50));

			if ($v[$i+1]<180)
			{ /* calcule les coordonnes des diffrents paralllogrammes */
				$x[$i+1]=$cx+$a*cos($v[$i+1]*M_PI/180);
				$y[$i+1]=$cy+$b*sin($v[$i+1]*M_PI/180);
			}
			else
			{
				$m=$i+1;
				$x[$m]=$cx-$a; /* c'est comme si on remplaait $v[$i+1] par 180 */
				$y[$m]=$cy;
				$doit=false; /* indique qu'il est inutile de continuer! */
			}
		}
	}

	/* dessine la "base" du camembert */
	for ($i=0;$i<$m;$i++) imagefilledarc($img,$cx,$cy+$d,2*$a,2*$b,$v[$i],$v[$i+1],$shade[$i],IMG_ARC_PIE);

	/* dessine la partie "verticale" du camembert */
	for ($i=0;$i<$m;$i++)
	{
		$area=array($x[$i],$y[$i]+$d,$x[$i],$y[$i],$x[$i+1],$y[$i+1],$x[$i+1],$y[$i+1]+$d);
		imagefilledpolygon($img,$area,4,$shade[$i]);
	}

	/* dessine le dessus du camembert */
	for ($i=0;$i<$n;$i++) imagefilledarc($img,$cx,$cy,2*$a,2*$b,$v[$i],$v[$i+1],$color[$i],IMG_ARC_PIE);

	/*imageellipse($img,$cx,$cy-$oy,2*$A,2*$B,$black); // dessine l'ellipse "englobante" */

	/* dessine les "flches" et met en place le texte */
	for ($i=0,$AA=$A*$A,$BB=$B*$B;$i<$n;$i++) if ($arr[$i][0])
	{
		$phi=($v[$i+1]+$v[$i])/2;
		/* intersection des "flches" avec l'ellipse "englobante" */
		$px=$a*3*cos($phi*M_PI/180)/4;
		$py=$b*3*sin($phi*M_PI/180)/4;
		/* quation du 2me degr avec 2 racines relles et distinctes */
		$U=$AA*$py*$py+$BB*$px*$px;
		$V=$AA*$oy*$px*$py;
		$W=$AA*$px*$px*($oy*$oy-$BB);
		/* calcule le pourcentage  afficher */
		$value=number_format(100*$arr[$i][0]/$sum,2,",","")."%";
		/* crit le texte  droite */
		if ($phi<90 || $phi>270)
		{
			$root=(-$V+sqrt($V*$V-$U*$W))/$U;
			imageline($img,$px+$cx,$py+$cy,$qx=$root+$cx,$qy=$root*$py/$px+$cy,$black);
			imageline($img,$qx,$qy,$qx+10,$qy,$black);

			imagestring($img,$size,$qx+14,$qy-12,$arr[$i][2].' ('.$value.')',$black);
			//imagestring($img,$size,$qx+14,$qy-12,$value,$black);
		}
		else
		{ /* crit le texte  gauche */
			$root=(-$V-sqrt($V*$V-$U*$W))/$U;
			imageline($img,$px+$cx,$py+$cy,$qx=$root+$cx,$qy=$root*$py/$px+$cy,$black);
			imageline($img,$qx,$qy,$qx-10,$qy,$black);

			imagestring($img,$size,$qx-12-$ifw*strlen($arr[$i][2].' ('.$value.')'),$qy-12,$arr[$i][2].' ('.$value.')',$black);
			//imagestring($img,$size,$qx-12-$ifw*strlen($value),$qy-2,$value,$black);
		}
	}

	header("Content-type: image/png");
	imagepng($img);
	imagedestroy($img);
}
camembert(unserialize(stripslashes($_GET['donn']))); /* enjoy! */


?>
