<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: index.php 926 2011-05-17 11:20:57Z mike007 $
// ---------------------------------------------------------------
// Module infoZ ralis en OPC
// ---------------------------------------------------------------
// Mixage des modules de lolo35 et otocinclus
// ---------------------------------------------------------------
// Valid par la team KwsPHP le 20/02/2007
// ---------------------------------------------------------------

if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}


$infoz_contenu ='[center][u][b]Version[/b][/u][/center]';
$distribution_on = 'KwsPHP '.array_pop(explode('-',$distribution_versions));

//version de kwsphp
$file = @fopen('http://www.kwsphp.org/modules/infoZ/version.txt', 'r');
$version = @fread($file, 8192);
@fclose($file);

if (empty($version))
{
	$infoz_contenu.='[puce][b]KwsPHP :[/b] [couleur=#009900]'.$distribution_on.'[/couleur] (version officielle inconnue)[/puce] ';
}
else
{
	$infoz_contenu.='[puce][b]KwsPHP :[/b] '.(($distribution_on==$version or $version<$distribution_on) ? '[couleur=#009900]'.$distribution_on.'[/couleur]' : '[couleur=#ffa80a]'.$distribution_on.'[/couleur] (vous pouvez migrer vers [url=http://www.kwsphp.org/index.php?mod=download&categorie=portail_kws]'.$version.'[/url])').'[/puce] ';
}
//version de kwsphp
if ($url_site != 'http://'.dirname($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'/')
{
	$infoz_contenu.='[puce][b]$url_site :[/b] [couleur=#ffa80a]'.str_replace(' ','[/couleur][couleur=#990000]&nbsp;[/couleur][couleur=#ffa80a]',$url_site).'[/couleur] au lieu de [couleur=#009900]http://'.dirname($_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']).'/[/couleur][/puce] ';
}
else
{
	$infoz_contenu.='[puce][b]$url_site :[/b] [couleur=#009900]'.str_replace(' ','[/couleur][couleur=#ffa80a]&nbsp;[/couleur][couleur=#009900]',$url_site).'[/couleur][/puce] ';
}
$mysql_get_client_info = preg_replace('#mysqlnd(\s?)#','',mysql_get_client_info());
//version php orange < 4.3 et vert si > 4.3
$infoz_contenu.='[puce][b]PHP :[/b] '.((phpversion() > 4.3) ? ("[couleur=#009900]".phpversion()."[/couleur]") : ("[couleur=#ffa80a]".phpversion()."[/couleur]")).'[/puce] ';
//version mysql vert si 4 ou inf et orange si 5
$infoz_contenu.='[puce][b]Serveur MySQL :[/b] '.((substr(mysql_get_server_info(), 0, 1) >= 5) ? ("[couleur=#009900]".mysql_get_server_info()."[/couleur]") : ("[couleur=#ffa80a]".mysql_get_server_info()."[/couleur]")).'[/puce] ';
$infoz_contenu.='[puce][b]Client MySQL :[/b] '.((substr($mysql_get_client_info, 0, 1) >= 5) ? ("[couleur=#009900]".mysql_get_client_info()."[/couleur]") : ("[couleur=#ffa80a]".mysql_get_client_info()."[/couleur]")).'[/puce] ';

// chmod des rpertoires
$infoz_contenu.='[center][u][b]CHMOD des r&eacute;pertoires[/b][/u][/center] ';
$liste_repertoire = array(
	'./images/avatars/upload/',
	'./images/rubriques/',
	'./images/smileys/'
);
if (file_exists('./sessions/'))
{
	$liste_repertoire[] = './sessions/';
}
if (is_module('afaire'))
{
	$liste_repertoire[] = './modules/afaire/images/cache/';
}
if (is_module('download'))
{
	require_once('./modules/download/parametres.php');
	$liste_repertoire[] = $dl_upload;
	$liste_repertoire[] = $dl_upload_image;
}
if (is_module('eskuel'))
{
	$liste_repertoire[] = './eskuel/';
}
if (is_module('espion'))
{
	$liste_repertoire[] = './modules/espion/archive/';
}

$infoz_contenu .= '[puce][b].'.str_replace('index.php','',$_SERVER['PHP_SELF']).' (dossier racine) :[/b] ';
if (is_writable('./'))
{
	$infoz_contenu .= '[couleur=#009900]ON -> '.chmod_fichier('./').'[/couleur]';
}
else
{
	$infoz_contenu .= '[couleur=#ffa80a]OFF -> '.chmod_fichier('./').'[/couleur]';
}
$infoz_contenu.='[/puce] ';

foreach($liste_repertoire as $repertoire)
{
	if ($repertoire == $dl_upload)
	{
		$texte = 'Rpertoire "fichier" du module download';
	}
	elseif ($repertoire == $dl_upload_image)
	{
		$texte = 'Rpertoire "image" du module download';
	}
	else
	{
		$texte = $repertoire;
	}

	$infoz_contenu .= '[puce][b]'.$texte.' :[/b] ';
	if (is_writable($repertoire))
	{
		$infoz_contenu .= '[couleur=#009900]ON -> '.chmod_fichier($repertoire).'[/couleur]';
	}
	else
	{
		$infoz_contenu .= '[couleur=#ffa80a]OFF -> '.chmod_fichier($repertoire).'[/couleur]';
	}
	$infoz_contenu.='[/puce] ';
}

$infoz_contenu.='[center][u][b]Fonction php[/b][/u][/center] ';
//registre global on ou off
$infoz_contenu.='[puce][b]Register globals :[/b] '.((ini_get('register_globals') == 1)?("[couleur=#ffa80a]ON[/couleur]"):("[couleur=#009900]OFF[/couleur]")).'[/puce] ';
//magic-quote on ou off
$infoz_contenu.='[puce][b]Magic quotes gpc :[/b] '.((get_magic_quotes_gpc() == 1) ? ("[couleur=#ffa80a]ON[/couleur]") : ("[couleur=#009900]OFF[/couleur]")).'[/puce] ';
//Magic quotes runtime on ou off
$infoz_contenu.='[puce][b]Magic quotes runtime :[/b] '.((get_magic_quotes_runtime() == 1) ? ("[couleur=#ffa80a]ON[/couleur]") : ("[couleur=#009900]OFF[/couleur]")).'[/puce] ';
//mysql_real_escape_string on ou off
$infoz_contenu.='[puce][b]mysql_real_escape_string :[/b] '.((function_exists('mysql_real_escape_string')) ? ("[couleur=#009900]ON[/couleur]") : ("[couleur=#ffa80a]OFF[/couleur]")).'[/puce] ';

$infoz_contenu.='[center][u][b]Extensions[/b][/u][/center] ';
//extension gd2 active ou non
$infoz_contenu.='[puce][b]L\'extension GD_2 :[/b] '.((extension_loaded ('gd') == 1)?('[couleur=#009900]activ&eacute;[/couleur]'):('[couleur=#ffa80a]d&eacute;sactiv&eacute;[/couleur]')).'[/puce] ';
//extension ob active ou non
//$infoz_contenu.='[puce][b]L\'extension ob :[/b] '.((extension_loaded ('output_buffering') == 1)?('[couleur=#009900]activ&eacute;[/couleur]'):('[couleur=#ffa80a]d&eacute;sactiv&eacute;[/couleur]')).'[/puce] ';

$infoz_contenu.='[center][u][b]Dossier[/b][/u][/center] ';
//emplacement dossier sesion
$var_session = session_save_path();
$infoz_contenu.='[puce][b]Le dossier sessions :[/b] '.(!empty($var_session) ? '[couleur=#009900]'.$var_session.'[/couleur]' : '')  .'[/puce] ';
//l'adresse url du site
$infoz_contenu.='[puce][b]Url du site :[/b] '.$HTTP_SERVER_VARS['SERVER_NAME'].'[/puce] ';
//definie si le site est dans le reprtoire racine ou non
$infoz_contenu.='[puce][b]Dossier racine :[/b] .'.str_replace('index.php','',$_SERVER['PHP_SELF']).'[/puce] ';

if (get_grade()<GRD_ADMIN and $debug!='on')
{
	// Le grade ne permet pas l'accs sans le code du jour
	if(!isset($_POST['codeacces']))
	{
		//pas de code
		bloc_head('Acc&egrave;s Interdit');
		echo '
		<p style="text-align:center;">
			<strong>
				Fonction r&eacute;serv&eacute;e !<br />
				<br />
				Vous n&rsquo;avez pas le grade suffisant pour acc&eacute;der &agrave; cette partie du site,<br />
				&agrave; moins que vous ne poss&eacute;diez un code d&rsquo;acces.<br />
			</strong>
			<br />
			<form style="text-align:center" method="post" action="index.php?mod=infoZ">
				Code d&rsquo;acces : <input name="codeacces" id="codeacces" maxlength="40" size="40" />
				<input type="submit" id="submit" value="  Envoyer  "/>
			</form>
		</p>';
		close_table();
	}
	else
	{
		// Un code  t transmi
		$codeacces = htmlentities(strip_tags($_POST['codeacces']), ENT_QUOTES);
		
		if($infoZ_cle == '' || $infoZ_validite < time() || $codeacces != md5($infoZ_cle))
		{
			// Le code n'est pas valable
			open_table();
			echo $codeacces;
			echo '<p style="text-align:center;">
				<b>ERREUR !</b><br />
				<br />
				Le code que vous avez indiqu&eacute; n&rsquo;est pas valable !!	<br />
				<br />
				<form method="post" action="index.php?mod=infoZ">
					<center>
						Code d&rsquo;acces : <input name="codeacces" id="codeacces" maxlength="40" size="40" />
						<input type="submit" id="submit" value="  Envoyer  "/>
					</center>
				</form>
			</p>';
			close_table();
		}
		else
		{
			// code ok, on affiche les infos
			bloc_head('infoZ');
			echo bbcode($infoz_contenu);
			close_table();
		}
	}
}
else
{    // Grade ok.
	if(!isset($_POST['codeacces']))
	{
		// l'admin a modifi les paramtres de codage
		
		$choix        = intval($_POST['choix']);
		$new_cle      = htmlentities(strip_tags($_POST['new_cle']), ENT_QUOTES);
		$new_validite = intval($_POST['new_validite']);
		
		if ($new_validite!=24 && $new_validite!=36 && $new_validite!=48) $new_validite=0;
		
		$extand_validite = intval($_POST['extand_validite']);
		
		if ($extand_validite!=12 && $extand_validite!=24 && $extand_validite!=36) $extand_validite=0;
		
		switch($choix)
		{
			case 1 : // extention de la validit du code
			$infoZ_validite += ($extand_validite*60*60);
			reqmysql('UPDATE `parametres` SET `valeur`="'.$infoZ_validite.'" WHERE `nom`="infoZ_validite"');
			break;
			case 2 : // nouveaux paramtres de codage
			if($new_cle!='')
			{
				$infoZ_cle = $new_cle; // mise  jour de la variable globale
				$new_cle .= '|'.time();
				
				$req = reqmysql('UPDATE `parametres` SET `valeur`="'.$new_cle.'" WHERE `nom`="infoZ_cle"');
				
				if(mysql_affected_rows()==0)
				{
					// pas de cle  mettre  jour, on va donc l'insrer
					$req = reqmysql('INSERT INTO `parametres` (`nom`, `valeur`) VALUES ("infoZ_cle", "'.$new_cle.'")');
				}
				$infoZ_validite = time() + ($new_validite*60*60); // mise  jour de la variable globale
				$req = reqmysql('UPDATE `parametres` SET `valeur`="'.$infoZ_validite.'" WHERE `nom`="infoZ_validite"');
				
				if(mysql_affected_rows()==0)
				{
					// pas d'info de validit  mettre  jour, on va donc l'insrer
					$req = reqmysql('INSERT INTO `parametres` (`nom`, `valeur`) VALUES ("infoZ_validite", "'.$infoZ_validite.'")');
				}
			}
			break;
			case 3 : // suppression du code d'acces
			$infoZ_validite = 0;
			reqmysql('UPDATE `parametres` SET `valeur`="'.$infoZ_validite.'" WHERE `nom`="infoZ_validite"');
			break;
		}
	}
	
	// Extraction de la cle de codage
	$cle = explode("|", $infoZ_cle);
	
	// Prparation de l'affichage
	if($infoZ_cle == '')
	{
		// La cle de codage n'est pas dfinie
		$contenu = '<form method="post" action="index.php?mod=infoZ">
		<fieldset style="margin:1em; padding:1em;">
			<p>
				<label style="display: inline; float: left; width: 300px;" for="new_cle">Cl&eacute; de g&eacute;n&eacute;ration du code d&rsquo;acces public :</label>
				<input name="new_cle" id="new_cle" maxlength="30" size="30" value="" />
			</p>
			<p>
				<label style="display: inline; float: left; width: 300px;" for="choix">validit&eacute; du code :</label>
				<input type="hidden" name="choix" id="choix" value="2" />
			</p>
			<p>
				<label style="display: inline; float: left; width: 300px;" for="new_validite">
					<select name="new_validite" id="new_validite">
						<option value="24"> 24h </option>
						<option value="36"> 36h </option>
						<option value="48"> 48h </option>
					</select>
				</label>
			</p>
			<p align="center">
				<input type="submit" id="submit" value=" G&eacute;n&eacute;rer un code "/>
			</p>
		</fieldset>
		</form>';
	}
	elseif ($infoZ_validite <= time())
	{
		// La validit du dernier code gnr est dpasse
		$contenu = '<form method="post" action="index.php?mod=infoZ">
		<fieldset style="margin:1em; padding:1em;">
			<legend><b>Pas de code valide actuellement !</b></legend>
			<p>
				<label style="display: inline; float: left; width: 300px;" for="new_cle">Cl&eacute; de g&eacute;n&eacute;ration du code d&rsquo;acces public :</label>
				<input type="hidden" name="choix" id="choix" value="2" />
				<input name="new_cle" id="new_cle" maxlength="30" size="30" value="'.$cle[0].'" />
			</p>
			<p>
				<label style="display: inline; float: left; width: 300px;" for="new_validite">G&eacute;n&eacute;rer un nouveau code. Validit&eacute; :</label>
					<select name="new_validite" id="new_validite">
						<option value="24"> 24h </option>
						<option value="36"> 36h </option>
						<option value="48"> 48h </option>
					</select>
					</label>
				</p>
			<p><input type="submit" id="submit" value=" G&eacute;n&eacute;rer un code "/></p>
		</fieldset>
		</form>';
	}
	else {
		// Il y a un code valide
		$contenu = '<form method="post" action="index.php?mod=infoZ">
		<fieldset style="margin:1em; padding:1em;">
		<legend><b>Code en fonction</b></legend>
		<p>
		<label style="display: inline; float: left; width: 300px;" for="new_cle">Cl&eacute; de g&eacute;n&eacute;ration du code d&rsquo;acces public :</label>
		<input name="new_cle" id="new_cle" maxlength="30" size="30" value="'.$cle[0].'" />
		</p>
		<p>
		<label style="display: inline; float: left; width: 300px;">Code actuel valide jusqu&rsquo;au '.date('d-m-Y H:i', $infoZ_validite).' :</label>
		<b>'.md5($infoZ_cle).'</b>
		</p>
		<p>
		<label style="display: inline; float: left; width: 300px;" for="extand_validite">
		<input name="choix" type="radio" value="1" /> Etendre la validit&eacute; du code de</label>
		<select name="extand_validite" id="extand_validite">
		<option value="12"> 12h </option>
		<option value="24"> 24h </option>
		<option value="36"> 36h </option>
		</label>
		</select>
		</p>
		<p>
		<label style="display: inline; float: left; width: 300px;" for="new_validite">
		<input name="choix" type="radio" value="2" /> G&eacute;n&eacute;rer un nouveau code pour :</label>
		<select name="new_validite" id="new_validite">
		<option value="24"> 24h </option>
		<option value="36"> 36h </option>
		<option value="48"> 48h </option>
		</select>
		</label>
		</p>
		<p>
		<label style="display: inline; float: left; width: 300px;" for="choix">
		<input name="choix" type="radio" value="3" /> Suppression du code d&rsquo;acces:</label>
		<b>'.md5($infoZ_cle).'</b>
		</p>
		<p align="center">
		<input type="submit" id="submit" value=" Valider " />
		</p>
		</fieldset>
		</form>';
	}
	
	// Affichage
	bloc_head('infoZ');
	//Affichage du formulaire du codepass
	echo '<div>'.$contenu.'</div>
	<fieldset style="margin:1em; padding:2em;">
		<div>'.bbcode($infoz_contenu).'</div>
		<p>
			Code que vous pouvez copier directement pour le forum ou pour un message priv&eacute; : (m&ecirc;me pr&eacute;sentation que ci-dessus)<br />
			<br />
			<center><textarea name="code" cols="100" rows="25">'.$infoz_contenu.'</textarea></center>
		</p>
	</fieldset>';
	// Fermeture du bloc
	close_table();
}
?>
