-- $Id: install.sql 917 2011-05-04 15:33:26Z mike007 $

DROP TABLE IF EXISTS `faq_cat`;
CREATE TABLE `faq_cat` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `categorie` varchar(50) NOT NULL DEFAULT '',
  `image` varchar(30) NOT NULL DEFAULT '',
  `mots_cles` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  PRIMARY KEY (`id`)
) TYPE=MyISAM COMMENT='Module FAQ : Catgorie' AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `faq_rep`;
CREATE TABLE `faq_rep` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `question` text NOT NULL,
  `reponse` text NOT NULL,
  `categorie` tinyint(3) NOT NULL DEFAULT '0',
  `mots_cles` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Module FAQ : Question-Rponse' AUTO_INCREMENT=1 ;


INSERT INTO `droit` SET `module`='multi-faq', `page`='gestion_faq', `grade`='4', `groupe`='0', `condition`='and';

INSERT INTO `droit_exclu` SET `module`='multi-faq', `page`='affadmin', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='multi-faq', `page`='gestion', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='multi-faq', `page`='poster', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='multi-faq', `page`='rubrique', `accessible`='0';
