-- $Id: install.sql 907 2010-08-20 18:32:03Z mike007.devpwsphp $

DROP TABLE IF EXISTS `news`;
CREATE TABLE `news` (
  `id` int(11) NOT NULL auto_increment,
  `ref` varchar(10) NOT NULL default '',
  `titre` varchar(70) NOT NULL default '',
  `date` int(11) NOT NULL default '0',
  `edit` varchar(20) NOT NULL default '',
  `auteur` varchar(30) default NULL,
  `contenu` text,
  `mots_cles` varchar(250) NOT NULL default '',
  `hit` int(11) NOT NULL default '0',
  `validation` tinyint(2) NOT NULL default '0',
  `envoi_mail` enum('0','1') NOT NULL default '1',
  `type` tinyint(2) NOT NULL default '0',
  `js` enum('0','1') NOT NULL default '0',
  `smiley` tinyint(2) NOT NULL default '1',
  `nbr_comment` int(11) NOT NULL default '0',
 PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Module news : Liste des news' AUTO_INCREMENT=1 ;


INSERT INTO `parametres` SET `nom`='news_gr_admin', `valeur`='3';
INSERT INTO `parametres` SET `nom`='news_gr_poster', `valeur`='3';
INSERT INTO `parametres` SET `nom`='news_gr_commentaires', `valeur`='0';
INSERT INTO `parametres` SET `nom`='news_valider', `valeur`='1';
INSERT INTO `parametres` SET `nom`='news_keywords', `valeur`='oui';
INSERT INTO `parametres` SET `nom`='news_aff_default', `valeur`='10';
INSERT INTO `parametres` SET `nom`='news_rubriques', `valeur`='1';

INSERT INTO `droit_exclu` SET `module`='news', `page`='affadmin', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='news', `page`='commentaires', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='news', `page`='envoi_mail', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='news', `page`='gestion', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='news', `page`='options', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='news', `page`='poster', `accessible`='0';