<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: update.php 907 2010-08-20 18:32:03Z mike007.devpwsphp $
// ---------------------------------------------------------------
// Cration : 18/06/08 par FouPouDave
// ---------------------------------------------------------------
 
if (!(defined('__KWS__'))) {die('Erreur d\'appel de fichier.');}

if (get_grade() < GRD_ADMIN)
{
	zoneReserve();
}
elseif (!file_exists('./modules/'.$K_mod.'/gestionnaire.txt'))
{
	bloc_head('Mise &agrave; jour du module '.$K_mod);
	echo df_message('erreur', '<h2>Votre module '.$K_mod.' est incomplet !</h2>', '<h3>Veuillez re-uploader les fichiers sur votre serveur<br />et recommencer la proc&eacute;dure de mise &agrave; jour !</h3>');
	close_table();
}
else
{
	if (isset($_POST['updateCNL']))
	{
		unset($_SESSION['modules_maj']);
		header('Location: index.php?mod=admin&ac=gestion_module');
		exit();
	}

	if (!isset(${$K_mod.'_version'}))
	{
		${$K_mod.'_version'} = 0;
	}

	$module_file = fopen('./modules/'.$K_mod.'/gestionnaire.txt','r');
	$mod_rev = trim(fgets($module_file ,999));	// Nom
	$mod_rev = trim(fgets($module_file ,999));	// Description
	$mod_rev = trim(fgets($module_file ,999));	// Obligatoire
	$mod_rev = trim(fgets($module_file ,999));	// Version
	fclose($module_file);

	$kws_rev = '1.6';

	// Controle url etapes
	if (isset($_POST['step2']))
	{
		$step = $_POST['step2'];
	}
	elseif (isset($_POST['step']) and $_POST['step'] > 0 and $_POST['step'] < 4)
	{
		$step = $_POST['step'];
	}
	else
	{
		$step = 1;
	}
	if ($step == 2 and !isset($_POST['updateOK']))
	{
		$step = 1;
	}

	// Inclusion du fichier class
	require_once 'includes/class.install.php';
	$class_install = new install();

	// Affichage de la barre des etapes a gauche
	$step_array = array ('Compatibilit&eacute;', 'Mise &agrave; jour', 'Terminer');
	$update_menu = $class_install->aff_step($step, $step_array);

	// Verif compatibilite
	if ($step == 1)
	{
		// rcup version portail
		$distribution_tmp = explode('-',$K_distribution_versions);
		foreach ($distribution_tmp as $distribution_num)
		{
			$distribution_on = $distribution_num;
		}
		// version portail insuffisante => pas de mise a jour possible
		if (substr($distribution_on, 0, 3) < $kws_rev)
		{
			$update_menu = $class_install->aff_step(3, $step_array);
			$update_form1 = '';
			$update_contenu = df_message('attention', '<span style="color:red;font-weight:bold">AVERTISSEMENT</span>', '<p>Cette version du module n&eacute;cessite la version '.$kws_rev.' de kwsPHP.<br />Vous devez proceder &agrave; la mise &agrave; jour de votre portail avant de poursuivre.</p>');
			$update_form2 = '<form name="rtb" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';
			$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
		}
		// Version module ok => mise  jour inutile
		elseif ($mod_rev <= ${$K_mod.'_version'})
		{
			$update_menu = $class_install->aff_step(3, $step_array);
			$update_form1 = '';
			$update_contenu = df_message('information', '<strong>Mise &agrave; jour inutile.</strong>', '<p>Cette version du module est d&eacute;j&agrave; celle install&eacute;e sur votre portail.</p>');
			$update_form2 = '<form name="rtb" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';
			$update_button = '<input type="submit" value=" Terminer " name="sbutton" />';
		}
		// ok pour la mise  jour
		else
		{
			$update_form1 = '';
			$update_contenu = df_message('attention', '<span style="color:red;font-weight:bold">AVERTISSEMENT</span>', '<p>Il est fortement recommand&eacute; d\'effectuer une sauvegarde de la base MySQL <strong>AVANT</strong> de proc&eacute;der &agrave; la mise &agrave; jour.</p><p>Ne soyez pas impatient !<br />La mise &agrave; jour peut se montrer longue.</p>');
			$update_form2 = '<form name="'.$mod.'_update" action="index.php?mod='.$mod.'&amp;ac=update" method="post">';
			$update_button = '<input type="submit" name="updateOK"  value=" Poursuivre la mise &agrave; jour " />
			<input type="submit" name="updateCNL" value=" Abandonner la mise &agrave; jour " style="margin-left:4em" />';
		} 
	}

	// Mise  jour
	elseif ($step == 2)
	{
		$update_result = '';
		function update_query($query, $erreur=true)
		{
			global $update_result;
			$update_test = reqmysql($query, $erreur);
			if (!$update_test)
			{
				$update_result .= 'Erreur de mise &agrave; jour lors de l\'execution de la requ&ecirc;te : '.$query.'<br />
				<br />';
			}
			return $update_test;
		}

		if (${$K_mod.'_version'} < 775)
		{
			update_query('UPDATE `parametres` SET `nom`="news_aff_default" WHERE `nom`="aff_news"');
			update_query('DELETE FROM `parametres` WHERE `nom`="aff_news";');

			if (mysql_num_rows(reqmysql('SELECT `id` FROM `parametres` WHERE `nom`="news_rubriques"'))== 0)
			{
				update_query("INSERT INTO `parametres` SET `nom` = 'news_rubriques', `valeur` = '1'");
			}
		}

		if (${$K_mod.'_version'} < 836)
		{
			if (mysql_num_rows(reqmysql('SELECT `id` FROM `parametres` WHERE `nom`="news_gr_commentaires"'))== 0)
			{
				update_query('INSERT INTO `parametres` SET `nom` = "news_gr_commentaires", `valeur` = "0"');
			}
		}

		if (${$K_mod.'_version'} < 899)
		{
			if (mysql_num_rows(reqmysql('DESCRIBE `news` "envoi_mail"'))==0)
			{
				update_query('ALTER TABLE `news` ADD `envoi_mail` ENUM("0","1") NOT NULL DEFAULT "1" AFTER `validation`;');
			}
			if (mysql_num_rows(reqmysql('SELECT * FROM `droit_exclu` WHERE `module`="news" AND `page`="envoi_mail"'))== 0)
			{
				update_query ('INSERT INTO `droit_exclu` SET `module`="news", `page`="envoi_mail", `accessible`="0";');
			}
			update_query ('DELETE FROM `droit` WHERE `module`="news" AND `page`="meta";');
		}

		if (${$K_mod.'_version'} < 907)
		{
			if (mysql_num_rows(reqmysql('DESCRIBE `news` "js"'))==0)
			{
				update_query('ALTER TABLE `news` ADD `js` ENUM("0","1") NOT NULL DEFAULT "0" AFTER `type`;');
			}
		}

		// table parametres
		if (mysql_num_rows(reqmysql('SELECT * FROM `parametres` WHERE `nom`="'.$mod.'_version"'))== 0)
		{
			update_query('INSERT INTO `parametres` SET `nom`="'.$K_mod.'_version", `valeur`="'.$mod_rev.'"');
		}
		else
		{
			update_query('UPDATE `parametres` SET `valeur`="'.$mod_rev.'" WHERE `nom`="'.$K_mod.'_version"');
		}

		// suppression de l'alerte de MAJ
		update_query('DELETE FROM `alerte` WHERE `module` = "'.$K_mod.'" AND `auteur` = "KwsPHP (MAJ)"');

		$update_form1 = '<form name="form1" action="index.php?mod='.$K_mod.'&amp;ac=update" method="post">';

		$update_contenu = '<p><strong>Mise &agrave; jour des tables</strong><br />
		<br />';
		if (!empty($update_result))
		{
			$update_contenu.= '<strong>Erreur</strong><br />
			'.$update_result.'
			<br />
			<span style="color:red;">La mise &agrave; jour a donc &eacute;t&eacute; incompl&egrave;te, vous &ecirc;tes donc contraint de nous signaler l\'erreur.</span><br />
			<br />
			Reportez cette erreur sur notre <a href="http://www.kwsphp.org/" target="_blank">forum de support</a>.</p>';
		}
		else
		{
			$update_contenu.= '<span style="color:#009900">Les tables ont &eacute;t&eacute; correctement mises &agrave; jour !</span></p>';
		}

		$update_form2 = '';

		$update_button = '<input type="submit" value=" Suivant " />';
	}

	elseif ($step == 3)
	{
		$update_form1 = '';

		$update_contenu = '<p>Votre module est maintenant &agrave; jour sur votre serveur.</p>
		'.(empty($_SESSION['update_msg'])? '' : $_SESSION['update_msg']).'
		<p>Le support du portail est assur&eacute; sur le forum de notre communaut&eacute; <a href="http://www.kwsphp.org/">KwsPHP.org</a>.</p>
		<p>Cliquer sur "Terminer" pour quitter le programme de mise &agrave; jour et retourner au gestionnaire de votre site.</p>';

		unset($_SESSION['update_msg']);

		$update_form2 = '<form name="form1" action="./index.php?mod=admin&amp;ac=gestion_module" method="post">';

		$update_button = '<input type="submit" name="sbutton" value=" Terminer " />';
	}

	bloc_head('Update du module '.$K_mod);
	echo '
	<script type="text/javascript" language="javascript">
		var head = document.getElementsByTagName("head")[0];
		var head_inc = document.createElement("link");
		head_inc.rel = "stylesheet";
		head_inc.type = "text/css";
		head_inc.href = "./includes/updatephp.css";
		head.appendChild(head_inc);
	</script>

	<p style="float:left;text-align:center;padding-left:5em;padding-top:20px;font-size:14px;font-weight:bold">
		Mise &agrave; jour du module '.$K_mod.' (vers la version '.$mod_rev.') pour KwsPHP '.$kws_rev.'
	</p>
	<div style="clear:both;float:left;width:20%;height:150px;text-align:center;padding-top:30px">'.$update_menu.'</div>
	<div style="float:right;width:75%;text-align:center;padding-top:15px">'.$update_form1.'
		<div style="width:95%;margin:auto;border: 1px solid #BCBCBC;">'.$update_contenu.'</div>
		'.$update_form2.'
		<input type="hidden" name="step" value="'.($step+1).'" /><br />
		<div style="text-align:right;padding-right:3em">'.$update_button.'</div>
		</form>
	</div>
	<br style="clear:both" />';
	close_table();
}
?>
