<?php

// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: upload.php 918 2011-05-04 16:19:16Z mike007 $
// ---------------------------------------------------------------
// Mise a jour : 14/04/07 par Nico_
// ---------------------------------------------------------------

if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

// Seuls les Grade 4 peuvent envoyer des images
if (get_grade() >= GRD_ADMIN)
{
	$action2 = ax($_REQUEST['action2']);
	$page_aff = true;
	if (!empty($action2))
	{
		bloc_head('Supprimer une image');
		//Suppression d'une image
		if ($action2 == 'del_img')
		{
			echo '
			<p style="text-align:center;">Supprimer l\'image : <strong>'.$_GET['nom_img'].'</strong> ? </p><br />
			<form style="text-align:center" method="post" action="./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;action='.$action.'">
			<input type="hidden" name="xss_retour" value="./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'" />
			<input type="hidden" name="action2" value="del_img2" />
			<input type="hidden" name="nom_img" value="'.$_GET['nom_img'].'" />
			<input type="submit" id="submit" name="oui" value=" Oui " />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<input type="reset" id="reset" name="non" value=" Non " onclick="history.go(-1)" /><br /><br />
			</form>';
			$page_aff = false;
		}

		// Suppression sur le serveur
		elseif ($action2 == 'del_img2')
		{
			unlink('modules/'.$K_mod.'/images/'.$_POST['nom_img']);
			echo df_message('','L&rsquo;image a &eacute;t&eacute; supprim&eacute;e du serveur !');
		}
		close_table();
	}
	
	if ($page_aff)
	{
		bloc_head('Ajouter une image');
		echo '
		<p class="align-center">
			Ajoutez votre image ici. Attention, seul les formats JPG, GIF et PNG sont accept&eacute;s !
		</p>';

		$err = '';

		// l'utilisateur a cliqu 'ajouter'
		if (isset ($_POST['type']) && $_POST['type'] == 'upload')
		{
			// A adapter
			$largeur_max = 1000;
			$hauteur_max = 1000;
			$poids_max   = 1000000;
			// Pas touche  la suite
			$poids_max_txt = round($poids_max / 1024).' ko';
			if (is_uploaded_file ($_FILES['image']['tmp_name']))
			{
				if ($infos_img = getimagesize ($_FILES['image']['tmp_name']))
				{
					if ($infos_img[0] > $largeur_max)
					$err .= 'L\'image &agrave; une largeur de '.$infos_img[0].'px alors que la largeur maximale est '.$largeur_max.' px.<br />';
					if ($infos_img[1] > $hauteur_max)
					$err .= 'L\'image &agrave; une hauteur de '.$infos_img[1].'px alors que la hauteur maximale est '.$hauteur_max.' px.<br />';
					if ($image_size > $poids_max)
					$err .= 'L\'image &agrave; un poids trop lourd. Il faut qu\'elle ne p&egrave;se que '.$poids_max_txt.' maximum.<br />';
					if ($infos_img[2] == 5 || $infos_img[2] == 6)
					$err .= 'Les formats PSD et BMP ne sont pas accept&eacute;s. Il faut du GIF, JPG, ou PNG.<br />';
					$image_name=$_FILES['image']['name'];
					if (file_exists('modules/page/images/'.$image_name))
					$err .= 'Il y a d&eacute;j&agrave; une image avec ce nom.<br />';
					if ($err == '')
					{
						//copy ($image, 'modules/page/images/'.$image_name);
						move_uploaded_file ($_FILES['image']['tmp_name'], 'modules/page/images/'.str_replace ('.php', '', $_FILES['image']['name']));
						$err = 'L\'image &agrave; bien &eacute;t&eacute; transf&eacute;r&eacute;e';
					}
				}
				else
				$err .= 'Ce n\'est pas une image qui &agrave; &eacute;t&eacute; upload&eacute;e.<br />';
			}
			else
			$err .= 'Aucune image n\'a &eacute;t&eacute; upload&eacute;e.<br />';
		}

		if ($err != '')
		{
			echo '
			<p class="align-center">'.$err.'</p>';
		}
		echo '
		<form class="align-center" name="upload" enctype="multipart/form-data" method="post" action="./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;action=images">
			<input type="hidden" name="type" value="upload" />
			<input type="hidden" name="MAX_FILE_SIZE" value="50000000" />
			<input type="file" size="35" name="image" /><br /><br />
			<input type="submit" id="submit" value="Ajouter" />
		</form>';
		close_table();

		$dossier = ScannerRepertoire('modules/'.$K_mod.'/images', 'file', false);
		$total_images = count($dossier);
		if (!empty($dossier))
		{
			if ($total_images!=0)
			{
				$pagination = new pagination($total_images, 20);
				if ($total_images > $pagination->elt_par_page)
				{
					$total_images = $pagination->elt_par_page + $pagination->getDebutPage();
				}
			}
			$i_images = 0;
			bloc_head('<a class="ancre" name="images"></a>Vos images');
			$i=0;
			foreach($dossier as $n => $Fichier)
			{
				$page_images_texte_elt[] = $Fichier;
				$Ext = strtoupper(substr($Fichier, 1+strrpos($Fichier, '.')));
				if(in_array($Ext, array('JPG', 'JPEG', 'GIF', 'PNG')))
				{
					if ($i_images >= $pagination->getDebutPage() and $i_images < $total_images)
					{
						if ($i!=0 and $i%4==0) echo '<hr style="clear:both" />';
						echo '
						<div class="align-center" style="float:left;width:25%;">
							<a href="./modules/'.$K_mod.'/images/'.ax($Fichier).'" target="_blank" title="'.ax($Fichier).'">'.ax(df_tronque($Fichier,20)).'</a>
							<br /><img src="./modules/'.$K_mod.'/images/'.ax($Fichier).'" alt="'.ax($Fichier).'" style="max-width:48px; border:none;" />
							<br /><a href="./index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=images&amp;action2=del_img&amp;nom_img='.$Fichier.'"><img src="themes/'.$K_theme.'/images/gestion/del.png" alt="Supprimer" style="border:none;" /></a>
						</div>
						';
						$i++;
					}
					$i_images++;
				}
			}
			echo '<br style="clear:both" />';
			// Affichage des pages
			$pagination->texte_elt = $page_images_texte_elt;
			echo $pagination->creer('./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;action=images&amp;int_page=%d#images','afficher').'';
			close_table();
		}

	}
	$_SESSION['K_retour'] = './index.php?mod=page&amp;ac=gestion';
}
// si grade diffrent de 4
else
{
	ZoneReserve('','Vous n&rsquo;avez pas le grade requis pour les uploads','off');
}
?>
