-- $Id: install.sql 848 2009-02-12 21:19:40Z mike007.devpwsphp $

DROP TABLE IF EXISTS `visiteurs`;
CREATE TABLE `visiteurs` (
  `id` int(11) NOT NULL auto_increment,
  `ip` varchar(15) NOT NULL default '',
  `pseudo` varchar(30) NOT NULL default '',
  `tpsdebut` int(11) NOT NULL default '0',
  `tpsfin` int(11) NOT NULL default '0',
  `date` varchar(10) NOT NULL default '',
  `pages` int(11) NOT NULL default '0',
  primary KEY `id` (`id`)
) TYPE=MyISAM COMMENT='Module stats : Liste des visiteurs du jour';

DROP TABLE IF EXISTS `stats`;
CREATE TABLE `stats` (
  `id` int(11) NOT NULL auto_increment,
  `type` varchar(15) NOT NULL default '',
  `valeur` varchar(100) NOT NULL default '',
  `hit` int(11) NOT NULL default '0',
  primary KEY `id` (`id`)
) TYPE=MyISAM COMMENT='Module stats : Statistique';

INSERT INTO `stats` SET `type`='heure', `valeur`='1';
INSERT INTO `stats` SET `type`='heure', `valeur`='2';
INSERT INTO `stats` SET `type`='heure', `valeur`='3';
INSERT INTO `stats` SET `type`='heure', `valeur`='4';
INSERT INTO `stats` SET `type`='heure', `valeur`='5';
INSERT INTO `stats` SET `type`='heure', `valeur`='6';
INSERT INTO `stats` SET `type`='heure', `valeur`='7';
INSERT INTO `stats` SET `type`='heure', `valeur`='8';
INSERT INTO `stats` SET `type`='heure', `valeur`='9';
INSERT INTO `stats` SET `type`='heure', `valeur`='10';
INSERT INTO `stats` SET `type`='heure', `valeur`='11';
INSERT INTO `stats` SET `type`='heure', `valeur`='12';
INSERT INTO `stats` SET `type`='heure', `valeur`='13';
INSERT INTO `stats` SET `type`='heure', `valeur`='14';
INSERT INTO `stats` SET `type`='heure', `valeur`='15';
INSERT INTO `stats` SET `type`='heure', `valeur`='16';
INSERT INTO `stats` SET `type`='heure', `valeur`='17';
INSERT INTO `stats` SET `type`='heure', `valeur`='18';
INSERT INTO `stats` SET `type`='heure', `valeur`='19';
INSERT INTO `stats` SET `type`='heure', `valeur`='20';
INSERT INTO `stats` SET `type`='heure', `valeur`='21';
INSERT INTO `stats` SET `type`='heure', `valeur`='22';
INSERT INTO `stats` SET `type`='heure', `valeur`='23';
INSERT INTO `stats` SET `type`='heure', `valeur`='0';

INSERT INTO `parametres` SET `nom`='nbr_visiteur_max', `valeur`='0';
INSERT INTO `parametres` SET `nom`='date_max_visiteur', `valeur`='0';
INSERT INTO `parametres` SET `nom`='nbr_membre_max', `valeur`='0';
INSERT INTO `parametres` SET `nom`='date_max_membre', `valeur`='0';
INSERT INTO `parametres` SET `nom`='nbr_simultanemous_membre', `valeur`='0';
INSERT INTO `parametres` SET `nom`='date_simultanemous_membre', `valeur`='0';
INSERT INTO `parametres` SET `nom`='nbr_simultanemous_visiteur', `valeur`='0';
INSERT INTO `parametres` SET `nom`='date_simultanemous_visiteur', `valeur`='0';

INSERT INTO `droit_exclu` SET `module`='stats', `page`='config', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='stats', `page`='stats_inf_light', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='stats', `page`='stats_inf', `accessible`='0';
INSERT INTO `droit_exclu` SET `module`='stats', `page`='visites', `accessible`='0';

