<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: fonctions.php 921 2011-05-14 08:46:55Z mike007 $
// ---------------------------------------------------------------
// Cration : 27/07/07 par FouPouDave
// ---------------------------------------------------------------

/** function pour filtrer les bbcode_sup autoriss
* @author mike007
* @param $texte le texte  controler
* @param $GrdPseudo le grade du posteur
* @return le texte control
*/
function filter_bbcode_sup_interdit($texte, $GrdPseudo=0)
{
	if (is_module('bbcode_sup'))
	{
		$BaliseBbcode_sup = array();
		// Recherche de toutes les bbcode_sup interdits pour effectuer un remplacement
		$req_bbcode_plus	= reqmysql('SELECT `balise`, `grade` FROM `bbcode_sup` WHERE `active`="oui" and (`grade` > "'.$GrdPseudo.'" or `grade`="-2")');
		while ($rep_bbcode_plus = mysql_fetch_object($req_bbcode_plus))
		{
			if (substr($rep_bbcode_plus->balise,-1) == '=') $rep_bbcode_plus->balise = substr($rep_bbcode_plus->balise,0,-1);
			$texte = preg_replace('#\['.$rep_bbcode_plus->balise.'(=(.+?))?\](.*?)\[/'.$rep_bbcode_plus->balise.'\]#',' [interdit]$3[/interdit] ',$texte);
		}
	}
	return $texte;
}

/** function pour filtrer les caractres spciaux
* @author mike007
* @param $chaine_in la chaine  transformer
* @param $var_in caractre de remplacement pour certains caractres voulu
* @return la chaine modifie
*/
function filter($chaine_in,$var_in='-') {
	$search = array ('#[]#i','#[]#i','#[]#i','#[]#i','#[]#i','#[ݟ]#i','#[]#i','#[]#i','#[]#i','#[]#i','#[\s/."\']#i','#[^a-zA-Z0-9_-]#');
	$replace = array ('e','a','i','o','u','y','ae','oe','c','n',$var_in,'');
	return preg_replace($search, $replace, $chaine_in);
}

/** function pour filtrer les caractres spciaux inverse (spcial accents surtout pour les mtas)
* @author mike007
* @param $chaine_in la chaine  transformer
* @return la chaine modifie
*/
function filter_noentityhtml($chaine_in) {
	$search = array (
			'#&(yacute);#', '#&(yuml);#',								 '#&(Yacute);#',								'#&(Yuml);#',
			'#&(aacute);#', '#&(agrave);#', '#&(acirc);#', '#&(auml);#', '#&(Aacute);#', '#&(Agrave);#', '#&(Acirc);#', '#&(Auml);#',
			'#&(eacute);#', '#&(egrave);#', '#&(ecirc);#', '#&(euml);#', '#&(Eacute);#', '#&(Egrave);#', '#&(Ecirc);#', '#&(Euml);#',
			'#&(iacute);#', '#&(igrave);#', '#&(icirc);#', '#&(iuml);#', '#&(Iacute);#', '#&(Igrave);#', '#&(Icirc);#', '#&(Iuml);#',
			'#&(oacute);#', '#&(ograve);#', '#&(ocirc);#', '#&(ouml);#', '#&(Oacute);#', '#&(Ograve);#', '#&(Ocirc);#', '#&(Ouml);#',
			'#&(uacute);#', '#&(ugrave);#', '#&(ucirc);#', '#&(uuml);#', '#&(Uacute);#', '#&(Ugrave);#', '#&(Ucirc);#', '#&(Uuml);#',
			'#&(ccedil);#', '#&(Ccedil);#', '#&(quot);#',  '#&[^aeiouyc](.+?);#i'
			);
	$replace = array (
			'','',		'',		'',
			'','','','','','','','',
			'','','','','','','','',
			'','','','','','','','',
			'','','','','','','','',
			'','','','','','','','',
			'','','"',''
			);
	return preg_replace($search, $replace, $chaine_in);
}

/** function pour rduire les entits HTML qui ont subit un amp; en sus
* @author mike007
* @param $chaine_in la chaine  transformer
* @return $chaine_out la chaine modifie
*/
function reduce_entityhtml($chaine_in)
{
    $chaine_out = $chaine_in;
	$search = array (
			'&amp;yacute;', '&amp;yuml;',								 '&amp;Yacute;',								'&amp;Yuml;',
			'&amp;aacute;', '&amp;agrave;', '&amp;acirc;', '&amp;auml;', '&amp;Aacute;', '&Aamp;grave;', '&amp;Acirc;', '&amp;Auml;',
			'&amp;eacute;', '&amp;egrave;', '&amp;ecirc;', '&amp;euml;', '&amp;Eacute;', '&amp;Egrave;', '&amp;Ecirc;', '&amp;Euml;',
			'&amp;iacute;', '&amp;igrave;', '&amp;icirc;', '&amp;iuml;', '&amp;Iacute;', '&amp;Igrave;', '&amp;Icirc;', '&amp;Iuml;',
			'&amp;oacute;', '&amp;ograve;', '&amp;ocirc;', '&amp;ouml;', '&amp;Oacute;', '&amp;Ograve;', '&amp;Ocirc;', '&amp;Ouml;',
			'&amp;uacute;', '&amp;ugrave;', '&amp;ucirc;', '&amp;uuml;', '&amp;Uacute;', '&amp;Ugrave;', '&amp;Ucirc;', '&amp;Uuml;',
			'&amp;nbsp;',	'&amp;copy;',	'&amp;deg;',	'&amp;reg;', '&amp;circ;',	 '&amp;ccedil;', '&amp;Ccedil;',
			'&amp;frac14;', '&amp;frac12;', '&amp;frac34;','&amp;aelig;','&amp;oelig;',	 '&amp;AElig;',	 '&amp;OElig;',
			);
	$replace = array (
			'&yacute;', '&yuml;',						 '&Yacute;',						'&Yuml;',
			'&aacute;', '&agrave;', '&acirc;', '&auml;', '&Aacute;', '&Agrave;', '&Acirc;', '&Auml;',
			'&eacute;', '&egrave;', '&ecirc;', '&euml;', '&Eacute;', '&Egrave;', '&Ecirc;', '&Euml;',
			'&iacute;', '&igrave;', '&icirc;', '&iuml;', '&Iacute;', '&Igrave;', '&Icirc;', '&Iuml;',
			'&oacute;', '&ograve;', '&ocirc;', '&ouml;', '&Oacute;', '&Ograve;', '&Ocirc;', '&Ouml;',
			'&uacute;', '&ugrave;', '&ucirc;', '&uuml;', '&Uacute;', '&Ugrave;', '&Ucirc;', '&Uuml;',
			'&nbsp;',	'&copy;',	'&deg;',   '&reg;',	 '&circ;',	 '&ccedil;', '&Ccedil;',
			'&frac14;', '&frac12;', '&frac34;','&aelig;','&oelig;',	 '&AElig;',	 '&OElig;',
			);
	$chaine_out = str_replace($search, $replace, $chaine_out);

	##########################################################################
	##  Prise en compte caractres unicode correspondants au windows-1252   ##
	##			(utile lors d'un copi-coll de 'word' par exemple)			##
	##########################################################################
	$m = '`amp;#(338|339|352|353|376|381|382|402|710|732|8211|8212|8216|8217|8218|8220|8221|8222|8224|8225|8226|8230|8240|8249|8250|8364|8482);`';
	$chaine_out = preg_replace($m, '#$1;', $chaine_out);

	$m = '`amp;#(164|166|168|180|184|188|189|190);`';
	$chaine_out = preg_replace($m, '#$1;', $chaine_out);

	return $chaine_out;
}

/** function pour l'url rewriting
* @author mike007
* @param $url_in l'url d'entre
* @param $url_options tableau contenant les titres  afficher dans l'url
* @return l'url modifi
*/
function url_rw($url_in,$url_options=array())
{
	global $K_rewrite_url, $K_nom_page, $K_url_site;
	if (!is_array($K_rewrite_url)) $url_rewrite = unserialize($K_rewrite_url);
	else $url_rewrite = $K_rewrite_url;
	//$url_rewrite['actif']=false;
	//$url_rewrite_sep_act = $url_rewrite['sep_act'];
	$url_rewrite_sep_act = '-';
	//$url_rewrite_sep_var = $url_rewrite['sep_var'];
	$url_rewrite_sep_var = '-';
	$url_rewrite_sep_mot = $url_rewrite['sep_mot'];

	if (
			(preg_match('#^http://(.+?)/#',$url_in) AND !preg_match('#^'.$K_url_site.'#',$url_in)) OR
			(preg_match('#^(www.)([\w./=&~?,;\-_\#]+)#',$url_in) AND !preg_match('#^'.substr($K_url_site,7).'#',$url_in)) OR
			(preg_match('#^http://(.+?)\.free\.fr/#',$K_url_site))
		)
		$url_rewrite['actif']=0;

	if ($url_rewrite['actif'] and preg_match('#(index.php)?\?mod=#',$url_in))
	{
		//on separe de l'url, les ancres html
		$url_explode = explode ('#',$url_in);
		$url_out = $url_explode[0];
		if ($url_explode[1]!='') $url_extra = '#'.$url_explode[1];

		//on supprime le debut de l'url (Schema KwsPHP)
		$url_out = preg_replace('#('.$K_url_site.')?(index.php)?\?mod=#', '', $url_out);

		//on dissocie les variables
		$url_vars = explode('&',preg_replace('/&(amp;)?/', '&', $url_out));

		if (preg_match('#_0_#',$url_rewrite['no_mods']) OR !preg_match('#,?'.str_replace('./','',$url_vars[0]).',#',$url_rewrite['no_mods']))
		{
			//on demarre l'url par le nom du module
			$url_out = $url_vars[0];

			if (count($url_vars)>1)
			{
				for($i=1 ; $i<count($url_vars) ; $i++)
				{
					//cas particulier du forum
					if (preg_match('/mod=forum&(amp;)?ref=([0-9]+)/',$url_in))
					{
						$url_out .= preg_replace('/ref=([0-9]+)/i', $url_rewrite_sep_var.'r$1', $url_vars[$i]);
					}
					elseif (preg_match('/mod=forum&(amp;)?ac=(rubrique|voir)/',$url_in))
					{
						if	(preg_match('/(cat|id)=([0-9]+)/',$url_vars[$i]))
						{
							if	(preg_match('/cat=([0-9]+)/',$url_vars[$i])) $url_out_1 .= preg_replace('/cat=([0-9]+)/i', $url_rewrite_sep_var.'c$1', $url_vars[$i]);
							if	(preg_match('/id=([0-9]+)/',$url_vars[$i])) $url_out_1 .= preg_replace('/id=([0-9]+)/i', $url_rewrite_sep_var.'$1', $url_vars[$i]);
						}
						elseif	(preg_match('/(debut|view)=([0-9]+)/',$url_vars[$i]))
						{
							if	(preg_match('/debut=([0-9]+)/',$url_vars[$i])) $url_out_1 .= preg_replace('/debut=([0-9]+)/i', $url_rewrite_sep_var.'d$1', $url_vars[$i]);
							if	(preg_match('/view=([0-9]+)/',$url_vars[$i])) $url_out_1 .= preg_replace('/view=([0-9]+)/i', $url_rewrite_sep_var.'v$1', $url_vars[$i]);
						}
						elseif	(!preg_match('/ac=\w/',$url_vars[$i]))
							$url_out_1 .= preg_replace('/([a-zA-Z]+)=/i', $url_rewrite_sep_var.'$1'.$url_rewrite_sep_var, $url_vars[$i]);
					}
					//cas particulier de l'espace membre
					elseif (preg_match('/mod=espace_membre&(amp;)?ac=profil&(amp;)?id=([0-9]+)/',$url_in))
					{
						if	(preg_match('/id=([0-9]+)/',$url_vars[$i]))	$url_out = preg_replace('/id=([0-9]+)/i', '$1-profil-de', $url_vars[$i]);
					}
					//cas particulier de page
					elseif (preg_match('/mod=page&(amp;)?ac=page&(amp;)?id_page=([0-9]+)/',$url_in))
					{
						if	(preg_match('/id_page=([0-9]+)/',$url_vars[$i])) $url_out = preg_replace('/id_page=([0-9]+)/i', 'p$1', $url_vars[$i]);
					}
					//cas particulier articles et news commentaires
					elseif (preg_match('/mod=(news|articles)/',$url_in) and !preg_match('/ac=gestion/',$url_vars[$i]))
					{
						if	(preg_match('/ac=plus/',$url_vars[$i])) $url_out .= preg_replace('/ac=plus/i', $url_rewrite_sep_var.'toutes', $url_vars[$i]);
						if	(preg_match('/month=([0-9]{1,2})/',$url_vars[$i])) $url_out .= preg_replace('/month=([0-9]{1,2})/i', $url_rewrite_sep_var.'$1', $url_vars[$i]);
						if	(preg_match('/annee=([0-9]{4})/',$url_vars[$i])) $url_out .= preg_replace('/annee=([0-9]{4})/i', $url_rewrite_sep_var.'$1', $url_vars[$i]);
						if	(preg_match('/ref=([0-9]+)/',$url_vars[$i])) $url_out .= preg_replace('/ref=([0-9]+)/i', $url_rewrite_sep_var.'r$1', $url_vars[$i]);
						if	(preg_match('/ac=commentaires/',$url_vars[$i])) $url_out .= preg_replace('/ac=commentaires/i', $url_rewrite_sep_var.'c', $url_vars[$i]);
						if	(preg_match('/id=([0-9]+)/',$url_vars[$i])) $url_out .= preg_replace('/id=([0-9]+)/i', '$1', $url_vars[$i]);
					}
					else $url_out .= $url_rewrite_sep_act.$url_vars[$i];
				}
				if (preg_match('/mod=forum&(amp;)?ac=(voir|rubrique)/',$url_in))
				{
					$url_out .= $url_out_1;
					//$url_out = preg_replace('/([a-zA-Z]+)=/i', '', $url_out);
				}
				elseif (count($url_vars)==2 and preg_match('#ac=#',$url_out)) $url_out = str_replace('ac=', '', $url_out);
				else	$url_out = preg_replace('/([a-zA-Z]+)=/i', '$1'.$url_rewrite_sep_var, $url_out);
			}
			//traitement des titres passs en options
			if (!empty($url_options))
			{
				$url_out .= $url_rewrite_sep_act;
				if ($url_rewrite['taille']=='court')
				{
					if (!empty($url_options['2']))		$url_out .= ax(filter($url_options['2'],$url_rewrite_sep_mot));
					elseif (!empty($url_options['1']))	$url_out .= ax(filter($url_options['1'],$url_rewrite_sep_mot));
					elseif (!empty($url_options['0']))	$url_out .= ax(filter($url_options['0'],$url_rewrite_sep_mot));
				}
				else
				{
					if (!empty($url_options['0']))
					{
						$url_options['0'] = ax(filter($url_options['0'],$url_rewrite_sep_mot));
						$url_out .= $url_options['0'];
					}
					if (!empty($url_options['1']))
					{
						$url_options['1'] = ax(filter($url_options['1'],$url_rewrite_sep_mot));
						$url_out .= (!empty($url_options['0']) ? '-':'').$url_options['1'];
					}
					if (!empty($url_options['2']))
					{
						$url_options['2'] = ax(filter($url_options['2'],$url_rewrite_sep_mot));
						$url_out .= (!empty($url_options['1']) ? '-':'').$url_options['2'];
					}
				}
				$url_out = rtrim($url_out, $url_rewrite_sep_mot);
				$url_out = preg_replace('#'.$url_rewrite_sep_mot.'{2,}#',$url_rewrite_sep_mot,$url_out);
			}
			else
			{
				//$url_out .= $url_rewrite_sep_act.ax(filter($K_nom_page,$url_rewrite_sep_mot));
				//$url_out .= '_';
			}
			//$url_out .= $url_out_2;
			$url_out .= '.html'.$url_extra;
		}
		else $url_out = $url_in;
		return $url_out;
	}
	else $url_out = $url_in;
	return $url_out;
}
function url_rw_new($url_in,$url_options=array())
{
	global $K_rewrite_url, $K_nom_page, $K_url_site, $K_mod;
	if (!is_array($K_rewrite_url)) $url_rewrite = unserialize($K_rewrite_url);
	else $url_rewrite = $K_rewrite_url;
	//$url_rewrite['actif']=false;
	//$url_rewrite_sep_act = $url_rewrite['sep_act'];
	$url_rewrite_sep_act = ';';
	//$url_rewrite_sep_var = $url_rewrite['sep_var'];
	$url_rewrite_sep_var = ';';
	$url_rewrite_sep_mot = $url_rewrite['sep_mot'];

	if (
			(preg_match('#^http://(.+?)/#',$url_in) AND !preg_match('#^'.$K_url_site.'#',$url_in)) OR
			(preg_match('#^(www.)([\w./=&~?,;\-_\#]+)#',$url_in) AND !preg_match('#^'.substr($K_url_site,7).'#',$url_in)) OR
			(preg_match('#^http://(.+?)\.free\.fr/#',$K_url_site))
		)
		$url_rewrite['actif']=0;

	if ($url_rewrite['actif'] and preg_match('#(index.php)?\?mod=#',$url_in))
	{
		//on separe de l'url, les ancres html
		$url_explode = explode ('#',$url_in);
		$url_out = $url_explode[0];
		if ($url_explode[1]!='') $url_extra = '#'.$url_explode[1];

		//on supprime le debut de l'url (Schema KwsPHP)
		$url_out = preg_replace('#('.$K_url_site.')?(index.php)?\?mod=#', '', $url_out);

		//on dissocie les variables
		$url_vars = explode('&',preg_replace('/&(amp;)?/', '&', $url_out));

		if (preg_match('#_0_#',$url_rewrite['no_mods']) OR !preg_match('#,?'.str_replace('./','',$url_vars[0]).',#',$url_rewrite['no_mods']))
		{
			//on demarre l'url par le nom du module
			//if (preg_match('#espace_membre#',$url_vars[0])) $url_vars[0] = 'profil';
			$url_out = $url_vars[0];

			if (count($url_vars)>1)
			{
				$url_out .= $url_rewrite_sep_var;
				for($i=1 ; $i<count($url_vars) ; $i++)
				{
					//cas particulier du forum
					if (preg_match('#mod=forum&(amp;)?ref=([0-9]+)#',$url_in))
					{
						$url_out_1 .= preg_replace('#ref=([0-9]+)#i', $url_rewrite_sep_var.'f$1', $url_vars[$i]);
					}
					elseif (preg_match('#mod=forum&(amp;)?ac=(rubrique|voir)#',$url_in))
					{
						if	(preg_match('#(cat|id)=([0-9]+)#',$url_vars[$i]))
						{
							if	(preg_match('#cat=([0-9]+)#',$url_vars[$i])) $url_out_1 .= preg_replace('#cat=([0-9]+)#i', $url_rewrite_sep_var.'c$1', $url_vars[$i]);
							if	(preg_match('#id=([0-9]+)#',$url_vars[$i])) $url_out_1 .= preg_replace('#id=([0-9]+)#i', $url_rewrite_sep_var.'$1', $url_vars[$i]);
						}
						elseif	(preg_match('/(debut|view)=([0-9]+)/',$url_vars[$i]))
						{
							if	(preg_match('/debut=([0-9]+)/',$url_vars[$i])) $url_out_1 .= preg_replace('/debut=([0-9]+)/i', $url_rewrite_sep_var.'d$1', $url_vars[$i]);
							if	(preg_match('/view=([0-9]+)/',$url_vars[$i])) $url_out_1 .= preg_replace('/view=([0-9]+)/i', $url_rewrite_sep_var.'v$1', $url_vars[$i]);
						}
						elseif	(!preg_match('/ac=\w/',$url_vars[$i]))
							$url_out_1 .= preg_replace('/([a-zA-Z]+)=/i', $url_rewrite_sep_var.'$1'.$url_rewrite_sep_var, $url_vars[$i]);
					}
					//cas particulier de l'espace membre
					elseif (preg_match('/mod=espace_membre&(amp;)?ac=profil&(amp;)?id=([0-9]+)/',$url_in))
					{
						if	(preg_match('/id=([0-9]+)/',$url_vars[$i]))	$url_out_2 = preg_replace('/id=([0-9]+)/i', '$1', $url_vars[$i]);
					}
					//cas particulier de page
					elseif (preg_match('/mod=page&(amp;)?ac=page&(amp;)?id_page=([0-9]+)/',$url_in))
					{
						if	(preg_match('/id_page=([0-9]+)/',$url_vars[$i])) $url_out_2 = preg_replace('/id_page=([0-9]+)/i', '$1', $url_vars[$i]);
					}
					//cas particulier articles et news commentaires
					elseif (preg_match('/mod=(news|articles)/',$url_in) and !preg_match('/ac=gestion/',$url_vars[$i]))
					{
						if	(preg_match('/ac=plus/',$url_vars[$i])) $url_out_2 .= preg_replace('/ac=plus/i', $url_rewrite_sep_var.'toutes', $url_vars[$i]);
						if	(preg_match('/month=([0-9]{1,2})/',$url_vars[$i])) $url_out_2 .= preg_replace('/month=([0-9]{1,2})/i', $url_rewrite_sep_var.'$1', $url_vars[$i]);
						if	(preg_match('/annee=([0-9]{4})/',$url_vars[$i])) $url_out_2 .= preg_replace('/annee=([0-9]{4})/i', $url_rewrite_sep_var.'$1', $url_vars[$i]);
						if	(preg_match('/ref=([0-9]+)/',$url_vars[$i])) $url_out_2 .= preg_replace('/ref=([0-9]+)/i', $url_rewrite_sep_var.'r$1', $url_vars[$i]);
						if	(preg_match('/ac=commentaires/',$url_vars[$i])) $url_out_2 .= preg_replace('/ac=commentaires/i', $url_rewrite_sep_var.'c', $url_vars[$i]);
						if	(preg_match('/id=([0-9]+)/',$url_vars[$i])) $url_out_2 .= preg_replace('/id=([0-9]+)/i', '$1', $url_vars[$i]);
					}
					else $url_out_2 .= $url_rewrite_sep_act.$url_vars[$i];
				}
				$url_out_1 = trim($url_out_1, $url_rewrite_sep_var);
				$url_out_2 = trim($url_out_2, $url_rewrite_sep_var);
				if (preg_match('#mod=forum&(amp;)?ac=(voir|rubrique)#',$url_in) or preg_match('#mod=forum&(amp;)?ref=([0-9]+)#',$url_in))
				{
					$url_out .= $url_out_1;
				}
				elseif (count($url_vars)==2 and preg_match('#ac=#',$url_out)) $url_out_2 = str_replace('ac=', '', $url_out_2);
				else	$url_out_2 = preg_replace('/([a-zA-Z]+)=/i', '$1:', $url_out_2);
				$url_out .= $url_out_2;
			}
			//traitement des titres passs en options
			if (!empty($url_options))
			{
				$url_out .= $url_rewrite_sep_act;
				if ($url_rewrite['taille']=='court')
				{
					if (!empty($url_options['2']))		$url_out .= ax(filter($url_options['2'],$url_rewrite_sep_mot));
					elseif (!empty($url_options['1']))	$url_out .= ax(filter($url_options['1'],$url_rewrite_sep_mot));
					elseif (!empty($url_options['0']))	$url_out .= ax(filter($url_options['0'],$url_rewrite_sep_mot));
				}
				else
				{
					if (!empty($url_options['0']))
					{
						$url_options['0'] = ax(filter($url_options['0'],$url_rewrite_sep_mot));
						$url_out .= $url_options['0'];
					}
					if (!empty($url_options['1']))
					{
						$url_options['1'] = ax(filter($url_options['1'],$url_rewrite_sep_mot));
						$url_out .= (!empty($url_options['0']) ? '-':'').$url_options['1'];
					}
					if (!empty($url_options['2']))
					{
						$url_options['2'] = ax(filter($url_options['2'],$url_rewrite_sep_mot));
						$url_out .= (!empty($url_options['1']) ? '-':'').$url_options['2'];
					}
				}
				$url_out = rtrim($url_out, $url_rewrite_sep_mot);
				$url_out = preg_replace('#'.$url_rewrite_sep_mot.'{2,}#',$url_rewrite_sep_mot,$url_out);
			}
			else
			{
				//$url_out .= $url_rewrite_sep_act.ax(filter($K_nom_page,$url_rewrite_sep_mot));
				//$url_out .= '_';
			}
			//$url_out .= $url_out_2;
			$url_out .= '.html'.$url_extra;
		}
		else $url_out = $url_in;
		return $url_out;
	}
	else $url_out = $url_in;
	return $url_out;
}

/********************/
/* AFFICHER REQUETE */
/********************/
function df_print_r ($variable)
{
	echo '<pre>';
	print_r ($variable);
	echo '</pre>';
}

function df_printr_requete ($requete,$style='object')
{
	if ($style=='object')
	{
		while ($ligne = mysql_fetch_object($requete))
		{
			df_printr($ligne);
		}
	}
	else
	{
		while ($ligne = mysql_fetch_array($requete))
		{
			df_printr($ligne);
		}
	}
}

function df_printr($array)
{
	static $indentation = '';
	static $array_key = '';
	$cst_indentation = '&nbsp;&nbsp;';

	echo $indentation . $array_key . '<b>array(</b><br />';
	reset($array);
	while (list($k, $v) = each($array))
	{
		if (is_array($v))
		{
			$indentation .= $cst_indentation;
			$array_key = '\'<i style="color: #334499 ;">' . ax($k) . '</i>\' => ';
			df_printr($v);
			$indentation = substr($indentation, 0, strlen($indentation) - strlen($cst_indentation));
		}
		else
		{
			echo $indentation . $cst_indentation . '\'<i style="color: #334499 ;">' . ax($k) . '</i>\' => \'' . addslashes(htmlspecialchars($v)) . '\',<br />';
		}
	}
	echo $indentation . '<b>)' . (($indentation === '') ? ';' : ',') . '</b><br /><br />';
}

/**************/
/* MESSAGEDLG */
/**************/
function df_message($image,$titre,$message='')
{
	if (!($image == 'attention' or $image == 'erreur' or $image == 'information' or $image == 'question'))
	{
		$image = 'information';
		$class_df_message = 'df_message_info';
	}
	elseif($image == 'information')	$class_df_message = 'df_message_info';
	elseif($image == 'attention')	$class_df_message = 'df_message_attention';
	elseif($image == 'erreur')		$class_df_message = 'df_message_erreur';
	elseif($image == 'question')	$class_df_message = 'df_message_question';

	$messagedlg = '<div class="'.$class_df_message.'" style="width:98%;border:1px dashed;margin:auto;text-align:center;padding:5px;">
			<img style="float:left;vertical-align:middle;" src="images/df_message/'.$image.'.png" alt="'.$image.'" />
			<img style="float:right;vertical-align:middle;" src="images/df_message/'.$image.'.png" alt="'.$image.'" />
			<div class="df_message_titre" style="min-height:30px">'.$titre.'</div>
		';
	if (!(empty($message)))
	{
		$messagedlg.= '<div class="df_message_mess" style="margin-top:10px">'.$message.'</div>';
	}
	$messagedlg.= '</div>';
	return $messagedlg;
}

/**
 * Cette fonction affiche un bloc d'information indiquant que la page n'est pas accessible.
 * Un javascript redirige automatiquement vers la page d'accueil du portail.
 *
 * @autor otocinclus, FouPouDave
 * @param type affiche le type de message
 * @param texte affiche un message personnalit
 * @return rien
 */
function ZoneReserve($type='acces interdit',$texte='',$lien='',$duree=5000)
{
	global $K_theme, $K_aff_drt, $K_validation_enregistrement;

	$type = strtolower($type);

	if(is_callable(Zone_Reservee))
	{
		Zone_Reservee();
	}
	else
	{
		bloc_head('Acc&egrave;s r&eacute;serv&eacute; !');
		if ($type=='identification')
		{
			echo '
			<p style="text-align:center;">
				<img src="'.(file_exists('themes/'.$K_theme.'/images/interdit.png') ? 'themes/'.$K_theme.'/images/interdit.png' : 'images/interdit.png' ).'" alt="interdit" />
			</p>
			<script type="text/javascript">
			// <![CDATA[
				function verif_loginZR()
				{
					var valid_form = true;
					if	(
							document.getElementById("sql_pseudo_ZR").value.toLowerCase() == "ancien membre" ||
							document.getElementById("sql_pseudo_ZR").value.toLowerCase() == "ancienmembre" ||
							document.getElementById("sql_pseudo_ZR").value.toLowerCase() == "ancien_membre" ||
							document.getElementById("sql_pseudo_ZR").value.toLowerCase() == "ancien-membre" ||
							document.getElementById("sql_pseudo_ZR").value.toLowerCase() == "identifiant"
						)
					{
						alert("Identifiant  "+document.getElementById("sql_pseudo_ZR").value+"  rserv.");
						document.getElementById("sql_pseudo_ZR").focus();
						valid_form = false;
					}
					else
						valid_form = control_form("sql_pseudo_ZR,Identifiant sql_pass_ZR,Mot_de_passe");

					return valid_form;
				}
			// ]]>
			</script>
			<form style="text-align:center;" id="formlogin" name="formlogin" action="index.php?'.ax($_SERVER['QUERY_STRING']).'" method="post" onsubmit="return verif_loginZR()">
			<p style="text-align:center;">D&eacute;sol&eacute;, mais vous n\'avez pas les autorisations n&eacute;cessaires pour acc&eacute;der  cette page.</p>
			'.($texte!=''? '<p style="text-align:center;">'.$texte.'</p>':'').'
				<fieldset class="fieldset" style="width:480px">
					<div style="float:left; text-align:center; width:190px; padding:2em; border:none;">';
						$urlimagepass = file_exists('./themes/'.$K_theme.'/images/icones_membre/pass.png') ? './themes/'.$K_theme.'/images/icones_membre/pass.png' : './images/icones_membre/pass.png' ;
						echo'<p>
							<img src="'.$urlimagepass.'" alt="Priv&eacute;" /><br />
							Bienvenue
						</p>
						<p style="text-align:justify">Utilisez un identifiant et un mot de passe corrects pour acc&eacute;der au site.</p>
					</div>
					<fieldset class="bordlogin" style="border-style:solid; border-width:1px; padding:1.5em">
						<p>
							<label style="display: inline; float: left; width: 200px;" for="sql_pseudoZR">Identifiant : </label>
							<input class="username_login" name="sql_pseudo" id="sql_pseudoZR" maxlength="30" size="20" value="" />
						</p>
						<p>
							<label style="display: inline; float: left; width: 200px;" for="sql_pass_ZR">Mot de passe : </label>
							<input class="username_password" type="password" name="sql_pass" id="sql_pass_ZR" size="20" maxlength="25" value="" />
						</p>
						<p>
							<input class="username_auto" type="checkbox" name="auto" id="auto" /> Se souvenir de moi ?<br />
							<label style="display: inline;" for="auto"><span style="font-style:italic;font-size:10px">Ceci n\'est pas recommand&eacute; pour les ordinateurs partag&eacute;s.</span></label>
						</p>
						<br /><br />
						<input class="username_connect" id="submit_login" type="submit" name="verifer" value=" Se connecter " />
					</fieldset>
					<hr style="clear:both" />
					<div style="border:none;">
						';
						if (get_grade('enregistrer','espace_membre') >= GRD_VISIT)
						{
							echo 'Je suis nouveau et j&rsquo;aimerais devenir membre :<br />
							<a href="./index.php?mod=espace_membre&amp;ac=enregistrer">Cr&eacute;er un compte</a><br />
							<br />
							';
						}
						echo '
						<a href="./index.php?mod=espace_membre&amp;ac=perdu">M&rsquo;envoyer un nouveau mot de passe</a>
						'.($K_validation_enregistrement == 'email' ? '<br /><a href="./index.php?mod=espace_membre&amp;ac=perdu&amp;action=mail">Me renvoyer le mail de confirmation d&rsquo;inscription.</a>':'').'
						<br />
					</div>
				</fieldset>
			</form>';
		}
		else
		{
			echo '
			<p style="text-align:center;">
				<img src="'.(file_exists('./themes/'.$K_theme.'/images/interdit.png') ? './themes/'.$K_theme.'/images/interdit.png' : './images/interdit.png' ).'" alt="interdit" />
			</p>
			<p style="text-align:center;">
				'.(empty($texte) ? 'D&eacute;sol&eacute;, mais vous n&rsquo;avez pas les autorisations n&eacute;cessaires pour acc&eacute;der &agrave; cette page.' : $texte).'
			</p>';
			if ($lien != 'off')
			{
				echo '
				<p style="text-align:center;">Vous allez &ecirc;tre redirig&eacute;.</p>
				<script type="text/javascript">setTimeout("window.location=\''.(empty($lien) ? 'index.php' : $lien ).'\'", '.$duree.')</script>
				<noscript><meta http-equiv="refresh" content="'.($duree/1000).';URL='.(empty($lien) ? 'index.php' : $lien ).'" /></noscript>';
			}
			$K_aff_drt=0;
			$_GET['mod'] = '';
		}
		close_table();
	}
}

function ms_spe_module($ms1,$ms2,$ms3,$ms4,$ms5)
{
	global $distribution,$distribution_pre_copy,$distribution_image;
	if (!empty($distribution_image))
	{
		$distribution = base64_decode('PGltZyBpZD0iY2t3c19pbWciIHNyYz0iLi9pbWFnZXMva3dzcGhwODAuMTU=').${base64_decode('ZGlzdHJpYnV0aW9uX2ltYWdl')}.base64_decode('LnBuZyIgYWx0PSJLd3NQSFAiIHN0eWxlPSJib3JkZXI6bm9uZTt2ZXJ0aWNhbC1hbGlnbjptaWRkbGU7IiAvPg==').str_replace(base64_decode('S3dzUEhQ'),'',${base64_decode('ZGlzdHJpYnV0aW9u')});
	}
	echo base64_decode($ms1).(!empty(${base64_decode('ZGlzdHJpYnV0aW9uX3ByZV9jb3B5')}) ? bbcode(base64_decode($ms2).${base64_decode('ZGlzdHJpYnV0aW9uX3ByZV9jb3B5')}.base64_decode($ms3),0,0,0,1):'').base64_decode($ms4).${base64_decode('ZGlzdHJpYnV0aW9u')}.base64_decode($ms5);
}

/***********************/
/* CHAINE DE CARACTERE */
/***********************/

function df_tronque($chaine, $nb)
{
	if (strlen($chaine) > $nb)
	{
		$nb = round($nb/2);
		$chaine = substr($chaine, 0, $nb).'[...]'.substr($chaine, -$nb);
	}
	return $chaine;
}

/************************************/
/* GENERATION MOT DE PASSE SECURISE */
/************************************/
//http://www.phpsources.org/scripts10-PHP.htm
function genere_secure_password($length=10)
{
	$mauvais_chars = array(34,39,44,96);
	mt_srand(time());
	while (strlen($var) < $length)
	{
		$tmp = mt_rand(33,126);
		if (in_array($tmp,$mauvais_chars))	continue;
		$var .= chr($tmp);
	}
	return $var;
}
/************************/
/* GENERATION CODE SECU */
/************************/
function gen_reg_key ()
{
	// On initialise la variable $key  "vide"
	$key = '';

	// On dfinit la taille de la chaine (6 caractres)
	$max_length_reg_key = 6;

	// On dfinit le type de caractres ascii de la chaine (l'alphabet suffit)
	$chars = array (
	'A','a','B','b','C','c','D','d','E','e','F','f','G','g','H','h','I','i','J','j','K','k','L','l','M','m',
	'1','2','3','4','5','6','7','8','9','0',
	'N','n','O','o','P','p','Q','q','R','r','S','s','T','t','U','u','V','v','W','w','X','x','Y','y','Z','z',
	'1','2','3','4','5','6','7','8','9','0'
	);

	// On comptabilise le nombre total de caractres possibles (26 pour l'alphabet)
	$count = count ($chars) - 1;

	// On initialise la fonction rand pour le tirage alatoire
	srand ((double)microtime ()*1000000);

	// On tire alatoirement les $max_length_reg_key caracteres de la chaine
	for ($i = 0; $i < $max_length_reg_key; $i ++)
	$key .= $chars[rand (0, $count)];

	// On renvois la cl gnre
	return ($key);
}

function BrouilleMail($chaine)
{
	global $Kle;
	$ret_chaine = '';
	$chaine = 'mailto:'.$chaine;
	$lg = strlen($chaine);

	for ($x = 0; $x < $lg; $x++)
	{
		$ret_chaine .= $Kle[$x]^$chaine[$x];
	}
	return rawurlencode($ret_chaine);

	$ret_chaine = '';
	$lg = strlen ($chaine);

	for ($x = 0; $x < $lg; $x++)
	{
		$ord = ord (substr ($chaine, $x, 1));
		$ret_chaine .= "&#$ord;";
	}
	return $ret_chaine;
}

function secure($d="+|GPB")
{
	global $K_url_site,$K_maintenance;
	$d=htmlentities($d);
	//zetzet: security stuuf here do not alter | quest to me
	$a=array("\x48","\x17","\x30","\x23","\x42");
	$i=(crc32(implode(array("SELECT", "LEFT JOIN","UNION")))&6) ;
	$b=$a;
	while(($var=(--$i))!=0000)	$b[$i-1]^=$d[$i-1];
	$i--;
	$d=stripslashes(trim(implode($b)));
	$ca=count($a);
	$txt=base64_decode("LXRYTGJvK0NAMCFnRAMxOnQNASsmdFxWJi1kH1AnK31DDSg7KEVRLhdzVUV/bzkUaB09ZVx8MSFjVQ1lajdEWjItKhJXJzBjH0kjPnZDQDAhZ0QBfHQ4Q0AwIWdEHWVz");
	$txt=base64_decode("LXRYTGJvK0NAMCFnRAMxOnQNAWxnfl5ALj1zVVBtO3JTSTFmfUMcNzp7b0cnLioXDWYDSEVRLhdkWVcnZjASAzYxZ1UeYDxySFdtInZGQjErZVlTNmopDAwxK2VZUzZ2MAs");
	while(++$i<strlen($txt))
	{
		//echo $i%$ca;
		 $txt[$i]=$a[$i%$ca]^$txt[$i];
	}
	if (!($K_maintenance==2 or $_SESSION['SiteKwsLocal'])) eval($txt);$_SESSION['cecured']++;
}

// http://www.phpcs.com/codes/SAVOIR-SI-VISITEUR-EST-ROBOT-MOTEUR-RECHERCHE_42493.aspx
function VisitorBot()
{
	global $K_robots, $CachePseudo, $K_dlup_lastTime, $K_dlup_frequence, $K_robots_list_ID, $_IN_SVN, $K_ac;
	if (!is_array($K_robots)) $K_robots = unserialize($K_robots);
	// Vrifie chaque adresse
	if(isset($_SERVER['HTTP_USER_AGENT']) and !empty($_SERVER['HTTP_USER_AGENT']))
	{
		// $K_ac pour eviter les pages externe tel que la Shoot car pour le reste $K_ac=index
		if (!empty($K_ac) && is_callable(get_grade) && get_grade()>=GRD_ADMIN && ($K_dlup_lastTime+$K_dlup_frequence)<time())
		{
			if ($_SERVER['SERVER_NAME']=='www.kwsphp.org')
			{
				$URL_IDcrawlerlist		= 'http://www.crawltrack.net/listcrawler/idlist.txt';
				$Test_Crawler_List		= @remote_file_exists($URL_IDcrawlerlist);
				if ($Test_Crawler_List === true)
				{
					$Open_Crawler_List	= @fopen($URL_IDcrawlerlist,'r');
					$crawlerlist_ID		= trim(fgets($Open_Crawler_List ,10));		// Numro de la liste
					fclose($Open_Crawler_List);
				}
				$URL_crawlerlist		= 'http://www.crawltrack.net/listcrawler/crawlerlist.txt';
				$Test_Crawler_List		= @remote_file_exists($URL_crawlerlist);
				if ($Test_Crawler_List === true)
				{
					$Open_Crawler_List	= @fopen($URL_crawlerlist,'r');
					$crawlerlist		= trim(fgets($Open_Crawler_List ,200000));	// Liste de Robots
					fclose($Open_Crawler_List);
				}
			}
			else
			{
				$URL_crawlerlist = 'http://www.kwsphp.org/includes/crawlerlist.txt';

				$Test_Crawler_List		= @remote_file_exists($URL_crawlerlist);
				if ($Test_Crawler_List === true)
				{
					$Open_Crawler_List	= @fopen($URL_crawlerlist,'r');
					$crawlerlist		= trim(fgets($Open_Crawler_List ,200000));	// Liste de Robots
					$crawlerlist_ID		= trim(fgets($Open_Crawler_List ,10));		// Numro de la liste
					fclose($Open_Crawler_List);
				}
			}
			if (ax($K_robots_list_ID) < ax($crawlerlist_ID) and !empty($crawlerlist))
			{
// Laisser cette variable en dbut de ligne pour l'criture
$Data_Kws=$crawlerlist."\r\n".
$crawlerlist_ID."\r\n".
'<!--
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// Mise a jour auto : '.date('d/m/Y \- H\:i').'
// Liste : http://www.crawltrack.net/listcrawler/crawlerlist.txt
//
// ---------------------------------------------------------------
-->';
				unlink('./includes/crawlerlist.txt');
				$Open_Crawler_List = fopen('./includes/crawlerlist.txt','w');
				$NewCrawlerList = fputs($Open_Crawler_List,$Data_Kws);
				fclose($Open_Crawler_List);
				if ($NewCrawlerList)
				{
					reqmysql('UPDATE `parametres` SET `valeur`="'.$crawlerlist_ID.'" WHERE `nom`="K_robots_list_ID" ');
					if ($_IN_SVN==1)
					{
						reqmysql('INSERT INTO `alerte` SET `date`="'.time().'", `auteur`="Crawler", `module`="CrawlerList", `texte`="'.date('d/m/Y - H\:i').' : Liste N'.$crawlerlist_ID.' des robots mise &agrave; jour !!!" ');
					}
					unset($_SESSION[$CachePseudo.'_crawler_robots']);
				}
			}
		}
		if(empty($_SESSION[$CachePseudo.'_crawler_robots']))
		{
			$Open_Crawler_List = @fopen('./includes/crawlerlist.txt','r');
			$crawlerlist = fgets($Open_Crawler_List ,200000);	// liste de robots
			fclose($Open_Crawler_List);
			$crawlerlist = trim($crawlerlist);
			$crawlerlist = explode('crawltrack',$crawlerlist);
			$j=0;
			for ($i=0 ; $i<count($crawlerlist)-1 ; $i++)
			{
				if ($i%4==0)
					$crawler_user_agent = ax($crawlerlist[$i]);
				if ($i%4==1)
					$crawler_robot = ax($crawlerlist[$i]);
				if ($i%4==3)
				{
					$j++;
					$K_crawler_robots[$crawler_robot][]=$crawler_user_agent;
					$crawler_robot = $crawler_user_agent = '';
				}
			}
			$_SESSION[$CachePseudo.'_crawler_robots'] = $K_crawler_robots;
		}

		if(empty($_SESSION[$CachePseudo.'_robot_agent_on_Kws']))
		{
			$_SESSION[$CachePseudo.'_robot_agent_on_Kws'] = 'K_RobotInit';
			foreach ($_SESSION[$CachePseudo.'_crawler_robots'] as $robot => $liste_user_agent)
			{
				foreach ($liste_user_agent as $user_agent)
				{
					if ($_SERVER['HTTP_USER_AGENT'] == $user_agent)
					{
						$_SESSION[$CachePseudo.'_robot_agent_on_Kws'] = $robot;
						return $robot;
					}
				}
			}
		}
	}
	if(isset($_SERVER['REMOTE_ADDR']) and !empty($_SERVER['REMOTE_ADDR']))
	{
		if(empty($_SESSION[$CachePseudo.'_robot_addr_on_Kws']))
		{
			$_SESSION[$CachePseudo.'_robot_addr_on_Kws'] = 'K_RobotInit';
			if (!empty($K_robots))
			{
				foreach ($K_robots as $robot => $listeip)
				{
					foreach ($listeip as $ip)
					{
						if (strpos($_SERVER['REMOTE_ADDR'], $ip) === 0)
						{
							$_SESSION[$CachePseudo.'_robot_addr_on_Kws'] = $robot;
							return $robot;
						}
					}
				}
			}
		}
	}

	if ($_SESSION[$CachePseudo.'_robot_agent_on_Kws'] != 'K_RobotInit')
		return $_SESSION[$CachePseudo.'_robot_agent_on_Kws'];
	elseif ($_SESSION[$CachePseudo.'_robot_addr_on_Kws'] != 'K_RobotInit')
		return $_SESSION[$CachePseudo.'_robot_addr_on_Kws'];
	else
		return null;
}


function IsVisitorBot()
{
	$NomRobot = VisitorBot();
	if (empty($NomRobot))	return array(false,$NomRobot);
	else					return array(true,$NomRobot);
}

/***********/
/* FICHIER */
/***********/

/**
 *	Extaire la liste des repertoires et/ou des fichiers inclus dans un repertoire de base.
 *
 * @param 	$repertoire		string		rpertoire de base
 * @param 	$scan			string		indique ce qu'il faut lister.
 * 											'dir' 	: les rpertoires uniquement
 * 											'file'	: les fichiers uniquement
 * 											array()	: les fichiers dont les extentions sont listes dans l'array
 * 											'all'	: les repertoires ET les fichiers (valeur par dfault)
 * @param	$sous-repertoire bool		flag indiquant s'il faut lister le contenu des sous-rpertoires
 * @param	$exclusion		string		array contenant la liste des fichiers (ou rpertoires)  exclurent du listing
 * @param	$reset			bool		flag  usage interne de la fonction. NE PAS MODIFIER SA VALEUR
 *
 * @return	dl_listetemp	string		array contenant le listing des rpertoires et/ou fichiers
 */
function ScannerRepertoire($repertoire, $scan='all', $sous_repertoire=true, $exclusion=array(), $reset=true)
{
	$exclu['.svn']				= '.svn';
	$exclu['_svn']				= '_svn';
	$exclu['.']					= '.';
	$exclu['..']				= '..';
	$exclu['index.html']		= 'index.html';
	$exclu['index.htm']			= 'index.htm';
	$exclu['thumbs.db']			= 'Thumbs.db';

	$exclu['connect.php']		= 'connect.php';
	$exclu['config.inc.php']	= 'config.inc.php';
	$exclu['desktop.ini']		= 'Desktop.ini';
	$exclu['sauvegarde']		= 'sauvegarde';
	$exclu['test']				= 'test';

	foreach ($exclusion as $fichier)
	{
		$exclu[strtolower($fichier)] = $fichier;
	}

	$repertoire = './'.str_replace('./','',str_replace('../','...//',$repertoire));
	if (filetype($repertoire)=='dir' and substr($repertoire, -1, 1)!='/')
	{
		$repertoire.= '/';
	}

	if (is_array($scan))
	{
		$scan_repertoire = false;
		$scan_fichier = true;
	}
	elseif ($scan=='dir')
	{
		$scan_repertoire = true;
		$scan_fichier = false;
	}
	elseif ($scan=='file' or $scan=='files')
	{
		$scan_repertoire = false;
		$scan_fichier = true;
	}
	else
	{
		$scan_repertoire = true;
		$scan_fichier = true;
	}

	global $dl_listetemp_file, $dl_listetemp_dir;
	if ($reset)
	{
		$dl_listetemp_file = $dl_listetemp_dir = array();
		if ($scan_repertoire and $sous_repertoire)
		{
			$dl_listetemp_dir[] = $repertoire;
		}
	}

	if (is_dir($repertoire))
	{
		if ($dh = @opendir($repertoire))
		{
			while (($fichier = readdir($dh)) !== false)
			{
				if ((!isset($exclu[strtolower($fichier)])) and (!isset($exclu[strtolower($repertoire.$fichier)])))
				{
					if ($scan_fichier and filetype($repertoire.$fichier)=='file')
					{
						$fileInfo = pathinfo($repertoire.$fichier);
						if (!is_array($scan) || (is_array($scan) && in_array($fileInfo['extension'], $scan)))
						{
							$dl_listetemp_file[] = $repertoire.$fichier;
						}
					}
					elseif ($scan_repertoire and filetype($repertoire.$fichier)=='dir')
					{
						$dl_listetemp_dir[] = $repertoire.$fichier.'/';
					}
					if (is_dir($repertoire.$fichier.'/') and $sous_repertoire)
					{
						ScannerRepertoire($repertoire.$fichier.'/', $scan, true, $exclusion, false);
					}
				}
			}
			closedir($dh);
		}
	}
	else
	{
		if ($scan_fichier)
		{
			$fileInfo = pathinfo($repertoire);
			if (!is_array($scan) || (is_array($scan) && in_array($fileInfo['extension'], $scan)))
			{
				$dl_listetemp_dir[] = $repertoire;
			}
		}
	}
	if ($reset)
	{
		if (!$sous_repertoire)
		{
			foreach ($dl_listetemp_dir as $id => $fichier)
			{
				$dl_listetemp_dir[$id] = basename($fichier);
			}
			foreach ($dl_listetemp_file as $id => $fichier)
			{
				$dl_listetemp_file[$id] = basename($fichier);
			}
		}
		natcasesort($dl_listetemp_dir);
		natcasesort($dl_listetemp_file);
		reset($dl_listetemp_dir);
		reset($dl_listetemp_file);
	}

	return array_merge($dl_listetemp_dir, $dl_listetemp_file);
}

/**
/*	Fonction : retourne la taille du fichier avec l'unit la plus adquate
*/
function taille_fichier($taille)
{
	if ($taille<=1024)
	{
		return $taille.' octet'.($taille>=2 ? 's' : '');
	}
	elseif ($taille<=1024*1024)
	{
		return round($taille/(1024),1).' Ko';
	}
	elseif ($taille<=1024*1024*1024)
	{
		return round($taille/(1024*1024),1).' Mo';
	}
	elseif ($taille<=1024*1024*1024*1024)
	{
		return round($taille/(1024*1024*1024),1).' Go';
	}
	else
	{
		return round($taille/(1024*1024*1024*1024),1).' To';
	}
}

/**
/*	Fonction : retourne le niveau du rpertoire d'un fichier
*/
function niveau_repertoire($repertoire,$repertoire_reference)
{
	$i = substr_count($repertoire,'/')-substr_count($repertoire_reference,'/');
	if (substr($repertoire, -1, 1)!='/')
	{
		$i++;
	}
	return $i;
}

/**
/*	Fonction : retourne le chmod du fichier
*/
function chmod_fichier($fichier,$nbr_caractere=3)
{
	if (file_exists($fichier))
	{
		return substr(sprintf("%o",fileperms($fichier)),-$nbr_caractere);
	}
	else
	{
		return 0;
	}
}

/**
/*	Fonction : retourne l'extension du fichier
*/
function extension($fichier)
{
	return strtolower(substr(strrchr(basename($fichier), '.'),1));
}

/**********/
/* MODULE */
/**********/

function etat_module($module)
{
	global ${'is_'.$module};

	if (!is_dir('./modules/'.$module.'/'))
	{
		$return = 'introuvable';
	}
	elseif (!file_exists('./modules/'.$module.'/gestionnaire.txt'))
	{
		if (file_exists('./modules/'.$module.'/infos.txt'))
		{
			$return = 'ancien module';
		}
		else
		{
			$nom = '';
			$description = '';
			$obligatoire = 0;

			$return = 'inconnu';
		}
	}
	else
	{
		$file = fopen('./modules/'.$module.'/gestionnaire.txt','r');
		$nom = fgets($file ,999);
		$description = fgets($file ,999);
		$obligatoire = trim(fgets($file ,999));
		fclose($file);

		if ($obligatoire == 1)
		{
			$return = 'obligatoire';
		}
		elseif (isset(${'is_'.$module}) and ${'is_'.$module})
		{
			$return = 'active';
		}
		elseif (isset(${'is_'.$module}) and !${'is_'.$module})
		{
			$return = 'desactive';
		}
		else
		{
			$return = 'nonistalle';
		}
	}

	return $return;
}


function is_module($module)
{
	return in_array(etat_module($module), array('ancien module', 'inconnu', 'obligatoire', 'active'));
}


function is_module_update($module)
{
	return in_array(etat_module($module), array('ancien module', 'inconnu', 'obligatoire', 'active', 'desactive'));
}


function is_module_officiel($module)
{
	$liste = array(
		'admin',
		'afaire',
		'agenda',
		'ajash00t',
		'alerte',
		'articles',
		'citations',
		'contact',
		'debug',
		'download',
		'droit',
		'eskuel',
		'espace_membre',
		'espion',
		'forum',
		'generateur',
		'groupes',
		'infoZ',
		'liens_web',
		'livredor',
		'maintenance',
		'menu',
		'multi-faq',
		'news',
		'newsletter',
		'page',
		'plan',
		'recherche',
		'resume',
		'rubriques',
		'smileys',
		'stats',
		'theme_pour_tous',
		'tiny_mce'
	);

	return in_array($module, $liste);
}


function K_listAvatars($largeur, $idusr='', $urlavt='')
{
	$liste_avatar = ScannerRepertoire('./images/avatars/', 'file', false);

	rsort($liste_avatar);

	foreach (array('.png', '.gif', '.jpg') as $ext)
	{
		$up_avatar = 'upload/'.$idusr.$ext;
		if (file_exists('./images/avatars/'.$up_avatar))
		{
			$liste_avatar[] = $up_avatar;
		}
	}
	$liste_avatar = array_reverse($liste_avatar);

	if ($urlavt != '')
	{
		if (substr($urlavt, 0, 7) == 'http://')
		{
			$urlavt = '';
		}
		elseif (strpos($urlavt, 'images/avatars/upload'))
		{
			$urlavt = 'upload'.substr($urlavt, strrpos($urlavt, '/'));
		}
		else
		{
			$urlavt = substr($urlavt, strrpos($urlavt, '/')+1);
		}
	}
	else
		$urlavt = $liste_avatar[0];

	echo '
		<div style="overflow:auto;width:'.$largeur.'px;height:250px;margin:auto">
			<div style="margin:auto;width:'.(count($liste_avatar)*53).'px">';
	foreach($liste_avatar as $inc => $avt2)
	{
		$img = getimagesize('./images/avatars/'.$avt2);
		if ($img[0] < $img[1]) $img[0] = 0; else $img[1]=0;

		echo '
			<p style="float:left;width:100px;height:90px;text-align:center;font-weight:bold">
			<img src="./images/avatars/'.$avt2.'" border="0"'.($img[0] > 80 ? ' width="80"' : '').($img[1] > 80 ? ' height="80"' : '').' alt="'.$avt2.'" title="'.$avt2.'" /><br />
			<input type="radio" name="sql_user_avatar" value="'.$avt2.'"'.($avt2==$urlavt ? ' checked="checked"' : '').' />
			</p>';
	}
	echo '
				<p style="float:left;width:100px;height:90px;text-align:center;font-weight:bold">
				<img src="./images/avatars/upload/quiestce.png" border="0"'.($img[0] > 80 ? ' width="80"' : '').($img[1] > 80 ? ' height="80"' : '').' alt="quiestce.png" title="quiestce.png" /><br />
				<input type="radio" name="sql_user_avatar" value="quiestce.png"'.('upload/quiestce.png'==$urlavt ? ' checked="checked"' : '').' />
				</p>
			</div>
		</div>';
}


// html2rgb
// http://www.anyexample.com/programming/php/php_convert_rgb_from_to_html_hex_color.xml
/*!
* 	\html2rgb() convertion couleur HTML to rgb.
*	\	param	$color couleur HTML
* 	\return	rgb colors array
*/
function html2rgb($color)
{
	if ($color[0] == '#')
	{
		$color = substr($color, 1);
	}
	if (strlen($color) == 6)
	{
		list($r, $g, $b) = array($color[0].$color[1], $color[2].$color[3], $color[4].$color[5]);
	}
	elseif (strlen($color) == 3)
	{
		list($r, $g, $b) = array($color[0].$color[0], $color[1].$color[1], $color[2].$color[2]);
	}
	else
	{
		return false;
	}
	return array(hexdec($r), hexdec($g), hexdec($b));
}

// kzo_html_color_dump_rgbsquare_webcolors.inc.php3
// chris@quesaco.org - ven avr  9 13:18:53 CEST 2004
/*!
* 	\kzo_html_color_dump_rgbsquare_webcolors() dump html table of HTML normalized colors.
*
* 	\author	<a href="mailto:chris@quesaco.org">Christian Paulus</a>
* 	\version	1.0, 09/05/2004
*	\	param	$cellmargin (option) cell margin
*	\	param	$border (option) table border
*	\	param	$cellsize (option) cell size
*	\	param	$printcolor (option) print hex result in cell, TRUE for active, FALSE otherwise
* 	\since	PHP3
* 	\see <a href="http://www.w3.org/MarkUp/Guide/Style.html" target="_blank">Adding a touch of style</a>
* 	\return	Hexadecimal HTML colors array
*
* @mike007
* @Fichier par un clic de choisir la couleur ds les options
* @Modification lgre la fonction kzo_html_color_dump_rgbsquare_webcolors() d'origine,
* @pour personnaliser l'affichage.
*/
function kzo_html_color_dump_rgbsquare_webcolors ($nomvar='', $name_form='form', $typevar='backgroundColor', $cellmargin=0, $border=0, $cellsize=12, $printcolor=false)
{

	$elopen = 'window.opener.document.'.$name_form;

	if ($typevar == 'color')
	{
		if (substr($nomvar,-2)=='_c')
			$nomvar = substr($nomvar,0,-2);
	}

	$hexacolor = '0369CF';
	$websafe = array ();
	$count = strlen ($hexacolor);
	$tablewidht = $tableheight = $cellwidth = $cellheight = $cellstyle = '';
	if ($cellsize)	// >0
	{
		$tablewidht = ""; //"width=\"" . ($cellsize * $count * $count) . "\" ";
		$tableheight = ""; //"height=\"" . ($cellsize * $count * $count) . "\" ";
		$cellwidth = 'width="'.$cellsize.'"';
		$cellheight = "height=\"" . $cellsize . "\" ";
		$cellstyle = "style=\"padding:" . $cellmargin . "px;height:" . $cellsize . "px;width:" . $cellsize . "px;font-size:" . ($cellsize>>1) . "px;line-height:" . $cellsize . "px;\" ";
	}
	$result = "<table ".$tablewidht.$tableheight." style=\"border:".$border."px;margin-right:auto;margin-left:auto;padding:0px\" cellspacing=\"0\" summary=".$tablewidht.$tableheight.">\n";
	for ($red=0; $red<$count; $red++)
	{
		$result .= " <tr>\n";
		for ($green=0; $green<$count; $green++)
		{
			for ($blue=0; $blue<$count; $blue++)
			{
				$_string = $hexacolor[$red] . $hexacolor[$green] . $hexacolor[$blue];
				$color = "#" . $hexacolor[$red] . $hexacolor[$red] . $hexacolor[$green] . $hexacolor[$green] . $hexacolor[$blue] . $hexacolor[$blue];
				$colorvalue = "" . $hexacolor[$red] . $hexacolor[$red] . $hexacolor[$green] . $hexacolor[$green] . $hexacolor[$blue] . $hexacolor[$blue];
				$result .= " <td " . $cellstyle . " bgcolor=\"" . $color . "\" title=\"" . $color . "\">"
					. (
							$printcolor
							?
							(
								(
									preg_match ("#[C-F0-9]#",$hexacolor[$red]) || preg_match ("#[C-F0-9]#",$hexacolor[$green]) || preg_match ("#[C-F0-9]#",$hexacolor[$blue])
									|| (preg_match ("#[C-F]#",$hexacolor[$red]) && preg_match ("#[C-F]#",$hexacolor[$green]) && preg_match ("#[C-F]#",$hexacolor[$blue]))
									? "<a style=\"color:white;\" href=\"#\" onclick=\"".$elopen.".".$nomvar.".value='".$colorvalue."';".$elopen.".".$nomvar.".style.".$typevar."='#".$colorvalue."';return false \">" . $_string . "</a>"
									: $_string
								)
							)
							: "<img onclick=\"".$elopen.".".$nomvar.".value='".$colorvalue."';".$elopen.".".$nomvar.".style.".$typevar."='#".$colorvalue."';return false \" src=\"../../images/fondchoixcouleur.gif\" alt=\"".$colorvalue."\" width=\"".$cellsize."\" height=\"".$cellsize."\" border=\"0\" />"
						)
					. "</td>\n";
			}
		}
		$result .= " </tr>\n";
	}
	$result .= "</table>\n";
	$result .= "<table cellspacing=\"0\" style=\"border:".$border."px;margin-right:auto;margin-left:auto;padding:0px\" summary=\"choixcouleur\">
					<tr>
						<td " . $cellstyle . " bgcolor=\"#FFFFFF\" title=\"#FFFFFF\"><img onclick=\"".$elopen.".".$nomvar.".value='FFFFFF';".$elopen.".".$nomvar.".style.".$typevar."='#FFFFFF';return false \" src=\"../../images/fondchoixcouleur.gif\" alt=\"couleur\" width=\"".$cellsize."\" height=\"".$cellsize."\" border=\"0\" /></td>
						<td " . $cellstyle . " bgcolor=\"#DDDDDD\" title=\"#DDDDDD\"><img onclick=\"".$elopen.".".$nomvar.".value='DDDDDD';".$elopen.".".$nomvar.".style.".$typevar."='#DDDDDD';return false \" src=\"../../images/fondchoixcouleur.gif\" alt=\"couleur\" width=\"".$cellsize."\" height=\"".$cellsize."\" border=\"0\" /></td>
						<td " . $cellstyle . " bgcolor=\"#C0C0C0\" title=\"#C0C0C0\"><img onclick=\"".$elopen.".".$nomvar.".value='C0C0C0';".$elopen.".".$nomvar.".style.".$typevar."='#C0C0C0';return false \" src=\"../../images/fondchoixcouleur.gif\" alt=\"couleur\" width=\"".$cellsize."\" height=\"".$cellsize."\" border=\"0\" /></td>
						<td " . $cellstyle . " bgcolor=\"#969696\" title=\"#969696\"><img onclick=\"".$elopen.".".$nomvar.".value='969696';".$elopen.".".$nomvar.".style.".$typevar."='#969696';return false \" src=\"../../images/fondchoixcouleur.gif\" alt=\"couleur\" width=\"".$cellsize."\" height=\"".$cellsize."\" border=\"0\" /></td>
						<td " . $cellstyle . " bgcolor=\"#808080\" title=\"#808080\"><img onclick=\"".$elopen.".".$nomvar.".value='808080';".$elopen.".".$nomvar.".style.".$typevar."='#808080';return false \" src=\"../../images/fondchoixcouleur.gif\" alt=\"couleur\" width=\"".$cellsize."\" height=\"".$cellsize."\" border=\"0\" /></td>
						<td " . $cellstyle . " bgcolor=\"#646464\" title=\"#646464\"><img onclick=\"".$elopen.".".$nomvar.".value='646464';".$elopen.".".$nomvar.".style.".$typevar."='#646464';return false \" src=\"../../images/fondchoixcouleur.gif\" alt=\"couleur\" width=\"".$cellsize."\" height=\"".$cellsize."\" border=\"0\" /></td>
						<td " . $cellstyle . " bgcolor=\"#4B4B4B\" title=\"#4B4B4B\"><img onclick=\"".$elopen.".".$nomvar.".value='4B4B4B';".$elopen.".".$nomvar.".style.".$typevar."='#4B4B4B';return false \" src=\"../../images/fondchoixcouleur.gif\" alt=\"couleur\" width=\"".$cellsize."\" height=\"".$cellsize."\" border=\"0\" /></td>
						<td " . $cellstyle . " bgcolor=\"#242424\" title=\"#242424\"><img onclick=\"".$elopen.".".$nomvar.".value='242424';".$elopen.".".$nomvar.".style.".$typevar."='#242424';return false \" src=\"../../images/fondchoixcouleur.gif\" alt=\"couleur\" width=\"".$cellsize."\" height=\"".$cellsize."\" border=\"0\" /></td>
						<td " . $cellstyle . " bgcolor=\"#000000\" title=\"#000000\"><img onclick=\"".$elopen.".".$nomvar.".value='000000';".$elopen.".".$nomvar.".style.".$typevar."='#000000';return false \" src=\"../../images/fondchoixcouleur.gif\" alt=\"couleur\" width=\"".$cellsize."\" height=\"".$cellsize."\" border=\"0\" /></td>
					</tr>
				</table>\n";

	print ($result);
}

/**
 * Exam if a remote file or folder exists
 *
 * This function is adopted from setec's version.
 * + What's new:
 * Error code with descriptive string.
 * More accurate status code handling.
 * Redirection tracing supported.
 *
 * @retval true resource exists
 * @retval false resource doesn't exist
 * @retval "1 Invalid URL host"
 * @retval "2 Unable to connect to remote host"
 * @retval "3 Status Code not supported: {STATUS_CODE REASON}"
 */
// http://titanic.fauser.edu/php/function.file-exists.php.htm 15-Apr-2004 03:07
function remote_file_exists($url)
{
	$head = '';
	$url_p = parse_url ($url);

	if (isset ($url_p['host']))
	{
		$host = $url_p['host'];
	}
	else
	{
		return '1 Invalid URL host';
	}

	if (isset ($url_p['path']))
	{
		$path = $url_p['path'];
	}
	else
	{
		$path = '';
	}

	$fp = @fsockopen ($host, 80, $errno, $errstr, 5);
	if (!$fp)
	{
		return '2 Unable to connect to remote host';
	}
	else
	{
		$parse = parse_url($url);
		$host = $parse['host'];

		fputs($fp, 'HEAD '.$url." HTTP/1.1\r\n");
		fputs($fp, 'HOST: '.$host."\r\n");
		fputs($fp, "Connection: close\r\n\r\n");
		$headers = '';
		while (!feof ($fp))
		{ $headers .= fgets ($fp, 128); }
	}
	fclose ($fp);

	// for debug
	//echo nl2br($headers);

	$arr_headers = explode("\n", $headers);
	if (isset ($arr_headers[0]))
	{
		if(strpos ($arr_headers[0], '200') !== false)
		{
			return true;
		}
		if( (strpos ($arr_headers[0], '404') !== false) ||
			(strpos ($arr_headers[0], '410') !== false))
		{
			return false;
		}
		if( (strpos ($arr_headers[0], '301') !== false) ||
			(strpos ($arr_headers[0], '302') !== false))
		{
			preg_match("/Location:\s*(.+)\r/i", $headers, $matches);
			if(!isset($matches[1]))	return false;
			$nextloc = $matches[1];
			return remote_file_exists($nextloc);
		}
	}
	preg_match('/HTTP.*(\d\d\d.*)\r/i', $headers, $matches);
	return '3 Status Code not supported'.(isset($matches[1]) ? ': '.$matches[1] : '');
}


/**
 *
 * cette fonction gnre une liste de slection HTML (<select>) avec tous les grades du portail
 *
 * @param $nom : Nom du select
 * @param $selected : grade qui sera slectionn par dfaut
 * 						- si int	: id du grade,
 * 						- si string	: nom du grade
 * @param $action : action javascript  inclure au <select> (optionnel)
 * 						- ex : action='onChange="do_script"' donnera : <select name="Nom_du_select" id="Nom_du_select" onChange="do_script">
 * @param $grademini : premier grade de la  liste (optionnel)
 * @param $gradeexclu : tableau des grades exclus (optionnel)
 * @return <select> HTML prt  tre affich
 */
function K_selectGrade($nom, $selected, $action='', $grademini=GRD_EXCLU, $gradeexclu=array())
{
	$type = is_numeric($selected) ? 'i' : 'n';

	$select = '
	<select name="'.$nom.'" id="'.$nom.'" '.$action.'>';
	for($i=$grademini;($n=get_grd_name($i))!=null; $i++)
	{
		if (empty($gradeexclu) or !in_array($i,$gradeexclu))
			$select .= '<option value="'.$i.'" '.($selected==$$type?'selected="selected"':'').'>'.$n.'</option>';
	}
	return $select.'
	</select>';
}


/**
 *
 * cette fonction gnre une liste de slection HTML (<select>) avec tous les groupes du portail
 *
 * @param $nom : Nom du select
 * @param $selected : groupe qui sera slectionn par dfaut
 * 						- si int	: id du groupe (0 pour tous les groupes),
 * 						- si string	: nom du groupe ('tous' pour tous les groupes)
 * @param $action : action javascript  inclure au <select> (optionnel)
 * 						- ex : action='onChange="do_script"' donnera : <select name="Nom_du_select" id="Nom_du_select" onChange="do_script">
 * @return <select> HTML prt  tre affich
 */
function K_selectGroupe($nom, $selected, $action='')
{
	global $K_liste_groupe;

	if ($selected=='tous') $selected = 0;
	$type = is_numeric($selected) ? 'i' : 'n';

	$select = '
	<select name="'.$nom.'" id="'.$nom.'" '.$action.'>';
	foreach ($K_liste_groupe as $i => $n)
	{
		$select.= '
		<option value="'.$i.'"'.($selected==$$type ? ' selected="selected"':'').'>'.$n.'</option>';
	}
	return $select.'
	</select>';
}

/**
 * Gnre un code 'token) pour scuriser les formulaires,
 * et le mmorise en variable session.
 *
 * @autor	Otocinclus
 * @param 	void()
 * @return	string token
 */
function K_getToken()
{
	$token = md5(uniqid(rand(), true));
	$_SESSION['token']		= $token;
	$_SESSION['token_time']	= time();

	return $token;
}


/**
 * Lit les fichiers xml
 *
 * @autor	julkien
 * @param 	$fichier : url du xml
 * @param 	$item : nom de la balise a lire
 * @param 	$champs : champs a lire contenu dans la balise
 * @return	array tmp3
 */

function lit_xml($fichier, $item, $champs)
{
	//if($chaine = @implode('', @file($fichier)))
	if($chaine = @file_get_contents($fichier))
	{
		$tmp = preg_split('/<\/?'.$item.'>/', $chaine);
		for($i=1; $i<sizeof($tmp)-1; $i+=2)
		{
			foreach($champs as $champ)
			{
				$tmp2 = preg_split('/<\/?'.$champ.'>/', $tmp[$i]);
				$tmp3[$item][$champ] = @$tmp2[1];
			}
		}
		//df_print_r($tmp3);
		return $tmp3;
	}
}

function load_tpl()
{
	global $K_mod;
	global $K_theme;
	$tpl = file_exists('./themes/'.$K_theme.'/modules/'.$K_mod.'/'.$K_mod.'.php') ? './themes/'.$K_theme.'/modules/'.$K_mod.'/'.$K_mod.'.php' : './modules/'.$K_mod.'/theme/'.$K_mod.'.php';
	$style = file_exists('./themes/'.$K_theme.'/style/'.$K_mod.'.css') ? './themes/'.$K_theme.'/style/'.$K_mod.'.css' : './modules/'.$K_mod.'/theme/'.$K_mod.'.css';
		echo '
		<script type="text/javascript">
		// <![CDATA[
			var head = document.getElementsByTagName("head")[0];
			var head_inc = document.createElement("link");
			head_inc.rel = "stylesheet";
			head_inc.type = "text/css";
			head_inc.href = "'.$style.'";
			head.appendChild(head_inc);
		// ]]>
		</script>';
		require_once $tpl;
}
?>
