<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: update1.0_to_1.3.456.php 889 2010-01-24 17:39:31Z mike007.devpwsphp $
// ---------------------------------------------------------------
// Fait par mike007, FouPouDave

session_start();

$Version_Ant = '1.0';
$Version_Rev = '1.3.456';
$update_titre = '<h2 style="text-align:center;width:100%">Mise &agrave; jour de KwsPHP <span style="color:#cc3300">V'.$Version_Ant.'</span> vers <span style="color:#009900">V'.$Version_Rev.'</span></h2><br />';

if (file_exists ('../connect.php'))
{
	chdir('../');
	include 'connect.php';
	chdir('install');
}
else
{
	header ('Location: install.php');
}

// Controle url etapes
if (isset ($_POST['step']) and $_POST['step'] >= 0 and $_POST['step'] < 10)
{
	$step = intval($_POST['step']);
}
elseif (isset ($_POST['step2']))
{
	$step = intval($_POST['step2']);
}
else
{
	$step = 1;
}

// Chargement de la langue
require_once './langues/config_lang.php';

// Inclusion du fichier class
chdir('../');
require_once 'includes/class.install.php';
if ($step > 3)
{
	require_once 'includes/traitement_variable.php';
}
else
{
	function antiXSS($value)
	{
		// les entiers
		if (is_numeric($value) && $value == intval($value))
		{
			return $value;
		}

		// Stripslashes
		static	$t=null;
		if ($t==null)
		{
			$t=get_magic_quotes_gpc();
		}
		if ($t)
		{
			$value = stripslashes($value);
		}
		if (!function_exists('mysql_real_escape_string'))
		{
			$value = stripslashes($value);
		}

		//on retourne une valeur filtre
		return htmlentities($value);
	}
	function ax($value)
	{
		return antiXSS($value);
	}
	function SQLprotect($value)
	{
		// Stripslashes
		static	$t=null;
		if ($t==null)
		{
			$t=get_magic_quotes_gpc();
		}
		if ($t)
		{
			$value = stripslashes($value);
		}

		// Protection SQL
		if (function_exists('mysql_real_escape_string'))
		{
			// @ --> Solution temporaire...
			$value = @ mysql_real_escape_string($value);
		}
		//pour version de PHP < 4.3.0 on utilise addslashes
		else
		{
			$value = addslashes($value);
		}

		//on retourne une valeur filtre
		return $value;
	}

	function sp($value)
	{
		return SQLprotect($value);
	}
}
chdir('install');
$class_install = new install();

// Affichage de la barre des etapes a gauche
$step_array = array ('Configuration', 'Identification', 'Mise &agrave; jour', 'Terminer');
$install_menu = $class_install->aff_step ($step, $step_array);

$install_no = 0;

if ($step == 1)
{
	include './config_server.php';
}
// Identification de l'admin
if ($step == 2)
{
	$requete = reqmysql("
		SELECT	*
		FROM	`parametres`
		WHERE	`nom` = 'distribution'
	");
	$ligne = mysql_fetch_object($requete);

	$test_agenda_old = false;
	$tables = reqmysql("SHOW TABLES;");
	while($tables_array = mysql_fetch_row($tables))
	{
		if (substr($tables_array[0],0,6)=='agenda')
		{
			$test_agenda_old = true;
			break;
		}
	}
	if ($test_agenda_old)
	{
		$install_form1 = '<form method="post" action="../" name="form1">';
		$install_contenu = 'ATTENTION : Vous avez une ancienne version du module agenda.<br /><br />
		Vous ne pouvez pas utilisez les fichiers d\'update de cette archive de KwsPHP pour faire votre mise &agrave; jour.<br />
		Vous devez utilisez ceux de l\'archive pr&eacute;c&eacute;dente : KwsPHP '.$Version_Rev.' puis seulement ensuite utilisez ceux l&agrave;.';
		$install_form2 = '';
		$install_button = '<input type="submit" value=" Retester " name="sbutton" />';
	}
	elseif ($ligne->valeur == 'KwsPHP '.$Version_Rev)
	{
		$install_form1 = '<form method="post" action="../" name="form1">';
		$install_contenu = 'Cette version est d&eacute;j&agrave; celle install&eacute;e.';
		$install_form2 = '';
		$install_button = '<input type="submit" value=" Terminer " name="sbutton" />';
	}
	elseif ($ligne->valeur == 'kws1.0' OR $ligne->valeur == 'KwsPHP 1.0')
	{
		$install_form1 = '<form method="post" action="update1.0_to_'.$Version_Rev.'.php" name="form1">';

		$install_contenu = 'La version du portail disponible sur votre ftp est KwsPHP version '.$Version_Ant.'. Votre base de donn&eacute;es doit maintenant &ecirc;tre mise &agrave; jour.<br />
		<br /><br />
		<div style="text-align:center; color:#3333cc;">
			Si vous avez migr votre portail vers pwslive, il est impratif de supprimer les champs crs sur vos tables.<br />
		</div>
		<br />
		<br />
		<div style="text-align:center; color:#33cc33; font-size:22pt;">
			Supprimez vos cookies<br />
		</div>
		<div style="text-align:center; color:#33cc33;">du fait de leur nouvelle gestion</div>
		<br />
		<br />
		<div style="text-align:center; color:#cc3300;">Avant de poursuivre et si vous ne l\'avez pas fait, il est indispensable de</div>
		<div style="text-align:center; color:#cc3300; font-size:22pt;">
			faire au moins une <strong>SAUVEGARDE</strong><br />
			de votre base de donn&eacute;es<br />
			parce que pour vos fichiers,<br />
			c\'est trop tard !<br />
		</div>

		<p style="text-align:center; color:#cc3300;">Malgr&eacute; toutes les pr&eacute;cautions prises, nous ne sommes pas &agrave; l\'abri d\'une erreur ou d\'un oubli, nous ne sommes pas des professionnels mais des amateurs passionn&eacute;s !
		<br />'._1_TEXT_CGU.'</p>
		<table class="cadre" summary="cadre">
			<tr>
				<td>Administrateur</td>
				<td><input type="text" name="pseudo1" /></td>
			</tr>
			<tr>
				<td>Mot de passe</td>
				<td><input type="password" name="password" /></td>
			</tr>
		</table>';

		$liste_a_effacer = array(
			//array('exemple.php',false)
		);
		if(count($liste_a_effacer)>0)
		{
			foreach($liste_a_effacer as $id => $fichier)
			{
				if ($fichier[1])
				{
					@unlink('../'.$fichier[0]);
				}
				if (!file_exists('../'.$fichier[0]))
				{
					unset($liste_a_effacer[$id]);
				}
			}
		}

		$liste_a_verifier = array(
			'connect.php',
			'modules/stats/stats_max.txt',
			'modules/stats/stats_simultane.txt'
		);
		if(count($liste_a_verifier)>0)
		{
			foreach($liste_a_verifier as $id => $fichier)
			{
				if (file_exists('../'.$fichier))
				{
					unset($liste_a_verifier[$id]);
				}
			}
		}

		if (count($liste_a_effacer)>0)
		{
			$install_contenu .= '<p>';
			foreach ($liste_a_effacer as $id => $fichier)
			{
				$install_contenu .= '<div style="color:#990000">- Le fichier <strong>'.$fichier.'</strong> doit tre effac. Veuillez le supprimer manuellement du ftp.</div>';
			}
			$install_contenu .= '</p>';
			$install_button = '<input type="hidden" name="step2" value="1" />
			<input type="submit" value=" Retester " />';
		}
		elseif (count($liste_a_verifier)>0)
		{
			$install_contenu .= '<p>';
			foreach ($liste_a_verifier as $id => $fichier)
			{
				$install_contenu .= '<div style="color:#990000">- Le fichier <strong>'.$fichier.'</strong> est manquant. Veuillez le remettre manuellement sur le ftp.</div>';
			}
			$install_contenu .= '</p>';
			$install_button = '<input type="hidden" name="step2" value="1" />
			<input type="submit" value=" Retester " />';
		}
		else
		{
			$install_button = '<input type="submit" value=" Continuer " />';
		}

		$install_form2 = '';
	}
	else
	{
		$install_form1 = '<form method="post" action="../" name="form1">';
		$install_contenu = 'Cette version n\'est pas support&eacute;e par le programme de mise &agrave; jour.';
		$install_form2 = '';
		$install_button = '<input type="submit" value=" Terminer " name="sbutton" />';
	}
}
elseif ($step == 3)
{
	$user_req = reqmysql('
		SELECT	`grade`,
				`pseudo`,
				`pass`
		FROM	`users`
		WHERE	`pseudo` = "'.sp($_POST['pseudo1']).'"
	');
	$user_line = mysql_fetch_object ($user_req);

    $update_erreur = '';
	if (mysql_num_rows ($user_req) != 0)
	{
		if ($user_line->grade < 4)
		{
			$update_erreur = 'Vous n\'avez pas le grade requis pour lancer l\'update.';
		}
		elseif ($user_line->pass != md5(sp($_POST['password'])))
		{
			$update_erreur = 'Le mot de passe est incorrect.<input type="hidden" name="pseudo" value="'.$_POST['pseudo1'].'" />';
		}
	}
	else
	{
		$update_erreur = 'Pseudo administrateur incorrect.';
	}
	if (substr(mysql_get_server_info(), 0, 3) < '4.1')
	{
		$update_erreur = '
		<span style="color:#cc3300">'._5_TEXT_19_2.' '.substr(mysql_get_server_info(), 0, 3).'.<br /><br />'._5_TEXT_19_3.'</span>';
	}
	else
	{
		$update_mysql = _5_TEXT_19_4;
	}

	if ($update_erreur=='')
	{
		// cookie de connection
		$requete = reqmysql('
			SELECT	`valeur`
			FROM	`parametres`
			WHERE	`nom` = "url_site"
		');
		$ligne = mysql_fetch_object ($requete);
		$url_site = $ligne->valeur;

		setcookie ('sql_pseudo', $user_line->pseudo, time()+3600, substr(str_replace('http://','',$url_site),strpos(str_replace('http://','',$url_site),'/')));
		setcookie ('sql_pass', $user_line->pass, time()+3600, substr(str_replace('http://','',$url_site),strpos(str_replace('http://','',$url_site),'/')));
		setcookie ('auto', 'off', time()+3600, substr(str_replace('http://','',$url_site),strpos(str_replace('http://','',$url_site),'/')));

		// Creation du fichier connect.php
		$connect = fopen('../connect.php', 'r');
		while (empty($serveur) or empty($login) /*or empty($pass)*/)
		{
			$ligne = fgets($connect);
			if (strpos($ligne,'","')!=0)
			{
				$ligne = substr($ligne, strpos($ligne,'("')+2);
				$ligne = substr($ligne, 0, strpos($ligne,'")'));
				$ligne = explode('","',$ligne);
			}
			elseif (strpos($ligne,"','")!=0)
			{
				$ligne = substr($ligne, strpos($ligne,"('")+2);
				$ligne = substr($ligne, 0, strpos($ligne,"')"));
				$ligne = explode("','",$ligne);
			}
			elseif ($ligne == false)
			{
				$serveur = 'Serveur';
				$login = 'Utilisateur';
				$pass = 'Mot de passe';
				$bdd = 'Nom de la base de donnes';
			}
			else
			{
				$ligne = '';
			}
			if (is_array($ligne) and isset($ligne[0]) and isset($ligne[1]) and isset($ligne[2]))
			{
				$serveur = $ligne[0];
				$login = $ligne[1];
				$pass = $ligne[2];
			}
		}
		while (empty($bdd))
		{
			$ligne = fgets($connect);
			if (strpos($ligne,'"')!=0)
			{
				$ligne = substr($ligne, strpos($ligne,'"')+1);
				$ligne = substr($ligne, 0, strpos($ligne,'"'));
			}
			elseif (strpos($ligne,"'")!=0)
			{
				$ligne = substr($ligne, strpos($ligne,"'")+1);
				$ligne = substr($ligne, 0, strpos($ligne,"'"));
			}
			else
			{
				$ligne = '';
			}

			$bdd = $ligne;
		}
		fclose($connect);
		if (!@unlink('../connect.php'))
		{
			$pb_connect = "<span style=\"color:#cc3300\">Il y a eu un problme lors de l'effacement du fichier connect.php.</span><br />
			vous devez remplacer le contenu de ce fichier (se trouvant sous la racine de votre site) par le texte ci-dessous :<br />
			<br />
			<code>
				&lt;?php<br />
				mysql_connect('".$serveur."','".$login."','".$pass."') or die('Impossible de se connecter au serveur.');<br />
				mysql_selectdb('".$bdd."') or die('Impossible de se connecter &agrave; la base.');<br />
				<br />
				require_once('includes/traitement_variable.php');<br />
				?&gt;
			</code>
			<br />
			<br />";
		}
		else
		{
			$pb_connect = '';
			$cc_result = $class_install->create_connect($serveur, $login, $pass, $bdd);
		}

		$update_result = '';
		function update_query ($query)
		{
			global $update_result;
			$update_test = reqmysql ($query);
			if (! $update_test)
			{
				$update_result .= 'Erreur de mise &agrave; jour lors de l\'execution de la requ&ecirc;te : '.$query.'<br />
				<br />';
			}
		}

		// ------------------------------------------------
		// Mise a jour depuis la 1.0
		// ------------------------------------------------
		update_query ('UPDATE `parametres` SET `valeur` = "KwsPHP '.$Version_Rev.'" WHERE `nom` = "distribution" ');
		// Nouvelle gestion du module stats
		$requete = reqmysql('
			SELECT	*
			FROM	`modules`
			WHERE	`module`="stats"
		');
		if (mysql_num_rows($requete)!=0)
		{
			while ($ligne = mysql_fetch_object($requete))
			{
				update_query ('
					UPDATE	`modules`
					SET		`parametre2`="'.($ligne->parametre2=='Oui' ? $ligne->parametre4 : $ligne->parametre2).'",
							`parametre4`="Oui"
					WHERE	`id`="'.$ligne->id.'"
				');
			}
		}
		//La fct effacer les mp plus vieux que... est a ce jour oprationnel, on remet a off l'option pour eviter les mauvaises surprises
		update_query ('UPDATE `parametres` SET `valeur` = "off" WHERE `nom` ="eff_msg_vieux"');
		//Insert paramtres manquants
		if (mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="aff_regles"'))== 0)
			update_query ('INSERT INTO `parametres` (`nom`, `valeur`) VALUES ("aff_regles","on") ');
 		update_query ('UPDATE `stats` SET `valeur`=1 WHERE `type`="heure" AND `valeur`=""');
		//ALTER pour la nouvelle gestion des "resolu"
		update_query ('ALTER TABLE `forum_topic` ADD `resolu` TINYINT(1) NOT NULL DEFAULT "0"');
		//ALTER pour la nouvelle gestion des comptes suspendus et prt a supprimer
		update_query ('ALTER TABLE `users` ADD `date_der_connec` VARCHAR(10) NOT NULL DEFAULT "" AFTER `statut`');
		update_query ('UPDATE `users` SET `date_der_connec` = "'.time().'" WHERE (`statut` != 1 OR `statut` != 2)');
		//Insert des paramtres pour la gestion des comptes suspendus et prt a supprimer
		update_query ('INSERT INTO `users` (`pseudo`, `nom`, `theme`, `aff_email`, `mp_popup`, `date`, `avatar`, `date_der_connec`) VALUES ("Ancien membre","Anonyme","kwsday","0","0","'.time().'","./images/avatars/upload/nophoto.png","'.time().'") ');
		update_query ('INSERT INTO `parametres` (`nom`, `valeur`) VALUES ("gestion_comptes_date","off") ');
		update_query ('INSERT INTO `parametres` (`nom`, `valeur`) VALUES ("delai_suspendu","6") ');
		update_query ('INSERT INTO `parametres` (`nom`, `valeur`) VALUES ("delai_supprime","12") ');
		//Insert du paramtre pour l'encodage du mail html ou texte
		update_query ('INSERT INTO `parametres` (`nom`, `valeur`) VALUES ("email_encod","0") ');
		// Effacement des alertes dorenavant inutiles
		update_query ('DELETE FROM `alerte` WHERE `module` LIKE "%Article%" OR `module` LIKE "%citations%" OR `module` LIKE "%lien_web%" OR `module` = "livredor"');
		// Intgration de la table droit
		update_query ("CREATE TABLE `droit` (`id` int(11) NOT NULL auto_increment, `module` varchar(50) NOT NULL, `page` varchar(50) NOT NULL, `grade` int(4) NOT NULL default '4', `groupe` int(4) NOT NULL default '0', PRIMARY KEY  (`id`)) TYPE=MyISAM COMMENT='Gre les droits d acces  un module' AUTO_INCREMENT=1 ;");
		update_query ("INSERT INTO `droit` (`id`, `module`, `page`, `grade`, `groupe`) VALUES ('', 'eskuel', 'main', 4, 0), ('', 'eskuel', 'phpinfo', 3, 0);");
		update_query ("CREATE TABLE `droit_exclu` (`id` int(11) NOT NULL auto_increment, `module` varchar(50) NOT NULL default '', `page` varchar(50) NOT NULL default '', PRIMARY KEY  (`id`)) TYPE=MyISAM COMMENT='Gre les droits d accs  un module' AUTO_INCREMENT=1 ;");
		update_query ("
			INSERT INTO `droit_exclu` (`id`, `module`, `page`) VALUES
				('', 'ajash00t', 'xml'),
				('', 'admin', 'class_modules'),
				('', 'espace_membre', 'header'),
				('', 'espace_membre', 'popup'),
				('', 'liens_web', 'visite'),
				('', 'maintenance', 'index'),
				('', 'menu', 'class_menu'),
				('', 'recherche', 'includes'),
				('', 'stats', 'config'),
				('', 'stats', 'stats_inf_light'),
				('', 'stats', 'stats_inf'),
				('', 'stats', 'visites');
		");
		// on insert les parametres pour la hack imprimer car jamais fait mais on controle qd mme
		// pas d accs au config.php donc il faut verifier chaque champ au lieu de faire un if (!isset(le nom de la variable))
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_grade"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_grade", `valeur`="3"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_fenetre"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_fenetre", `valeur`="Imprimer le document"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_police"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_police", `valeur`="Verdana, Arial, Helvetica, sans-serif"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_taille1"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_taille1", `valeur`="24px"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_style1"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_style1", `valeur`="normal"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_weight1"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_weight1", `valeur`="bold"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_deco1"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_deco1", `valeur`=""');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_color1"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_color1", `valeur`="#000000"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_color"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_color", `valeur`="#000000"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_taille"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_taille", `valeur`="11px"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_linkcolor"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_linkcolor", `valeur`="#0000FF"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_linkdeco"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_linkdeco", `valeur`=""');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_hovercolor"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_hovercolor", `valeur`="#FF0000"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_hoverdeco"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_hoverdeco", `valeur`="underline"');
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="imprim_lien"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="imprim_lien", `valeur`="Imprimer"');
		// Stats
		chdir('../');
		include('modules/stats/stats_max.txt');
		include('modules/stats/stats_simultane.txt');
		chdir('install');
		update_query("
			INSERT INTO `parametres` (id, `nom`, `valeur`) VALUES
			('', 'nbr_visiteur_max', '".$nbr_visiteur_max."'),
			('', 'date_max_visiteur', '".$date_max_visiteur."'),
			('', 'nbr_membre_max', '".$nbr_membre_max."'),
			('', 'date_max_membre', '".$date_max_membre."'),
			('', 'nbr_simultanemous_membre', '".$nbr_simultanemous_membre."'),
			('', 'date_simultanemous_membre', '".$date_simultanemous_membre."'),
			('', 'nbr_simultanemous_visiteur', '".$nbr_simultanemous_visiteur."'),
			('', 'date_simultanemous_visiteur', '".$date_simultanemous_visiteur."');");
		// News
		update_query ('ALTER TABLE `news` ADD `edit` VARCHAR(20) NOT NULL DEFAULT "" AFTER `date`');
		// Maintenance
		if ( mysql_num_rows(reqmysql('SELECT `nom` FROM `parametres` WHERE `nom` ="maintenance_texte"'))== 0)
			update_query ('INSERT INTO `parametres` SET `nom`="maintenance_texte", `valeur`="Veuillez nous excuser pour cette gne, mais le site est actuellement en maintenance.\r\n\r\n[b]Le Webmaster[/b]"');
		//lien_web -> liens_web
		update_query ('RENAME TABLE `liens` TO `liens_web`;');
		update_query ('ALTER TABLE `liens_web` CHANGE `nom` `nom` VARCHAR(100);');
		update_query ('ALTER TABLE `liens_web` CHANGE `categorie` `categorie` VARCHAR( 30 ) NOT NULL DEFAULT "divers";');
		update_query ('DROP TABLE IF EXISTS `liens_web_opt`;');
		update_query ('
			CREATE TABLE `liens_web_opt` (
			  `id` int(11) NOT NULL auto_increment,
			  `nom` varchar(50) NOT NULL default "",
			  `valeur` varchar(100) NOT NULL default "",
			  `commentaire` text NOT NULL,
			  PRIMARY KEY  (`id`)
			) TYPE=MyISAM COMMENT="Module liens_web : les parametres";
		');

		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'limitedeb', '1', 'Sujets compris entre 1');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'limitefin', '15', 'Et plus');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'aspect', '1', '1 permet d\'afficher lien + description, 0 seulement lien');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'minute', '1', '1 permet d\'afficher date et heure, 0 sans date et heure');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'sujet', '1', '1 permet d\'afficher le titre, 0 aucun titre');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'police', 'Verdana,Arial,sans-serif', 'Police de caract&egrave;res (Verdana,arial etc...)');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'fil_textsize', '11', 'taille des liens et description');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'title_textcolor', '990000', 'couleur des liens (000000 donne noir)');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'text_textcolor', '006633', 'couleur description (000000 donne noir)');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'frame_color', 'FFFFCC', 'couleur arrire plan (FFFFFF donne blanc)');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'content', '', 'laisser vide ou 1 comme paramtre optionnel<br />&nbsp;peut passer d\'un texte sans format  un texte html');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'caractere', '', 'laisser vide ou 1 comme paramtre<br />&nbsp;permet de remplacer le jeu de caractres en utf-8');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'cache', '30', 'gestion du cache exprime en minutes<br />&nbsp;en fonction de la frquence de mise  jour');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'widthframe', '100%', 'Largeur de la frame (si % mettre le %, si pixel ne pas mettre px)');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'heightframe', '650', 'Hauteur de la frame (% non autoris)');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'scrolling', 'yes', ' Scrolling de la frame : yes ou no');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'visible_cat_liens', 'no', 'Une catgorie visible dans le bloc : yes ou no');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'nom_cat_liens', '', 'Catgorie des liens visible dans le bloc');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'liens_sensbloc', 'none', 'Sens de dfilement dans le bloc');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'liens_vitessebloc', '80', 'Vitesse de dfilement du bloc (plus on baisse, plus a acclre)');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'nb_liens_bloc', '5', 'nombre de lien dans le bloc');");
		update_query ("INSERT INTO `liens_web_opt` VALUES ('', 'aff_miniature','0', 'Affichage des miniatures (0 ou 1)');");

		update_query ("UPDATE `modules` SET `parametre2`='./index.php?mod=liens_web' WHERE `parametre2`='index.php?mod=lien_web'");

		//Insertion des tables du module download
		$presence_download = false;
		$tables = reqmysql("SHOW TABLES;");
		while($tables_array = mysql_fetch_row($tables))
		{
			if ($tables_array[0]=='dl')
			{
				$presence_download = true;
			}
		}
		if (!$presence_download)
		{
			$class_install->install_mod('download');
		}
		else
		{
			update_query ('ALTER TABLE `dl` CHANGE `version` `version` VARCHAR( 255 ) NOT NULL');
			update_query ('UPDATE `dl` SET `grade`="-2" WHERE `grade`="5"');
			update_query ('UPDATE `dl_parametres` SET `valeur`="-2" WHERE `parametre` LIKE "grd_%"AND `valeur`="5"');
		}

		$install_form1 = '<form method="post" action="update1.0_to_'.$Version_Rev.'.php" name="form1">';

		$install_contenu = '<b>Mise &agrave; jour des tables</b><br /><br />';

		if (!empty($update_result))
		{
			$install_contenu.= '<span style="color:#009900">'.$update_mysql.'</span>
			<br /><br />
			<b>Erreur</b><br />
			'.$update_result.'
			<br />
			<span style="color:red;">La mise &agrave; jour a donc &eacute;t&eacute; incompl&egrave;te, vous &ecirc;tes donc contraint de nous signaler l\'erreur.</span><br />
			<br />
			Reportez cette erreur sur notre <a href="http://www.kwsphp.org/" target="_blank">forum de support</a>.';
		}
		else
		{
			$install_contenu.= $pb_connect.'
			<span style="color:#009900">Les tables ont &eacute;t&eacute; correctement mises &agrave; jour !</span><br />
			<br />
			<span style="color:#009900">'.$update_mysql.'</span>
			<br /><br />
			<strong>ATTENTION :<br />
			La fonction des options g&eacute;n&eacute;rales "Effacer les messages trop vieux de plus de :" est maintenant oprationnel.<br />
			Le param&egrave;tre &agrave; &eacute;t&eacute; remis &agrave; "off" afin d\'&eacute;viter les mauvaises surprises.</strong>';
		}

		$install_form2 = '';

		$install_button = '<input type="submit" value=" Suivant " />';
	}
	else
	{
		$install_menu = $class_install->aff_step (1, $step_array);
		$step = 0;

		$install_form1 = '<form method="post" action="update1.0_to_'.$Version_Rev.'.php" name="form1">';

		$install_contenu = '
		<div style="color:#cc3300;font-weight:bold;text-align:center;font-variant:small-caps">
			Erreur<br /><br />'.$update_erreur.'<br /><br />
		</div>';

		$install_form2 = '';

		$install_button = '<input type="submit" value=" Retour " />';
	}
}
elseif ($step == 4)
{
/*
	$test = false;
	$tables = reqmysql("SHOW TABLES;");
	while($tables_array = mysql_fetch_row($tables))
	{
		if (substr($tables_array[0],0,6)=='agenda')
		{
			$test = true;
			break;
		}
	}
*/
	$install_form1 = '';

	$install_contenu = '<p>KwsPHP est maintenant mise &agrave; jour sur votre serveur.</p>
<!-- plus besoin  ce niveau  partir de la 1.6 : redirection automatique update suivant
	<p style="text-align:center; color:#cc3300; font-size:18pt;">
		Vous devrez IMPERATIVEMENT supprimer<br />
		le r&eacute;pertoire "install" de votre serveur<br />
		avant de poursuivre !
	</p>
-->
	';
	if (!$test)
	{
		// obsolete, puisque basculement update suivant qui donnera acces au gestionnaire, le controle se fait au dbut si ancien agenda
		//$install_contenu .= '<p><strong>Si vous souhaitez utiliser le module "agenda", vous devez faire une <a href="../index.php?mod=agenda&amp;ac=install" target="_blank">installation indpendante</a>.</strong></p>';
	}
	$install_contenu .= '<p>Si vous souhaitez que votre site soit r&eacute;f&eacute;renc&eacute; sur l\'annuaire de Kws, envoyer un email &agrave; <a href="mailto:annuaire@kwsphp.org">cette adresse</a>.</p>
	<p>Le support du portail est assur&eacute; sur le forum de notre communaut&eacute; <a href="http://www.kwsphp.org/">KwsPHP.org</a>.</p>
	<p>La KwsPHP Team vous souhaite une bonne utilisation et esp&egrave;re que vous serez satisfait.</p>';
/*
	if (!$test)
	{
		$install_form2 = '<form method="post" action="../index.php" name="form1">';

		$install_button = '<input type="submit" value=" Terminer " name="sbutton" />';
	}
	else
	{
		$install_form2 = '<form method="post" action="../index.php?mod=agenda&amp;ac=update" name="form0">';

		$install_button = '<input type="submit" value=" Mettre &agrave; jour le module agenda " name="sbutton" />';
	}
*/
	$install_form2 = '<form method="post" action="../index.php" name="form1">';
	$install_button = '<input type="submit" value=" Poursuivre " name="sbutton" />';
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" >
	<title>Mise &agrave; jour de KwsPHP en version <?php echo $Version_Rev;?></title>
	<link rel="stylesheet" type="text/css" href="install.css" >
</head>

<body>
	<table class="tab_exterieur" summary="tab_exterieur">
		<tr>
			<td>
				<table class="tab_middle" summary="tab_middle">
					<tr>
						<td>
							<table class="tab_interne" summary="tab_interne">
								<tr>
									<td colspan="3">
										<img src="images/kwsphp2.jpg" width="266" height="75" align="middle" alt="Logo install" />
										<br /><br />
										Un portail en PHP cl&eacute; en main !
										<br /><br />
									</td>
								</tr>
								<tr>
									<td valign="top"><?php echo $install_menu; ?></td>
									<td width="2"></td>
									<td width="85%" valign="top">
										<?php echo $install_form1; ?>
										<table bgcolor="#ffffff" width="100%" style="border: 1px solid #BCBCBC;" summary="update4">
											<tr>
												<td valign="top"><?php echo $update_titre.$install_contenu; ?></td>
											</tr>
										</table>
										<?php echo $install_form2; ?>
										<input type="hidden" name="step" value="<?php echo $step+1; ?>" /><br />
										<div align="right"><?php echo $install_button; ?></div>
										</form>
									</td>
								</tr>
						</table>
					</td>
				</tr>
			</table>
			<br />
			<div id="ckws"><a href="http://www.kwsphp.org/">&copy; KwsPHP version <?php echo $Version_Rev;?></a></div>
		</td>
	</tr>
</table>
</body>