<?php
// -----------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: alerte.php 777 2008-08-19 05:20:00Z otocinclus.devpwsphp $
// -----------------------------------------------------------------
//
// Module Agenda
//
// -----------------------------------------------------------------

/**
 * @file alerte.php
 *
 * Fichier gnrant l'affichage des alertes du module :
 *		- Annonces des anniversaires
 *		- Annonces des vnements
 *
 * @author Otocinclus
 * @version 1.0
 * @date Novembre 2007
 */

// Scu
if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

include_once 'modules/agenda/includes/lib_agenda.php';

// Annonces des anniversaires et vnements
if (get_grade('voir') >= GRD_MEMBR && is_module('agenda'))
{
	$mod_bak = $K_mod;
	$K_mod = 'agenda';


	include_once 'modules/agenda/includes/lib_alertes.php';

	$alerteAnniv = $alerteEvent = '';
	if ($agenda_annonce_anniv=='on')
	{
		$alerteAnniv = alerteAnniv('alerte', $agenda_futur_anniv);
	}
	if ($agenda_annonce_event=='on')
	{
		$alerteEvent = alerteEvent('alerte', $agenda_futur_event, $agenda_type_futur_event);
	}

	$annonce = '';

	if (!empty($alerteAnniv))
	{
		$annonce .= '
		<span style="font-weight:bold">Anniversaires :</span>';
		if ($agenda_defile_anniv != "off")
		{
			if ($agenda_defile_anniv == 'H')
			{
				$alerteAnniv = str_replace('<br />','&nbsp;&nbsp;&nbsp;-=-=-=-&nbsp;&nbsp;&nbsp; ',$alerteAnniv);
				$haut = 0;
			}
			else $haut = 90;

			$annonce .= '
			<marquee behavior="scroll" direction="'.$agenda_sensdefile_anniv.'" scrollamount="'.intval(1+$agenda_vitessedefile_anniv/5).'" scrolldelay="'.(60-(3*$agenda_vitessedefile_anniv)).'" height="'.$haut.'" onmouseover="this.stop()" onmouseout="this.start()">
			<p style="padding-top:'.$haut.'px; padding-bottom:'.$haut.'px">'.$alerteAnniv.'</p>
			</marquee>';
		}
		else $annonce .= '<br />'.$alerteAnniv;
	}

	if (!empty($alerteEvent))
	{
		$annonce .= ($annonce!='' ? '<br />' : '').'
		<span style="font-weight:bold">Evenements :</span>';
		if ($agenda_defile_event != "off")
		{
			if ($agenda_defile_event == 'H')
			{
				$alerteEvent = str_replace('<br />','&nbsp;&nbsp;&nbsp;-=-=-=-&nbsp;&nbsp;&nbsp; ',$alerteEvent);
				$haut = 0;
			}
			else $haut = 25;

			$annonce .= '
			<marquee behavior="scroll" direction="'.$agenda_sensdefile_event.'" scrollamount="'.intval(1+$agenda_vitessedefile_event/5).'" scrolldelay="'.(60-(3*$agenda_vitessedefile_event)).'" height="'.$haut.'" onmouseover="this.stop()" onmouseout="this.start()">
			<p style="padding-top:'.$haut.'px; padding-bottom:'.$haut.'px">'.$alerteEvent.'</p>
			</marquee>';
		}
		else $annonce .= '<br />'.$alerteEvent;
	}
	
	if ($annonce != '')
	{
		bloc_head(' Agenda :');
		echo $annonce;
		close_table();
	}

	// restore $K_mod
	$K_mod = $mod_bak;
}

?>
