<?php
// -----------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: anniversaire.php 903 2010-04-25 07:54:35Z mike007.devpwsphp $
// -----------------------------------------------------------------
//
// Module Agenda
//
// -----------------------------------------------------------------

/**
 * @file anniversaire.php
 *
 * Fichier du module Agenda prenant en charge les actions lies aux anniversaires :
 *		- dsactivation de l'envoi automatique du message d'anniversaire.
 *		- affichage de l'annuaire des anniv  condition que le membre ait renseign sa date de naissance.
 *		- enregistrement date de naissance si ncessaire.
 *
 * @author Otocinclus
 * @version 1.0
 * @date Novembre 2007
 */

// Scurit !!
if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}
include_once 'modules/agenda/includes/lib_agenda.php';

// il faut tre membre
if (get_grade() < GRD_MEMBR)
{
	zoneReserve((get_grade()==GRD_VISIT ? 'identification' : ''));
}
else
{
	// si demande d'annulation message anniversaire
	if ($_REQUEST['action'] == 'MsgNo')
	{
		reqmysql('UPDATE `agenda_anniv` SET `msg_anniversaire`="5000" WHERE `id_mbr`="'.$K_user->id.'" ');
		bloc_head('Anniversaire');
		echo '
		<p style="text-align:center">
		Votre demande &agrave; bien &eacute;t&eacute; prise en compte.<br />
		D&eacute;sormais, nous ne vous enverons plus de message automatique pour votre anniversaire.</p><br />
		<form action="index.php" style="text-align:center">
		<input type="submit" id="submit" name="rtb" value=" Retour &agrave; l\'accueil " />
		</form>';
		close_table();
	}
	else
	{
		// si nouvelle date naissance envoye
		if ($_POST['action']=='editNaiss' && isset($_POST['envoyerNaiss']))
		{
			$a = $_POST['int_naissannee'];
			$m = $_POST['int_naissmois'];
			$j = $_POST['int_naissjour'];

			// si date valide
			if (checkdate($m, $j, $a))
			{
				$user->date_naissance = $a.'-'.$m.'-'.$j;
				$user->aff_naissance  = $post_int_aff_naissance!=1 ? '0' : '1'; //isset($_POST['aff_naissance']) ? (intval($_POST['aff_naissance'])!='1' ? '0' : '1') : '0';
				$req = reqmysql('INSERT INTO `agenda_anniv`
								 SET	`pseudo`		 = "'.$K_pseudo.'",
										`id_mbr`		 = "'.$user->id.'",
										`date_naissance` = "'.$user->date_naissance.'",
										`aff_naissance`  = "'.$user->aff_naissance.'"
								');
				open_table();
				echo '
				<p style="text-align:center; font-weight:bold">Votre date de naissance est maintenant enregistr&eacute;e.</p>';
				close_table();
			}

			// date non valide
			else
			{
				open_table();
				echo '
				<p style="text-align:center;color:#EE0000; font-weight:bold;">La date que vous avez saisie n\'est pas valide !!</p>';
				close_table();
			}
		}

		include_once 'modules/'.$K_mod.'/includes/lib_anniv.php';

		// la date de naissance doit tre renseigne
		$req = reqmysql('SELECT `date_naissance` FROM `agenda_anniv` WHERE `id_mbr`="'.$K_user->id.'"');
		$obj_anniv = @mysql_fetch_object($req);

		if (!isset($obj_anniv->date_naissance) || $obj_anniv->date_naissance == '' || $obj_anniv->date_naissance == '0000-00-00')
		{
			bloc_head('Date de naissance requise');
			echo '
			<p style="text-align:center">
			Vous n\'avez pas encore renseign&eacute; votre date de naissance.<br />
			Or cela est n&eacute;cessaire pour acc&eacute;der au listing des anniversaires.
			</p><br />
			<strong>Indiquer maintenant votre date de naissance :</strong>';

			editNaissForm();

			close_table();
		}
		else
		{
			$requete = reqmysql('
				SELECT `a`.`id`, `a`.`id_mbr`, `a`.`pseudo`, `users`.`avatar`, IF(`aff_naissance`=1, `date_naissance`, CONCAT("0000-", RIGHT(`date_naissance`, 5))) AS date_naissance
				FROM `agenda_anniv` AS a
				LEFT JOIN `users` ON `users`.`id` = `a`.`id_mbr`
				WHERE `date_naissance`!="0000-00-00" AND `date_naissance`!= ""
				ORDER BY RIGHT(`date_naissance`, 5), `pseudo`
			');
			bloc_head('Liste des anniversaires');
			echo affAnniv($requete);
			close_table();
		}
	}
}
?>
