<?php
// -----------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: bloc.php 842 2009-02-10 12:21:43Z mike007.devpwsphp $
// -----------------------------------------------------------------
//
// Module Agenda
//
// -----------------------------------------------------------------

/**
 * @file bloc.php
 *
 * Fichier gnrant et affichant le(s) bloc(s) du module Agenda.
 * Ce fichier gre les deux types de blocs (calendrier et anniversaires),
 * pouvant tre affichs simultanment ou indpendemment.
 *
 * @author Otocinclus
 * @version 1.0
 * @date Novembre 2007
 */


// Scu
if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

if (get_grade('voir')>=GRD_VISIT and is_module('agenda'))
{
	// backup $K_mod et rinitialisation avec le nom du bloc
	$mod_bak = $K_mod;
	$K_mod = $result_blocs->module;

	include_once 'modules/'.$K_mod.'/includes/lib_agenda.php';

	// Creation de la date si pas de date
	if (!isset($_REQUEST['int_mb']) || $_REQUEST['int_mb']<1 || $_REQUEST['int_mb']>12) $m = date('n');
	else $m = $_REQUEST['int_mb'];

	if (!isset($_REQUEST['int_ab'])) $a = date('Y');
	else $a = $_REQUEST['int_ab'];

	$cal_bloc = mktime(0, 0, 0, $m, '1', $a);
	$cal = array();
	dateInfo($a, $m);

	$bloc = '';

	// --------------------------------------------------------------------
	// Affichage du bloc Calendrier
	// --------------------------------------------------------------------
	if($result_blocs->parametre2==1)
	{
		include_once 'modules/'.$K_mod.'/includes/lib_calend.php';
		include_once 'modules/'.$K_mod.'/includes/lib_lune.php';

		$lune = phaseLune(date('Y'), date('n'), date('j'));
		$tabfete = array();
		$cejour = date('m-d');
		$cond = 'LEFT(`jour`, 2) = "'.date('m', $cal_bloc).'" OR `jour` = "'.$cejour.'"';
		$tabfete = findFetes($cond);
		$tabfete['aff'] = @in_array('bloc', $agenda_aff_fetes) ? 1 : 0;

		$bloc = '
		<div id="bloc_cal"></div>
		<p style="text-align:center;"><i>'.kws_date('jS F Y').'</i></p>
		<center>
		<img src="'.affImage('/lune/lune_'.$lune['age'].'.png').'" title="'.$lune['phase'].'" style="border:none; height:16px; width:16px;" alt="lune" />&nbsp;&nbsp;
		'.$tabfete[$cejour]['nom'].'&nbsp;&nbsp;'.($tabfete[$cejour]['logo'] == '' ? '' : '
		<img src="'.affImage($tabfete[$cejour]['logo']).'" alt="image '.$tabfete[$cejour]['nom'].'" />').'
		<hr /></center>
		<div style="text-align:center;">
		<form action="#bloc_cal" method="post" name="avant" style="display: inline">
		<input type="hidden" name="int_ab" value="'.date('Y', $cal['pre_mois']).'" />
		<input type="hidden" name="int_mb" value="'.date('n', $cal['pre_mois']).'" />
		<img src="'.affImage('gauche.png').'" border="0" alt="pr&eacute;c&eacute;dant" title="Mois pr&eacute;c&eacute;dant" onclick="avant.submit()" />&nbsp;
		</form>
		<a href="index.php?mod='.$K_mod.'&amp;type=mois&amp;int_a='.$cal['annee'].'&amp;int_m='.$cal['mois'].'"><strong>'.$tmois[($cal['mois'] - 1)].' '.$cal['annee'].'</strong></a>&nbsp;
		<form action="#bloc_cal" method="post" name="apres" style="display: inline">
		<input type="hidden" name="int_ab" value="'.date('Y', $cal['sui_mois']).'" />
		<input type="hidden" name="int_mb" value="'.date('n', $cal['sui_mois']).'" />
		<img src="'.affImage('droite.png').'" border="0" alt="suivant" title="Mois suivant" onclick="apres.submit()" />
		</form>
		</div>
		<center>'.calendMois($tabfete, $agenda_aff_anniv, $agenda_aff_event, 'Small', true).'</center>';

		/* Ajout vnement si grade suffisant */
		if (get_grade() >= $agenda_grade_post)
		{
			$bloc .= '<p align="center"><a href="index.php?mod='.$K_mod.'&amp;ac=evenements">Proposer un &eacute;v&egrave;nement</a></p>';
		}

		/* affichage du bloc */
		Bloc($result_blocs->parametre1, $bloc);
	}
	else
	{
		include_once 'modules/'.$K_mod.'/includes/lib_alertes.php';
		$alerteAnniv = alerteAnniv('bloc', $result_blocs->parametre4);
		$alerteEvent = alerteEvent('bloc', $result_blocs->parametre4, $agenda_type_futur_event);

		// ------------------------------------------------------------------
		// Bloc Anniversaire
		// ------------------------------------------------------------------
		if($result_blocs->parametre2==2)
		{
			$bloc  = '<center><a href="index.php?mod='.$K_mod.'&amp;ac=anniversaire"><img src="'.affImage('anniv.png').'" border="0" alt="Voir tous les anniversaires" /></a></center><br />';

			if ($alerteAnniv != '')
			{
				bloc($result_blocs->parametre1, $bloc.$alerteAnniv);
			}
			elseif ($result_blocs->parametre3==0)
			{
				bloc($result_blocs->parametre1, $bloc.'<center>Personne ne f&ecirc;te son anniversaire aujourd\'hui.</center>');
			}

		}

		// ------------------------------------------------------------------
		// Affichage du bloc Evenements
		// ------------------------------------------------------------------
		elseif($result_blocs->parametre2==3)
		{
			$bloc  = '<center><a href="index.php?mod='.$K_mod.'&amp;ac=evenements"><img src="'.affImage('agenda.png').'" width="36" height="36" border="0" alt="Les evenements" /></a></center><br />';

			if ($alerteEvent != '')
			{
				bloc($result_blocs->parametre1, $bloc.str_replace('<br />','<br /><br />',$alerteEvent));
			}
			elseif ($result_blocs->parametre3==0)
			{
				bloc($result_blocs->parametre1, $bloc.'<center>Pas d\'&eacute;v&egrave;nement.</center>');
			}
		}

		// ------------------------------------------------------------------
		// Affichage du bloc mixte Anniversaires / Evenements
		// ------------------------------------------------------------------
		elseif($result_blocs->parametre2==4)
		{
			$bloc  = ($alerteAnniv != '' ? '<center><a href="index.php?mod='.$K_mod.'&amp;ac=anniversaire"><img src="'.affImage('anniv.png').'" border="0" width="21" height="24" alt="Les anniversaires" />&nbsp;&nbsp;Anniversaires</a></center><br />' : '').$alerteAnniv;
			$bloc .= $bloc != '' ? '<br />' : '';
			$bloc .= ($alerteEvent != '' ? '<center><a href="index.php?mod='.$K_mod.'&amp;ac=evenements"><img src="'.affImage('agenda.png').'" width="24" height="24" border="0" alt="Les evenements" />&nbsp;&nbsp;Evenements</a></center><br />' : '').str_replace('<br />','<br /><br />',$alerteEvent);

			if ($bloc != '')
			{
				bloc($result_blocs->parametre1, $bloc);
			}
			elseif ($result_blocs->parametre3==0)
			{
				bloc($result_blocs->parametre1, '<center>Ni anniversaires, ni &eacute;v&egrave;nement.</center>');
			}
		}
	}

	// restore $K_mod
	$K_mod = $mod_bak;
}
?>
