<?php
// -----------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: gestion.php 903 2010-04-25 07:54:35Z mike007.devpwsphp $
// -----------------------------------------------------------------
//
// Module Agenda
//
// -----------------------------------------------------------------

/**
 * @file gestion.php
 *
 * Toute la gestion du module Agenda.
 *
 * @author Otocinclus
 * @date Novembre 2007
 * @date Aout 2008
 */

// Scurit !!
if (!(defined('__KWS__'))) {die('Erreur d\'appel de fichier.');}

include_once 'modules/agenda/includes/lib_agenda.php';

if (isset($_REQUEST['int_id'])) $id = $_REQUEST['int_id']; else unset($id);
if (isset($_REQUEST['int_a']))	 $a = $_REQUEST['int_a']; else $a = date('Y');
if (isset($_REQUEST['int_m']))	 $m = $_REQUEST['int_m']; else $m = date('m');
if (isset($_REQUEST['int_j']))	 $j = $_REQUEST['int_j']; else $j = date('d');
if (isset($_REQUEST['int_weekof'])) $weekof = $_REQUEST['int_weekof']; else unset($weekof);

$action	= isset($_REQUEST['action']) ? $_REQUEST['action'] : '';
$do		= isset($_REQUEST['do'])	 ? $_REQUEST['do']	   : '';
$aff	= $_REQUEST['add'] == '1'	 ? false : true;

// Si modrateur agenda
if (get_grade('gerer') < GRD_MODOG)
{
	// --------------- grade insuffisant ---------------
	zoneReserve((get_grade()==GRD_VISIT ? 'identification' : ''));
}
else
{
	// Titre de la Page
	bloc_head('Gestion de l\'agenda');

	// ---------------------------------------------------------------------------------------------
	// -------------------------------- Affichage du menu principal --------------------------------
	// ---------------------------------------------------------------------------------------------

	// Barre de Navigation
	echo '
	<p style="text-align:center;">
	<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=fetes">Ftes</a> -
	<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=anniv">Anniversaires</a> -
	<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=event">Ev&egrave;nements</a>
	<span style="float:right; width:150px;"><a href="index.php?mod=espace_membre&amp;ac=login&amp;doss=mod">Retour >></a></span>
	</p>
	<br /><hr /><br />';

	// initialisation nbre max d'vnements  afficher par page
	$max = 20;

	// ---------------------------------------------------------------------------------------------
	// ----------------------------- Evnements en attente validation ------------------------------
	// ---------------------------------------------------------------------------------------------
	// initialisation en fonction 1 event ou tous
	if ($do == 'all')
	{
		$where_events = ' `is_valid` = "0"';
		$where_alerte = '';
	}
	else
	{
		$where_events = '`idx` = "'.$id.'"';
		$where_alerte = '`date`="'.$id.'" AND ';
	}
	// ---------- validation ----------
	if ($action == 'valider')
	{
		reqmysql('UPDATE `agenda_events` SET `is_valid`="1" WHERE '.$where_events );
		// efface l'alerte
		reqmysql('DELETE FROM `alerte` WHERE '.$where_alerte.'`module`="agenda"');
		echo '
		<p style="text-align:center; font-weight:bold;">
		L\'&eacute;v&egrave;nement est d&eacute;sormais visible sur le portail
		</p>';
	}
	// ---------- Effacer tout ----------
	elseif ($action == 'delvalid')
	{
		reqmysql('DELETE FROM `agenda_events` WHERE '.$where_events );
		// efface l'alerte
		reqmysql('DELETE FROM `alerte` WHERE '.$where_alerte.'`module`="agenda"');
		echo '
		<p style="text-align:center; font-weight:bold;>L\'&eacute;v&egrave;nement a &eacute;t&eacute; supprim&eacute;</p>';
	}
	// ---------- affichage ----------
	if ($action!='event' || $do!='supprimer')
	{
		include_once 'modules/'.$K_mod.'/includes/lib_event.php';
		$titre = '<u>Ev&egrave;nements  valider</u>
		<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=valider&amp;do=all" title="Tout valider" style="margin-left:3em;">
		<img src="'.affImage('validertout.png').'" border="0" alt="tout valider" />
		</a>
		<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=delvalid&amp;do=all" title="Tout effacer" style="margin-left:1em;">
		<img src="'.affImage('deltout.png').'" border="0" alt="tout effacer" />
		</a>';
		$cond = '`agenda_events`.`is_valid`="0"';

		if (afficheEventsList($titre, $cond, $max)) echo '<hr /><br />';
	}
	// fin gestion des validations


	// ---------------------------------------------------------------------------------------------
	// ---------------------------------- Gestion des ftes ----------------------------------------
	// ---------------------------------------------------------------------------------------------
	if ($action == "fetes")
	{
		// Menu ftes
		bloc_head('Gestion des ftes');
		// barre de nav mensuelle
		echo '
		<p style="text-align:center;">';
		for($i=1;$i<13;$i++)
		{
			echo '
			&nbsp;<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=fetes&amp;int_m='.$i.'">'.$tmois[$i-1].'</a>&nbsp;';
		}
		echo '
		<br /><br />
		<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=fetes&amp;do=add">Ajouter une fte</a>&nbsp;&nbsp;
		<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=fetes&amp;do=mobile">Recalculer les dates des ftes mobiles</a>
		</p>';
		close_table();

		// --------------- Actions ---------------
		switch ($do)
		{
		case 'add'	: // Ajout d'une fte
		case 'edit' : // modif d'une fte
			// le formulaire a t envoy : on traite.
			if (isset($_POST['envoyerFete']))
			{
				// si date valide
				if (checkdate($m, $j, 2004))	//seul le jour et le mois sont ncessaires pour les ftes.
												// 2004 permet juste de valider tous les jours y compris le 20/02
				{
					$date_fete = ($m<10?'0'.$m:$m).'-'.($j<10?'0'.$j:$j);
					$ferie = $_POST['int_rdo_ferie']!='1' ? '0' : '1';
					if (isset($id))
					{
						// c'est une modif
						$req = reqmysql('
							UPDATE `agenda_fetes`
							SET	`jour`  = "'.$date_fete.'",
								`nom`	 = "'.$_POST['sql_fete_nom'].'",
								`logo`  = "'.$_POST['sql_fete_logo'].'",
								`ferie` = "'.$ferie.'"
							WHERE `id` = "'.$id.'"
						');
						$message = 'Mise &agrave; jour &eacute;ffectu&eacute;e';
					}
					else
					{
						// c'est une nouvelle fete
						$req = reqmysql('
							INSERT INTO `agenda_fetes`
							SET	`jour`  = "'.$date_fete.'",
								`nom`	 = "'.$_POST['sql_fete_nom'].'",
								`logo`  = "'.$_POST['sql_fete_logo'].'",
								`ferie` = "'.$ferie.'"
						');
						$message = 'La nouvelle fte est enregistr&eacute;e.';
					}

					open_table();
					echo '
					<p style="font-weight:bold; text-align:center;">'.$message.'</p>
					<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-2);" />';
					close_table();
				}

				// date non valide
				else
				{
					open_table();
					echo '
					<p style="color:#EE0000; font-weight:bold; text-align:center;">La date que vous avez saisie n\'est pas valide !!</p>
					<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-1);" />';
					close_table();
				}
			}
			// Affichage du formulaire
			else
			{
				$formTitre = 'Ajouter une nouvelle fte.';
				if (isset($id))
				{
					// c'est une mise  jour
					$req_fetes = reqmysql('
						SELECT `nom`, LEFT(`jour`, 2) AS moisFete, RIGHT(`jour`, 2) AS jourFete, `logo`, `ferie`
						FROM   `agenda_fetes`
						WHERE  `id` = "'.$id.'"
					');
					$obj_fetes = mysql_fetch_object($req_fetes);
					$id_texte = '<input type="hidden" name="int_id" value="'.$id.'" />';
					$formTitre = 'Modification d\'une fte.';
				}

				echo '
				<h3>'.$formTitre.'</h3>
				<form action="index.php" method="post">
				<input type="hidden" name="mod" value="'.$K_mod.'" />
				<input type="hidden" name="ac" value="'.$K_ac.'" />
				<input type="hidden" name="action" value="fetes" />
				<input type="hidden" name="do" value="'.$do.'" />
				'.$id_texte.'
				<p><span style="width:150px; float:left;">Nom de la fte : </span><input type="text" name="sql_fete_nom" value="'.$obj_fetes->nom.'" /></p>
				<p>
				<span style="width:150px; float:left;">Date : </span>
				'.select('int_j', $obj_fetes->jourFete, 0, 31, 1, 'jour').'
				 / '.select('int_m', $obj_fetes->moisFete, 0, 12, 1, 'mois').'
				</p>
				<p><span style="width:150px; float:left;">Jour fri :</span>
				<input type="radio" value="1" name="int_rdo_ferie"'.($obj_fetes->ferie=='1' ? ' checked="checked"' : '').' />Oui&nbsp;&nbsp;
				<input type="radio" value="0" name="int_rdo_ferie"'.($obj_fetes->ferie=='0' ? ' checked="checked"' : '').' />Non
				</p>
				<p><span style="width:150px; float:left;">Logo :</span><input type="text" name="sql_fete_logo" value="'.$obj_fetes->logo.'" /></p>
				<span style="width:250px; float:left; text-align:right;">
				<input type="submit" id="submit" name="envoyerFete" value=" Envoyer " />&nbsp;&nbsp;&nbsp;
				<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-1);" />
				</span>
				</form>';
			}
			break;

		case 'delete' : // ----- Effacer fte -----
			$req = reqmysql('DELETE FROM `agenda_fetes` WHERE `id` = "'.$id.'"' );
			open_table();
			echo '
			<p style="font-weight:bold; text-align:center;">Fte effac&eacute;e.</p>
			<input type="button" id="button" name="retour" value=" retour " onclick="history.go(-1);" />';
			close_table();
			break;

		case 'mobile' : // ----- Recalcule les dates des ftes mobiles
			include_once 'modules/agenda/includes/fetesMobiles.php';
			echo 'Les ftes mobiles ont bien t recalcules.<br />';
			break;

		default : // ----- Affichage des ftes par mois -----
			if (!isset($m) || $m<1 || $m>12) $m = 1;

			$req_fetes = reqmysql('
				SELECT `id`, `nom`, RIGHT(`jour`, 2) AS jourFete, `logo`, `ferie`
				FROM `agenda_fetes`
				WHERE LEFT(`jour`, 2)='.($m < 10 ? '0'.$m : $m).'
				ORDER BY jourFete
			');
			while($obj_fetes=mysql_fetch_object($req_fetes))
			{
				$color = $obj_fetes->ferie ? ' color:#ff0000;' : '';
				$aff_mois .= '
				<li style="clear:both">
				<span style="width:10em; padding-left:20px; float:left;'.$color.'"><img src="modules/'.$K_mod.'/imgs/droite.png" alt="puce" />
				<strong>'.($obj_fetes->jourFete == '01' ? '1er' : $obj_fetes->jourFete).' '.$tmois[$m-1].'</strong>
				</span>
				<span style="width:18em; float:left;'.$color.'">'.$obj_fetes->nom.'</span>
				<span style="width:15em; float:left;">'.($obj_fetes->logo=='' ? '&nbsp;' : '<img src="'.affImage($obj_fetes->logo).'" alt="logo" />').'</span>
				<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=fetes&amp;do=edit&amp;int_id='.$obj_fetes->id.'">
				<img src="themes/'.$K_theme.'/images/gestion/edit.png" border="0" alt="modifier" title="Modifier la cette fte" /></a> &nbsp;&nbsp;&nbsp;
				<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=fetes&amp;do=delete&amp;int_id='.$obj_fetes->id.'"
				onclick="if (confirm(\'tes vous sr de vouloir effacer cette fte ?\') == true) {return true} else {return false}">
				<img src="themes/'.$K_theme.'/images/gestion/del.png" border="0" alt="effacer" title="Effacer cette fte" /></a> &nbsp;
				</li>';
			}

			echo '
			<ul style="list-style-type:none; text-indent:0px;">
			<li><br />
			<img src="modules/'.$K_mod.'/imgs/puce.png" alt="puce" /> Au mois de <strong>'.$tmois[$m-1].' :</strong><br /><br />
			</li>'.$aff_mois.'
			</ul>';
		}
	} // fin gestion ftes.


	// ---------------------------------------------------------------------------------------------
	// --------------------------------- Gestion des anniversaires ---------------------------------
	// ---------------------------------------------------------------------------------------------
	elseif ($action == 'anniv')
	{
		include_once 'modules/agenda/includes/lib_anniv.php';

		// Menu anniversaire
		bloc_head('Gestion des anniversaires');
		// barre de nav mensuelle
		echo '
		<p style="text-align:center;">';
		for($i=1;$i<13;$i++)
		{
			echo '
			&nbsp;<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=anniv&amp;int_m='.$i.'">'.$tmois[$i-1].'</a>&nbsp;';
		}
		$mbr = array();
		$mbr[0]['id']	  = 0;
		$mbr[0]['pseudo'] = '-+- Membre -+-';
		$req_mbr = reqmysql('
			SELECT `users`.`id` AS idu, `users`.`pseudo`, `agenda_anniv`.`id` AS ida, `agenda_anniv`.`id_mbr`
			FROM `users`
			LEFT JOIN `agenda_anniv` ON `agenda_anniv`.`id_mbr` = `users`.`id`
			ORDER BY `pseudo`
		');

		$i=1;
		while ($obj_mbr = mysql_fetch_object($req_mbr))
		{
			$mbr[$i]['id']	   = $obj_mbr->ida;
			$mbr[$i]['pseudo'] = $obj_mbr->pseudo;
			$i++;
		}
		$select_mbr = 'mbr" onchange="window.location=\'index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=anniv&amp;do=edit&amp;int_id=\' + this.options[this.selectedIndex].value';
		echo '
		</p>
		<center>
		<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=anniv&amp;do=add">Ajouter un anniversaire</a>&nbsp;&nbsp;
		<form action="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=anniv&amp;do=edit">
		Rechercher un membre : '.selectMembre($select_mbr, $mbr).'
		</form>
		</center>';
		close_table();

		// --------------- Traitements ---------------
		switch ($do)
		{
		// ----- Ajout d'un anniversaire -----
		case 'add'	:

		// ----- Modif d'une date de naissance -----
		case 'edit' :
			if (isset($_POST['envoyerNaiss']))
			{
				// le formulaire a t envoy
				$message = '';
				if (checkdate($m, $j, $a))
				{
					$date_naissance = $a.'-'.$m.'-'.$j;
					$aff_naissance	= $_POST['int_aff_naissance']!='1' ? '0' : '1';
					$new_pseudo 	= isset($_POST['sql_non_membre']) ? $_POST['sql_non_membre'] : '';
					$id_mbr 		= isset($_POST['int_id_mbr']) ? $_POST['int_id_mbr'] : 0;
					if (isset($id))
					{
						// c'est un update
						$req = reqmysql('
							UPDATE `agenda_anniv`
							SET	`date_naissance` = "'.$date_naissance.'",
								`aff_naissance`  = "'.$aff_naissance.'"
							WHERE `id` = "'.$id.'"
						');

						$message = '
						<p style="font-weight:bold; text-align:center;">La nouvelle date de naissance est enregistr&eacute;e.</p>
						<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-1);" />';
					}
					else
					{
						// c'est un nouvel anniversaire
						if ($id_mbr != 0 && $new_pseudo != '')
						{
							// erreur : membre ou non membre mais pas les deux !!
							$message = '
							<p style="text-align:center;color:#cc3300">Il faut <strong>ou</strong> s&eacute;lectionner un membre <strong>ou</strong> saisir un pseudo externe,<br />
							mais pas les deux &agrave; la fois !!</p>
							<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-1);" />';
						}
						elseif ($id_mbr == 0 && $new_pseudo == '')
						{
							// erreur : il faut un pseudo !!
							$message = '
							<p style="text-align:center;color:#cc3300">Il faut indiquer un pseudo !!</p>
							<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-1);" />';
						}
						elseif ($id_mbr == 0)
						{
							// ce n'est pas un membre
							$req = reqmysql('
								SELECT `users`.`id` FROM `users` WHERE `users`.`pseudo`="'.$new_pseudo.'"
								UNION SELECT `agenda_anniv`.`id` FROM `agenda_anniv` WHERE `agenda_anniv`.`pseudo`="'.$new_pseudo.'"
									');
							if (mysql_num_rows($req) > 0)
							{
								$message = '
								<p style="text-align:center;color:#cc3300">Ce pseudo n\'est pas disponible !!</p>
								<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-1);" />';
							}
							else
							{
								// c'est bon on peut enregistrer
								$req = reqmysql('
									INSERT INTO `agenda_anniv`
									SET	`id_mbr`		 = "0",
										`pseudo`		 = "'.$new_pseudo.'",
										`date_naissance` = "'.$date_naissance.'",
										`aff_naissance`  = "'.$aff_naissance.'"
								');
							}
						}
						else
						{
							// c'est un membre
							$req = reqmysql('SELECT `pseudo` FROM `users` WHERE `id`="'.$id_mbr.'"');
							$obj = mysql_fetch_object($req);
							$req = reqmysql('
								INSERT INTO `agenda_anniv`
								SET	`id_mbr`		 = "'.$id_mbr.'",
									`pseudo`		 = "'.$obj->pseudo.'",
									`date_naissance` = "'.$date_naissance.'",
									`aff_naissance`  = "'.$aff_naissance.'"
							');
						}
					}
				}
				else
				{
					$message = '
					<span style="color:#ee0000; font-weight:bold; tex-align:center;">La date que vous avez saisie n\'est pas valide !!</p>
					<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-1);" />';
				}

				$message = $message!='' ? $message : '
				<p style="font-weight:bold; text-align:center;">La nouvelle date de naissance est enregistr&eacute;e.</p>
				<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-2);" />';

				open_table();
				echo $message;
				close_table();
			}
			else
			{
				// Affichage du formulaire
				if (isset($id))
				{
					// c'est une mise  jour
					$req = reqmysql('
						SELECT `id_mbr`, `pseudo`, `date_naissance`, `aff_naissance`
						FROM	`agenda_anniv`
						WHERE	`id` = "'.$id.'"
					');
					$obj_naiss = mysql_fetch_object($req);
					list($a, $m, $j) = explode('-', $obj_naiss->date_naissance);
					$formTitre = 'Modification naissance de '.$obj_naiss->pseudo;
					$id_texte = '
					<input type="hidden" name="int_id" value="'.$id.'" />
					<input type="hidden" name="int_id_mbr" value="'.$obj->id_mbr.'" />';
				}
				else
				{
					// c'est un ajout
					$formTitre = 'Ajouter une date de naissance';
					$req_users = reqmysql('
						SELECT `id`, `pseudo`
						FROM  `users`
						WHERE `pseudo` NOT IN (SELECT `pseudo` FROM `agenda_anniv`)
					');
					$id_texte = '
					<p><span style="width:80px;float:left;">Pseudo : </span>
					<span style="width:170px;float:left;text-align:right;font-style:italic;">Selectionner un membre :&nbsp;&nbsp;</span>
					<select name="int_id_mbr">
						<option value="0"> -+- Membres -+- </option>';
					while ($obj_users=mysql_fetch_object($req_users))
					{
						$id_texte .= '
						<option value="'.$obj_users->id.'">'.$obj_users->pseudo.'</option>';
					}
					$id_texte .= '
					</select><br />
					<span style="width:250px;float:left;text-align:right;font-style:italic;">ou saisir un pseudo :&nbsp;&nbsp;</span>
					<input type="text" name="sql_non_membre" value="" />
					</p>';
				}

				echo '
				<h3>'.$formTitre.'</h3>
				<form id="formAnni" name="formAnni" action="index.php" method="post">
				<input type="hidden" name="mod" value="'.$K_mod.'" />
				<input type="hidden" name="ac" value="'.$K_ac.'" />
				<input type="hidden" name="action" value="anniv" />
				<input type="hidden" name="do" value="'.$do.'" />
				'.$id_texte.'
				<p><span style="width:250px; float:left;">Date de Naissance : </span>
				'.select('int_j', $j, 0, 31, 1, 'jour').' / '.select('int_m', $m, 0, 12, 1, 'mois').' / '.select('int_a', $a, $today['year'], $today['year']-100, -1).'
				</p>
				<p>
				<span style="width:250px; float:left;">Montrer la date de naissance compl&egrave;te : </span>
				<input type="radio" value="1" name="int_aff_naissance"'.($aff=='1' ? ' checked="checked"' : '').' />Oui&nbsp;&nbsp;
				<input type="radio" value="0" name="int_aff_naissance"'.($aff=='0' ? ' checked="checked"' : '').' />Non
				</p>
				<span style="width:250px; float:left; text-align:right; padding-right:1.5em;">
				<input type="submit" id="submit" name="envoyerNaiss" value=" Envoyer " />
				</span>
				<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-1);" />
				</form>';


			}
			break;

		// ----- Effacer date de naissance -----
		case 'delete' :
			$req = reqmysql('
				DELETE FROM `agenda_anniv`
				WHERE `agenda_anniv`.`id` = "'.$id.'"
			');
			open_table();
			echo '
			<p style="text-align:center; font-weight:bold;">Date de naissance effac&eacute;e.</p>
			<input type="button" id="button" name="retour" value=" Retour " onclick="history.go(-1);" />';
			close_table();
			break;

		// ----- Afficher les anniversaires par mois -----
		default :
			if (!isset($m) || $m<1 || $m>12) $m = 1;

			$req_anni = reqmysql('
				SELECT		`a`.`id`, `a`.`id_mbr`, `a`.`pseudo`, `a`.`date_naissance`, `u`.`avatar`
				FROM		`agenda_anniv` AS a
				LEFT JOIN	`users` AS u ON `u`.`id` = `a`.`id_mbr`
				WHERE		MONTH(`a`.`date_naissance`)="'.($m < 10 ? '0'.$m : $m).'"
				ORDER BY	DAYOFMONTH(`a`.`date_naissance`), `a`.`pseudo`
			');
			echo affAnniv($req_anni, $K_ac);

		}
	} // Fin gestion anniversaires


	// ---------------------------------------------------------------------------------------------
	// ---------------------------------- Gestion des vnements -----------------------------------
	// ---------------------------------------------------------------------------------------------
	elseif ($action == 'event')
	{
		include_once 'modules/'.$K_mod.'/includes/lib_event.php';
		// ----- Menu vnements -----
		if ($do!='supprimer')
		{
			bloc_head('Gestion des &eacute;v&egrave;nements');
			echo '
			<p style="text-align:center;">';
			for($i=1;$i<13;$i++)
			{
				echo '
				&nbsp;<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=event&amp;do=mois&amp;int_id='.$i.'">'.$tmois[$i-1].'</a>&nbsp;';
			}
			echo '
			<br /><br />
			<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=event&amp;do=delold">Effacer anciens</a> -
			<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=event&amp;do=passe">Ev&egrave;nements pass&eacute;s</a> -
			<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=event&amp;do=futur">Ev&egrave;nements  venir</a> -
			<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=event">Derniers &eacute;v&egrave;nements saisis</a> -
			<a href="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=event&amp;do=add">Nouvel &eacute;v&egrave;nement</a>
			</p>
			<hr /><br />';
		}

		// --------------- Traitements ---------------
		switch ($do)
		{
		// ----- Ajout d'un vnement -----
		case 'add'	:
			if (isset($_POST['post_event']) && $_POST['post_event'] == ' Envoyer ')
			{
				$dates_event = datesEvent();

				if ($dates_event['ok'] &&
					!empty($_POST['sql_titre_event']) &&
					$_POST['int_ref_event'] > 0
					)
				{
					reqmysql('
						INSERT INTO `agenda_events`
						SET `ref`      = "'.$_POST['int_ref_event'].'",
							`titre`    = "'.$_POST['sql_titre_event'].'",
							`texte`    = "'.sp($_POST['texte']).'",
							`lieu`	   = "'.$_POST['sql_lieu_event'].'",
							`contact`  = "'.$_POST['sql_contact_event'].'",
							`grade`    = "'.$_POST['int_grade_event'].'",
							`groupe`   = "'.$_POST['int_groupe_event'].'",
							`date`	   = "'.$dates_event['date'].'",
							`date_fin` = "'.$dates_event['date_fin'].'",
							`id_user`  = "'.$_POST['int_user_event'].'",
							`time`	   = "'.$dates_event['temps'].'",
							`is_valid` = "1"
					');

					echo '
					<p style="text-align:center; font-weight:bold;">
					L\'&eacute;v&egrave;nement a &eacute;t&eacute; ajout&eacute;
					<br /><br />
					<form action="index.php?mod='.$K_mod.'&amp;ac=gestion" method="post">
					<input type="submit" id="submit" name="submit" value="Retour">
					</form>
					</p>';
				}
				else
				{
					if (!$dates_event['ok']) $msg = 'La date de l\'&eacute;v&egrave;nement est incorrecte<br />';
					if (empty($_POST['sql_titre_event'])) $msg .= 'Vous devez indiquer le titre de l\'&eacute;v&egrave;nement<br />';
					if ($_POST['int_ref_event'] == 0) $msg .= 'Vous devez indiquer dans quelle rubrique classer cet &eacute;v&egrave;nement<br />';
					
					echo '
					<p style="text-align:center; font-weight:bold; color:#ee0000;">
					'.$msg.'					
					<br />
					<form action="index.php?mod='.$K_mod.'&amp;ac=gestion" method="post">
					<input type="submit" id="submit" name="submit" value="Retour">
					</form>
					</p>';
				}
			}
			else
			{
				// ----- Affichage du formulaire -----
				echo '<h3><u>Ajouter un &eacute;v&egrave;nement </u></h3>';
				$evt['jour1']  = $evt['jour2']	= $today['mday'];
				$evt['mois1']  = $evt['mois2']	= $today['mon'];
				$evt['annee1'] = $evt['annee2'] = $today['year'];
				afficheFormEvent($evt, ' Envoyer ');
			}
			break;

		// ----- Modifier un vnement -----
		case 'editer' :
			if (isset($_POST['post_event']) && $_POST['post_event'] == ' Modifier ')
			{
				// le formulaire a t post.
				$dates_event = datesEvent();

				if ($dates_event['ok'])
				{
					reqmysql('
						UPDATE `agenda_events`
						SET `ref`      = "'.$_POST['int_ref_event'].'",
							`titre`    = "'.$_POST['sql_titre_event'].'",
							`texte`    = "'.sp($_POST['texte']).'",
							`lieu`	   = "'.$_POST['sql_lieu_event'].'",
							`contact`  = "'.$_POST['sql_contact_event'].'",
							`grade`    = "'.$_POST['int_grade_event'].'",
							`groupe`   = "'.$_POST['int_groupe_event'].'",
							`date`	   = "'.$dates_event['date'].'",
							`date_fin` = "'.$dates_event['date_fin'].'"
						WHERE `idx` = "'.$id.'"
					');

					echo '
					<p style="text-align:center; font-weight:bold;">
					L\'&eacute;v&egrave;nement a &eacute;t&eacute; modifi&eacute;</b>
					<br /><br />
					<form style="text-align:center" action="./index.php?mod='.$K_mod.'&amp;ac=gestion" method="post">
					<input type="submit" id="button" name="retour" value="Retour" />
					</form>
					</p>';
				}
				else
				{
					echo '
					<p style="text-align:center; font-weight:bold; color:#ee0000;">
					La date de l\'&eacute;v&egrave;nement est incorrecte</b>
					<br /><br />
					<form action="index.php?mod='.$K_mod.'&amp;ac=gestion" method="post">
					<input type="submit" id="submit" name="submit" value="Retour">
					</form>
					</p>';
				}
			}
			else
			{
				// affichage de l'vnement  modifier
				echo '<h3><u>Modifier un &eacute;v&egrave;nement </u></h3>';

				$req = reqmysql('
					SELECT	`ref`, `titre`, `texte`, `lieu`, `contact`, `groupe`, `grade`,
							DAYOFMONTH(`date`) AS jour1, MONTH(`date`) AS mois1, YEAR(`date`) AS annee1, HOUR(`date`) AS heure1, MINUTE(`date`) AS minute1,
							DAYOFMONTH(`date_fin`) AS jour2, MONTH(`date_fin`) AS mois2, YEAR(`date_fin`) AS annee2, HOUR(`date_fin`) AS heure2, MINUTE(`date_fin`) AS minute2
					FROM `agenda_events`
					WHERE `agenda_events`.`idx` = "'.$id.'"
				');
				if (mysql_num_rows($req)>0)
				{
					$evt = mysql_fetch_assoc($req);
					afficheFormEvent($evt, ' Modifier ');
				}
				else
				{
					echo '
					<br />
					<center>Cet &eacute;v&egrave;nement n\'&eacute;xiste pas !!!<br /><br />
					<form><input type="button" id="button" value=" Retour " onclick="history.go(-1)" /></form>
					</center>';
				}
			}
			break;

		// ----- Effacer UN vnement -----
		case 'supprimer' :
			reqmysql('DELETE FROM `agenda_events` WHERE `idx` = "'.$id.'"');
			// efface l'alerte
			reqmysql('DELETE FROM `alerte` WHERE `date`="'.$id.'" AND `module`="agenda"');
			$retour = 'index.php?mod='.$K_mod.'&ac='.$K_ac.'&action='.$action;
			echo '
			<p style="text-align:center; font-weight:bold;">L\'&eacute;v&egrave;nement a &eacute;t&eacute; supprim&eacute;</p>
			<script type="text/javascript">setTimeout("window.location.href=\''.$retour.'\'", 3000);</script>';   //"history.go(-1)"
			close_table();
			break;

		// ----- Effacer DES vnements anciens -----
		case 'delold' :
			if (isset($_POST['int_ageEvents']))
			{
				// le formulaire a t post.
				$ageEvents = $_POST['int_ageEvents'];
				$req=reqmysql('DELETE FROM `agenda_events` WHERE TO_DAYS(NOW()) - TO_DAYS(date) >= "'.$ageEvents.'"');
				$nb = mysql_affected_rows();
				echo '
				<p style="text-align:center; font-weight:bold;">';
				switch ($nb)
				{
				case 0 : echo 'Aucun &eacute;l&eacute;ment ne correspond au crit&egrave;re.';
						 break;
				case 1 : echo '1 &eacute;l&eacute;ment a &eacute;t&eacute; supprim&eacute;.';
						 break;
				default: echo $nb.' &eacute;l&eacute;ments ont &eacute;t&eacute; supprim&eacute;s.';
				}
				echo '
				</p>
				<form action="index.php?mod='.$K_mod.'&amp;ac=gestion&amp;action=passe" method="post">
				<input type="submit" id="submit" name="submit" value=" Retour ">
				</form>
				<script type="text/javascript">setTimeout("history.go(-1)", 3000)</script>';
			}
			else
			{
				// affichage du formulaire
				bloc_head('Effacer les vieux &eacute;v&egrave;nements');
				formEffaceVieuxEvents();
				close_table();
			}
			break;

		// ----- Affiche les vnements passs -----
		case 'passe' :
			$titre = 'Ev&egrave;nements pass&eacute;s :';
			$cond  = '`agenda_events`.`is_valid`="1" AND `agenda_events`.`date` <= NOW()';
			afficheEventsList($titre, $cond, $max);
			echo '<hr /><br />';
			// Destruction
			formEffaceVieuxEvents();
			break;

		// ----- Affiche les vnements  venir -----
		case 'futur' :
			$titre = 'Ev&egrave;nements  venir :';
			$cond  = '`agenda_events`.`is_valid`="1" AND `agenda_events`.`date` >= NOW()';
			afficheEventsList($titre, $cond, $max);
			break;

		// ----- Affiche par mois -----
		case 'mois' :
			if (!isset($id) || $id<1 || $id>12)  $id = $today['mon'];

			$titre = 'Ev&egrave;nements de '.$tmois[$id-1].' :';
			$cond  = '`agenda_events`.`is_valid`="1" AND MONTH(`agenda_events`.`date`)='.$id.' AND YEAR(`agenda_events`.`date`)='.$today['year'];
			afficheEventsList($titre, $cond, $max);
			break;

		// ----- par dfaut affiche les derniers vnements saisis -----
		default :
			$titre = $max.' derniers &eacute;v&egrave;nements saisi :';
			$cond  = '`agenda_events`.`is_valid`="1"';
			afficheEventsList($titre, $cond, $max, '`agenda_events`.`time` DESC LIMIT 0,'.$max);
		}

		close_table();
	}

	close_table();
}

//==================================================================================================

function selectMembre($nom, $tab)
{
	$select = '<select name="'.$nom.'">';
	for ($i=0; $i<count($tab); $i++)
	{
		$select .= '
		<option value="'.$tab[$i]['id'].'">'.$tab[$i]['pseudo'].'</option>';
	}
	$select .= '
	</select>';
	return $select;
}

?>
