<?php
// -----------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: params.php 900 2010-04-12 21:03:22Z mike007.devpwsphp $
// -----------------------------------------------------------------
//
// Module Agenda
//
// -----------------------------------------------------------------

/**
 * @file params.php
 *
 * Ce fichier prend en charge le rglage des paramtres spcifiques administrateur,  savoir :
 * 		- grade gestion,
 *		- grade pour proposer des vnements,
 *		- grade pour accder (lecture) aux calendriers
 *		- Affichage dans les calendriers des vnements et anniversaires,
 *		- Alertes et messages anniversaires,
 *
 * @author Otocinclus
 * @version 1.0
 * @date Novembre 2007
 */

// scu
if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

include_once 'modules/agenda/includes/lib_agenda.php';

//vrification du grade administrateur
if (get_grade('administrer') < GRD_ADMIN)
{
	// message d'erreur si le grade minimum n'est pas atteint
	zoneReserve();
}
else
{
	// Si le formulaire a bien t post
	if (isset($_POST['saveOption']))
	{
		$option_cal = array('an', 'mois', 'sem', 'jour', 'bloc');
		// traitement des variables externes
		$agenda_def_cal2 = $_POST['agenda_def_cal2'];
		if (!(in_array($agenda_def_cal2, $option_cal))) $agenda_def_cal2 = 'mois';
		$agenda_formatCalAnnu2 = $_POST['int_agenda_formatCalAnnu2'] == 3 ? 3 : 4;
		if (is_array($_POST['agenda_aff_fetes']))
			foreach($_POST['agenda_aff_fetes'] as $fete)
			{
				if (in_array($fete, $option_cal)) $agenda_aff_fetes2[]=$fete;
			}
		$agenda_aff_event2			= $_POST['agenda_aff_event2']=='on' ? 'on' : 'off';
		$agenda_annonce_event2		= $_POST['agenda_annonce_event2']=='on' ? 'on' : 'off';
		$agenda_futur_event2		= $_POST['int_agenda_futur_event2'];
		$agenda_type_futur_event2	= $_POST['agenda_type_futur_event2']=='nbre' ? 'nbre' : 'temps';
		$agenda_defile_event2		= $_POST['defile_event']=='H' ? 'H' : ($_POST['defile_event']=='V' ? 'V' : 'off');
		$agenda_sensdefile_event2	= $_POST['sensdefile_event'];
		if ($agenda_sensdefile_event2!= 'left' && $agenda_sensdefile_event2 != 'right' && $agenda_sensdefile_event2 != 'up' && $agenda_sensdefile_event2 != 'down') $agenda_sensdefile_event2 = 'up';
		$agenda_vitessedefile_event2= $_POST['int_vitessedefile_event'];
		$agenda_anniv2				= $_POST['agenda_anniv2']=='on' ? 'on' : 'off';
		$agenda_aff_anniv2			= $_POST['agenda_aff_anniv2']=='on' ? 'on' : 'off';
		$agenda_annonce_anniv2		= $_POST['agenda_annonce_anniv2']=='on' ? 'on' : 'off';
		$agenda_futur_anniv2		= $_POST['int_agenda_futur_anniv2'];
		$agenda_defile_anniv2		= $_POST['defile_anniv']=='H' ? 'H' : ($_POST['defile_anniv']=='V' ? 'V' : 'off');
		$agenda_sensdefile_anniv2	= $_POST['sensdefile_anniv'];
		if ($agenda_sensdefile_anniv2!= 'left' && $agenda_sensdefile_anniv2 != 'right' && $agenda_sensdefile_anniv2 != 'up' && $agenda_sensdefile_anniv2 != 'down') $agenda_sensdefile_anniv2 = 'up';
		$agenda_vitessedefile_anniv2= $_POST['int_vitessedefile_anniv'];
		$agenda_type_msga2			= $_POST['agenda_type_msga2']=='mp' ? 'mp' : ($_POST['agenda_type_msga2']=='mail' ? 'mail' : 'off');
		$agenda_msg_anniv2			= $_POST['sql_agenda_msg_anniv2'];

		if ($agenda_anniv2 != 'on')
		{
			$agenda_aff_anniv2 = 'off';
			$agenda_type_msga2 = 'off';
		}
		if ($agenda_aff_anniv2 != 'on')	$agenda_annonce_anniv2 = 'off';

		// mise a jour de la bdd
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_def_cal2.'"		WHERE nom="agenda_def_cal" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_formatCalAnnu2.'" WHERE nom="agenda_formatCalAnnu" ');
		reqmysql('UPDATE `parametres` SET `valeur`=\''.serialize($agenda_aff_fetes2).'\' WHERE nom="agenda_aff_fetes" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_aff_event2.'" 	WHERE nom="agenda_aff_event" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_anniv2.'" 		WHERE nom="agenda_anniv" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_aff_anniv2.'" 	WHERE nom="agenda_aff_anniv" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_annonce_anniv2.'" WHERE nom="agenda_annonce_anniv" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_futur_anniv2.'"	WHERE nom="agenda_futur_anniv" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_type_msga2.'" 	WHERE nom="agenda_type_msga" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_msg_anniv2.'" 	WHERE nom="agenda_msg_anniv" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_annonce_event2.'" WHERE nom="agenda_annonce_event" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_futur_event2.'"	WHERE nom="agenda_futur_event" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_type_futur_event2.'"	WHERE nom="agenda_type_futur_event" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_defile_event2.'"	WHERE nom="agenda_defile_event" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_sensdefile_event2.'" WHERE nom="agenda_sensdefile_event" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_vitessedefile_event2.'" WHERE nom="agenda_vitessedefile_event" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_defile_anniv2.'"	WHERE nom="agenda_defile_anniv" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_sensdefile_anniv2.'" WHERE nom="agenda_sensdefile_anniv" ');
		reqmysql('UPDATE `parametres` SET `valeur`="'.$agenda_vitessedefile_anniv2.'" WHERE nom="agenda_vitessedefile_anniv" ');

		// affichage rsultat
		bloc_head ("Options de l'agenda :") ;
		echo '
		<p style="text-align:center; font-weight:bold;">Param&egrave;tres enregistr&eacute;s<br /><br />
		<form action="index.php?mod=espace_membre&amp;ac=login&amp;doss=admin" name="rtb" id="rtb">
		<input type="submit" id="submit" value=" Retour " />
		</form>
		<script type="text/javascript">>setTimeout("window.location=\'index.php?mod=espace_membre&ac=login&doss=admin\'", 3000)</script>';
		close_table();
	}

	// sinon, affichage du formulaire
	else
	{
		if ($agenda_defile_event != 'V' && $agenda_defile_event != 'H') $agenda_defile_event = 'off';
		if ($agenda_defile_anniv != 'V' && $agenda_defile_anniv != 'H') $agenda_defile_anniv = 'off';
		echo '
		<br />
		<script type="text/javascript">
		function defile_option(type)
		{
			objSelect = document.getElementById("defile_"+type);
			valeur = objSelect.options[objSelect.selectedIndex].value;
			objSensSelect = document.getElementById("sensdefile_"+type);
			objDiv = document.getElementById("defile"+type);
			if (valeur == "off")
				objDiv.style.display = "none";
			else
			{
				if (valeur == "H")
				{
					objSensSelect.options[0].text  = "la droite";
					objSensSelect.options[0].value = "right";
					objSensSelect.options[1].text  = "la gauche";
					objSensSelect.options[1].value = "left";
				}
				else
				{
					objSensSelect.options[0].text  = "le haut";
					objSensSelect.options[0].value = "up";
					objSensSelect.options[1].text  = "le bas";
					objSensSelect.options[1].value = "down";
				}
				objDiv.style.display = "block";
			}
		}
		</script>';
		open_table();
		echo '
		<img src="'.affImage('agenda.png').'" alt="agenda" border="0" align="left" />
		<h2 style="text-align:center;">Param&egrave;tres du module Agenda</h2><br />
		<form name="agenda" id="agenda" method="post" action="index.php">
		<input type="hidden" name="mod" value="'.$K_mod.'" />
		<input type="hidden" name="ac" value="params" />
		<fieldset style="padding:1px; width:98%;">
			<legend><strong>Les calendriers</strong></legend>
			<p>
			<label style="float:left;width:28em;padding-left:1em;" for="agenda_def_cal2">Calendrier par default :</label>
			<select name="agenda_def_cal2" id="agenda_def_cal2">
			<option value="jour"'.($agenda_def_cal == 'jour' ? ' selected="selected"' : '').'>Journalier</option>
			<option value="sem"'.($agenda_def_cal == 'sem' ? ' selected="selected"' : '').'>Hebdomadaire</option>
			<option value="mois"'.($agenda_def_cal == 'mois' ? ' selected="selected"' : '').'>Mensuel</option>
			<option value="an"'.($agenda_def_cal == 'an' ? ' selected="selected"' : '').'>Annuel</option>
			</select>
			</p>
			<p>
			<label style="float:left;width:28em;padding-left:1em;" for="quadri">Format du calendrier annuel :</label>
			<input type="radio" name="int_agenda_formatCalAnnu2" id="quadri" value="4" '.($agenda_formatCalAnnu == "4" ? 'checked="checked"' : '').' /> Quadrimestres (3x4)<br />
			<label style="float:left;width:28em;padding-left:1em;" for="tri">&nbsp;</label>
			<input type="radio" name="int_agenda_formatCalAnnu2" id="tri" value="3" '.($agenda_formatCalAnnu != "4" ? 'checked="checked"' : '').' /> Trimestres (4x3)
			</p>
		</fieldset>
		<br />
		<fieldset style="padding:1px; width:98%;">
			<legend><strong>Les f&ecirc;tes</strong></legend>
			<div style="padding-top:6px">
			<label style="float:left;width:28em;padding-left:1em;" for="fetes_an">Afficher les f&ecirc;tes dans les calendriers :</label><br />
			<div style="text-align:center">
			<input type="checkbox" name="agenda_aff_fetes[]" id="fetes_an"	 value="an"  '.(@in_array('an',	 $agenda_aff_fetes) ? ' checked="cheked"' : '').' />Annuels&nbsp;&nbsp;
			<input type="checkbox" name="agenda_aff_fetes[]" id="fetes_mois" value="mois"'.(@in_array('mois', $agenda_aff_fetes) ? ' checked="cheked"' : '').'/>Mensuels&nbsp;&nbsp;
			<input type="checkbox" name="agenda_aff_fetes[]" id="fetes_sem"  value="sem" '.(@in_array('sem',  $agenda_aff_fetes) ? ' checked="cheked"' : '').'/>Hebdomadaires&nbsp;&nbsp;
			<input type="checkbox" name="agenda_aff_fetes[]" id="fetes_jour" value="jour"'.(@in_array('jour', $agenda_aff_fetes) ? ' checked="cheked"' : '').'/>Journaliers&nbsp;&nbsp;
			<input type="checkbox" name="agenda_aff_fetes[]" id="fetes_bloc" value="bloc"'.(@in_array('bloc', $agenda_aff_fetes) ? ' checked="cheked"' : '').'/>du bloc agenda
			</div>
			</div>
		</fieldset>
		<br />
		<fieldset style="padding:1px; width:98%;">
			<legend><strong>Les &eacute;v&eacute;nements</strong></legend>
			<p>
			<label style="float:left;width:28em;padding-left:1em;" for="agenda_aff_event2">Afficher les &eacute;v&egrave;nements dans les calendriers :</label>
			<select name="agenda_aff_event2">
			<option value="on">Oui</option>
			<option value="off" '.($agenda_aff_event == "off" ? 'selected="selected"' : '').'>Non</option>
			</select>
			</p>
			<p>
			<label style="float:left;width:28em;padding-left:1em;" for="agenda_annonce_event2">Annoncer les &eacute;v&egrave;nements du jour sous l\'&eacute;dito :</label>
			<select name="agenda_annonce_event2">
			<option value="on">Oui</option>
			<option value="off" '.($agenda_annonce_event == "off" ? ' selected="selected"' : '').'>Non</option>
			</select>
			</p>
			<p>
			<label style="float:left;width:28em;padding-left:1em;" for="int_agenda_futur_event2">Annoncer les &eacute;v&egrave;nements &agrave; venir </label>
			'.select('int_agenda_futur_event2', $agenda_futur_event, 0, 30).'&nbsp;
			<select name="agenda_type_futur_event2">
			<option value="temps">jours &agrave; l\'avance</option>
			<option value="nbre"'.($agenda_type_futur_event=='nbre'?' selected="selected"':'').'>prochains &eacute;v&egrave;nements</option>
			</select>
			</p>
			<div>
			<label style="float:left;width:28em;padding-left:1em;" for="defile_event">Faire d&eacute;filer les &eacute;v&egrave;nements :</label>
			<select id="defile_event" name="defile_event" onchange="defile_option(\'event\')">
			<option value="off">Non</option>
			<option value="V" '.($agenda_defile_event == "V" ? ' selected="selected"' : '').'>Verticalement</option>
			<option value="H" '.($agenda_defile_event == "H" ? ' selected="selected"' : '').'>Horizontalement</option>
			</select>
			</div>
			<div id="defileevent" style="display:'.($agenda_defile_event == 'off' ? 'none' : 'bloc').'">
			<label style="float:left;width:26em;padding-left:5em;" for="sensdefile_event"> D&eacute;filement vers : </label>
			<select id="sensdefile_event" name="sensdefile_event">';
		if ($agenda_defile_event == 'V')
		{
			echo '
			<option value="up">le haut</option>
			<option value="down" '.($agenda_sensdefile_event == "down" ? ' selected="selected"' : '').'>le bas</option>';
		}
		else
		{
			echo '
			<option value="right">la droite</option>
			<option value="left" '.($agenda_sensdefile_event == "left" ? ' selected="selected"' : '').'>la gauche</option>';
		}
		echo '
			</select><br />
			<label style="float:left;width:26em;padding-left:5em;" for="int_vitessedefile_event"> Vitesse de d&eacute;filement : </label>
			<select name="int_vitessedefile_event">
			<option value="1">1</option>
			<option value="2" '.($agenda_vitessedefile_event == "2" ? ' selected="selected"' : '').'>2</option>
			<option value="3" '.($agenda_vitessedefile_event == "3" ? ' selected="selected"' : '').'>3</option>
			<option value="4" '.($agenda_vitessedefile_event == "4" ? ' selected="selected"' : '').'>4</option>
			<option value="5" '.($agenda_vitessedefile_event == "5" ? ' selected="selected"' : '').'>5</option>
			<option value="6" '.($agenda_vitessedefile_event == "6" ? ' selected="selected"' : '').'>6</option>
			<option value="7" '.($agenda_vitessedefile_event == "7" ? ' selected="selected"' : '').'>7</option>
			<option value="8" '.($agenda_vitessedefile_event == "8" ? ' selected="selected"' : '').'>8</option>
			<option value="9" '.($agenda_vitessedefile_event == "9" ? ' selected="selected"' : '').'>9</option>
			<option value="10" '.($agenda_vitessedefile_event == "10" ? ' selected="selected"' : '').'>10</option>
			</select>
			</div>
		</fieldset>
		<br />
		<fieldset style="padding:1px; width:98%;">
			<legend><strong>Les anniversaires</strong></legend>
			<p>
			<label style="float:left;width:28em;padding-left:1em;" for="agenda_aff_anniv2">Grer les anniversaires :</label>
			<select name="agenda_anniv2">
			<option value="on">Oui</option>
			<option value="off" '.($agenda_anniv != "on" ? ' selected="selected"' : '').'>Non</option>
			</select>
			</p>
			<p>
			<label style="float:left;width:28em;padding-left:1em;" for="agenda_aff_anniv2">Afficher les anniversaires dans les calendriers :</label>
			<select name="agenda_aff_anniv2">
			<option value="on">Oui</option>
			<option value="off" '.($agenda_aff_anniv == "off" ? ' selected="selected"' : '').'>Non</option>
			</select>
			</p>
			<p>
			<label style="float:left;width:28em;padding-left:1em;" for="agenda_annonce_anniv2">Annoncer les anniversaires du jour sous l\'&eacute;dito :</label>
			<select name="agenda_annonce_anniv2">
			<option value="on">Oui</option>
			<option value="off" '.($agenda_annonce_anniv == "off" ? ' selected="selected"' : '').'>Non</option>
			</select>
			</p>
			<p>
			<label style="float:left;width:28em;padding-left:1em;" for="int_agenda_futur_anniv2">Annoncer les anniversaires &agrave; venir :</label>
			'.select('int_agenda_futur_anniv2', $agenda_futur_anniv, 0, 30).'&nbsp;&nbsp;&nbsp;jours &agrave; l\'avance.
			</p>
			<div>
			<label style="float:left;width:28em;padding-left:1em;" for="defile_anniv">Faire d&eacute;filer les anniversaires :</label>
			<select id="defile_anniv" name="defile_anniv" onchange="defile_option(\'anniv\')">
			<option value="off">Non</option>
			<option value="V" '.($agenda_defile_anniv == 'V' ? ' selected="selected"' : '').'>Verticalement</option>
			<option value="H" '.($agenda_defile_anniv == 'H' ? ' selected="selected"' : '').'>Horizontalement</option>
			</select>
			</div>
			<div id="defileanniv" style="display:'.($agenda_defile_anniv == 'off' ? 'none' : 'bloc').'">
			<label style="float:left;width:26em;padding-left:5em;" for="sensdefile_anniv">D&eacute;filement vers : </label>
			<select id="sensdefile_anniv" name="sensdefile_anniv">';
		if ($agenda_defile_anniv == 'V')
		{
			echo '
			<option value="up">le haut</option>
			<option value="down" '.($agenda_sensdefile_anniv == "down" ? ' selected="selected"' : '').'>le bas</option>';
		}
		else
		{
			echo '
			<option value="right">la droite</option>
			<option value="left" '.($agenda_sensdefile_anniv == "left" ? ' selected="selected"' : '').'>la gauche</option>';
		}
		echo '
			</select><br />
			<label style="float:left;width:26em;padding-left:5em;" for="int_vitessedefile_anniv">Vitesse de d&eacute;filement : </label>
			<select name="int_vitessedefile_anniv">
			<option value="1">1</option>
			<option value="2" '.($agenda_vitessedefile_anniv == "2" ? ' selected="selected"' : '').'>2</option>
			<option value="3" '.($agenda_vitessedefile_anniv == "3" ? ' selected="selected"' : '').'>3</option>
			<option value="4" '.($agenda_vitessedefile_anniv == "4" ? ' selected="selected"' : '').'>4</option>
			<option value="5" '.($agenda_vitessedefile_anniv == "5" ? ' selected="selected"' : '').'>5</option>
			<option value="6" '.($agenda_vitessedefile_anniv == "6" ? ' selected="selected"' : '').'>6</option>
			<option value="7" '.($agenda_vitessedefile_anniv == "7" ? ' selected="selected"' : '').'>7</option>
			<option value="8" '.($agenda_vitessedefile_anniv == "8" ? ' selected="selected"' : '').'>8</option>
			<option value="9" '.($agenda_vitessedefile_anniv == "9" ? ' selected="selected"' : '').'>9</option>
			<option value="10" '.($agenda_vitessedefile_anniv == "10" ? ' selected="selected"' : '').'>10</option>
			</select>
			</div>
			<p>
			<label style="float:left;width:28em;padding-left:1em;" for="agenda_type_msga2">Envoi automatique d\'un message d\'anniversaire :</label>
			<select name="agenda_type_msga2" id="agenda_type_msga2">
			<option value="off"'. ($agenda_type_msga=='off' ?' selected="selected"' : '').'>aucun</option>
			'.($K_mp_grade != '-2' ? '<option value="mp"'.  ($agenda_type_msga=='mp'	?' selected="selected"' : '').'>message priv</option>':'').'
			<option value="mail"'.($agenda_type_msga=='mail'?' selected="selected"' : '').'>email</option>
			</select>
			</p>
			<p>
			<label style="float:left;width:8em;padding-left:1em;" for="sql_agenda_msg_anniv2">Message :</label>
			<textarea rows="10" cols="55" name="sql_agenda_msg_anniv2" id="sql_agenda_msg_anniv2">'.$agenda_msg_anniv.'</textarea>
			</p>
			<p style="padding-left:2em; width:98%;">
			<u>Attention</u> : <i>Le message sera envoy lors du passage sur le site du premier visiteur du jour de l\'anniversaire.<br />
			S\'il se trouve que le jour d\'un anniversaire <strong>personne</strong> ne visite le site, le message ne sera jamais envoy !</i>
			</p>
		</fieldset>
		<p style="text-align:center;">
		<input type="submit" id="submit" name="saveOption" value=" Enregistrer " />
		<input type="reset" id="reset" value=" R&eacute;tablir " style="margin-left:2em;" />
		</p>
		</form>';

		close_table();
	}
}

?>
