<?php

// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: gestion.php 928 2011-05-18 18:30:56Z mike007 $
// ---------------------------------------------------------------
// Mise a jour : 30/06/06 par Jack
// Mise a jour : 16/10/06 par mike007
// ---------------------------------------------------------------

if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

if (get_grade() >= $articles_gr_admin)
{
	# FIN DES MODIFICATIONS
	bloc_head('Gestion des articles');
	
	// Gestion des articles
	if (!isset($_REQUEST['action']))
	{
		// SOMMAIRE
		echo '<p style="text-align:center">
			<a href="index.php?mod=articles&amp;ac=poster" title="Poster un article"><img src="themes/'.$K_theme.'/images/gestion/poster.png" alt="poster" style="border:none;" /></a>&nbsp;&nbsp;&nbsp;
			<a href="index.php?mod=articles&amp;ac=options" title="Gestion des options"><img src="themes/'.$K_theme.'/images/gestion/options.png" alt="Options" style="border:none;" /></a>&nbsp;&nbsp;&nbsp;
			<a href="index.php?mod=rubriques&amp;ac=gestion" title="Gestion des rubriques"><img src="themes/'.$K_theme.'/images/gestion/articles_cat2.png" alt="Rubriques" style="border:none;" /></a>&nbsp;&nbsp;&nbsp;
			<a href="index.php?mod=articles&amp;ac=aide" title="Une petite aide"><img src="themes/'.$K_theme.'/images/gestion/aide.png" alt="Aide" style="border:none;" /></a>
		</p>
		<hr />';
		
		// ARTICLES EN ATTENTE DE VALIDATION
		$req_art = reqmysql('
			SELECT		`articles`.`id`			AS id,
						`articles`.`ref`		AS ref,
						`articles`.`titre`		AS titre,
						`articles`.`auteur`		AS auteur,
						`articles`.`texte`		AS texte,
						`articles`.`type`		AS type,
						`articles`.`date`		AS date,
						`rubriques`.`titre`		AS cat_titre,
						`rubriques`.`id`		AS cat_id
			FROM		`articles`
			LEFT JOIN	`rubriques`
				ON		`articles`.`ref`=`rubriques`.`id`
			WHERE		`articles`.`validation`="1"
			ORDER BY	`articles`.`ref` ASC,
						`articles`.`date` DESC
		');
		
		$nb_attente   = mysql_num_rows($req_art);
		
		echo'<h3>Articles en attente de validation :</h3>';
		
		// S'il n'y a aucun article disponible on informe l'admin
		if ($nb_attente == 0)
		{
			echo '<p style="font-style:italic;">Vous n&rsquo;avez aucun article en attente de validation.</p>';
		}
		else
		{
			// Autrement on affiche tous les articles en attente de validation
			echo'<table summary="articles validation">';
			while ($art_attente = mysql_fetch_object($req_art))
			{
				if ($art_attente->type==0)		$article_format = 'Html';
				elseif ($art_attente->type==1)	$article_format = 'BBcode';
				elseif ($art_attente->type==2)	$article_format = 'Lien externe';
				echo '<tr>
					<td><a href="index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;action=edit&amp;int_id='.$art_attente->id.'"><img src="themes/'.$K_theme.'/images/gestion/edit.png" alt="Editer" style="border:none;" /></a></td>
					<td><a href="index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;action=del&amp;int_id='.$art_attente->id.'"><img src="themes/'.$K_theme.'/images/gestion/del.png" alt="Supprimer" style="border:none;" /></a></td>
					<td><a href="index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;action=valid&amp;int_id='.$art_attente->id.'&amp;date='.$art_attente->date.'"><img src="themes/'.$K_theme.'/images/gestion/valider.png" alt="Valider" style="border:none;" /></a></td>
					<td>- '.ax($art_attente->titre).' ('.$article_format.')</td>
					<td>'.ax($art_attente->cat_titre).'</td>
				</tr>';
			}
			echo'</table>';
		}
		echo'<hr />';
		
		// LISTE DES ARTICLES VALIDES
		$req_art = reqmysql('
			SELECT		`articles`.`id`			AS id,
						`articles`.`ref`		AS ref,
						`articles`.`titre`		AS titre,
						`articles`.`auteur`		AS auteur,
						`articles`.`texte`		AS texte,
						`articles`.`type`		AS type,
						`articles`.`js`			AS js,
						`articles`.`date`		AS date,
						`rubriques`.`titre`		AS cat_titre,
						`rubriques`.`id`		AS cat_id
			FROM		`articles`
			LEFT JOIN	`rubriques`
				ON		`articles`.`ref`=`rubriques`.`id`
			WHERE		`articles`.`validation`="0"
			ORDER BY	`articles`.`date` DESC,
						`rubriques`.`titre` ASC,
						`articles`.`date` DESC
		');
		
		$nb_valide = mysql_num_rows($req_art);

		echo'
		<h3>Liste des articles :</h3>';
		// S'il n'y a aucun article disponible on informe l'admin
		if ($nb_valide == 0)
		{
			echo '
			<p style="font-style:italic;">Vous n&rsquo;avez aucun article de valid&eacute;.</p>';
		}
		else
		{
			$pagination = new pagination($nb_valide, $articles_nbre_page, 'page');

			if ($nb_valide > $pagination->elt_par_page)
			{
				$nb_valide = $pagination->elt_par_page + $pagination->getDebutPage();
			}
			// Autrement on affiche tous les articles valids
			echo'<table summary="articles vali&eacute;s">';
			$i_articles=0;
			while ($art = mysql_fetch_object($req_art))
			{
				if ($i_articles >= $pagination->getDebutPage() and $i_articles < $nb_valide)
				{
					if ($art->type==0)
					{
						$article_format = 'Html';
						if ($art->js==1)
							$article_format .= ' +Js';
					}
					elseif ($art->type==1)	$article_format = 'BBcode';
					elseif ($art->type==2)	$article_format = 'Lien externe';
					echo '
					<tr>
						<td><a href="index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;action=edit&amp;int_id='.$art->id.'"><img src="themes/'.$K_theme.'/images/gestion/edit.png" alt="Editer" style="border:none;" /></a></td>
						<td><a href="index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;action=del&amp;int_id='.$art->id.'"><img src="themes/'.$K_theme.'/images/gestion/del.png" alt="Supprimer" style="border:none;" /></a></td>
						<td>- '.ax($art->titre).' ('.$article_format.') </td>
						<td> '.ax($art->cat_titre).' </td>
						<td> &curren; <em>'.kws_date('dS F Y',$art->date).'</em> &curren;</td>
					</tr>';
				}
				$i_articles++;
			}
			echo'</table><hr />
			'.$pagination->creer('./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;int_page=%d');
		}
	}
	else
	{
		// GESTION DES ARTICLES

		// Validation de l'article
		if ($_GET['action'] == 'valid')
		{
			reqmysql('
				UPDATE	`articles`
				SET		`validation`="0"
				WHERE	`id`="'.$_GET['int_id'].'"
			');

			echo '
			<center>
				<p>Article valid&eacute;.'.$art_attente->date.'</p>
				<p><a href="index.php?mod=articles&amp;ac=gestion">Retour</a></p>
			</center>';
		}
		
		// Demande confirmation de la suppression de l'article
		if ($_GET['action'] == 'del')
		{
			$req_art = reqmysql('
				SELECT	`titre`
				FROM	`articles`
				WHERE	`id`="'.$_GET['int_id'].'"
			');
			$art = mysql_fetch_object($req_art) ;
			
			echo '<br />
			<center>
				<p>Voulez-vous vraiment supprimer l\'article : <strong>'.ax($art->titre).'</strong> ?</p>
					<br />
					<form action="./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'" method="post">
						<input type="hidden" name="action" value="del2" />
						<input type="hidden" name="int_id" value="'.$_GET['int_id'].'" />
						<input type="submit" id="submit" value=" Oui " />
						<input type="button" id="button" value=" Non " onclick="history.go(-1)" />
					</form>
			</center>';
		}
		
		// Confirmation de la suppression de l'article
		if ($_POST['action'] == 'del2')
		{
			//suppression de l'article
			reqmysql('
				DELETE FROM	`articles`
				WHERE		`id`="'.$_POST['int_id'].'"
			');

			echo '<p style="text-align:center;">
				Article supprim&eacute;.<br />
				<a href="index.php?mod=articles&amp;ac=gestion">Retour</a>
			</p>';
		}
		
		// Edition de l'article
		if ($_GET['action'] == 'edit')
		{
			$req_art = reqmysql('
				SELECT	`titre`,
						`texte`,
						`mots_cles`,
						`auteur`,
						`ref`,
						`img`,
						`accroche`,
						`type`,
						`js`,
						`attribut`,
						`validation`
				FROM	`articles`
				WHERE	`id`="'.$_GET['int_id'].'"
			');
			$art = mysql_fetch_object($req_art) ;

			echo '<script type="text/javascript" src="./includes/bbcode.js"></script>
			<script type="text/javascript" src="./includes/bjs.js"></script>

			<form name="formulaire" method="post" action="./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'" onsubmit="return control_form(\'sql_titreart,Titre sql_auteurart,Auteur postzone,Message lien_postzone,Lien \')">
				<input type="hidden" name="action" value="edit2" />
				<input type="hidden" name="validation" value="'.$art->validation.'" />
				<input type="hidden" name="int_id" value="'.$_GET['int_id'].'" />
				<fieldset class="fieldset_post">
					<legend>&Eacute;dition de l&rsquo;article</legend>
					<dl>
						<dt><label>Titre :</label></dt>
						<dd><input type="text" size="30" id="sql_titreart" name="sql_titreart" value="'.ax($art->titre).'" /></dd>
					</dl>
					<dl>
						<dt><label>Auteur :</label></dt>
						<dd><input type="text" size="30" id="sql_auteurart" name="sql_auteurart" value="'.ax($art->auteur).'" /></dd>
					</dl>
					<dl>
						<dt><label>Rubrique :</label></dt>
						<dd>
							<select name="int_ref">';
								$req_article = reqmysql('
									SELECT		`titre`,
												`id`
									FROM		`rubriques`
									WHERE		(`rubriques`.`module` LIKE "%articles%" OR `rubriques`.`module`="")
									ORDER BY	`rubriques`.`titre` ASC
								');

								while ($article = mysql_fetch_object($req_article))
								{
									echo '<option '.($art->ref == $article->id ? 'selected="selected"':'').' value="'.$article->id.'" >'.ax($article->titre).'</option>';
								}
								echo '
							</select>
						</dd>
					</dl>
<!-- HA Ajout des champs Image-aperu et Accroche -->
					<dl>
						<dt><label>Image-aperu :</label></dt>
						<dd><input type="text" size="30" name="sql_img" id="sql_img" value="'.ax($art->img).'" /></dd>
					</dl>
					<dl id="dl_accroche" style="display:'.($art->type == '2'?'none':'block').';">
						<dt><label>Accroche:<br />- 250 caract&egrave;res max<br />- Html interdit</label></dt>
						<dd><textarea rows="6" cols="60" name="sql_accroche" id="sql_accroche" onkeyup="this.value = this.value.slice(0, 250)">'.ax($art->accroche).'</textarea></dd>
					</dl>
<!-- HA -->
					<dl>
						<dt><label>Format du texte :</label></dt>
						<dd>
							<input type="radio" value="1"'.($art->type == '1' ? ' checked="checked"' : '').' name="int_type" onclick="if(this.checked) choice_format_post(this.value);" />BBcode
							<span style="margin-left:75px">&nbsp;</span>
							<input type="radio" value="0"'.($art->type == '0' ? ' checked="checked"' : '').' name="int_type" onclick="if(this.checked) choice_format_post(this.value);" />Html
							'.($K_grade >= GRD_ADMIN ?
							' + Js <input type="checkbox" value="1" '.($art->js == 1 ? 'checked="checked"' : '').' name="int_js" />':'').'
							<br />
							<input type="radio" value="2"'.($art->type == '2' ? ' checked="checked"' : '').' name="int_type" onclick="if(this.checked) choice_format_post(this.value);" />Lien vers une page
						</dd>
					</dl>
					';
					if (is_module('smileys')) afficher_smileys($art->attribut);
					include './includes/balises.php';
					echo '
					<div class="fieldset_post">
						<textarea style="display:'.($art->type == '2'?'none':'block').'" cols="90" rows="'.(empty($new_textareaRows)?'13':$new_textareaRows).'" name="texte" id="postzone" onkeyup="bjs(this.value,\'apercu\')" onchange="bjs(this.value,\'apercu\')">'.ax($art->texte,true).'</textarea>
						<input disabled="disabled" style="display:'.($art->type == '2'?'block':'none').';margin:auto" type="text" size="90" name="texte" id="lien_postzone" value="'.ax($art->texte).'" />
					</div>
					<div id="apercu_check" style="text-align:center;display:'.($art->type == '2'?'none':'block').';">
						<input type="checkbox" onclick="pr_act(this);" /> Pr&eacute;visualisation du message:
						<span style="margin-left:50px">&nbsp;</span>
						<input type="button" value="Actualiser" style="visibility:hidden" id="prev" name="prev" onclick="finalprev(\'./includes/xml_prev.php\',document.getElementById(\'postzone\').value,\'apercu\')" />
					</div>
					<div id="HTML_prev_button" style="text-align:center;display:none;">
						<input type="button" value="'.(is_module('tiny_mce')? 'R&eacute;diger avec Tiny et ':'').'Pr&eacute;visualiser HTML" onclick="javascript:popupcentre(\'./includes/prevhtml.php?sql_name_form=\'+this.form.name+\''.(is_module('tiny_mce') ? '&amp;tiny='.$is_tiny_mce:'').'\',\'Article\',\'800\',\'610\',\'yes\')" />
					</div>
					<div id="apercu" style="display:none"></div>
					<hr />
					<div style="text-align:center">
						Facultatif : Mots cl&eacute;s (s&eacute;par&eacute;s par des virgules) de l\'article :<br />
						<input type="text" name="sql_mots_cles" size="90" value="'.ax($art->mots_cles).'" /><br /><br />
						<input type="submit" id="submit" value="  Modifier  " />
						<span style="margin-left:25px">&nbsp;</span>
						<input type="reset" id="reset" value="  Annuler  " onclick="history.go(-1);" />
					</div>
				</fieldset>
			</form><br style="clear:both" />
			<script type="text/javascript">
			// <![CDATA[
			';
				if ($art->type == '0')		echo "choice_format_post('0');";
				elseif ($art->type == '2')	echo "choice_format_post('2');";
			echo '
			// ]]>
			</script>
			';
		}
		
		// Confirmation de la modification de l'article
		if ($_POST['action'] == 'edit2')
		{
			if ($_POST['sql_titreart'] !='' AND $_POST['sql_auteurart'] !='' AND $_POST['texte'] !='')
			{
				$_POST['texte'] = filter_bbcode_sup_interdit($_POST['texte'],get_grade());
				$TypeArt		= $_POST['int_type'];
				$JsArt			= empty($_POST['int_js']) ? 0:1;
				if ($TypeArt != 0) $JsArt = 0;
				// On s'assure que la valeur de la validation reste bien  celle existante en ajoutant la variable : $validation
				$requete  = reqmysql('
				UPDATE	`articles`
				SET		`titre`			= "'.$_POST['sql_titreart'].'",
						`auteur`		= "'.$_POST['sql_auteurart'].'",
						`ref`			= "'.$_POST['int_ref'].'",
						`img`			= "'.$_POST['sql_img'].'",
						`accroche`	 	= "'.($_POST['int_type']!=2?$_POST['sql_accroche']:'').'",
						`type`			= "'.$TypeArt.'",
						`js`			= "'.$JsArt.'",
						`texte`			= "'.sp($_POST['texte']).'",
						`mots_cles`		= "'.$_POST['sql_mots_cles'].'",
						`attribut`		= "'.($_POST['int_type']==1? intval($_POST['smileys']):0).'",
						`validation`	= "'.intval($validation).'"
				WHERE	`id`			= "'.$_POST['int_id'].'"
				');
				echo '<br />
				<center>
					<p>Modifications prises en compte.</p>
					<p><a href="index.php?mod='.$mod.'&amp;ac=gestion">Retour</a></p>
				</center>';
			}
			else
			{
				echo '
				<p style="text-align:center;">
				Vous n\'avez pas rempli tous les champs</p>
				<p style="text-align:center;font-weight:bold;">
				<a href="index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'&amp;action=edit&amp;int_id='.$int_id.'">Retour</a>
				</p>';
			}
		}
	}
	close_table ();
}
else
{
	ZoneReserve();
}
?>
