<?php

// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: resume.php 905 2010-07-01 13:00:23Z mike007.devpwsphp $
// ---------------------------------------------------------------
// Mise a jour : 30/06/06 par Jack
// ---------------------------------------------------------------

if (!(defined('__KWS__'))) {die('Erreur d\'appel de fichier.');}

if (get_grade()>=GRD_VISIT and is_module('articles'))
{
	$texte = '';

	$res_articles = reqmysql('
		SELECT		`articles`.`id`			AS art_id,
					`articles`.`titre`		AS art_titre,
					`articles`.`date`		AS art_date,
					`articles`.`auteur`		AS art_auteur,
					`articles`.`accroche`	AS art_accroche,
					`articles`.`type`		AS art_type,
					`articles`.`attribut`	AS art_attribut,
					`articles`.`texte`		AS art_texte,
					`articles`.`ref`		AS art_ref,
					`articles`.`hit`		AS art_hit,
					`rubriques`.`titre`		AS cat_titre,
					`rubriques`.`image`		AS cat_img,
					(SELECT COUNT(*) FROM `commentaires` WHERE	`ref` = CONCAT("art",`articles`.`id`) ) AS nb_com,
					`users`.`id`			AS usr_id,
					`users`.`grade`			AS usr_grade,
					`users`.`avatar`		AS avatar
		FROM		`articles`
		LEFT JOIN	`users`
			ON		`users`.`pseudo` = `articles`.`auteur`
		JOIN `rubriques`
			ON		`articles`.`ref` = `rubriques`.`id`
		WHERE		`articles`.`validation`="0"
			AND		`articles`.`ref` IN '.$K_user->rubrique[0].'
		GROUP BY	`articles`.`id`
		ORDER BY	`articles`.`id` DESC
		LIMIT		0,'.$resume->parametre2
	);

	//Au moins un article existe
	if (mysql_num_rows($res_articles) != 0)
	{
		$resume3 = explode('-',$resume->parametre3);
		$i=0;
		while ($art_info = mysql_fetch_object($res_articles))
		{
			$art_com = $art_info->nb_com;
			$new = ' '.(((time()-$art_info->art_date) < ($resume->parametre4*24*3600)) ? '<img src="themes/'.$K_theme.'/images/resume/new.png" alt="new" style="border:none;" />' : '' ).' ';
			//Debut boucle de listing des articles
			//Contenu du resume et mise en forme du titre
			$titre = '
			<a href="'.(url_rw('./index.php?mod=articles&amp;ac=commentaires&amp;id='.$art_info->art_id,array($art_info->art_titre))).'" title="Lire l\'article: &laquo;'.ax($art_info->art_titre).'&raquo;">
			<span style="font-weight:bold; font-size:1.1em; font-family:Comic;">'.($resume_colonne==2 ? wordwrap(ax($art_info->art_titre),(preg_match('#img#i',$new) ? '35':'40'),'<br />',1):ax($art_info->art_titre)).'</span>
			</a>&nbsp;'.$new;
			$texte .='<fieldset class="fieldset_resume"><legend>'.$titre.'</legend>';
			list($image_width, $image_height, $image_type, $image_attr) = @getimagesize($art_info->cat_img);
			$texte .='
			<a href="'.(url_rw('./index.php?mod=articles&amp;ref='.$art_info->art_ref,array($art_info->cat_titre))).'">
			<img src="'.$art_info->cat_img.'" alt="Image" style="border:none;'.($image_width>50 ? 'width:50px;' : '').'float:right;padding:5px;" />
			</a>';
			$texte .= '
			<em>Article Post&eacute; par <a href="'.(url_rw('./index.php?mod=espace_membre&amp;ac=profil&amp;id='.$art_info->usr_id,array($art_info->art_auteur))).'">'.get_grd_symbol($art_info->usr_grade).ax($art_info->art_auteur).' </a>
			<br />le '.kws_date('l jS F Y \&\a\g\r\a\v\e\; H:i',$art_info->art_date).'
			<br /><br />dans la cat&eacute;gorie <a href="'.(url_rw('./index.php?mod=articles&amp;ref='.$art_info->art_ref,array($art_info->cat_titre))).'"><strong>"'.ax($art_info->cat_titre).'"</strong></a></em>
			';
			$texte .= (!empty($art_info->art_accroche) ? '<hr style="clear:both"/>'.bbcode($art_info->art_accroche,1,1):'<br style="clear:both"/>');
			if ($i<$resume3[0])
			{
				if (!empty($resume3[1]) and strlen($art_info->art_texte) > $resume3[1])
				{
					$art_info->art_texte = substr($art_info->art_texte,0,$resume3[1])."\n\nSuite ...\n\n";
				}
				if($art_info->art_type==1) //BBCode
				{
					$texte .= '<hr />'.bbcode($art_info->art_texte,$art_info->art_attribut,1);
				}
				elseif($art_info->art_type==2) // Lien Externe
				{
					$texte .= '<hr />
					L\'article que vous voulez consulter est un lien externe. Cliquez sur
					<a href="'.ax($art_info->art_texte).'">ce lien</a> pour le consulter.
					<br />';
				}
				else  // HTML
				{
					$texte .= '<hr />'.bbcode($art_info->art_texte,0,0,1,1);
				}
				if (strpos($texte,'|{}|')!=FALSE) // Coupure de page
				{
					$texte = substr($texte,0,strpos($texte,'|{}|')).'<br />
					<a href="'.(url_rw('./index.php?mod=articles&amp;ac=commentaires&amp;id='.$art_info->art_id,array($art_info->art_titre))).'" title="Suite de l\'article">Suite...</a><br /><br />';
				}
			}
			$texte .= '<hr />
			<div style="text-align:right;font-style:italic;">
			<a href="'.(url_rw('./index.php?mod=articles&amp;ac=commentaires&amp;id='.$art_info->art_id,array($art_info->art_titre))).'">
			'.($i>=$resume3[0] ? 'Lire cet article<br />' : ((!empty($resume3[1]) and strlen($art_info->art_texte) > $resume3[1])? 'Lire la suite<br />' : '')).'(Lu '.$art_info->art_hit.' fois) | '.$art_info->nb_com.' commentaire'.($art_info->nb_com>1 ? 's':'').'</a>
			</div>
			</fieldset>';
			$i++;
		}
		$texte .= '<br /><div style="text-align:right;"><a href="'.(url_rw('./index.php?mod=articles')).'">Tous les articles</a></div>';
	}
	else
	{
		//Pas d'articles
		$texte = '
		<div style="font-style:italic; text-align:center;">
		<h5>Aucun article n&rsquo;a encore &eacute;t&eacute; post&eacute;</h5>
		</div>';
	}

	bloc_head('<a href="'.(url_rw('./index.php?mod='.$resume->module)).'"><strong>'.$resume->parametre1.'</strong></a>');
	echo $texte;
	close_table();
}
?>
