<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: index.php 915 2011-04-20 19:41:37Z mike007 $
// ---------------------------------------------------------------

if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

$autorisation_tiny_mce = (is_module('tiny_mce'));

bloc_head('Contact');
if (isset($_POST['contact_envoyer']))
{
	$FormRetour = '
	<form style="text-align:center" action="./index.php?mod='.$K_mod.'" method="post">
		<input type="hidden" name="sql_contact_pseudo" value="'.stripslashes($_POST['sql_contact_pseudo']).'" />
		<input type="hidden" name="sql_contact_email" value="'.stripslashes($_POST['sql_contact_email']).'" />
		<input type="hidden" name="sql_contact_objet" value="'.stripslashes($_POST['sql_contact_objet']).'" />
		<input type="hidden" name="texte" value="'.stripslashes($_POST['texte']).'" />
		<input type="submit" value=" Retour" />
	</form>
	';
	$atom	= '[-a-z0-9!#$%&\'*+\\/=?^_`{|}~]';		// caractres autoriss avant l'arobase
	$domain = '([a-z0-9]([-a-z0-9]*[a-z0-9]+)?)';	// caractres autoriss aprs l'arobase (nom de domaine)

	$regex = '/^' . $atom . '+' .					// Une ou plusieurs fois les caractres autoriss avant l'arobase
	'(\.' . $atom . '+)*' . 						// Suivis par zro point ou plus
													// spars par des caractres autoriss avant l'arobase
	'@' .											// Suivis d'un arobase
	'(' . $domain . '{1,63}\.)+' .					// Suivis par 1  63 caractres autoriss pour le nom de domaine
													// spars par des points
	$domain . '{2,63}$/i';							// Suivi de 2  63 caractres autoriss pour le nom de domaine

	if (empty($_POST['sql_contact_pseudo']) || empty($_POST['sql_contact_email']) || empty($_POST['sql_contact_objet']) || empty($_POST['texte']))
	{
		$contact_msg = df_message('erreur', 'Vous n\'avez pas rempli tous les champs du formulaire !<br /><br />'.$FormRetour);
	}
	elseif (!preg_match($regex, $_POST['sql_contact_email']))
	{
		$contact_msg = df_message('erreur', 'Format d&rsquo;e-mail incorrect<br /><br />'.$FormRetour);
	}
	elseif (sha1($_POST['sql_code_secu'].date ('Ymd')) != $_POST['code'])
	{
		$contact_msg = df_message('erreur', 'MAUVAIS CODE DE SECURITE<br /><br />'.$FormRetour);
	}
	elseif (sha1($_POST['sql_code_secu'].date('Ymd')) == $_POST['code'])
	{
		$bbcode_noreplace = array('mail1','mail2','mail3');
		require_once './includes/class.mail.php';
		$mail = new kws_mail();
		// l'expditeur
		$mail->add_adresses(array(stripslashes($_POST['sql_contact_pseudo']) => stripslashes($_POST['sql_contact_email'])), 'From');
		// on masque le mail de l'admin en le mettant en Bcc
		//$mail->add_adresses(array('Admin ['.substr($K_url_site,7,-1).']' => ''), 'To');
		$mail->add_adresses(array($K_expediteur => $K_email_expediteur), 'To');

		// sujet du message
		$mail->set_sujet('[Message de '.substr($K_url_site,7,-1).'] '.stripslashes($_POST['sql_contact_objet']));
		// le texte en html ou txt selon que l'on passe par tiny ou pas
		if ($autorisation_tiny_mce)
		{
			$mail->set_message(bbcode(str_replace("\r\n", '', $_POST['texte']), 0, 1, 0, 1, 0), 'multi');
		}
		else
		{
			$mail->set_message(bbcode($_POST['texte'], 0, 1), 'multi');
		}
		// et c'est parti
		$envoi = $mail->envoyer();

		if (!empty($K_contact_emails_copie))
		{
			$ContactEmailsCopie = explode(';',$K_contact_emails_copie);
			foreach($ContactEmailsCopie as $EmailCopie)
			{
				if ($EmailCopie != $K_email_expediteur)
				{
					$mail->raz(array('To'));
					$mail->add_adresses(array($K_expediteur => trim($EmailCopie)), 'To');
					$mail->envoyer();
				}
			}
		}
		// copie  l'expditeur si souhait
		if ($_POST['contact_copie'] == 'oui')
		{
			$mail->raz(array('To'),1);
			$mail->add_adresses(array(stripslashes($_POST['sql_contact_pseudo']) => stripslashes($_POST['sql_contact_email'])), 'To');
			// sujet du message
			$mail->set_sujet('[(Copie) Message de '.substr($K_url_site,7,-1).'] '.stripslashes($_POST['sql_contact_objet']));
			$mail->envoyer();
		}

		if ($envoi)
		{
			$contact_msg = df_message('information', 'Message envoy&eacute;.');
		}
		else
		{
			$contact_msg = df_message('erreur', 'Votre message n\'a pas pu tre envoy  cause de l\'erreur suivante :', $mail->erreur_msg);
		}
	}
	// affichage du message de compte rendu
	echo $contact_msg;
}
else
{
	$code_confirm = gen_reg_key();
	$_SESSION['code_confirm'] = $code_confirm;
	$dte = sha1($code_confirm.date('Ymd'));

	echo '
	<script type="text/javascript" src="includes/md5.js"></script>
	<script type="text/javascript">
	// <![CDATA[
	function VerifSubmitContact()
	{
		var valid_form = true;
		var adresse = document.getElementById("sql_contact_email").value;
		var K_TestMail = false;

		for (var j=1; j<(adresse.length); j++)
		{
			if (adresse.charAt(j)=="@")
			{
				if (j<(adresse.length-4))
				{
					for (var k=j; k<(adresse.length-2); k++)
					{
						if (adresse.charAt(k)==".") K_TestMail = true;
					}
				}
			}
		}
		if (adresse != "" && K_TestMail == false)
		{
			alert("Le champ  E-mail  n\'est pas correct.");
			document.getElementById("sql_contact_email").focus();
			valid_form = false;
		}

		if (valid_form == true)
			valid_form = control_form("sql_contact_pseudo,'.(empty($K_pseudo) ? 'Nom_&_Prnom':'Identifiant').' sql_contact_email,E-mail sql_contact_objet,Objet postzone,Message sql_code_secu,Code_de_scurit");

		return valid_form;
	}
	// Fonction de vrification de diffrentes frappes clavier
	function verif_frappe(codeSecu)
	{
		var code_gen = "'.md5($code_confirm).'";
		var code = codeSecu.value;
		if (hex_md5(code) == code_gen)
		{
			codeSecu.style.borderColor ="green";
			document.getElementById("codeok").innerHTML= "<img style=\"margin-top:-5px\" src=\"./themes/'.$K_theme.'/images/gestion/ok.png\" alt=\"OK\"/>";
		}
		else
		{
			codeSecu.style.borderColor = "red";
			document.getElementById("codeok").innerHTML= "<em>Votre Code n&rsquo;est pas identique &agrave; l&rsquo;image.<\/em>";
		}
	}
	// ]]>
	</script>';

	if ($autorisation_tiny_mce)
	{
		if ($K_tiny_mce_confType == 5) $tiny_mce_confType_perso = 3;
		include_once './modules/tiny_mce/kwsphp.php';
	}

	echo '
	<form id="formulaire" method="post" action="'.url_rw('./index.php?mod='.$K_mod).'" onsubmit="return VerifSubmitContact()" class="contact"><br />
		<fieldset class="fieldset_post">
			<legend>Contactez-nous</legend>
				';
				if (!empty($K_contact_mess_infos))
				{
					echo df_message('',bbcode($K_contact_mess_infos,0,1)).'<br />';
				}
				echo '
				<dl>
					<dt><label for="sql_contact_pseudo"><span>*</span> '.(empty($K_pseudo) ? 'Nom &amp; Pr&eacute;nom':'Identifiant').' : </label></dt>
					<dd><input type="text" name="sql_contact_pseudo" id="sql_contact_pseudo" value="'.(!empty($_POST['sql_contact_pseudo']) ? ax($_POST['sql_contact_pseudo']): ax($K_user->pseudo)).'" /></dd>
				</dl>
				<dl>
					<dt><label for="sql_contact_email"><span>*</span> Votre adresse e-mail : </label></dt>
					<dd><input name="sql_contact_email" id="sql_contact_email" maxlength="40" size="50" value="'.(!empty($_POST['sql_contact_email']) ? ax($_POST['sql_contact_email']): ax($K_user->email)).'" /></dd>
				</dl>
				<dl>
					<dt><label for="sql_contact_objet"><span>*</span> Objet : </label></dt>
					<dd><input name="sql_contact_objet" id="sql_contact_objet" maxlength="100" size="50" value="'.ax($_POST['sql_contact_objet']).'" /></dd>
				</dl>
				<label><span>*</span> Message : </label><br /><br />
				<div class="fieldset_post">
					<textarea name="texte" cols="90" rows="'.(empty($new_textareaRows)?'13':$new_textareaRows).'" id="postzone" >'.ax($_POST['texte']).'</textarea>
				</div>
				<dl>
					<dt><label class="label_contact" for="contact_copieo">Recevoir une copie :</label></dt>
					<dd><input type="radio" value="oui" name="contact_copie" id="contact_copieo" />Oui <input type="radio" value="non" checked="checked" name="contact_copie" id="contact_copien" />Non</dd>
				</dl>
		';
		if (get_grade() < GRD_MEMBR && in_array($K_mod,unserialize($K_code_secu_mods)))
		{
			echo '
				<dl>
					<dt><label>Code de s&eacute;curit&eacute; :</label></dt>
					<dd>
						<img src="./index.php?mod=generateur&amp;type=contact" alt="Code de s&eacute;curit&eacute;" border="1" />
					</dd>
				</dl>
				<dl>
					<dt><label><span>*</span> Veuillez saisir le code de s&eacute;curit&eacute; :</label></dt>
					<dd>
						<input type="text" name="sql_code_secu" id="sql_code_secu" maxlength="6" size="30" value="" onkeyup="verif_frappe(this)" />
						<span class="mini_message" id="codeok"></span>
					</dd>
				</dl>
				';
		}
		else
		{
			echo '
				<input type="hidden" name="sql_code_secu" id="sql_code_secu" value="'.$code_confirm.'" />';
		}

		echo '
				<input type="hidden" name="code" id="code" value="'.$dte.'" />
				<p style="text-align:center;">
					<input type="submit" name="contact_envoyer" id="envoyer" value=" Envoyer " />
					<span style="margin-left:25px">&nbsp;</span>
					<input type="button" name="annuler" id="annuler" value=" Annuler " onclick="history.go(-1);" />
				</p>
				<hr />
				<dl>
					<dt><label><span>*</span> Champs obligatoires !</label></dt>
					<dd>&nbsp;</dd>
				</dl>
		</fieldset>
	</form>';
}
close_table();
?>
