<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: ajouter_image.php 889 2010-01-24 17:39:31Z mike007.devpwsphp $
// ---------------------------------------------------------------
// Cration : 07/10/07 par FouPouDave
// ---------------------------------------------------------------

/**
*	Scurit
*/
if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

/** 
*	Transformation des paramtres du module en variables
*/
require './modules/download/parametres.php';

// ---------------------------------------------------------------

// Chargement de la classe
require_once './includes/upload.class.php';

if ($dl_image_ajouter)
{
	bloc_head('Ajouter une image d\'illustration');
	// Instanciation d'un nouvel objet "upload"
	$Upload = new Upload();

	if (isset($_POST['ajouter_image']))
	{
		// Pour changer le mode d'criture (entre 0 et 3)
		$Upload->WriteMode = 2;

		// Pour filtrer les fichiers par entte
		//$Upload->MimeType  = 'image/gif;image/pjpeg;image/bmp;image/x-png';

		// Pour vrifier la page appelante
		//$Upload->CheckReferer = 'http://mondomaine/mon_chemin/mon_fichier.php';

		// Pour gnrer une erreur si les champs sont obligatoires
		$Upload->Required     = true;

		// Pour interdire automatiquement tous les fichiers considrs comme "dangereux"
		$Upload->SecurityMax  = true;

		// Dfinition du rpertoire de destination
		$Upload->DirUpload    = $dl_upload_image;

		// On lance la procdure d'upload
		$Upload->Execute();

		// Gestion erreur / succs
		if ($UploadError)
		{
			foreach ($Upload->GetError() as $dl_id => $dl_champ)
			{
				if (is_array($dl_champ))
				{
					foreach ($dl_champ as $dl_id => $dl_champ2)
					{
						echo df_message('erreur',$dl_champ2);
					}
				}
				else
				{
					echo df_message('erreur',$dl_champ);
				}
			}
		}
		else
		{
			echo df_message('information','L\'upload est effectu&eacute; avec succ&egrave;s !');
		}
	}
	else
	{
		// Pour limiter la taille d'un fichier (exprime en ko)
		$Upload->MaxFilesize  = '64';

		// Pour ajouter des attributs aux champs de type file
		$Upload->FieldOptions = 'size="80"';
		
		// Pour indiquer le nombre de champs dsir
		$Upload->Fields       = 1;

		// Pour tester la largeur / hauteur d'une image
		//$Upload->ImgMaxHeight = 200;
		//$Upload->ImgMaxWidth  = 200;
		//$Upload->ImgMinHeight = 100;
		//$Upload->ImgMinWidth  = 100;

		// Pour filtrer les fichiers par extension
		$Upload->Extension = '.gif;.jpg;.jpeg;.bmp;.png';

		// Initialisation du formulaire
		$Upload->InitForm();

		//Formulaire
		if (preg_replace('#M#', '', ini_get('upload_max_filesize'))*1024 <= $Upload->MaxFilesize/1024)
		{
			echo 'La taille de l\'image est limite par l\'hbergeur  '.(preg_replace('#M#', '', ini_get('upload_max_filesize'))*1024).' ko.<br />';
		}
		else
		{
			echo 'La taille de l\'image est limite par le webmaster  '.($Upload->MaxFilesize/1024).' ko.<br />';
		}
		echo 'L\'extension de l\'image doit tre '.str_replace(';', ' ou ', $Upload->Extension).'.<br />
		La largeur de l\'image est compris de '.(!empty($Upload->ImgMinWidth) ? $Upload->ImgMinWidth : '0').'  '.(!empty($Upload->ImgMaxWidth) ? $Upload->ImgMaxWidth : 'illimite').'.<br />
		La hauteur de l\'image est compris de '.(!empty($Upload->ImgMinHeight) ? $Upload->ImgMinHeight : '0').'  '.(!empty($Upload->ImgMaxHeight) ? $Upload->ImgMaxHeight : 'illimite').'.<br />
		<br />
		<div style="text-align:center;">
		<form method="post" enctype="multipart/form-data" action="index.php?mod=download&amp;ac=ajouter_image">'.
			$Upload->Field[0].$Upload->Field[1].'<br />
			<br />
			<input type="submit" id="submit" value="Envoyer" name="ajouter_image" /><br />
		</form>
		</div>
		<br />';
	}
	close_table();
}
else
{
	ZoneReserve();
}
?>