/**
 * Lister les id des topics d'une catgorie avec un objet
 * XMLHTTPRequest.
 */
/* Cration de la variable globale qui contiendra l'objet XHR */
var requete = null;
/**
 * Fonction prive qui va crer un objet XHR.
 * Cette fonction initialisera la valeur dans la variable globale dfinie
 * ci-dessus.
 */
function creerRequete()
{
    try
    {
        /* On tente de crer un objet XmlHTTPRequest */
        requete = new XMLHttpRequest();
    }
    catch (microsoft)
    {
        /* Microsoft utilisant une autre technique, on essays de crer un objet ActiveX */
        try
        {
            requete = new ActiveXObject('Msxml2.XMLHTTP');
        }
        catch(autremicrosoft)
        {
            /* La premire mthode a chou, on en teste une seconde */
            try
            {
                requete = new ActiveXObject('Microsoft.XMLHTTP');
            }
            catch(echec)
            {
                /*  ce stade, aucune mthode ne fonctionne... mettez donc votre navigateur  jour ;) */
                requete = null;
            }
        }
    }
    if(requete == null)
    {
        alert('Impossible de crer l\'objet requte,\nVotre navigateur ne semble pas supporter les object XMLHttpRequest.');
    }
}
/**
 * Fonction prive qui va mettre  jour l'affichage de la page.
 */
function actualiserIdTopics()
{
    var listeIdTopics = requete.responseText;
    var blocListe = document.getElementById('blocIdTopics');
	if (listeIdTopics != '' )
	{
		blocListe.innerHTML = listeIdTopics;
	}
	else blocListe.innerHTML = 'Pas de sujet dans cette cat&eacute;gorie';
}

/**
 * Fonction publique appele par la page affiche.
 * Cette fonction va initialiser la cration de l'objet XHR puis appeler
 * le code serveur afin de rcuprer les donnes  modifier dans la page.
 */
function getIdTopics(idr)
{
    /* Si il n'y a pas d'identifiant de rgion, on fait disparatre la seconde liste au cas o elle serait affiche */
    if(idr == 'vide')
    {
        document.getElementById('blocIdTopics').innerHTML = '';
    }
    else
    {
        /*  cet endroit prcis, on peut faire apparatre un message d'attente */
        var blocListe = document.getElementById('blocIdTopics');
        blocListe.innerHTML = "Traitement en cours, veuillez patienter...";
        /* On cre l'objet XHR */
        creerRequete();
        /* Dfinition du fichier de traitement */
        var url = './modules/forum/moveposts_ids.php?idr='+ idr;
        /* Envoi de la requte  la page de traitement */
        requete.open('GET', url, true);
        /* On surveille le changement d'tat de la requte qui va passer successivement de 1  4 */
        requete.onreadystatechange = function()
        {
            /* Lorsque l'tat est  4 */
            if(requete.readyState == 4)
            {
                /* Si on a un statut  200 */
                if(requete.status == 200)
                {
                    /* Mise  jour de l'affichage, on appelle la fonction aproprie */
                    actualiserIdTopics();
                }
            }
        };
        requete.send(null);
    }
} 


function verifId(form)
{
	if (document.getElementById("new_cat").value == "vide")
	{
		alert('Veuillez choisir une catgorie.') ;
	}
	else if (document.getElementById("idnewtopic").value == "")
	{
		alert('Veuillez choisir un sujet.') ;
	}
	else if (document.getElementById("idnewtopic").value == -1 && document.getElementById("sql_titrenewtopic").value == "")
	{
		alert('Veuillez renseigner le titre du nouveau sujet.') ;
		document.getElementById("sql_titrenewtopic").focus();
	}
	else if(document.getElementById("idnewtopic") && document.getElementById("idnewtopic").value != "")
	{
		form.submit();
	}

	
}
function input_new(Elt)
{
	if (Elt.options[Elt.selectedIndex].value == -1)
		document.getElementById('input_titrenewtopic').style.display = 'block';
	else
		document.getElementById('input_titrenewtopic').style.display = 'none';
}