<?php

// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: index.php 927 2011-05-17 17:19:37Z mike007 $
// ---------------------------------------------------------------
// Mise a jour : 04/02/08 par Mike007
// ---------------------------------------------------------------

chdir('../../');

require_once "./connect.php" ;
require_once './includes/fonctions.php';
require_once './config.php';
include_once 'includes/bbcode.php';
include_once 'includes/date.php';

if (preg_match('#modules/maintenance/#',$K_url_site))	$K_url_site = str_replace('modules/maintenance/','',$K_url_site);

$texte = '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<base href="'.$K_url_site.'" />
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-15" />
<meta http-equiv="Content-Language" content="fr"/>
<meta http-equiv="content-script-Type" content="text/javascript" />
<title>Site en maintenance - '.ax($K_nom_page).'</title>
<meta name="Subject" content="'.ax($K_nom_page).'" />
<meta name="Description" content="'.ax($K_description).'" />
<meta name="Keywords" content="'.ax($K_keywords).'" />
<meta name="robots" content="all" />
<!--  ####   Frquence de passage des robots indexeurs Ne mettez pas moins de 7 jours. -->
<meta name="revisit-after" content="7 days" />
<meta name="expires" content="never" />
<!--  ####   Barre d\'outils sur les images -->
<meta http-equiv="imagetoolbar" content="no" />
<meta name="identifier-url" content="'.ax($K_url_site).'" />
<meta name="author" content="'.ax($K_expediteur).'" />
<meta name="reply-to" content="'.str_replace('@',' [at] ',ax($K_email_expediteur)).'" />
<!--  ####   Ne pas modifier ! Merci pour ceux qui passent du temps pour vous ! -->
<meta name="copyright" content="KwsPHP" />
<meta name="creator" content="http://www.kwsphp.org/" />
<meta name="publisher" content="http://www.kwsphp.org/" />
<meta name="contact" content="'.str_replace('@',' [at] ',ax($K_email_expediteur)).'" />
<link rel="icon" href="./images/favicon/favicon.ico" type="images/x-icon" />
<link rel="shortcut icon" href="./images/favicon/favicon.ico" type="image/x-icon" />
<link rel="stylesheet" href="./themes/'.$K_theme.'/style/style.css" type="text/css" />
<style type="text/css" media="all">
<!--
	body
	{
		font-size:10pt;
		font-family: Georgia, Verdana, Trebuchet MS,  Helvetica, Arial, sans-serif;
	}
	fieldset
	{
		border-style:solid;
		border-width:1px;
		border-color:#CCCCCC;
		padding:1.5em;
	}
	form
	{
		width:700px;
		margin-left:auto;
		margin-right:auto;
	}
-->
</style>
</head>';

$texte .='
<body>
	<div style="width:700px;margin-left:auto;margin-right:auto;text-align:justify;">
		<div style="text-align:center"><br />
			<a href="'.$K_url_site.'" title="Accueil">
				'.(file_exists($K_logo) ? '<img src="'.$K_logo.'" style="border:0px;max-width:700px" alt="'.$K_url_site.'"/>' : $K_url_site).'
			</a>
			<br /><br />Bienvenue sur '.ax($K_nom_page).'
		</div>
		<fieldset style="width:660px">
			<legend><strong>Le site est en maintenance :</strong></legend>
			<div style="float:left;width:130px;line-height:30px;margin-right:15px">
				<img src="./modules/maintenance/travaux.png" alt="travaux" />
			</div>
			<div style="float:left;text-align:center;width:255px;line-height:30px;">
				D&eacute;but le :<br />
				<strong>'.kws_date('l dS F Y \<\b\r \/\>\&\a\g\r\a\v\e\; H:i',$K_maintenance_datedebut).'</strong>
			</div>
			<div style="float:left;text-align:center;width:255px;line-height:30px;">
				Fin estim&eacute;e le :<br />
				<strong>'.kws_date('l dS F Y \<\b\r \/\>\&\a\g\r\a\v\e\; H:i',$K_maintenance_datefin).'</strong>
			</div>
			<div style="clear:both">
			'.($K_maintenance_texte !='' ? '<hr />'.bbcode($K_maintenance_texte,0,1,1).'' : '').'
			</div>
		</fieldset>
		<br />
	</div>';
	$urlimagepass = file_exists('./themes/'.$K_theme.'/images/icones_membre/pass2.png') ? './themes/'.$K_theme.'/images/icones_membre/pass2.png' : './images/icones_membre/pass2.png' ;
	$widthimagepass = @getimagesize($urlimagepass);
	echo $texte;
	chdir('modules/maintenance/');
	if (file_exists('../sh00tM/index.php')) include_once '../sh00tM/index.php';
	$texte ='
	<form id="formlogin" name="formlogin" action="index.php?mod=espace_membre&amp;ac=login" method="post">
		<div class="login">
			<fieldset style="width:660px">
				<legend style="line-height:'.$widthimagepass[1].'px">
					<img style="float:left;margin-right:10px" src="'.$urlimagepass.'" alt="Priv&amp;eacute;" />
					<strong>Identification Administrateur :</strong>
				</legend>
					<div style="float:left;width:45%">
						<label style="display: inline; width: 80px;" for="sql_pseudo">Identifiant : </label>
						<input class="username_login" type="text" name="sql_pseudo" id="sql_pseudo" size="15" maxlength="30" value="" />
					</div>
					<div style="float:left;width:45%">
						<label style="display: inline; width: 100px;" for="sql_pass">Mot de passe : </label>
						<input class="username_password" type="password" name="sql_pass" id="sql_pass" size="15" maxlength="25" value="" />
					</div>
					<div style="float:left;width:10%;text-align:right">
						<input class="username_auto" type="checkbox" name="auto" id="auto" title="Se souvenir de moi. Ceci n&rsquo;est pas recommand&eacute; pour les ordinateurs partags." />
						<input id="submit_login" type="submit" name="veriferok" value=" OK " />
						<input type="hidden" name="verifer" value=" Se Connecter " />

					</div>
					<div style="clear:both;text-align:center">
						<br /><em>Seul l\'administrateur peut se connecter au site</em>
					</div>
			</fieldset>
		</div>
		<br />
		<div style="text-align:center">
			<span class="gen">'.bbcode($K_distribution_pre_copy,0,0,0,1).' </span>
			<a id="ckws" href="http://www.kwsphp.org/" '.($K_url_site != 'http://www.kwsphp.org/' ? 'target="_blank"':'').' title="CMS KwsPHP, le site cls en main (Portail PHP, Content Management System)">
				'.ax($K_distribution).' - &copy;2006-2011
			</a>
		</div>
	</form>
</body>
</html>';

echo $texte;
?>