<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: gestion.php 903 2010-04-25 07:54:35Z mike007.devpwsphp $
// ---------------------------------------------------------------
// Mise a jour : 12/07/06 par Jack
// Mise a jour : 16/06/07 par mike007
// Mise a jour : 09/03/08 par Barbar
// ---------------------------------------------------------------

if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}
?>

<script type="text/javascript">
// <![CDATA[
	function verifModuleBox(val) 
	{
		if (val != 0 && document.getElementById('box_'+val).checked)
		{
			document.getElementById('box_0').checked = false;
		}
		else if (document.getElementById('box_0').checked)
		{
			var i=1;
			while (document.getElementById('box_'+i)!= null)
			{
				document.getElementById('box_'+i).checked = false;
				i++;
			}
		}
		return true;
	}

	function envoyer()
	{
		var box = false;
		var i=0;
		while (document.getElementById('box_'+i)!= null)
		{
			if (document.getElementById('box_'+i).checked)	box=true;
			i++;
		}
		
		if (document.formulaire.sql_titre_rubrique.value=='')
		{
			alert('Veuillez indiquer le titre de la rubrique.');
			document.formulaire.sql_titre_rubrique.focus();
			return false;
		}
		else if (document.formulaire.sql_texte_rubrique.value=='' || document.formulaire.sql_texte_rubrique.value=='Tapez ici la description de la rubrique')
		{
			alert('Vous ne pouvez pas poster une rubrique sans descriptif !');
			document.formulaire.sql_texte_rubrique.focus();
			return false;
		}
		else if (box==false)
		{
			alert('Vous devez indiquer au moins un module');
			document.getElementById('box_0').focus();
			return false;
		}
		else if (document.formulaire.image.value=='')
		{
			alert('Vous ne pouvez pas poster une rubrique sans image !');
			document.formulaire.image.focus();
			return false;
		}
		else return true;
	}
// ]]>
</script>

<?php

// liste des modules utilisant les rubriques
$rubriques_liste_modules = scannerRepertoire('./modules/', 'dir', false);

foreach ($rubriques_liste_modules as $i => $module)
{
	if (!${$module.'_rubriques'}) unset($rubriques_liste_modules[$i]);
}


// Chargement de la classe
require './includes/upload.class.php';

// Instanciation d'un objet Upload
$Upload = new Upload();

function dir_rep_rub($default)
{
	$default	= preg_replace('#images/rubriques/#', '' , $default);
	$liste		= ScannerRepertoire('./images/rubriques/','file', false);

	$code		= '<select name="image" onchange="ShowImg(\'Cat_Rub\',\'./images/rubriques/\'+this.options[this.selectedIndex].value)">'."\n" ;

	if(count($liste)<1)
	{
		$code .= ' vide...';
	}
	else
	{
		$ext = array('png','gif','jpeg','jpg','tiff','bmp');
		for ($i=0 ; $i<count($liste) ; $i++)
		{
			$test = $liste[$i];
			if(strpos($test,'.') !== FALSE and in_array(strtolower(substr($test,strrpos($test,'.')+1)),$ext))
			{
				$code .= '<option value="'.$liste[$i].'"'.($default==$test ?' selected="selected"':'').'>'.$liste[$i].'</option>'."\n";
			}
		}
	}
	$code .= '</select>'."\n";
	return $code;
}

function uploadRub($Upload)
{
	global $UploadError, $K_theme;

	// Rpertoire d'enregistrement des images
	$Upload->DirUpload = 'images/rubriques';

	// Si champ vide -> Erreur
	$Upload->Required = true;

	// Liste des extensions autoris&eacute;es
	$Upload->Extension = '.gif;.jpg;.jpeg;.bmp;.png';

	// Liste des enttes de fichiers autoris&eacute;s
	$Upload->MimeType = 'image/gif;image/pjpeg;image/jpeg;image/bmp;image/png';

	// Interdire les fichiers potentiellement dangereux
	$Upload->SecurityMax = true;

	//--------------------
	// lance la procdure d'upload
	$Upload-> Execute();

	// Teste le bon d&eacute;roulement des op&eacute;rations
	if ($UploadError)
	{
		$ok			= false;
		$renvoie	.= 'Il y a eu une erreur.<br />';
		$renvoie	.= $Upload-> GetError();
	}
	else
	{
		$ok = true;
	}

	// On rcupre les information de l'upload
	$resume = $Upload->GetSummary();

	// Nom du fichier upload
	$renvoie	='images/rubriques/';
	$renvoie	.= $resume[1][nom];

	//print_r($Upload-> GetSummary());

	return array($ok,$renvoie);
}


// ---------------------------------------------DEBUT
if (get_grade()>=GRD_MODOG)
{
	///////////////////////
	// Cration de rubrique
	if($_REQUEST['action']=='new')
	{
		// cration des checkbox pour la slection des modules
		$rub_box_mod = '
		<input type="checkbox" id="box_0" name="sql_module_rubrique[]" value="tous" checked="checked" onclick="verifModuleBox(0)" />Tous&nbsp;&nbsp;&nbsp;ou';
		$i = 1;
		foreach ($rubriques_liste_modules as $rub_mod)
		{
			if (is_module($rub_mod))
			{
				$rub_box_mod .= ($i%5==0 ? '<br />' : '&nbsp;&nbsp;').'
				<input type="checkbox" id="box_'.$i.'" name="sql_module_rubrique[]" value="'.$rub_mod.'" onclick="verifModuleBox('.$i.')" />'.$rub_mod.'&nbsp;&nbsp;';
				$i++;
			}
		}
		
		bloc_head('Nouvelle Rubrique');

		/**
		* Cration du formulaire
		**/
		// Pour limiter la taille d'un fichier (exprime en ko)
		$Upload->MaxFilesize  = 20;

		// Personnaliser les options du champ
		//$Upload->FieldOptions = 'size=60';

		// Initialise le champ de type 'FILE'
		$Upload-> InitForm();

		echo '
		<form id="Form_Rub" name="formulaire" method="post" enctype="multipart/form-data" action="./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'" onsubmit="return envoyer()">
			<input type="hidden" name="action" value="new2" />
			'.$Upload->Field[0].'

			<img id="Cat_Rub" name="rubrique" src="./images/rubriques/__vide.png" alt="image rubrique" style="float:right;padding-right:40%;" />
			<p>
			<label class="label_admin_options1" for="sql_titre_rubrique">Titre : </label>
			<input type="text" size="30" name="sql_titre_rubrique" />
			</p>

			<p>
			<label class="label_admin_options1">Catgorie parente : </label>
			<select name="int_sref">
				<option value="0" >Aucune</option>
				<option disabled="disabled" value="">---------------------</option>';
			foreach ($K_liste_titre_rubrique as $scat_id => $scat_titre)
			{
				echo '
					<option value="'.$scat_id.'">'.ax($scat_titre).' ('.(!empty($K_liste_module_rubrique[$scat_id]) ? ax($K_liste_module_rubrique[$scat_id]):'Tous').')</option>';
			}
			echo '
			</select>
			</p>

			<p>
			<label class="label_admin_options1">Image : </label>
			'.dir_rep_rub('__vide.png').'
			</p>
			
			<p>
			<label class="label_admin_options1">Fichier : </label>
			'.$Upload->Field[1].'
			</p>
			
			<p>
			<label class="label_admin_options1" for="int_grade_rubrique">Visible par : </label>
			'.K_selectGrade('int_grade_rubrique', GRD_VISIT).'
			<select name="et_ou_rubrique">
				<option value="or">ou</option>
				<option value="and">et</option>
			</select>
			'.K_selectGroupe('int_groupe_rubrique', 'tous').'
			</p>
			
			<p>
			<label class="label_admin_options1" for="sql_module_rubrique">Modules : </label>
			'.$rub_box_mod.'
			</p>
			
			<p>
			<label class="label_admin_options1" for="sql_texte_rubrique">Descriptif :</label>
			<textarea rows="7" cols="60" name="sql_texte_rubrique">Tapez ici la description de la rubrique</textarea>
			</p>
			
			<p style="text-align:center;">
			<input type="submit" id="poster" name="poster" value="Poster" />&nbsp;&nbsp;&nbsp;
			<input type="reset" id="reset" value="Annuler" onclick="javascript:history.go(-1)" />
			</p>
		</form>';

		close_table();
	}
	// Confirmation de cration de rubrique
	elseif ($_REQUEST['action'] == 'new2')
	{
		//df_print_r($_POST);
		$image = 'images/rubriques/'.$_POST['image'];

		$imageUp = uploadRub($Upload);

		if($imageUp[0])  $image=$imageUp[1];

		bloc_head('Nouvelle rubrique');

		if (!empty($_POST['sql_titre_rubrique']) &&
			!in_array($_POST['sql_titre_rubrique'], $K_liste_titre_rubrique) &&
			!empty($_POST['sql_texte_rubrique']) && 
			$_POST['sql_texte_rubrique']!='Tapez ici la description de la rubrique' && 
			is_array($_POST['sql_module_rubrique'])
			)
		{
			if (in_array('tous', $_POST['sql_module_rubrique']))
			{
				$rub_modules = '';
			}
			else
			{
				$rub_modules = implode(',', $_POST['sql_module_rubrique']);
			}

			reqmysql('
				INSERT INTO `rubriques`
				SET	`titre`		= "'.$_POST['sql_titre_rubrique'].'",
					`module`	= "'.$rub_modules.'",
					`sref`		= "'.$_POST['int_sref'].'",
					`image`		= "'.$image.'",
					`texte`		= "'.$_POST['sql_texte_rubrique'].'"
			') or die('Une erreur est survenue');
			
			$rub_page = 'id_'.mysql_insert_id();
			$rub_cond = $_POST['et_ou_rubrique']=='or' ? 'or' : 'and';
			reqmysql('
				INSERT INTO	`droit`
				SET			`module`	= "rubriques",
							`page`		= "'.$rub_page.'",
							`grade`		= "'.$_POST['int_grade_rubrique'].'",
							`groupe`	= "'.$_POST['int_groupe_rubrique'].'",
							`condition`	= "'.$rub_cond.'"
			') or die ('Une erreur est survenue');
			
			if($image[0])
			{
				echo '<br />
				<div style="text-align:center;">
				La rubrique <strong>'.ax($_POST['sql_titre_rubrique']).'</strong> a &eacute;t&eacute; cr&eacute;&eacute;e.<br /><br />';
			}
			else
			{
				echo '<br />
				<div style="text-align:center;">
				'.$imageUp[1].'<br />';
			}
			echo '<p style="text-align:center;"><a href="./index.php?mod=rubriques&amp;ac=gestion">Retour</a></p>';
		}
		else
		{
			if ($_POST['sql_titre_rubrique'] == '') $msg  = 'Vous n\'avez pas rempli le champ <em>Titre</em><br />';
			if (in_array($_POST['sql_titre_rubrique'], $K_liste_titre_rubrique)) $msg .= 'Une rubrique portant ce nom existe d&eacute;j&agrave;<br />';
			if ($_POST['sql_texte_rubrique'] == '') $msg .= 'Vous n\'avez pas rempli le champ <em>Contenu</em><br />';
		 	if (!is_array($_POST['sql_module_rubrique'])) $msg .= 'Vous n\'avez pas indiqu&eacute; les modules concern&eacute;s par votre rubrique !<br />';
			
			echo '<br />'.df_message(
				'attention', 
				'<strong>Formulaire incomplet !</strong>', '<p style="color:red">'.$msg.'</p>
				<p style="text-align:center;font-weight:bold;"><a href="./index.php?mod=rubriques&amp;ac=gestion&amp;action=new">Retour</a></p>'
			).'<br />';		
		}
		echo '
		</div>';
		close_table();
	}
	//Supprimer une rubrique
	elseif ($_REQUEST['action'] == 'del')
	{
		bloc_head('Supprimer une rubrique');

		$requete = reqmysql('
			SELECT	`titre`
			FROM	`rubriques`
			WHERE	`id` = "'.$_GET['int_id'].'"
		');
		$cat = mysql_fetch_object($requete);

		echo '<br />
		<div style="text-align:center;">
			Etes-vous s&ucirc;r de vouloir supprimer la rubrique : <strong>'.ax($cat->titre).'</strong>?<br />
			<br />
			<form action="./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'" enctype="multipart/form-data" method="post">
				<input type="hidden" name="action" value="del2" />
				<input type="hidden" name="int_id" value="'.$_GET['int_id'].'" />
				<input type="submit" id="submit" value="Oui" />
				<input type="button" id="button" value="Non" onclick="history.go(-1)" /><br />
			</form>
			<br />
		</div>' ;

		close_table() ;
	}
	// Confirmation de suppression de rubrique
	elseif ($_REQUEST['action'] == 'del2')
	{
		bloc_head('Supprimer une rubrique');

		reqmysql('
			DELETE FROM	`rubriques`
			WHERE		`id`="'.$_POST['int_id'].'"
		');
		reqmysql('
			DELETE FROM `droit`
			WHERE `module` = "rubriques"
				AND `page` = "id_'.$_POST['int_id'].'"
		');
		
		echo '
		<p style="text-align:center;"><strong>Rubrique supprim&eacute;e</strong></p>
		<p style="text-align:center;"><a href="./index.php?mod=rubriques&amp;ac=gestion">Retour</a></p>';

		close_table();
	}
	// Edition de rubrique
	elseif ($_REQUEST['action'] == 'edit')
	{
		//Cration du formulaire

		// Pour limiter la taille d'un fichier (exprim&eacute;e en ko)
		$Upload->MaxFilesize  = 20;

		// Personnaliser les options du champ
		//$Upload->FieldOptions = 'size=50';

		// Initialise le champ de type 'FILE'
		$Upload-> InitForm();

		$requete = reqmysql('
			SELECT	`r`.`titre`, `r`.`image`, `r`.`sref`, `r`.`texte`, `r`.`module`,
					`d`.`grade`, `d`.`groupe`, `d`.`condition`
			FROM	`rubriques` AS r
			LEFT JOIN `droit` AS d ON (`d`.`module`="rubriques" AND `d`.`page`="id_'.$_GET['int_id'].'")
			WHERE	`r`.`id`="'.$_GET['int_id'].'"
		');
		$cat = mysql_fetch_object($requete) ;

		if (empty($cat->module))
		{
			$liste_mod[0] = 'Tous';
		}
		else
		{
			$liste_mod = explode(',', $cat->module);
		}
		$rub_box_mod = '
			<input type="checkbox" id="box_0" name="sql_module_rubrique[]" value="tous" '.(in_array('Tous', $liste_mod)? 'checked="checked"' : '').' onclick="verifModuleBox(0)" />Tous&nbsp;&nbsp;&nbsp;ou';
		$i = 1;
		foreach ($rubriques_liste_modules as $rub_mod)
		{
			if (is_module($rub_mod))
			{
				$rub_box_mod .= ($i%5==0 ? '<br />' : '&nbsp;&nbsp;').'
				<input type="checkbox" id="box_'.$i.'" name="sql_module_rubrique[]" value="'.$rub_mod.'" '.(in_array($rub_mod, $liste_mod) ? 'checked="checked"' : '').' onclick="verifModuleBox('.$i.')" />'.$rub_mod.'&nbsp;&nbsp;';
				$i++;
			}
		}

		bloc_head('Editer une Rubrique');

		echo '
		<form id="Form_Rub" name="formulaire" action="./index.php?mod='.$K_mod.'&amp;ac='.$K_ac.'" enctype="multipart/form-data" method="post" onsubmit="return envoyer()">
			<input type="hidden" name="action" value="edit2" />
			<input type="hidden" name="int_id" value="'.$_GET['int_id'].'" />
			'.$Upload->Field[0].'

			<img id="Cat_Rub" name="rubrique" src="'.$cat->image.'" alt="rubrique" style="float:right;margin-right:40%;border:thick #ffd700 outset;" />

			<p>
			<label class="label_admin_options1" for="sql_titre_rubrique">Titre : </label>
			<input type="text" name="sql_titre_rubrique" id="sql_titre_rubrique" size="30" value="'.ax($cat->titre).'" />
			</p>

			<p>
			<label class="label_admin_options1" for="int_sref">Catgorie parente : </label>
			<select id="int_sref" name="int_sref">
				<option value="0" >Aucune</option>
				<option disabled="disabled" value="">---------------------</option>';
		foreach ($K_liste_titre_rubrique as $scat_id => $scat_titre)
		{
			echo '
				<option  value="'.$scat_id.'" '.($scat_id==$cat->sref ? 'selected="selected"':'').'>'.ax($scat_titre).' ('.(!empty($K_liste_module_rubrique[$scat_id]) ? ax($K_liste_module_rubrique[$scat_id]):'Tous').')</option>';
		}
		echo '
			</select>
			</p>

			<p>
			<label class="label_admin_options1">Image : </label>
			'.dir_rep_rub($cat->image).'
			</p>
			
			<p>
			<label class="label_admin_options1">Fichier : </label>
			'.$Upload->Field[1].'
			</p>
			
			<p>
			<label class="label_admin_options1" for="int_grade_rubrique">Visible par : </label>
			'.K_selectGrade('int_grade_rubrique', $cat->grade).'
			<select name="et_ou_rubrique">
				<option value="or">ou</option>
				<option value="and" '.($cat->condition=="and" ? 'selected="selected"' : '').'>et</option>
			</select>
			'.K_selectGroupe('int_groupe_rubrique', $cat->groupe).'
			</p>

			<p>
			<label class="label_admin_options1" for="sql_module_rubrique">Modules : </label>
			'.$rub_box_mod.'
			</p>
			
			<p>
			<label class="label_admin_options1" for="sql_texte_rubrique">Descriptif :</label>
			<textarea rows="7" cols="60" name="sql_texte_rubrique" id="sql_texte_rubrique">'.ax($cat->texte).'</textarea>
			</p>
			
			<p style="text-align:center;">
			<input type="submit" id="submit" value="Poster" />&nbsp;&nbsp;&nbsp;
			<input type="reset" id="reset" value="Annuler" onclick="javascript:history.go(-1)" />
			</p>
		</form>';

		close_table();
	}
	// Confirmation d'edition de rubrique
	elseif ($_REQUEST['action'] == 'edit2')
	{
		if (!empty($_POST['sql_titre_rubrique']) &&
			(!in_array($_POST['sql_titre_rubrique'], $K_liste_titre_rubrique) || array_search($_POST['sql_titre_rubrique'], $K_liste_titre_rubrique) == $_POST['int_id']) &&
			!empty($_POST['sql_texte_rubrique']) && 
			$_POST['sql_texte_rubrique']!='Tapez ici la description de la rubrique' && 
			is_array($_POST['sql_module_rubrique'])
			)
		{
			$image = 'images/rubriques/'.$_POST['image'];

			$imageUp = uploadRub($Upload);
			if($imageUp[0])
			{
				$image=$imageUp[1];
			}
			if (in_array('tous', $_POST['sql_module_rubrique'])) 
			{
				$rub_modules = '';
			}
			else
			{
				$rub_modules = implode(',', $_POST['sql_module_rubrique']);
			}

			bloc_head('Editer une rubrique');

			reqmysql('
				UPDATE	`rubriques`
				SET		`titre`		= "'.$_POST['sql_titre_rubrique'].'",
						`module`	= "'.$rub_modules.'",
						`sref` 		= "'.$_POST['int_sref'].'",
						`image`		= "'.$image.'",
						`texte`		= "'.$_POST['sql_texte_rubrique'].'"
				WHERE	`id`		= "'.$_POST['int_id'].'"
			');

			$rub_cond = $_POST['et_ou_rubrique']=='or' ? 'or' : 'and';
			reqmysql('
				UPDATE	`droit`
				SET		`grade`		= "'.$_POST['int_grade_rubrique'].'",
						`groupe`	= "'.$_POST['int_groupe_rubrique'].'",
						`condition`	= "'.$rub_cond.'"
				WHERE	`module`	= "rubriques"
					AND `page`		= "id_'.$_POST['int_id'].'"
			');

			if($image[0])
			{
				echo '<br />
				<div style="text-align:center;">
				Modifications enregistr&eacute;es<br />';
			}
			else
			{
				echo '<br />
				<div style="text-align:center;">
				'.$imageUp[1].'<br />';
			}
			echo '
			<p style="text-align:center;"><a href="./index.php?mod=rubriques&amp;ac=gestion">Retour</a></p>
			</div>';

			close_table();
		}
		else
		{
			bloc_head('Editer une rubrique');
			if ($_POST['sql_titre_rubrique'] == '') $msg  = 'Vous n\'avez pas rempli le champ <em>Titre</em><br />';
			if (in_array($_POST['sql_titre_rubrique'], $K_liste_titre_rubrique) && array_search($_POST['sql_titre_rubrique'], $K_liste_titre_rubrique) != $_POST['int_id']) $msg  .= 'Une autre rubrique porte d&eacute;j&agrave; ce <em>titre</em>.<br />';
			if ($_POST['sql_texte_rubrique'] == '') $msg .= 'Vous n\'avez pas rempli le champ <em>Contenu</em><br />';
		 	if (!is_array($_POST['sql_module_rubrique'])) $msg .= 'Vous n\'avez pas indiqu&eacute; les modules concern&eacute;s par votre rubrique !<br />';
			echo '<br />'.df_message('attention', '<strong>Formulaire incomplet !</strong>', '<p style="color:red">'.$msg.'</p>
			<p style="text-align:center;font-weight:bold;"><a href="./index.php?mod=rubriques&amp;ac=gestion&amp;action=edit&amp;int_id='.$_POST['int_id'].'">Retour</a></p>').'<br />';
			close_table();
		}

	//////////////////////
	// Affichage des rubriques
	}
	else
	{
		bloc_head('Gestion des rubriques');

		echo '<br />
		<img src="themes/'.$K_theme.'/images/gestion/puce.png" alt="puce" />&nbsp;&nbsp;<a href="./index.php?mod=rubriques&amp;ac=gestion&amp;action=new"><strong>Ajouter une rubrique</strong></a><br />
		<br />
		<hr />';

		$requete = reqmysql('
			SELECT		`r`.`titre`, `r`.`id`, `r`.`sref`, `r`.`image`, `r`.`module`,
						`d`.`grade`, `d`.`condition`,
						`g`.`nom`	AS groupe
			FROM		`rubriques` AS r
			LEFT JOIN	`droit` AS d
				ON		`d`.`module`="rubriques" AND `d`.`page`=CONCAT("id_", `r`.`id`)
			LEFT JOIN	`groupes_grp` AS g
				ON		`g`.`id` = `d`.`groupe`
			ORDER BY	`r`.`module` ASC, `r`.`titre` ASC, `r`.`sref` ASC
		');

		if (mysql_num_rows($requete) == 0)
		{
			echo 'Aucune rubrique trouv&eacute;e<br />
			<hr />' ;
		}
		else
		{
			echo '
			<ul style="list-style-type:none; text-indent:0px ! important;">
			<li>
				<div style="width:5%; float:left;">&nbsp;</div>
				<div style="width:5%; float:left;">&nbsp;</div>
				<div style="width:50px; float:left;">Image</div>
				<div style="width:25%; float:left;">Nom</div>
				<div style="width:20%; float:left;">Module</div>
				<div style="width:35%; float:left;">Visible par</div>
				<div style="clear:both;"></div>
			</li>';

			while ($cat = mysql_fetch_object($requete))
			{
				$visible =	get_grd_name($cat->grade).' '
							.str_replace(array('or', 'and'), array('ou', 'et'), $cat->condition).' '
							.($cat->groupe==NULL ? 'aucun groupe n&eacute;cessaire' : ax($cat->groupe));
				echo '
				<li onmouseover="this.className = \'onmouse_over\';" onmouseout="this.className = \'onmouse_out\';">
					<div style="width:5%; float:left;">
						<a href="./index.php?mod=rubriques&amp;ac=gestion&amp;action=edit&amp;int_id='.$cat->id.'"><img src="themes/'.$K_theme.'/images/gestion/edit.png" alt="Editer" style="border:none;" /></a>
					</div>
					<div style="width:5%; float:left;">
						<a href="./index.php?mod=rubriques&amp;ac=gestion&amp;action=del&amp;int_id='.$cat->id.'"><img src="themes/'.$K_theme.'/images/gestion/del.png" alt="Supprimer" style="border:none;" /></a>
					</div>
					<div style="width:50px; float:left;"><img src="'.$cat->image.'" alt="Image" style="border:none; height:24px; max-height:24px;" /></div>
					<div style="width:25%; padding-top:5px; float:left;">- '.ax($cat->titre).'</div>
					<div style="width:20%; padding-top:5px; float:left;">'.(empty($cat->module)?"Tous":ax($cat->module)).'</div>
					<div style="width:35%; padding-top:5px; float:left;">'.$visible.'</div>
					<div style="clear:both;"></div>
				</li>';
			}
			echo '
			</ul><br />
			<hr />';
		}
		echo'<br />
		<div style="text-align:center">';
		if (is_module('articles') && get_grade() >= $articles_gr_poster)
		{
			echo '
			<a href="./index.php?mod=articles&amp;ac=poster" style="margin-left:20px;margin-right:20px;">Poster un article</a>';
		}
		if (is_module('news') && get_grade() >= $news_gr_poster)
		{
			echo '
			<a href="./index.php?mod=news&amp;ac=poster" style="margin-left:20px;margin-right:20px;">Poster une news</a>';
		}
		echo '
		</div><br />';

		close_table();
	}
}
else
{
	ZoneReserve();
}
?>
