<?php
// ---------------------------------------------------------------
// KwsPHP kOoGar Web System
// $Id: stats_inf.php 884 2009-10-08 19:41:01Z mike007.devpwsphp $
// ---------------------------------------------------------------
// Mise a jour : 11/02/07 par Ditch
// ---------------------------------------------------------------

if (!(defined('__KWS__'))) {die ('Erreur d\'appel de fichier.');}

/******************/
/* Intgration OS */
/******************/
function os_systeme($agent)
{
	if (preg_match('#(eCatch|HTTrack|teleport|Wget|webcopier)#i', $agent)) return 27;
	//http://webcab.de/wapua.htm
	if (preg_match('#(DoCoMo/1.0|DoCoMo/2.0|portalmmm/1.0|portalmmm/2.0|ACER|Alcatel|AnnyWay|AUDIOVOX|BlackBerry|CDM|Ericsson|LG\b|LGE|Motorola|MOT-|NEC|Nokia|Panasonic|QCI|SAGEM|SAMSUNG|SEC-|Sanyo|Sendo|SHARP|SIE-|SonyEricsson|Telit|Telit_Mobile_Terminals|TSM)#i', $agent)) return 28;
	elseif (preg_match('#(AvantGo 3.2|EudoraWeb 2.1|UP.Browser|Plucker|PalmSource|NetFront/3.0|Xiino/1.0.9E|Elaine/3.0|Pixo-Browser)#i', $agent)) return 28;
	elseif (preg_match('#(PluckerPalm|RegKing|EPOC|PalmOS|KDDI|EZOS|Zaurus C750|SPV C500|hspr-H102|UPG1|Wapagsim|J-PHONEKGT/|UP.Link|Symbian)#i', $agent)) return 28;
	if (preg_match('#(win|windows) ?XP#i', $agent)) return 15;
	if (preg_match('#(win|windows) ?(NT)#i', $agent))
	{
		if (preg_match('#(win|windows) ?NT ?6.1#i', $agent)) return 26;
		if (preg_match('#(win|windows) ?NT ?6(\.0)?#i', $agent)) return 24;
		if (preg_match('#(win|windows) ?NT ?(5\.1|6(\.0)?)#i', $agent)) return 15;
		if (preg_match('#(win|windows) ?NT ?5.2#i', $agent)) return 25;
		if (preg_match('#(win|windows) ?NT ?(5(\.0)?)#i', $agent)) return 17; return 16;
	}
	//http://www.siteware.ch/webresources/useragents/spiders/
	//http://www.user-agents.org/
	if (preg_match('#(aLaide.com toolset|altavista|arachnoidea|ask|bot|crawl|google|gulliver|heritrix|indy library|informant|infoseek|nutch|Python|Qseero|robot|search|slurp|scooter|spider|TopBlogsInfo|ultraseek|wisewire)#i', $agent)) return 1;
	if (preg_match('#(win|windows) ?(2000)#i', $agent)) return 17;
	if (preg_match('#(linux)#i', $agent)) return 12;
	if (preg_match('#(mac|ppc)#i', $agent)) return 4;
	if (preg_match('#(win|windows) ?(98)#i', $agent)) return 19;
	if (preg_match('#tv#i', $agent)) return 20;
	if (preg_match('#(win|windows) ?(9x ?4\.90|Me)#i', $agent)) return 14;
	if (preg_match('#(win|windows) ?(95)#i', $agent)) return 18;
	if (preg_match('#(win|windows)#i', $agent)) return 13;
	if (preg_match('#freebsd#i', $agent)) return 9;
	if (preg_match('#SunOs#i', $agent)) return 10;
	if (preg_match('#beos#i', $agent)) return 3;
	if (preg_match('#(unix|x11)#i', $agent)) return 5;
	if (preg_match('#os/2#i', $agent)) return 2;
	if (preg_match('#IRIX#i', $agent)) return 6;
	if (preg_match('#netbsd#i', $agent)) return 23;
	if (preg_match('#openbsd#i', $agent)) return 22;
	if (preg_match('#HP-UX#i', $agent)) return 7;
	if (preg_match('#AIX#i', $agent)) return 8;
	if (preg_match('#QNX#i', $agent)) return 21;

	if (preg_match('#^Mozilla(/|\s)5.0$#i', $agent)) return 1;

	if ($_IN_SVN and !empty($agent))
	{
		$TexteAlerteAgent = '
		<div style="text-align:center;width:600px;margin:auto">
			OS inconnu.
			<table style="text-align:right;"><tr>
				<td><span style="color:green;">GetHostByAddr</span></td>
				<td><span style="color:green;"> => </span></td>
				<td style="text-align:left;"><strong><em>'.gethostbyaddr($_SERVER['REMOTE_ADDR']).'</em></strong></td>
			</tr><tr>
				<td><span style="color:darkorange;">HTTP_USER_AGENT</span></td>
				<td><span style="color:darkorange;"> => </span></td>
				<td style="text-align:left;"><strong><em>'.sp($agent).'</em></strong></td>
			</tr></table>
			Merci de le signaler sur le forum de <a href="http://www.kwsphp.org/">KwsPHP</a>
		</div>';
		if (mysql_num_rows(reqmysql('SELECT `id` FROM `alerte` WHERE `auteur`="KwsPHP OS" AND `texte`="'.sp($TexteAlerteAgent).'"')) == 0)
		{
			reqmysql('INSERT INTO `alerte` SET `date`="'.time().'", `auteur`="KwsPHP OS", `module`="Stats", `texte`="'.sp($TexteAlerteAgent).'" ');
		}
	}
	return 0;
}

$os = sp(os_systeme($_SERVER['HTTP_USER_AGENT']));

reqmysql('UPDATE `stats` SET `hit`=`hit`+1 WHERE `type`="os" and `valeur`="'.$os.'"');

if(mysql_affected_rows()==0)
{
	reqmysql('INSERT INTO `stats` SET `type`="os",`valeur`="'.$os.'",`hit`="1"');
}

/***********************/
/* Intgration Browser */
/***********************/
function navigateur($agent)
{
	global $liste_navigateurs;

	if (preg_match('#Mozilla/([0-9.]+)#i', $agent, $version) && !preg_match('#compatible#i', $agent))
	{
		if (preg_match('#Chrome[[:alnum:]]*[/\ ]([0-9.]+)#i', $agent, $version))  return '27**'.$version[1];
	}

	for ($i=5;$i<=21;$i++)
	{
		if (preg_match('#'.$liste_navigateurs[$i] . '[ \/]([0-9\.]+)#i', $agent, $version)) return $i.'**'.$version[1];
	}

	if (preg_match('#MSIE[ \/]([0-9\.]+)#i', $agent, $version)) return '4**'.$version[1];

	if (preg_match('#Mozilla/([0-9.]+)#i', $agent, $version) && !preg_match('#compatible#i', $agent))
	{
		if (preg_match('#Firefox[[:alnum:]]*[/\ ]([0-9.]+)#i', $agent, $version))  return '26**'.$version[1];
		if (preg_match('#K-Meleon[[:alnum:]]*[/\ ]([0-9.]+)#i', $agent, $version))  return '28**'.$version[1];
		if (preg_match('#netscape[[:alnum:]]*[/\ ]([0-9.]+)#i', $agent, $version))  return '2**'.$version[1];
		if (preg_match('#rv:([0-9.]+)#i', $agent, $version) || preg_match('#[^[]]m([0-9.]+)#i',$agent, $version)) return '3**'.$version[1];
		return '2**'.$version[1];
	}
	if (preg_match('#(alexa|ask|altavista|arachnoidea|bot|clickfr|google|infoseek|microsoft|msn|scooter|searchme|slurp|spider|twiceler|ultraseek|voila|wisenut|yahoo)#i', $agent)) return '1**0';
	return '0**0';
}

$nav = sp(navigateur($_SERVER['HTTP_USER_AGENT']));

reqmysql('UPDATE `stats` SET `hit`=`hit`+1 WHERE `type`="nav" and `valeur`="'.$nav.'"');

if(mysql_affected_rows()==0)
{
	reqmysql('INSERT INTO `stats` SET `type`="nav",`valeur`="'.$nav.'",`hit`="1"');
}

/*********************/
/* Intgration Heure */
/*********************/
$heure = date("G");
reqmysql('UPDATE `stats` SET `hit`=`hit`+1 WHERE `type`="heure" and `valeur`="'.$heure.'"');

if(mysql_affected_rows()==0)
{
	reqmysql('INSERT INTO `stats` SET `type`="heure",`valeur`="'.$heure.'",`hit`="1"');
}

/************************/
/* Intgration Refrant */
/************************/

if (isset($_SERVER['HTTP_X_FORWARDED_FOR']) & $_SERVER['HTTP_X_FORWARDED_FOR']!='')
{
	$remote_addr=$_SERVER['HTTP_X_FORWARDED_FOR'];
}
else
{
	$remote_addr=$_SERVER['REMOTE_ADDR'];
}


$http_referer=$_SERVER['HTTP_REFERER'];

$temp=parse_url($http_referer);
$from=$temp['host'].$temp['path'];
$from=substr($from,0,strrpos($from,'/'));
$from='http://'.$from.'/';

if($from=='http:///')
{
	$from = $url_site;
}


if($from<>$url_site)
{	
	reqmysql('UPDATE `stats` SET `hit`=`hit`+1 WHERE `type`="ref" AND `valeur`="'.sp($from).'"');
	
	if(mysql_affected_rows()==0)
	{
		reqmysql('INSERT INTO `stats` SET `type`="ref", `valeur`="'.sp($from).'", `hit`=1');
	}
	
}

/**************************/
/* Intgration de la page */
/**************************/
include 'modules/stats/stats_inf_light.php';
?>
